//  Copyright 2019 root.ext@gmail.com
//
//  Licensed under the Apache License, Version 2.0 (the "License");
//  you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at
//
//  http://www.apache.org/licenses/LICENSE-2.0
//
//  Unless required by applicable law or agreed to in writing, software
//  distributed under the License is distributed on an "AS IS" BASIS,
//  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//  See the License for the specific language governing permissions and
//  limitations under the License.

import 'dart:ffi';

import 'opengl_header.dart';
import 'opengl_library.dart';

GlCullFace glCullFace = Pointer<NativeFunction<GlCullFaceNative>>.fromAddress(0).asFunction<GlCullFace>();
GlFrontFace glFrontFace = Pointer<NativeFunction<GlFrontFaceNative>>.fromAddress(0).asFunction<GlFrontFace>();
GlHint glHint = Pointer<NativeFunction<GlHintNative>>.fromAddress(0).asFunction<GlHint>();
GlLineWidth glLineWidth = Pointer<NativeFunction<GlLineWidthNative>>.fromAddress(0).asFunction<GlLineWidth>();
GlPointSize glPointSize = Pointer<NativeFunction<GlPointSizeNative>>.fromAddress(0).asFunction<GlPointSize>();
GlPolygonMode glPolygonMode = Pointer<NativeFunction<GlPolygonModeNative>>.fromAddress(0).asFunction<GlPolygonMode>();
GlScissor glScissor = Pointer<NativeFunction<GlScissorNative>>.fromAddress(0).asFunction<GlScissor>();
GlTexParameterf glTexParameterf = Pointer<NativeFunction<GlTexParameterfNative>>.fromAddress(0).asFunction<GlTexParameterf>();
GlTexParameterfv glTexParameterfv = Pointer<NativeFunction<GlTexParameterfvNative>>.fromAddress(0).asFunction<GlTexParameterfv>();
GlTexParameteri glTexParameteri = Pointer<NativeFunction<GlTexParameteriNative>>.fromAddress(0).asFunction<GlTexParameteri>();
GlTexParameteriv glTexParameteriv = Pointer<NativeFunction<GlTexParameterivNative>>.fromAddress(0).asFunction<GlTexParameteriv>();
GlTexImage1D glTexImage1D = Pointer<NativeFunction<GlTexImage1DNative>>.fromAddress(0).asFunction<GlTexImage1D>();
GlTexImage2D glTexImage2D = Pointer<NativeFunction<GlTexImage2DNative>>.fromAddress(0).asFunction<GlTexImage2D>();
GlDrawBuffer glDrawBuffer = Pointer<NativeFunction<GlDrawBufferNative>>.fromAddress(0).asFunction<GlDrawBuffer>();
GlClear glClear = Pointer<NativeFunction<GlClearNative>>.fromAddress(0).asFunction<GlClear>();
GlClearColor glClearColor = Pointer<NativeFunction<GlClearColorNative>>.fromAddress(0).asFunction<GlClearColor>();
GlClearStencil glClearStencil = Pointer<NativeFunction<GlClearStencilNative>>.fromAddress(0).asFunction<GlClearStencil>();
GlClearDepth glClearDepth = Pointer<NativeFunction<GlClearDepthNative>>.fromAddress(0).asFunction<GlClearDepth>();
GlStencilMask glStencilMask = Pointer<NativeFunction<GlStencilMaskNative>>.fromAddress(0).asFunction<GlStencilMask>();
GlColorMask glColorMask = Pointer<NativeFunction<GlColorMaskNative>>.fromAddress(0).asFunction<GlColorMask>();
GlDepthMask glDepthMask = Pointer<NativeFunction<GlDepthMaskNative>>.fromAddress(0).asFunction<GlDepthMask>();
GlDisable glDisable = Pointer<NativeFunction<GlDisableNative>>.fromAddress(0).asFunction<GlDisable>();
GlEnable glEnable = Pointer<NativeFunction<GlEnableNative>>.fromAddress(0).asFunction<GlEnable>();
GlFinish glFinish = Pointer<NativeFunction<GlFinishNative>>.fromAddress(0).asFunction<GlFinish>();
GlFlush glFlush = Pointer<NativeFunction<GlFlushNative>>.fromAddress(0).asFunction<GlFlush>();
GlBlendFunc glBlendFunc = Pointer<NativeFunction<GlBlendFuncNative>>.fromAddress(0).asFunction<GlBlendFunc>();
GlLogicOp glLogicOp = Pointer<NativeFunction<GlLogicOpNative>>.fromAddress(0).asFunction<GlLogicOp>();
GlStencilFunc glStencilFunc = Pointer<NativeFunction<GlStencilFuncNative>>.fromAddress(0).asFunction<GlStencilFunc>();
GlStencilOp glStencilOp = Pointer<NativeFunction<GlStencilOpNative>>.fromAddress(0).asFunction<GlStencilOp>();
GlDepthFunc glDepthFunc = Pointer<NativeFunction<GlDepthFuncNative>>.fromAddress(0).asFunction<GlDepthFunc>();
GlPixelStoref glPixelStoref = Pointer<NativeFunction<GlPixelStorefNative>>.fromAddress(0).asFunction<GlPixelStoref>();
GlPixelStorei glPixelStorei = Pointer<NativeFunction<GlPixelStoreiNative>>.fromAddress(0).asFunction<GlPixelStorei>();
GlReadBuffer glReadBuffer = Pointer<NativeFunction<GlReadBufferNative>>.fromAddress(0).asFunction<GlReadBuffer>();
GlReadPixels glReadPixels = Pointer<NativeFunction<GlReadPixelsNative>>.fromAddress(0).asFunction<GlReadPixels>();
GlGetBooleanv glGetBooleanv = Pointer<NativeFunction<GlGetBooleanvNative>>.fromAddress(0).asFunction<GlGetBooleanv>();
GlGetDoublev glGetDoublev = Pointer<NativeFunction<GlGetDoublevNative>>.fromAddress(0).asFunction<GlGetDoublev>();
GlGetError glGetError = Pointer<NativeFunction<GlGetErrorNative>>.fromAddress(0).asFunction<GlGetError>();
GlGetFloatv glGetFloatv = Pointer<NativeFunction<GlGetFloatvNative>>.fromAddress(0).asFunction<GlGetFloatv>();
GlGetIntegerv glGetIntegerv = Pointer<NativeFunction<GlGetIntegervNative>>.fromAddress(0).asFunction<GlGetIntegerv>();
GlGetString glGetString = Pointer<NativeFunction<GlGetStringNative>>.fromAddress(0).asFunction<GlGetString>();
GlGetTexImage glGetTexImage = Pointer<NativeFunction<GlGetTexImageNative>>.fromAddress(0).asFunction<GlGetTexImage>();
GlGetTexParameterfv glGetTexParameterfv = Pointer<NativeFunction<GlGetTexParameterfvNative>>.fromAddress(0).asFunction<GlGetTexParameterfv>();
GlGetTexParameteriv glGetTexParameteriv = Pointer<NativeFunction<GlGetTexParameterivNative>>.fromAddress(0).asFunction<GlGetTexParameteriv>();
GlGetTexLevelParameterfv glGetTexLevelParameterfv = Pointer<NativeFunction<GlGetTexLevelParameterfvNative>>.fromAddress(0).asFunction<GlGetTexLevelParameterfv>();
GlGetTexLevelParameteriv glGetTexLevelParameteriv = Pointer<NativeFunction<GlGetTexLevelParameterivNative>>.fromAddress(0).asFunction<GlGetTexLevelParameteriv>();
GlIsEnabled glIsEnabled = Pointer<NativeFunction<GlIsEnabledNative>>.fromAddress(0).asFunction<GlIsEnabled>();
GlDepthRange glDepthRange = Pointer<NativeFunction<GlDepthRangeNative>>.fromAddress(0).asFunction<GlDepthRange>();
GlViewport glViewport = Pointer<NativeFunction<GlViewportNative>>.fromAddress(0).asFunction<GlViewport>();
GlDrawArrays glDrawArrays = Pointer<NativeFunction<GlDrawArraysNative>>.fromAddress(0).asFunction<GlDrawArrays>();
GlDrawElements glDrawElements = Pointer<NativeFunction<GlDrawElementsNative>>.fromAddress(0).asFunction<GlDrawElements>();
GlGetPointerv glGetPointerv = Pointer<NativeFunction<GlGetPointervNative>>.fromAddress(0).asFunction<GlGetPointerv>();
GlPolygonOffset glPolygonOffset = Pointer<NativeFunction<GlPolygonOffsetNative>>.fromAddress(0).asFunction<GlPolygonOffset>();
GlCopyTexImage1D glCopyTexImage1D = Pointer<NativeFunction<GlCopyTexImage1DNative>>.fromAddress(0).asFunction<GlCopyTexImage1D>();
GlCopyTexImage2D glCopyTexImage2D = Pointer<NativeFunction<GlCopyTexImage2DNative>>.fromAddress(0).asFunction<GlCopyTexImage2D>();
GlCopyTexSubImage1D glCopyTexSubImage1D = Pointer<NativeFunction<GlCopyTexSubImage1DNative>>.fromAddress(0).asFunction<GlCopyTexSubImage1D>();
GlCopyTexSubImage2D glCopyTexSubImage2D = Pointer<NativeFunction<GlCopyTexSubImage2DNative>>.fromAddress(0).asFunction<GlCopyTexSubImage2D>();
GlTexSubImage1D glTexSubImage1D = Pointer<NativeFunction<GlTexSubImage1DNative>>.fromAddress(0).asFunction<GlTexSubImage1D>();
GlTexSubImage2D glTexSubImage2D = Pointer<NativeFunction<GlTexSubImage2DNative>>.fromAddress(0).asFunction<GlTexSubImage2D>();
GlBindTexture glBindTexture = Pointer<NativeFunction<GlBindTextureNative>>.fromAddress(0).asFunction<GlBindTexture>();
GlDeleteTextures glDeleteTextures = Pointer<NativeFunction<GlDeleteTexturesNative>>.fromAddress(0).asFunction<GlDeleteTextures>();
GlGenTextures glGenTextures = Pointer<NativeFunction<GlGenTexturesNative>>.fromAddress(0).asFunction<GlGenTextures>();
GlIsTexture glIsTexture = Pointer<NativeFunction<GlIsTextureNative>>.fromAddress(0).asFunction<GlIsTexture>();
GlDrawRangeElements glDrawRangeElements = Pointer<NativeFunction<GlDrawRangeElementsNative>>.fromAddress(0).asFunction<GlDrawRangeElements>();
GlTexImage3D glTexImage3D = Pointer<NativeFunction<GlTexImage3DNative>>.fromAddress(0).asFunction<GlTexImage3D>();
GlTexSubImage3D glTexSubImage3D = Pointer<NativeFunction<GlTexSubImage3DNative>>.fromAddress(0).asFunction<GlTexSubImage3D>();
GlCopyTexSubImage3D glCopyTexSubImage3D = Pointer<NativeFunction<GlCopyTexSubImage3DNative>>.fromAddress(0).asFunction<GlCopyTexSubImage3D>();
GlActiveTexture glActiveTexture = Pointer<NativeFunction<GlActiveTextureNative>>.fromAddress(0).asFunction<GlActiveTexture>();
GlSampleCoverage glSampleCoverage = Pointer<NativeFunction<GlSampleCoverageNative>>.fromAddress(0).asFunction<GlSampleCoverage>();
GlCompressedTexImage3D glCompressedTexImage3D = Pointer<NativeFunction<GlCompressedTexImage3DNative>>.fromAddress(0).asFunction<GlCompressedTexImage3D>();
GlCompressedTexImage2D glCompressedTexImage2D = Pointer<NativeFunction<GlCompressedTexImage2DNative>>.fromAddress(0).asFunction<GlCompressedTexImage2D>();
GlCompressedTexImage1D glCompressedTexImage1D = Pointer<NativeFunction<GlCompressedTexImage1DNative>>.fromAddress(0).asFunction<GlCompressedTexImage1D>();
GlCompressedTexSubImage3D glCompressedTexSubImage3D = Pointer<NativeFunction<GlCompressedTexSubImage3DNative>>.fromAddress(0).asFunction<GlCompressedTexSubImage3D>();
GlCompressedTexSubImage2D glCompressedTexSubImage2D = Pointer<NativeFunction<GlCompressedTexSubImage2DNative>>.fromAddress(0).asFunction<GlCompressedTexSubImage2D>();
GlCompressedTexSubImage1D glCompressedTexSubImage1D = Pointer<NativeFunction<GlCompressedTexSubImage1DNative>>.fromAddress(0).asFunction<GlCompressedTexSubImage1D>();
GlGetCompressedTexImage glGetCompressedTexImage = Pointer<NativeFunction<GlGetCompressedTexImageNative>>.fromAddress(0).asFunction<GlGetCompressedTexImage>();
GlBlendFuncSeparate glBlendFuncSeparate = Pointer<NativeFunction<GlBlendFuncSeparateNative>>.fromAddress(0).asFunction<GlBlendFuncSeparate>();
GlMultiDrawArrays glMultiDrawArrays = Pointer<NativeFunction<GlMultiDrawArraysNative>>.fromAddress(0).asFunction<GlMultiDrawArrays>();
GlMultiDrawElements glMultiDrawElements = Pointer<NativeFunction<GlMultiDrawElementsNative>>.fromAddress(0).asFunction<GlMultiDrawElements>();
GlPointParameterf glPointParameterf = Pointer<NativeFunction<GlPointParameterfNative>>.fromAddress(0).asFunction<GlPointParameterf>();
GlPointParameterfv glPointParameterfv = Pointer<NativeFunction<GlPointParameterfvNative>>.fromAddress(0).asFunction<GlPointParameterfv>();
GlPointParameteri glPointParameteri = Pointer<NativeFunction<GlPointParameteriNative>>.fromAddress(0).asFunction<GlPointParameteri>();
GlPointParameteriv glPointParameteriv = Pointer<NativeFunction<GlPointParameterivNative>>.fromAddress(0).asFunction<GlPointParameteriv>();
GlBlendColor glBlendColor = Pointer<NativeFunction<GlBlendColorNative>>.fromAddress(0).asFunction<GlBlendColor>();
GlBlendEquation glBlendEquation = Pointer<NativeFunction<GlBlendEquationNative>>.fromAddress(0).asFunction<GlBlendEquation>();
GlGenQueries glGenQueries = Pointer<NativeFunction<GlGenQueriesNative>>.fromAddress(0).asFunction<GlGenQueries>();
GlDeleteQueries glDeleteQueries = Pointer<NativeFunction<GlDeleteQueriesNative>>.fromAddress(0).asFunction<GlDeleteQueries>();
GlIsQuery glIsQuery = Pointer<NativeFunction<GlIsQueryNative>>.fromAddress(0).asFunction<GlIsQuery>();
GlBeginQuery glBeginQuery = Pointer<NativeFunction<GlBeginQueryNative>>.fromAddress(0).asFunction<GlBeginQuery>();
GlEndQuery glEndQuery = Pointer<NativeFunction<GlEndQueryNative>>.fromAddress(0).asFunction<GlEndQuery>();
GlGetQueryiv glGetQueryiv = Pointer<NativeFunction<GlGetQueryivNative>>.fromAddress(0).asFunction<GlGetQueryiv>();
GlGetQueryObjectiv glGetQueryObjectiv = Pointer<NativeFunction<GlGetQueryObjectivNative>>.fromAddress(0).asFunction<GlGetQueryObjectiv>();
GlGetQueryObjectuiv glGetQueryObjectuiv = Pointer<NativeFunction<GlGetQueryObjectuivNative>>.fromAddress(0).asFunction<GlGetQueryObjectuiv>();
GlBindBuffer glBindBuffer = Pointer<NativeFunction<GlBindBufferNative>>.fromAddress(0).asFunction<GlBindBuffer>();
GlDeleteBuffers glDeleteBuffers = Pointer<NativeFunction<GlDeleteBuffersNative>>.fromAddress(0).asFunction<GlDeleteBuffers>();
GlGenBuffers glGenBuffers = Pointer<NativeFunction<GlGenBuffersNative>>.fromAddress(0).asFunction<GlGenBuffers>();
GlIsBuffer glIsBuffer = Pointer<NativeFunction<GlIsBufferNative>>.fromAddress(0).asFunction<GlIsBuffer>();
GlBufferData glBufferData = Pointer<NativeFunction<GlBufferDataNative>>.fromAddress(0).asFunction<GlBufferData>();
GlBufferSubData glBufferSubData = Pointer<NativeFunction<GlBufferSubDataNative>>.fromAddress(0).asFunction<GlBufferSubData>();
GlGetBufferSubData glGetBufferSubData = Pointer<NativeFunction<GlGetBufferSubDataNative>>.fromAddress(0).asFunction<GlGetBufferSubData>();
GlMapBuffer glMapBuffer = Pointer<NativeFunction<GlMapBufferNative>>.fromAddress(0).asFunction<GlMapBuffer>();
GlUnmapBuffer glUnmapBuffer = Pointer<NativeFunction<GlUnmapBufferNative>>.fromAddress(0).asFunction<GlUnmapBuffer>();
GlGetBufferParameteriv glGetBufferParameteriv = Pointer<NativeFunction<GlGetBufferParameterivNative>>.fromAddress(0).asFunction<GlGetBufferParameteriv>();
GlGetBufferPointerv glGetBufferPointerv = Pointer<NativeFunction<GlGetBufferPointervNative>>.fromAddress(0).asFunction<GlGetBufferPointerv>();
GlBlendEquationSeparate glBlendEquationSeparate = Pointer<NativeFunction<GlBlendEquationSeparateNative>>.fromAddress(0).asFunction<GlBlendEquationSeparate>();
GlDrawBuffers glDrawBuffers = Pointer<NativeFunction<GlDrawBuffersNative>>.fromAddress(0).asFunction<GlDrawBuffers>();
GlStencilOpSeparate glStencilOpSeparate = Pointer<NativeFunction<GlStencilOpSeparateNative>>.fromAddress(0).asFunction<GlStencilOpSeparate>();
GlStencilFuncSeparate glStencilFuncSeparate = Pointer<NativeFunction<GlStencilFuncSeparateNative>>.fromAddress(0).asFunction<GlStencilFuncSeparate>();
GlStencilMaskSeparate glStencilMaskSeparate = Pointer<NativeFunction<GlStencilMaskSeparateNative>>.fromAddress(0).asFunction<GlStencilMaskSeparate>();
GlAttachShader glAttachShader = Pointer<NativeFunction<GlAttachShaderNative>>.fromAddress(0).asFunction<GlAttachShader>();
GlBindAttribLocation glBindAttribLocation = Pointer<NativeFunction<GlBindAttribLocationNative>>.fromAddress(0).asFunction<GlBindAttribLocation>();
GlCompileShader glCompileShader = Pointer<NativeFunction<GlCompileShaderNative>>.fromAddress(0).asFunction<GlCompileShader>();
GlCreateProgram glCreateProgram = Pointer<NativeFunction<GlCreateProgramNative>>.fromAddress(0).asFunction<GlCreateProgram>();
GlCreateShader glCreateShader = Pointer<NativeFunction<GlCreateShaderNative>>.fromAddress(0).asFunction<GlCreateShader>();
GlDeleteProgram glDeleteProgram = Pointer<NativeFunction<GlDeleteProgramNative>>.fromAddress(0).asFunction<GlDeleteProgram>();
GlDeleteShader glDeleteShader = Pointer<NativeFunction<GlDeleteShaderNative>>.fromAddress(0).asFunction<GlDeleteShader>();
GlDetachShader glDetachShader = Pointer<NativeFunction<GlDetachShaderNative>>.fromAddress(0).asFunction<GlDetachShader>();
GlDisableVertexAttribArray glDisableVertexAttribArray = Pointer<NativeFunction<GlDisableVertexAttribArrayNative>>.fromAddress(0).asFunction<GlDisableVertexAttribArray>();
GlEnableVertexAttribArray glEnableVertexAttribArray = Pointer<NativeFunction<GlEnableVertexAttribArrayNative>>.fromAddress(0).asFunction<GlEnableVertexAttribArray>();
GlGetActiveAttrib glGetActiveAttrib = Pointer<NativeFunction<GlGetActiveAttribNative>>.fromAddress(0).asFunction<GlGetActiveAttrib>();
GlGetActiveUniform glGetActiveUniform = Pointer<NativeFunction<GlGetActiveUniformNative>>.fromAddress(0).asFunction<GlGetActiveUniform>();
GlGetAttachedShaders glGetAttachedShaders = Pointer<NativeFunction<GlGetAttachedShadersNative>>.fromAddress(0).asFunction<GlGetAttachedShaders>();
GlGetAttribLocation glGetAttribLocation = Pointer<NativeFunction<GlGetAttribLocationNative>>.fromAddress(0).asFunction<GlGetAttribLocation>();
GlGetProgramiv glGetProgramiv = Pointer<NativeFunction<GlGetProgramivNative>>.fromAddress(0).asFunction<GlGetProgramiv>();
GlGetProgramInfoLog glGetProgramInfoLog = Pointer<NativeFunction<GlGetProgramInfoLogNative>>.fromAddress(0).asFunction<GlGetProgramInfoLog>();
GlGetShaderiv glGetShaderiv = Pointer<NativeFunction<GlGetShaderivNative>>.fromAddress(0).asFunction<GlGetShaderiv>();
GlGetShaderInfoLog glGetShaderInfoLog = Pointer<NativeFunction<GlGetShaderInfoLogNative>>.fromAddress(0).asFunction<GlGetShaderInfoLog>();
GlGetShaderSource glGetShaderSource = Pointer<NativeFunction<GlGetShaderSourceNative>>.fromAddress(0).asFunction<GlGetShaderSource>();
GlGetUniformLocation glGetUniformLocation = Pointer<NativeFunction<GlGetUniformLocationNative>>.fromAddress(0).asFunction<GlGetUniformLocation>();
GlGetUniformfv glGetUniformfv = Pointer<NativeFunction<GlGetUniformfvNative>>.fromAddress(0).asFunction<GlGetUniformfv>();
GlGetUniformiv glGetUniformiv = Pointer<NativeFunction<GlGetUniformivNative>>.fromAddress(0).asFunction<GlGetUniformiv>();
GlGetVertexAttribdv glGetVertexAttribdv = Pointer<NativeFunction<GlGetVertexAttribdvNative>>.fromAddress(0).asFunction<GlGetVertexAttribdv>();
GlGetVertexAttribfv glGetVertexAttribfv = Pointer<NativeFunction<GlGetVertexAttribfvNative>>.fromAddress(0).asFunction<GlGetVertexAttribfv>();
GlGetVertexAttribiv glGetVertexAttribiv = Pointer<NativeFunction<GlGetVertexAttribivNative>>.fromAddress(0).asFunction<GlGetVertexAttribiv>();
GlGetVertexAttribPointerv glGetVertexAttribPointerv = Pointer<NativeFunction<GlGetVertexAttribPointervNative>>.fromAddress(0).asFunction<GlGetVertexAttribPointerv>();
GlIsProgram glIsProgram = Pointer<NativeFunction<GlIsProgramNative>>.fromAddress(0).asFunction<GlIsProgram>();
GlIsShader glIsShader = Pointer<NativeFunction<GlIsShaderNative>>.fromAddress(0).asFunction<GlIsShader>();
GlLinkProgram glLinkProgram = Pointer<NativeFunction<GlLinkProgramNative>>.fromAddress(0).asFunction<GlLinkProgram>();
GlShaderSource glShaderSource = Pointer<NativeFunction<GlShaderSourceNative>>.fromAddress(0).asFunction<GlShaderSource>();
GlUseProgram glUseProgram = Pointer<NativeFunction<GlUseProgramNative>>.fromAddress(0).asFunction<GlUseProgram>();
GlUniform1f glUniform1f = Pointer<NativeFunction<GlUniform1fNative>>.fromAddress(0).asFunction<GlUniform1f>();
GlUniform2f glUniform2f = Pointer<NativeFunction<GlUniform2fNative>>.fromAddress(0).asFunction<GlUniform2f>();
GlUniform3f glUniform3f = Pointer<NativeFunction<GlUniform3fNative>>.fromAddress(0).asFunction<GlUniform3f>();
GlUniform4f glUniform4f = Pointer<NativeFunction<GlUniform4fNative>>.fromAddress(0).asFunction<GlUniform4f>();
GlUniform1i glUniform1i = Pointer<NativeFunction<GlUniform1iNative>>.fromAddress(0).asFunction<GlUniform1i>();
GlUniform2i glUniform2i = Pointer<NativeFunction<GlUniform2iNative>>.fromAddress(0).asFunction<GlUniform2i>();
GlUniform3i glUniform3i = Pointer<NativeFunction<GlUniform3iNative>>.fromAddress(0).asFunction<GlUniform3i>();
GlUniform4i glUniform4i = Pointer<NativeFunction<GlUniform4iNative>>.fromAddress(0).asFunction<GlUniform4i>();
GlUniform1fv glUniform1fv = Pointer<NativeFunction<GlUniform1fvNative>>.fromAddress(0).asFunction<GlUniform1fv>();
GlUniform2fv glUniform2fv = Pointer<NativeFunction<GlUniform2fvNative>>.fromAddress(0).asFunction<GlUniform2fv>();
GlUniform3fv glUniform3fv = Pointer<NativeFunction<GlUniform3fvNative>>.fromAddress(0).asFunction<GlUniform3fv>();
GlUniform4fv glUniform4fv = Pointer<NativeFunction<GlUniform4fvNative>>.fromAddress(0).asFunction<GlUniform4fv>();
GlUniform1iv glUniform1iv = Pointer<NativeFunction<GlUniform1ivNative>>.fromAddress(0).asFunction<GlUniform1iv>();
GlUniform2iv glUniform2iv = Pointer<NativeFunction<GlUniform2ivNative>>.fromAddress(0).asFunction<GlUniform2iv>();
GlUniform3iv glUniform3iv = Pointer<NativeFunction<GlUniform3ivNative>>.fromAddress(0).asFunction<GlUniform3iv>();
GlUniform4iv glUniform4iv = Pointer<NativeFunction<GlUniform4ivNative>>.fromAddress(0).asFunction<GlUniform4iv>();
GlUniformMatrix2fv glUniformMatrix2fv = Pointer<NativeFunction<GlUniformMatrix2fvNative>>.fromAddress(0).asFunction<GlUniformMatrix2fv>();
GlUniformMatrix3fv glUniformMatrix3fv = Pointer<NativeFunction<GlUniformMatrix3fvNative>>.fromAddress(0).asFunction<GlUniformMatrix3fv>();
GlUniformMatrix4fv glUniformMatrix4fv = Pointer<NativeFunction<GlUniformMatrix4fvNative>>.fromAddress(0).asFunction<GlUniformMatrix4fv>();
GlValidateProgram glValidateProgram = Pointer<NativeFunction<GlValidateProgramNative>>.fromAddress(0).asFunction<GlValidateProgram>();
GlVertexAttrib1d glVertexAttrib1d = Pointer<NativeFunction<GlVertexAttrib1dNative>>.fromAddress(0).asFunction<GlVertexAttrib1d>();
GlVertexAttrib1dv glVertexAttrib1dv = Pointer<NativeFunction<GlVertexAttrib1dvNative>>.fromAddress(0).asFunction<GlVertexAttrib1dv>();
GlVertexAttrib1f glVertexAttrib1f = Pointer<NativeFunction<GlVertexAttrib1fNative>>.fromAddress(0).asFunction<GlVertexAttrib1f>();
GlVertexAttrib1fv glVertexAttrib1fv = Pointer<NativeFunction<GlVertexAttrib1fvNative>>.fromAddress(0).asFunction<GlVertexAttrib1fv>();
GlVertexAttrib1s glVertexAttrib1s = Pointer<NativeFunction<GlVertexAttrib1sNative>>.fromAddress(0).asFunction<GlVertexAttrib1s>();
GlVertexAttrib1sv glVertexAttrib1sv = Pointer<NativeFunction<GlVertexAttrib1svNative>>.fromAddress(0).asFunction<GlVertexAttrib1sv>();
GlVertexAttrib2d glVertexAttrib2d = Pointer<NativeFunction<GlVertexAttrib2dNative>>.fromAddress(0).asFunction<GlVertexAttrib2d>();
GlVertexAttrib2dv glVertexAttrib2dv = Pointer<NativeFunction<GlVertexAttrib2dvNative>>.fromAddress(0).asFunction<GlVertexAttrib2dv>();
GlVertexAttrib2f glVertexAttrib2f = Pointer<NativeFunction<GlVertexAttrib2fNative>>.fromAddress(0).asFunction<GlVertexAttrib2f>();
GlVertexAttrib2fv glVertexAttrib2fv = Pointer<NativeFunction<GlVertexAttrib2fvNative>>.fromAddress(0).asFunction<GlVertexAttrib2fv>();
GlVertexAttrib2s glVertexAttrib2s = Pointer<NativeFunction<GlVertexAttrib2sNative>>.fromAddress(0).asFunction<GlVertexAttrib2s>();
GlVertexAttrib2sv glVertexAttrib2sv = Pointer<NativeFunction<GlVertexAttrib2svNative>>.fromAddress(0).asFunction<GlVertexAttrib2sv>();
GlVertexAttrib3d glVertexAttrib3d = Pointer<NativeFunction<GlVertexAttrib3dNative>>.fromAddress(0).asFunction<GlVertexAttrib3d>();
GlVertexAttrib3dv glVertexAttrib3dv = Pointer<NativeFunction<GlVertexAttrib3dvNative>>.fromAddress(0).asFunction<GlVertexAttrib3dv>();
GlVertexAttrib3f glVertexAttrib3f = Pointer<NativeFunction<GlVertexAttrib3fNative>>.fromAddress(0).asFunction<GlVertexAttrib3f>();
GlVertexAttrib3fv glVertexAttrib3fv = Pointer<NativeFunction<GlVertexAttrib3fvNative>>.fromAddress(0).asFunction<GlVertexAttrib3fv>();
GlVertexAttrib3s glVertexAttrib3s = Pointer<NativeFunction<GlVertexAttrib3sNative>>.fromAddress(0).asFunction<GlVertexAttrib3s>();
GlVertexAttrib3sv glVertexAttrib3sv = Pointer<NativeFunction<GlVertexAttrib3svNative>>.fromAddress(0).asFunction<GlVertexAttrib3sv>();
GlVertexAttrib4Nbv glVertexAttrib4Nbv = Pointer<NativeFunction<GlVertexAttrib4NbvNative>>.fromAddress(0).asFunction<GlVertexAttrib4Nbv>();
GlVertexAttrib4Niv glVertexAttrib4Niv = Pointer<NativeFunction<GlVertexAttrib4NivNative>>.fromAddress(0).asFunction<GlVertexAttrib4Niv>();
GlVertexAttrib4Nsv glVertexAttrib4Nsv = Pointer<NativeFunction<GlVertexAttrib4NsvNative>>.fromAddress(0).asFunction<GlVertexAttrib4Nsv>();
GlVertexAttrib4Nub glVertexAttrib4Nub = Pointer<NativeFunction<GlVertexAttrib4NubNative>>.fromAddress(0).asFunction<GlVertexAttrib4Nub>();
GlVertexAttrib4Nubv glVertexAttrib4Nubv = Pointer<NativeFunction<GlVertexAttrib4NubvNative>>.fromAddress(0).asFunction<GlVertexAttrib4Nubv>();
GlVertexAttrib4Nuiv glVertexAttrib4Nuiv = Pointer<NativeFunction<GlVertexAttrib4NuivNative>>.fromAddress(0).asFunction<GlVertexAttrib4Nuiv>();
GlVertexAttrib4Nusv glVertexAttrib4Nusv = Pointer<NativeFunction<GlVertexAttrib4NusvNative>>.fromAddress(0).asFunction<GlVertexAttrib4Nusv>();
GlVertexAttrib4bv glVertexAttrib4bv = Pointer<NativeFunction<GlVertexAttrib4bvNative>>.fromAddress(0).asFunction<GlVertexAttrib4bv>();
GlVertexAttrib4d glVertexAttrib4d = Pointer<NativeFunction<GlVertexAttrib4dNative>>.fromAddress(0).asFunction<GlVertexAttrib4d>();
GlVertexAttrib4dv glVertexAttrib4dv = Pointer<NativeFunction<GlVertexAttrib4dvNative>>.fromAddress(0).asFunction<GlVertexAttrib4dv>();
GlVertexAttrib4f glVertexAttrib4f = Pointer<NativeFunction<GlVertexAttrib4fNative>>.fromAddress(0).asFunction<GlVertexAttrib4f>();
GlVertexAttrib4fv glVertexAttrib4fv = Pointer<NativeFunction<GlVertexAttrib4fvNative>>.fromAddress(0).asFunction<GlVertexAttrib4fv>();
GlVertexAttrib4iv glVertexAttrib4iv = Pointer<NativeFunction<GlVertexAttrib4ivNative>>.fromAddress(0).asFunction<GlVertexAttrib4iv>();
GlVertexAttrib4s glVertexAttrib4s = Pointer<NativeFunction<GlVertexAttrib4sNative>>.fromAddress(0).asFunction<GlVertexAttrib4s>();
GlVertexAttrib4sv glVertexAttrib4sv = Pointer<NativeFunction<GlVertexAttrib4svNative>>.fromAddress(0).asFunction<GlVertexAttrib4sv>();
GlVertexAttrib4ubv glVertexAttrib4ubv = Pointer<NativeFunction<GlVertexAttrib4ubvNative>>.fromAddress(0).asFunction<GlVertexAttrib4ubv>();
GlVertexAttrib4uiv glVertexAttrib4uiv = Pointer<NativeFunction<GlVertexAttrib4uivNative>>.fromAddress(0).asFunction<GlVertexAttrib4uiv>();
GlVertexAttrib4usv glVertexAttrib4usv = Pointer<NativeFunction<GlVertexAttrib4usvNative>>.fromAddress(0).asFunction<GlVertexAttrib4usv>();
GlVertexAttribPointer glVertexAttribPointer = Pointer<NativeFunction<GlVertexAttribPointerNative>>.fromAddress(0).asFunction<GlVertexAttribPointer>();
GlUniformMatrix2x3fv glUniformMatrix2x3fv = Pointer<NativeFunction<GlUniformMatrix2x3fvNative>>.fromAddress(0).asFunction<GlUniformMatrix2x3fv>();
GlUniformMatrix3x2fv glUniformMatrix3x2fv = Pointer<NativeFunction<GlUniformMatrix3x2fvNative>>.fromAddress(0).asFunction<GlUniformMatrix3x2fv>();
GlUniformMatrix2x4fv glUniformMatrix2x4fv = Pointer<NativeFunction<GlUniformMatrix2x4fvNative>>.fromAddress(0).asFunction<GlUniformMatrix2x4fv>();
GlUniformMatrix4x2fv glUniformMatrix4x2fv = Pointer<NativeFunction<GlUniformMatrix4x2fvNative>>.fromAddress(0).asFunction<GlUniformMatrix4x2fv>();
GlUniformMatrix3x4fv glUniformMatrix3x4fv = Pointer<NativeFunction<GlUniformMatrix3x4fvNative>>.fromAddress(0).asFunction<GlUniformMatrix3x4fv>();
GlUniformMatrix4x3fv glUniformMatrix4x3fv = Pointer<NativeFunction<GlUniformMatrix4x3fvNative>>.fromAddress(0).asFunction<GlUniformMatrix4x3fv>();
GlColorMaski glColorMaski = Pointer<NativeFunction<GlColorMaskiNative>>.fromAddress(0).asFunction<GlColorMaski>();
GlGetBooleani_v glGetBooleani_v = Pointer<NativeFunction<GlGetBooleani_vNative>>.fromAddress(0).asFunction<GlGetBooleani_v>();
GlGetIntegeri_v glGetIntegeri_v = Pointer<NativeFunction<GlGetIntegeri_vNative>>.fromAddress(0).asFunction<GlGetIntegeri_v>();
GlEnablei glEnablei = Pointer<NativeFunction<GlEnableiNative>>.fromAddress(0).asFunction<GlEnablei>();
GlDisablei glDisablei = Pointer<NativeFunction<GlDisableiNative>>.fromAddress(0).asFunction<GlDisablei>();
GlIsEnabledi glIsEnabledi = Pointer<NativeFunction<GlIsEnablediNative>>.fromAddress(0).asFunction<GlIsEnabledi>();
GlBeginTransformFeedback glBeginTransformFeedback = Pointer<NativeFunction<GlBeginTransformFeedbackNative>>.fromAddress(0).asFunction<GlBeginTransformFeedback>();
GlEndTransformFeedback glEndTransformFeedback = Pointer<NativeFunction<GlEndTransformFeedbackNative>>.fromAddress(0).asFunction<GlEndTransformFeedback>();
GlBindBufferRange glBindBufferRange = Pointer<NativeFunction<GlBindBufferRangeNative>>.fromAddress(0).asFunction<GlBindBufferRange>();
GlBindBufferBase glBindBufferBase = Pointer<NativeFunction<GlBindBufferBaseNative>>.fromAddress(0).asFunction<GlBindBufferBase>();
GlTransformFeedbackVaryings glTransformFeedbackVaryings = Pointer<NativeFunction<GlTransformFeedbackVaryingsNative>>.fromAddress(0).asFunction<GlTransformFeedbackVaryings>();
GlGetTransformFeedbackVarying glGetTransformFeedbackVarying = Pointer<NativeFunction<GlGetTransformFeedbackVaryingNative>>.fromAddress(0).asFunction<GlGetTransformFeedbackVarying>();
GlClampColor glClampColor = Pointer<NativeFunction<GlClampColorNative>>.fromAddress(0).asFunction<GlClampColor>();
GlBeginConditionalRender glBeginConditionalRender = Pointer<NativeFunction<GlBeginConditionalRenderNative>>.fromAddress(0).asFunction<GlBeginConditionalRender>();
GlEndConditionalRender glEndConditionalRender = Pointer<NativeFunction<GlEndConditionalRenderNative>>.fromAddress(0).asFunction<GlEndConditionalRender>();
GlVertexAttribIPointer glVertexAttribIPointer = Pointer<NativeFunction<GlVertexAttribIPointerNative>>.fromAddress(0).asFunction<GlVertexAttribIPointer>();
GlGetVertexAttribIiv glGetVertexAttribIiv = Pointer<NativeFunction<GlGetVertexAttribIivNative>>.fromAddress(0).asFunction<GlGetVertexAttribIiv>();
GlGetVertexAttribIuiv glGetVertexAttribIuiv = Pointer<NativeFunction<GlGetVertexAttribIuivNative>>.fromAddress(0).asFunction<GlGetVertexAttribIuiv>();
GlVertexAttribI1i glVertexAttribI1i = Pointer<NativeFunction<GlVertexAttribI1iNative>>.fromAddress(0).asFunction<GlVertexAttribI1i>();
GlVertexAttribI2i glVertexAttribI2i = Pointer<NativeFunction<GlVertexAttribI2iNative>>.fromAddress(0).asFunction<GlVertexAttribI2i>();
GlVertexAttribI3i glVertexAttribI3i = Pointer<NativeFunction<GlVertexAttribI3iNative>>.fromAddress(0).asFunction<GlVertexAttribI3i>();
GlVertexAttribI4i glVertexAttribI4i = Pointer<NativeFunction<GlVertexAttribI4iNative>>.fromAddress(0).asFunction<GlVertexAttribI4i>();
GlVertexAttribI1ui glVertexAttribI1ui = Pointer<NativeFunction<GlVertexAttribI1uiNative>>.fromAddress(0).asFunction<GlVertexAttribI1ui>();
GlVertexAttribI2ui glVertexAttribI2ui = Pointer<NativeFunction<GlVertexAttribI2uiNative>>.fromAddress(0).asFunction<GlVertexAttribI2ui>();
GlVertexAttribI3ui glVertexAttribI3ui = Pointer<NativeFunction<GlVertexAttribI3uiNative>>.fromAddress(0).asFunction<GlVertexAttribI3ui>();
GlVertexAttribI4ui glVertexAttribI4ui = Pointer<NativeFunction<GlVertexAttribI4uiNative>>.fromAddress(0).asFunction<GlVertexAttribI4ui>();
GlVertexAttribI1iv glVertexAttribI1iv = Pointer<NativeFunction<GlVertexAttribI1ivNative>>.fromAddress(0).asFunction<GlVertexAttribI1iv>();
GlVertexAttribI2iv glVertexAttribI2iv = Pointer<NativeFunction<GlVertexAttribI2ivNative>>.fromAddress(0).asFunction<GlVertexAttribI2iv>();
GlVertexAttribI3iv glVertexAttribI3iv = Pointer<NativeFunction<GlVertexAttribI3ivNative>>.fromAddress(0).asFunction<GlVertexAttribI3iv>();
GlVertexAttribI4iv glVertexAttribI4iv = Pointer<NativeFunction<GlVertexAttribI4ivNative>>.fromAddress(0).asFunction<GlVertexAttribI4iv>();
GlVertexAttribI1uiv glVertexAttribI1uiv = Pointer<NativeFunction<GlVertexAttribI1uivNative>>.fromAddress(0).asFunction<GlVertexAttribI1uiv>();
GlVertexAttribI2uiv glVertexAttribI2uiv = Pointer<NativeFunction<GlVertexAttribI2uivNative>>.fromAddress(0).asFunction<GlVertexAttribI2uiv>();
GlVertexAttribI3uiv glVertexAttribI3uiv = Pointer<NativeFunction<GlVertexAttribI3uivNative>>.fromAddress(0).asFunction<GlVertexAttribI3uiv>();
GlVertexAttribI4uiv glVertexAttribI4uiv = Pointer<NativeFunction<GlVertexAttribI4uivNative>>.fromAddress(0).asFunction<GlVertexAttribI4uiv>();
GlVertexAttribI4bv glVertexAttribI4bv = Pointer<NativeFunction<GlVertexAttribI4bvNative>>.fromAddress(0).asFunction<GlVertexAttribI4bv>();
GlVertexAttribI4sv glVertexAttribI4sv = Pointer<NativeFunction<GlVertexAttribI4svNative>>.fromAddress(0).asFunction<GlVertexAttribI4sv>();
GlVertexAttribI4ubv glVertexAttribI4ubv = Pointer<NativeFunction<GlVertexAttribI4ubvNative>>.fromAddress(0).asFunction<GlVertexAttribI4ubv>();
GlVertexAttribI4usv glVertexAttribI4usv = Pointer<NativeFunction<GlVertexAttribI4usvNative>>.fromAddress(0).asFunction<GlVertexAttribI4usv>();
GlGetUniformuiv glGetUniformuiv = Pointer<NativeFunction<GlGetUniformuivNative>>.fromAddress(0).asFunction<GlGetUniformuiv>();
GlBindFragDataLocation glBindFragDataLocation = Pointer<NativeFunction<GlBindFragDataLocationNative>>.fromAddress(0).asFunction<GlBindFragDataLocation>();
GlGetFragDataLocation glGetFragDataLocation = Pointer<NativeFunction<GlGetFragDataLocationNative>>.fromAddress(0).asFunction<GlGetFragDataLocation>();
GlUniform1ui glUniform1ui = Pointer<NativeFunction<GlUniform1uiNative>>.fromAddress(0).asFunction<GlUniform1ui>();
GlUniform2ui glUniform2ui = Pointer<NativeFunction<GlUniform2uiNative>>.fromAddress(0).asFunction<GlUniform2ui>();
GlUniform3ui glUniform3ui = Pointer<NativeFunction<GlUniform3uiNative>>.fromAddress(0).asFunction<GlUniform3ui>();
GlUniform4ui glUniform4ui = Pointer<NativeFunction<GlUniform4uiNative>>.fromAddress(0).asFunction<GlUniform4ui>();
GlUniform1uiv glUniform1uiv = Pointer<NativeFunction<GlUniform1uivNative>>.fromAddress(0).asFunction<GlUniform1uiv>();
GlUniform2uiv glUniform2uiv = Pointer<NativeFunction<GlUniform2uivNative>>.fromAddress(0).asFunction<GlUniform2uiv>();
GlUniform3uiv glUniform3uiv = Pointer<NativeFunction<GlUniform3uivNative>>.fromAddress(0).asFunction<GlUniform3uiv>();
GlUniform4uiv glUniform4uiv = Pointer<NativeFunction<GlUniform4uivNative>>.fromAddress(0).asFunction<GlUniform4uiv>();
GlTexParameterIiv glTexParameterIiv = Pointer<NativeFunction<GlTexParameterIivNative>>.fromAddress(0).asFunction<GlTexParameterIiv>();
GlTexParameterIuiv glTexParameterIuiv = Pointer<NativeFunction<GlTexParameterIuivNative>>.fromAddress(0).asFunction<GlTexParameterIuiv>();
GlGetTexParameterIiv glGetTexParameterIiv = Pointer<NativeFunction<GlGetTexParameterIivNative>>.fromAddress(0).asFunction<GlGetTexParameterIiv>();
GlGetTexParameterIuiv glGetTexParameterIuiv = Pointer<NativeFunction<GlGetTexParameterIuivNative>>.fromAddress(0).asFunction<GlGetTexParameterIuiv>();
GlClearBufferiv glClearBufferiv = Pointer<NativeFunction<GlClearBufferivNative>>.fromAddress(0).asFunction<GlClearBufferiv>();
GlClearBufferuiv glClearBufferuiv = Pointer<NativeFunction<GlClearBufferuivNative>>.fromAddress(0).asFunction<GlClearBufferuiv>();
GlClearBufferfv glClearBufferfv = Pointer<NativeFunction<GlClearBufferfvNative>>.fromAddress(0).asFunction<GlClearBufferfv>();
GlClearBufferfi glClearBufferfi = Pointer<NativeFunction<GlClearBufferfiNative>>.fromAddress(0).asFunction<GlClearBufferfi>();
GlGetStringi glGetStringi = Pointer<NativeFunction<GlGetStringiNative>>.fromAddress(0).asFunction<GlGetStringi>();
GlIsRenderbuffer glIsRenderbuffer = Pointer<NativeFunction<GlIsRenderbufferNative>>.fromAddress(0).asFunction<GlIsRenderbuffer>();
GlBindRenderbuffer glBindRenderbuffer = Pointer<NativeFunction<GlBindRenderbufferNative>>.fromAddress(0).asFunction<GlBindRenderbuffer>();
GlDeleteRenderbuffers glDeleteRenderbuffers = Pointer<NativeFunction<GlDeleteRenderbuffersNative>>.fromAddress(0).asFunction<GlDeleteRenderbuffers>();
GlGenRenderbuffers glGenRenderbuffers = Pointer<NativeFunction<GlGenRenderbuffersNative>>.fromAddress(0).asFunction<GlGenRenderbuffers>();
GlRenderbufferStorage glRenderbufferStorage = Pointer<NativeFunction<GlRenderbufferStorageNative>>.fromAddress(0).asFunction<GlRenderbufferStorage>();
GlGetRenderbufferParameteriv glGetRenderbufferParameteriv = Pointer<NativeFunction<GlGetRenderbufferParameterivNative>>.fromAddress(0).asFunction<GlGetRenderbufferParameteriv>();
GlIsFramebuffer glIsFramebuffer = Pointer<NativeFunction<GlIsFramebufferNative>>.fromAddress(0).asFunction<GlIsFramebuffer>();
GlBindFramebuffer glBindFramebuffer = Pointer<NativeFunction<GlBindFramebufferNative>>.fromAddress(0).asFunction<GlBindFramebuffer>();
GlDeleteFramebuffers glDeleteFramebuffers = Pointer<NativeFunction<GlDeleteFramebuffersNative>>.fromAddress(0).asFunction<GlDeleteFramebuffers>();
GlGenFramebuffers glGenFramebuffers = Pointer<NativeFunction<GlGenFramebuffersNative>>.fromAddress(0).asFunction<GlGenFramebuffers>();
GlCheckFramebufferStatus glCheckFramebufferStatus = Pointer<NativeFunction<GlCheckFramebufferStatusNative>>.fromAddress(0).asFunction<GlCheckFramebufferStatus>();
GlFramebufferTexture1D glFramebufferTexture1D = Pointer<NativeFunction<GlFramebufferTexture1DNative>>.fromAddress(0).asFunction<GlFramebufferTexture1D>();
GlFramebufferTexture2D glFramebufferTexture2D = Pointer<NativeFunction<GlFramebufferTexture2DNative>>.fromAddress(0).asFunction<GlFramebufferTexture2D>();
GlFramebufferTexture3D glFramebufferTexture3D = Pointer<NativeFunction<GlFramebufferTexture3DNative>>.fromAddress(0).asFunction<GlFramebufferTexture3D>();
GlFramebufferRenderbuffer glFramebufferRenderbuffer = Pointer<NativeFunction<GlFramebufferRenderbufferNative>>.fromAddress(0).asFunction<GlFramebufferRenderbuffer>();
GlGetFramebufferAttachmentParameteriv glGetFramebufferAttachmentParameteriv = Pointer<NativeFunction<GlGetFramebufferAttachmentParameterivNative>>.fromAddress(0).asFunction<GlGetFramebufferAttachmentParameteriv>();
GlGenerateMipmap glGenerateMipmap = Pointer<NativeFunction<GlGenerateMipmapNative>>.fromAddress(0).asFunction<GlGenerateMipmap>();
GlBlitFramebuffer glBlitFramebuffer = Pointer<NativeFunction<GlBlitFramebufferNative>>.fromAddress(0).asFunction<GlBlitFramebuffer>();
GlRenderbufferStorageMultisample glRenderbufferStorageMultisample = Pointer<NativeFunction<GlRenderbufferStorageMultisampleNative>>.fromAddress(0).asFunction<GlRenderbufferStorageMultisample>();
GlFramebufferTextureLayer glFramebufferTextureLayer = Pointer<NativeFunction<GlFramebufferTextureLayerNative>>.fromAddress(0).asFunction<GlFramebufferTextureLayer>();
GlMapBufferRange glMapBufferRange = Pointer<NativeFunction<GlMapBufferRangeNative>>.fromAddress(0).asFunction<GlMapBufferRange>();
GlFlushMappedBufferRange glFlushMappedBufferRange = Pointer<NativeFunction<GlFlushMappedBufferRangeNative>>.fromAddress(0).asFunction<GlFlushMappedBufferRange>();
GlBindVertexArray glBindVertexArray = Pointer<NativeFunction<GlBindVertexArrayNative>>.fromAddress(0).asFunction<GlBindVertexArray>();
GlDeleteVertexArrays glDeleteVertexArrays = Pointer<NativeFunction<GlDeleteVertexArraysNative>>.fromAddress(0).asFunction<GlDeleteVertexArrays>();
GlGenVertexArrays glGenVertexArrays = Pointer<NativeFunction<GlGenVertexArraysNative>>.fromAddress(0).asFunction<GlGenVertexArrays>();
GlIsVertexArray glIsVertexArray = Pointer<NativeFunction<GlIsVertexArrayNative>>.fromAddress(0).asFunction<GlIsVertexArray>();
GlDrawArraysInstanced glDrawArraysInstanced = Pointer<NativeFunction<GlDrawArraysInstancedNative>>.fromAddress(0).asFunction<GlDrawArraysInstanced>();
GlDrawElementsInstanced glDrawElementsInstanced = Pointer<NativeFunction<GlDrawElementsInstancedNative>>.fromAddress(0).asFunction<GlDrawElementsInstanced>();
GlTexBuffer glTexBuffer = Pointer<NativeFunction<GlTexBufferNative>>.fromAddress(0).asFunction<GlTexBuffer>();
GlPrimitiveRestartIndex glPrimitiveRestartIndex = Pointer<NativeFunction<GlPrimitiveRestartIndexNative>>.fromAddress(0).asFunction<GlPrimitiveRestartIndex>();
GlCopyBufferSubData glCopyBufferSubData = Pointer<NativeFunction<GlCopyBufferSubDataNative>>.fromAddress(0).asFunction<GlCopyBufferSubData>();
GlGetUniformIndices glGetUniformIndices = Pointer<NativeFunction<GlGetUniformIndicesNative>>.fromAddress(0).asFunction<GlGetUniformIndices>();
GlGetActiveUniformsiv glGetActiveUniformsiv = Pointer<NativeFunction<GlGetActiveUniformsivNative>>.fromAddress(0).asFunction<GlGetActiveUniformsiv>();
GlGetActiveUniformName glGetActiveUniformName = Pointer<NativeFunction<GlGetActiveUniformNameNative>>.fromAddress(0).asFunction<GlGetActiveUniformName>();
GlGetUniformBlockIndex glGetUniformBlockIndex = Pointer<NativeFunction<GlGetUniformBlockIndexNative>>.fromAddress(0).asFunction<GlGetUniformBlockIndex>();
GlGetActiveUniformBlockiv glGetActiveUniformBlockiv = Pointer<NativeFunction<GlGetActiveUniformBlockivNative>>.fromAddress(0).asFunction<GlGetActiveUniformBlockiv>();
GlGetActiveUniformBlockName glGetActiveUniformBlockName = Pointer<NativeFunction<GlGetActiveUniformBlockNameNative>>.fromAddress(0).asFunction<GlGetActiveUniformBlockName>();
GlUniformBlockBinding glUniformBlockBinding = Pointer<NativeFunction<GlUniformBlockBindingNative>>.fromAddress(0).asFunction<GlUniformBlockBinding>();
GlDrawElementsBaseVertex glDrawElementsBaseVertex = Pointer<NativeFunction<GlDrawElementsBaseVertexNative>>.fromAddress(0).asFunction<GlDrawElementsBaseVertex>();
GlDrawRangeElementsBaseVertex glDrawRangeElementsBaseVertex = Pointer<NativeFunction<GlDrawRangeElementsBaseVertexNative>>.fromAddress(0).asFunction<GlDrawRangeElementsBaseVertex>();
GlDrawElementsInstancedBaseVertex glDrawElementsInstancedBaseVertex = Pointer<NativeFunction<GlDrawElementsInstancedBaseVertexNative>>.fromAddress(0).asFunction<GlDrawElementsInstancedBaseVertex>();
GlMultiDrawElementsBaseVertex glMultiDrawElementsBaseVertex = Pointer<NativeFunction<GlMultiDrawElementsBaseVertexNative>>.fromAddress(0).asFunction<GlMultiDrawElementsBaseVertex>();
GlProvokingVertex glProvokingVertex = Pointer<NativeFunction<GlProvokingVertexNative>>.fromAddress(0).asFunction<GlProvokingVertex>();
GlFenceSync glFenceSync = Pointer<NativeFunction<GlFenceSyncNative>>.fromAddress(0).asFunction<GlFenceSync>();
GlIsSync glIsSync = Pointer<NativeFunction<GlIsSyncNative>>.fromAddress(0).asFunction<GlIsSync>();
GlDeleteSync glDeleteSync = Pointer<NativeFunction<GlDeleteSyncNative>>.fromAddress(0).asFunction<GlDeleteSync>();
GlClientWaitSync glClientWaitSync = Pointer<NativeFunction<GlClientWaitSyncNative>>.fromAddress(0).asFunction<GlClientWaitSync>();
GlWaitSync glWaitSync = Pointer<NativeFunction<GlWaitSyncNative>>.fromAddress(0).asFunction<GlWaitSync>();
GlGetInteger64v glGetInteger64v = Pointer<NativeFunction<GlGetInteger64vNative>>.fromAddress(0).asFunction<GlGetInteger64v>();
GlGetSynciv glGetSynciv = Pointer<NativeFunction<GlGetSyncivNative>>.fromAddress(0).asFunction<GlGetSynciv>();
GlGetInteger64i_v glGetInteger64i_v = Pointer<NativeFunction<GlGetInteger64i_vNative>>.fromAddress(0).asFunction<GlGetInteger64i_v>();
GlGetBufferParameteri64v glGetBufferParameteri64v = Pointer<NativeFunction<GlGetBufferParameteri64vNative>>.fromAddress(0).asFunction<GlGetBufferParameteri64v>();
GlFramebufferTexture glFramebufferTexture = Pointer<NativeFunction<GlFramebufferTextureNative>>.fromAddress(0).asFunction<GlFramebufferTexture>();
GlTexImage2DMultisample glTexImage2DMultisample = Pointer<NativeFunction<GlTexImage2DMultisampleNative>>.fromAddress(0).asFunction<GlTexImage2DMultisample>();
GlTexImage3DMultisample glTexImage3DMultisample = Pointer<NativeFunction<GlTexImage3DMultisampleNative>>.fromAddress(0).asFunction<GlTexImage3DMultisample>();
GlGetMultisamplefv glGetMultisamplefv = Pointer<NativeFunction<GlGetMultisamplefvNative>>.fromAddress(0).asFunction<GlGetMultisamplefv>();
GlSampleMaski glSampleMaski = Pointer<NativeFunction<GlSampleMaskiNative>>.fromAddress(0).asFunction<GlSampleMaski>();
GlBindFragDataLocationIndexed glBindFragDataLocationIndexed = Pointer<NativeFunction<GlBindFragDataLocationIndexedNative>>.fromAddress(0).asFunction<GlBindFragDataLocationIndexed>();
GlGetFragDataIndex glGetFragDataIndex = Pointer<NativeFunction<GlGetFragDataIndexNative>>.fromAddress(0).asFunction<GlGetFragDataIndex>();
GlGenSamplers glGenSamplers = Pointer<NativeFunction<GlGenSamplersNative>>.fromAddress(0).asFunction<GlGenSamplers>();
GlDeleteSamplers glDeleteSamplers = Pointer<NativeFunction<GlDeleteSamplersNative>>.fromAddress(0).asFunction<GlDeleteSamplers>();
GlIsSampler glIsSampler = Pointer<NativeFunction<GlIsSamplerNative>>.fromAddress(0).asFunction<GlIsSampler>();
GlBindSampler glBindSampler = Pointer<NativeFunction<GlBindSamplerNative>>.fromAddress(0).asFunction<GlBindSampler>();
GlSamplerParameteri glSamplerParameteri = Pointer<NativeFunction<GlSamplerParameteriNative>>.fromAddress(0).asFunction<GlSamplerParameteri>();
GlSamplerParameteriv glSamplerParameteriv = Pointer<NativeFunction<GlSamplerParameterivNative>>.fromAddress(0).asFunction<GlSamplerParameteriv>();
GlSamplerParameterf glSamplerParameterf = Pointer<NativeFunction<GlSamplerParameterfNative>>.fromAddress(0).asFunction<GlSamplerParameterf>();
GlSamplerParameterfv glSamplerParameterfv = Pointer<NativeFunction<GlSamplerParameterfvNative>>.fromAddress(0).asFunction<GlSamplerParameterfv>();
GlSamplerParameterIiv glSamplerParameterIiv = Pointer<NativeFunction<GlSamplerParameterIivNative>>.fromAddress(0).asFunction<GlSamplerParameterIiv>();
GlSamplerParameterIuiv glSamplerParameterIuiv = Pointer<NativeFunction<GlSamplerParameterIuivNative>>.fromAddress(0).asFunction<GlSamplerParameterIuiv>();
GlGetSamplerParameteriv glGetSamplerParameteriv = Pointer<NativeFunction<GlGetSamplerParameterivNative>>.fromAddress(0).asFunction<GlGetSamplerParameteriv>();
GlGetSamplerParameterIiv glGetSamplerParameterIiv = Pointer<NativeFunction<GlGetSamplerParameterIivNative>>.fromAddress(0).asFunction<GlGetSamplerParameterIiv>();
GlGetSamplerParameterfv glGetSamplerParameterfv = Pointer<NativeFunction<GlGetSamplerParameterfvNative>>.fromAddress(0).asFunction<GlGetSamplerParameterfv>();
GlGetSamplerParameterIuiv glGetSamplerParameterIuiv = Pointer<NativeFunction<GlGetSamplerParameterIuivNative>>.fromAddress(0).asFunction<GlGetSamplerParameterIuiv>();
GlQueryCounter glQueryCounter = Pointer<NativeFunction<GlQueryCounterNative>>.fromAddress(0).asFunction<GlQueryCounter>();
GlGetQueryObjecti64v glGetQueryObjecti64v = Pointer<NativeFunction<GlGetQueryObjecti64vNative>>.fromAddress(0).asFunction<GlGetQueryObjecti64v>();
GlGetQueryObjectui64v glGetQueryObjectui64v = Pointer<NativeFunction<GlGetQueryObjectui64vNative>>.fromAddress(0).asFunction<GlGetQueryObjectui64v>();
GlVertexAttribDivisor glVertexAttribDivisor = Pointer<NativeFunction<GlVertexAttribDivisorNative>>.fromAddress(0).asFunction<GlVertexAttribDivisor>();
GlVertexAttribP1ui glVertexAttribP1ui = Pointer<NativeFunction<GlVertexAttribP1uiNative>>.fromAddress(0).asFunction<GlVertexAttribP1ui>();
GlVertexAttribP1uiv glVertexAttribP1uiv = Pointer<NativeFunction<GlVertexAttribP1uivNative>>.fromAddress(0).asFunction<GlVertexAttribP1uiv>();
GlVertexAttribP2ui glVertexAttribP2ui = Pointer<NativeFunction<GlVertexAttribP2uiNative>>.fromAddress(0).asFunction<GlVertexAttribP2ui>();
GlVertexAttribP2uiv glVertexAttribP2uiv = Pointer<NativeFunction<GlVertexAttribP2uivNative>>.fromAddress(0).asFunction<GlVertexAttribP2uiv>();
GlVertexAttribP3ui glVertexAttribP3ui = Pointer<NativeFunction<GlVertexAttribP3uiNative>>.fromAddress(0).asFunction<GlVertexAttribP3ui>();
GlVertexAttribP3uiv glVertexAttribP3uiv = Pointer<NativeFunction<GlVertexAttribP3uivNative>>.fromAddress(0).asFunction<GlVertexAttribP3uiv>();
GlVertexAttribP4ui glVertexAttribP4ui = Pointer<NativeFunction<GlVertexAttribP4uiNative>>.fromAddress(0).asFunction<GlVertexAttribP4ui>();
GlVertexAttribP4uiv glVertexAttribP4uiv = Pointer<NativeFunction<GlVertexAttribP4uivNative>>.fromAddress(0).asFunction<GlVertexAttribP4uiv>();
GlMinSampleShading glMinSampleShading = Pointer<NativeFunction<GlMinSampleShadingNative>>.fromAddress(0).asFunction<GlMinSampleShading>();
GlBlendEquationi glBlendEquationi = Pointer<NativeFunction<GlBlendEquationiNative>>.fromAddress(0).asFunction<GlBlendEquationi>();
GlBlendEquationSeparatei glBlendEquationSeparatei = Pointer<NativeFunction<GlBlendEquationSeparateiNative>>.fromAddress(0).asFunction<GlBlendEquationSeparatei>();
GlBlendFunci glBlendFunci = Pointer<NativeFunction<GlBlendFunciNative>>.fromAddress(0).asFunction<GlBlendFunci>();
GlBlendFuncSeparatei glBlendFuncSeparatei = Pointer<NativeFunction<GlBlendFuncSeparateiNative>>.fromAddress(0).asFunction<GlBlendFuncSeparatei>();
GlDrawArraysIndirect glDrawArraysIndirect = Pointer<NativeFunction<GlDrawArraysIndirectNative>>.fromAddress(0).asFunction<GlDrawArraysIndirect>();
GlDrawElementsIndirect glDrawElementsIndirect = Pointer<NativeFunction<GlDrawElementsIndirectNative>>.fromAddress(0).asFunction<GlDrawElementsIndirect>();
GlUniform1d glUniform1d = Pointer<NativeFunction<GlUniform1dNative>>.fromAddress(0).asFunction<GlUniform1d>();
GlUniform2d glUniform2d = Pointer<NativeFunction<GlUniform2dNative>>.fromAddress(0).asFunction<GlUniform2d>();
GlUniform3d glUniform3d = Pointer<NativeFunction<GlUniform3dNative>>.fromAddress(0).asFunction<GlUniform3d>();
GlUniform4d glUniform4d = Pointer<NativeFunction<GlUniform4dNative>>.fromAddress(0).asFunction<GlUniform4d>();
GlUniform1dv glUniform1dv = Pointer<NativeFunction<GlUniform1dvNative>>.fromAddress(0).asFunction<GlUniform1dv>();
GlUniform2dv glUniform2dv = Pointer<NativeFunction<GlUniform2dvNative>>.fromAddress(0).asFunction<GlUniform2dv>();
GlUniform3dv glUniform3dv = Pointer<NativeFunction<GlUniform3dvNative>>.fromAddress(0).asFunction<GlUniform3dv>();
GlUniform4dv glUniform4dv = Pointer<NativeFunction<GlUniform4dvNative>>.fromAddress(0).asFunction<GlUniform4dv>();
GlUniformMatrix2dv glUniformMatrix2dv = Pointer<NativeFunction<GlUniformMatrix2dvNative>>.fromAddress(0).asFunction<GlUniformMatrix2dv>();
GlUniformMatrix3dv glUniformMatrix3dv = Pointer<NativeFunction<GlUniformMatrix3dvNative>>.fromAddress(0).asFunction<GlUniformMatrix3dv>();
GlUniformMatrix4dv glUniformMatrix4dv = Pointer<NativeFunction<GlUniformMatrix4dvNative>>.fromAddress(0).asFunction<GlUniformMatrix4dv>();
GlUniformMatrix2x3dv glUniformMatrix2x3dv = Pointer<NativeFunction<GlUniformMatrix2x3dvNative>>.fromAddress(0).asFunction<GlUniformMatrix2x3dv>();
GlUniformMatrix2x4dv glUniformMatrix2x4dv = Pointer<NativeFunction<GlUniformMatrix2x4dvNative>>.fromAddress(0).asFunction<GlUniformMatrix2x4dv>();
GlUniformMatrix3x2dv glUniformMatrix3x2dv = Pointer<NativeFunction<GlUniformMatrix3x2dvNative>>.fromAddress(0).asFunction<GlUniformMatrix3x2dv>();
GlUniformMatrix3x4dv glUniformMatrix3x4dv = Pointer<NativeFunction<GlUniformMatrix3x4dvNative>>.fromAddress(0).asFunction<GlUniformMatrix3x4dv>();
GlUniformMatrix4x2dv glUniformMatrix4x2dv = Pointer<NativeFunction<GlUniformMatrix4x2dvNative>>.fromAddress(0).asFunction<GlUniformMatrix4x2dv>();
GlUniformMatrix4x3dv glUniformMatrix4x3dv = Pointer<NativeFunction<GlUniformMatrix4x3dvNative>>.fromAddress(0).asFunction<GlUniformMatrix4x3dv>();
GlGetUniformdv glGetUniformdv = Pointer<NativeFunction<GlGetUniformdvNative>>.fromAddress(0).asFunction<GlGetUniformdv>();
GlGetSubroutineUniformLocation glGetSubroutineUniformLocation = Pointer<NativeFunction<GlGetSubroutineUniformLocationNative>>.fromAddress(0).asFunction<GlGetSubroutineUniformLocation>();
GlGetSubroutineIndex glGetSubroutineIndex = Pointer<NativeFunction<GlGetSubroutineIndexNative>>.fromAddress(0).asFunction<GlGetSubroutineIndex>();
GlGetActiveSubroutineUniformiv glGetActiveSubroutineUniformiv = Pointer<NativeFunction<GlGetActiveSubroutineUniformivNative>>.fromAddress(0).asFunction<GlGetActiveSubroutineUniformiv>();
GlGetActiveSubroutineUniformName glGetActiveSubroutineUniformName = Pointer<NativeFunction<GlGetActiveSubroutineUniformNameNative>>.fromAddress(0).asFunction<GlGetActiveSubroutineUniformName>();
GlGetActiveSubroutineName glGetActiveSubroutineName = Pointer<NativeFunction<GlGetActiveSubroutineNameNative>>.fromAddress(0).asFunction<GlGetActiveSubroutineName>();
GlUniformSubroutinesuiv glUniformSubroutinesuiv = Pointer<NativeFunction<GlUniformSubroutinesuivNative>>.fromAddress(0).asFunction<GlUniformSubroutinesuiv>();
GlGetUniformSubroutineuiv glGetUniformSubroutineuiv = Pointer<NativeFunction<GlGetUniformSubroutineuivNative>>.fromAddress(0).asFunction<GlGetUniformSubroutineuiv>();
GlGetProgramStageiv glGetProgramStageiv = Pointer<NativeFunction<GlGetProgramStageivNative>>.fromAddress(0).asFunction<GlGetProgramStageiv>();
GlPatchParameteri glPatchParameteri = Pointer<NativeFunction<GlPatchParameteriNative>>.fromAddress(0).asFunction<GlPatchParameteri>();
GlPatchParameterfv glPatchParameterfv = Pointer<NativeFunction<GlPatchParameterfvNative>>.fromAddress(0).asFunction<GlPatchParameterfv>();
GlBindTransformFeedback glBindTransformFeedback = Pointer<NativeFunction<GlBindTransformFeedbackNative>>.fromAddress(0).asFunction<GlBindTransformFeedback>();
GlDeleteTransformFeedbacks glDeleteTransformFeedbacks = Pointer<NativeFunction<GlDeleteTransformFeedbacksNative>>.fromAddress(0).asFunction<GlDeleteTransformFeedbacks>();
GlGenTransformFeedbacks glGenTransformFeedbacks = Pointer<NativeFunction<GlGenTransformFeedbacksNative>>.fromAddress(0).asFunction<GlGenTransformFeedbacks>();
GlIsTransformFeedback glIsTransformFeedback = Pointer<NativeFunction<GlIsTransformFeedbackNative>>.fromAddress(0).asFunction<GlIsTransformFeedback>();
GlPauseTransformFeedback glPauseTransformFeedback = Pointer<NativeFunction<GlPauseTransformFeedbackNative>>.fromAddress(0).asFunction<GlPauseTransformFeedback>();
GlResumeTransformFeedback glResumeTransformFeedback = Pointer<NativeFunction<GlResumeTransformFeedbackNative>>.fromAddress(0).asFunction<GlResumeTransformFeedback>();
GlDrawTransformFeedback glDrawTransformFeedback = Pointer<NativeFunction<GlDrawTransformFeedbackNative>>.fromAddress(0).asFunction<GlDrawTransformFeedback>();
GlDrawTransformFeedbackStream glDrawTransformFeedbackStream = Pointer<NativeFunction<GlDrawTransformFeedbackStreamNative>>.fromAddress(0).asFunction<GlDrawTransformFeedbackStream>();
GlBeginQueryIndexed glBeginQueryIndexed = Pointer<NativeFunction<GlBeginQueryIndexedNative>>.fromAddress(0).asFunction<GlBeginQueryIndexed>();
GlEndQueryIndexed glEndQueryIndexed = Pointer<NativeFunction<GlEndQueryIndexedNative>>.fromAddress(0).asFunction<GlEndQueryIndexed>();
GlGetQueryIndexediv glGetQueryIndexediv = Pointer<NativeFunction<GlGetQueryIndexedivNative>>.fromAddress(0).asFunction<GlGetQueryIndexediv>();
GlReleaseShaderCompiler glReleaseShaderCompiler = Pointer<NativeFunction<GlReleaseShaderCompilerNative>>.fromAddress(0).asFunction<GlReleaseShaderCompiler>();
GlShaderBinary glShaderBinary = Pointer<NativeFunction<GlShaderBinaryNative>>.fromAddress(0).asFunction<GlShaderBinary>();
GlGetShaderPrecisionFormat glGetShaderPrecisionFormat = Pointer<NativeFunction<GlGetShaderPrecisionFormatNative>>.fromAddress(0).asFunction<GlGetShaderPrecisionFormat>();
GlDepthRangef glDepthRangef = Pointer<NativeFunction<GlDepthRangefNative>>.fromAddress(0).asFunction<GlDepthRangef>();
GlClearDepthf glClearDepthf = Pointer<NativeFunction<GlClearDepthfNative>>.fromAddress(0).asFunction<GlClearDepthf>();
GlGetProgramBinary glGetProgramBinary = Pointer<NativeFunction<GlGetProgramBinaryNative>>.fromAddress(0).asFunction<GlGetProgramBinary>();
GlProgramBinary glProgramBinary = Pointer<NativeFunction<GlProgramBinaryNative>>.fromAddress(0).asFunction<GlProgramBinary>();
GlProgramParameteri glProgramParameteri = Pointer<NativeFunction<GlProgramParameteriNative>>.fromAddress(0).asFunction<GlProgramParameteri>();
GlUseProgramStages glUseProgramStages = Pointer<NativeFunction<GlUseProgramStagesNative>>.fromAddress(0).asFunction<GlUseProgramStages>();
GlActiveShaderProgram glActiveShaderProgram = Pointer<NativeFunction<GlActiveShaderProgramNative>>.fromAddress(0).asFunction<GlActiveShaderProgram>();
GlCreateShaderProgramv glCreateShaderProgramv = Pointer<NativeFunction<GlCreateShaderProgramvNative>>.fromAddress(0).asFunction<GlCreateShaderProgramv>();
GlBindProgramPipeline glBindProgramPipeline = Pointer<NativeFunction<GlBindProgramPipelineNative>>.fromAddress(0).asFunction<GlBindProgramPipeline>();
GlDeleteProgramPipelines glDeleteProgramPipelines = Pointer<NativeFunction<GlDeleteProgramPipelinesNative>>.fromAddress(0).asFunction<GlDeleteProgramPipelines>();
GlGenProgramPipelines glGenProgramPipelines = Pointer<NativeFunction<GlGenProgramPipelinesNative>>.fromAddress(0).asFunction<GlGenProgramPipelines>();
GlIsProgramPipeline glIsProgramPipeline = Pointer<NativeFunction<GlIsProgramPipelineNative>>.fromAddress(0).asFunction<GlIsProgramPipeline>();
GlGetProgramPipelineiv glGetProgramPipelineiv = Pointer<NativeFunction<GlGetProgramPipelineivNative>>.fromAddress(0).asFunction<GlGetProgramPipelineiv>();
GlProgramUniform1i glProgramUniform1i = Pointer<NativeFunction<GlProgramUniform1iNative>>.fromAddress(0).asFunction<GlProgramUniform1i>();
GlProgramUniform1iv glProgramUniform1iv = Pointer<NativeFunction<GlProgramUniform1ivNative>>.fromAddress(0).asFunction<GlProgramUniform1iv>();
GlProgramUniform1f glProgramUniform1f = Pointer<NativeFunction<GlProgramUniform1fNative>>.fromAddress(0).asFunction<GlProgramUniform1f>();
GlProgramUniform1fv glProgramUniform1fv = Pointer<NativeFunction<GlProgramUniform1fvNative>>.fromAddress(0).asFunction<GlProgramUniform1fv>();
GlProgramUniform1d glProgramUniform1d = Pointer<NativeFunction<GlProgramUniform1dNative>>.fromAddress(0).asFunction<GlProgramUniform1d>();
GlProgramUniform1dv glProgramUniform1dv = Pointer<NativeFunction<GlProgramUniform1dvNative>>.fromAddress(0).asFunction<GlProgramUniform1dv>();
GlProgramUniform1ui glProgramUniform1ui = Pointer<NativeFunction<GlProgramUniform1uiNative>>.fromAddress(0).asFunction<GlProgramUniform1ui>();
GlProgramUniform1uiv glProgramUniform1uiv = Pointer<NativeFunction<GlProgramUniform1uivNative>>.fromAddress(0).asFunction<GlProgramUniform1uiv>();
GlProgramUniform2i glProgramUniform2i = Pointer<NativeFunction<GlProgramUniform2iNative>>.fromAddress(0).asFunction<GlProgramUniform2i>();
GlProgramUniform2iv glProgramUniform2iv = Pointer<NativeFunction<GlProgramUniform2ivNative>>.fromAddress(0).asFunction<GlProgramUniform2iv>();
GlProgramUniform2f glProgramUniform2f = Pointer<NativeFunction<GlProgramUniform2fNative>>.fromAddress(0).asFunction<GlProgramUniform2f>();
GlProgramUniform2fv glProgramUniform2fv = Pointer<NativeFunction<GlProgramUniform2fvNative>>.fromAddress(0).asFunction<GlProgramUniform2fv>();
GlProgramUniform2d glProgramUniform2d = Pointer<NativeFunction<GlProgramUniform2dNative>>.fromAddress(0).asFunction<GlProgramUniform2d>();
GlProgramUniform2dv glProgramUniform2dv = Pointer<NativeFunction<GlProgramUniform2dvNative>>.fromAddress(0).asFunction<GlProgramUniform2dv>();
GlProgramUniform2ui glProgramUniform2ui = Pointer<NativeFunction<GlProgramUniform2uiNative>>.fromAddress(0).asFunction<GlProgramUniform2ui>();
GlProgramUniform2uiv glProgramUniform2uiv = Pointer<NativeFunction<GlProgramUniform2uivNative>>.fromAddress(0).asFunction<GlProgramUniform2uiv>();
GlProgramUniform3i glProgramUniform3i = Pointer<NativeFunction<GlProgramUniform3iNative>>.fromAddress(0).asFunction<GlProgramUniform3i>();
GlProgramUniform3iv glProgramUniform3iv = Pointer<NativeFunction<GlProgramUniform3ivNative>>.fromAddress(0).asFunction<GlProgramUniform3iv>();
GlProgramUniform3f glProgramUniform3f = Pointer<NativeFunction<GlProgramUniform3fNative>>.fromAddress(0).asFunction<GlProgramUniform3f>();
GlProgramUniform3fv glProgramUniform3fv = Pointer<NativeFunction<GlProgramUniform3fvNative>>.fromAddress(0).asFunction<GlProgramUniform3fv>();
GlProgramUniform3d glProgramUniform3d = Pointer<NativeFunction<GlProgramUniform3dNative>>.fromAddress(0).asFunction<GlProgramUniform3d>();
GlProgramUniform3dv glProgramUniform3dv = Pointer<NativeFunction<GlProgramUniform3dvNative>>.fromAddress(0).asFunction<GlProgramUniform3dv>();
GlProgramUniform3ui glProgramUniform3ui = Pointer<NativeFunction<GlProgramUniform3uiNative>>.fromAddress(0).asFunction<GlProgramUniform3ui>();
GlProgramUniform3uiv glProgramUniform3uiv = Pointer<NativeFunction<GlProgramUniform3uivNative>>.fromAddress(0).asFunction<GlProgramUniform3uiv>();
GlProgramUniform4i glProgramUniform4i = Pointer<NativeFunction<GlProgramUniform4iNative>>.fromAddress(0).asFunction<GlProgramUniform4i>();
GlProgramUniform4iv glProgramUniform4iv = Pointer<NativeFunction<GlProgramUniform4ivNative>>.fromAddress(0).asFunction<GlProgramUniform4iv>();
GlProgramUniform4f glProgramUniform4f = Pointer<NativeFunction<GlProgramUniform4fNative>>.fromAddress(0).asFunction<GlProgramUniform4f>();
GlProgramUniform4fv glProgramUniform4fv = Pointer<NativeFunction<GlProgramUniform4fvNative>>.fromAddress(0).asFunction<GlProgramUniform4fv>();
GlProgramUniform4d glProgramUniform4d = Pointer<NativeFunction<GlProgramUniform4dNative>>.fromAddress(0).asFunction<GlProgramUniform4d>();
GlProgramUniform4dv glProgramUniform4dv = Pointer<NativeFunction<GlProgramUniform4dvNative>>.fromAddress(0).asFunction<GlProgramUniform4dv>();
GlProgramUniform4ui glProgramUniform4ui = Pointer<NativeFunction<GlProgramUniform4uiNative>>.fromAddress(0).asFunction<GlProgramUniform4ui>();
GlProgramUniform4uiv glProgramUniform4uiv = Pointer<NativeFunction<GlProgramUniform4uivNative>>.fromAddress(0).asFunction<GlProgramUniform4uiv>();
GlProgramUniformMatrix2fv glProgramUniformMatrix2fv = Pointer<NativeFunction<GlProgramUniformMatrix2fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2fv>();
GlProgramUniformMatrix3fv glProgramUniformMatrix3fv = Pointer<NativeFunction<GlProgramUniformMatrix3fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3fv>();
GlProgramUniformMatrix4fv glProgramUniformMatrix4fv = Pointer<NativeFunction<GlProgramUniformMatrix4fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4fv>();
GlProgramUniformMatrix2dv glProgramUniformMatrix2dv = Pointer<NativeFunction<GlProgramUniformMatrix2dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2dv>();
GlProgramUniformMatrix3dv glProgramUniformMatrix3dv = Pointer<NativeFunction<GlProgramUniformMatrix3dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3dv>();
GlProgramUniformMatrix4dv glProgramUniformMatrix4dv = Pointer<NativeFunction<GlProgramUniformMatrix4dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4dv>();
GlProgramUniformMatrix2x3fv glProgramUniformMatrix2x3fv = Pointer<NativeFunction<GlProgramUniformMatrix2x3fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x3fv>();
GlProgramUniformMatrix3x2fv glProgramUniformMatrix3x2fv = Pointer<NativeFunction<GlProgramUniformMatrix3x2fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x2fv>();
GlProgramUniformMatrix2x4fv glProgramUniformMatrix2x4fv = Pointer<NativeFunction<GlProgramUniformMatrix2x4fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x4fv>();
GlProgramUniformMatrix4x2fv glProgramUniformMatrix4x2fv = Pointer<NativeFunction<GlProgramUniformMatrix4x2fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x2fv>();
GlProgramUniformMatrix3x4fv glProgramUniformMatrix3x4fv = Pointer<NativeFunction<GlProgramUniformMatrix3x4fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x4fv>();
GlProgramUniformMatrix4x3fv glProgramUniformMatrix4x3fv = Pointer<NativeFunction<GlProgramUniformMatrix4x3fvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x3fv>();
GlProgramUniformMatrix2x3dv glProgramUniformMatrix2x3dv = Pointer<NativeFunction<GlProgramUniformMatrix2x3dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x3dv>();
GlProgramUniformMatrix3x2dv glProgramUniformMatrix3x2dv = Pointer<NativeFunction<GlProgramUniformMatrix3x2dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x2dv>();
GlProgramUniformMatrix2x4dv glProgramUniformMatrix2x4dv = Pointer<NativeFunction<GlProgramUniformMatrix2x4dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x4dv>();
GlProgramUniformMatrix4x2dv glProgramUniformMatrix4x2dv = Pointer<NativeFunction<GlProgramUniformMatrix4x2dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x2dv>();
GlProgramUniformMatrix3x4dv glProgramUniformMatrix3x4dv = Pointer<NativeFunction<GlProgramUniformMatrix3x4dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x4dv>();
GlProgramUniformMatrix4x3dv glProgramUniformMatrix4x3dv = Pointer<NativeFunction<GlProgramUniformMatrix4x3dvNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x3dv>();
GlValidateProgramPipeline glValidateProgramPipeline = Pointer<NativeFunction<GlValidateProgramPipelineNative>>.fromAddress(0).asFunction<GlValidateProgramPipeline>();
GlGetProgramPipelineInfoLog glGetProgramPipelineInfoLog = Pointer<NativeFunction<GlGetProgramPipelineInfoLogNative>>.fromAddress(0).asFunction<GlGetProgramPipelineInfoLog>();
GlVertexAttribL1d glVertexAttribL1d = Pointer<NativeFunction<GlVertexAttribL1dNative>>.fromAddress(0).asFunction<GlVertexAttribL1d>();
GlVertexAttribL2d glVertexAttribL2d = Pointer<NativeFunction<GlVertexAttribL2dNative>>.fromAddress(0).asFunction<GlVertexAttribL2d>();
GlVertexAttribL3d glVertexAttribL3d = Pointer<NativeFunction<GlVertexAttribL3dNative>>.fromAddress(0).asFunction<GlVertexAttribL3d>();
GlVertexAttribL4d glVertexAttribL4d = Pointer<NativeFunction<GlVertexAttribL4dNative>>.fromAddress(0).asFunction<GlVertexAttribL4d>();
GlVertexAttribL1dv glVertexAttribL1dv = Pointer<NativeFunction<GlVertexAttribL1dvNative>>.fromAddress(0).asFunction<GlVertexAttribL1dv>();
GlVertexAttribL2dv glVertexAttribL2dv = Pointer<NativeFunction<GlVertexAttribL2dvNative>>.fromAddress(0).asFunction<GlVertexAttribL2dv>();
GlVertexAttribL3dv glVertexAttribL3dv = Pointer<NativeFunction<GlVertexAttribL3dvNative>>.fromAddress(0).asFunction<GlVertexAttribL3dv>();
GlVertexAttribL4dv glVertexAttribL4dv = Pointer<NativeFunction<GlVertexAttribL4dvNative>>.fromAddress(0).asFunction<GlVertexAttribL4dv>();
GlVertexAttribLPointer glVertexAttribLPointer = Pointer<NativeFunction<GlVertexAttribLPointerNative>>.fromAddress(0).asFunction<GlVertexAttribLPointer>();
GlGetVertexAttribLdv glGetVertexAttribLdv = Pointer<NativeFunction<GlGetVertexAttribLdvNative>>.fromAddress(0).asFunction<GlGetVertexAttribLdv>();
GlViewportArrayv glViewportArrayv = Pointer<NativeFunction<GlViewportArrayvNative>>.fromAddress(0).asFunction<GlViewportArrayv>();
GlViewportIndexedf glViewportIndexedf = Pointer<NativeFunction<GlViewportIndexedfNative>>.fromAddress(0).asFunction<GlViewportIndexedf>();
GlViewportIndexedfv glViewportIndexedfv = Pointer<NativeFunction<GlViewportIndexedfvNative>>.fromAddress(0).asFunction<GlViewportIndexedfv>();
GlScissorArrayv glScissorArrayv = Pointer<NativeFunction<GlScissorArrayvNative>>.fromAddress(0).asFunction<GlScissorArrayv>();
GlScissorIndexed glScissorIndexed = Pointer<NativeFunction<GlScissorIndexedNative>>.fromAddress(0).asFunction<GlScissorIndexed>();
GlScissorIndexedv glScissorIndexedv = Pointer<NativeFunction<GlScissorIndexedvNative>>.fromAddress(0).asFunction<GlScissorIndexedv>();
GlDepthRangeArrayv glDepthRangeArrayv = Pointer<NativeFunction<GlDepthRangeArrayvNative>>.fromAddress(0).asFunction<GlDepthRangeArrayv>();
GlDepthRangeIndexed glDepthRangeIndexed = Pointer<NativeFunction<GlDepthRangeIndexedNative>>.fromAddress(0).asFunction<GlDepthRangeIndexed>();
GlGetFloati_v glGetFloati_v = Pointer<NativeFunction<GlGetFloati_vNative>>.fromAddress(0).asFunction<GlGetFloati_v>();
GlGetDoublei_v glGetDoublei_v = Pointer<NativeFunction<GlGetDoublei_vNative>>.fromAddress(0).asFunction<GlGetDoublei_v>();
GlDrawArraysInstancedBaseInstance glDrawArraysInstancedBaseInstance = Pointer<NativeFunction<GlDrawArraysInstancedBaseInstanceNative>>.fromAddress(0).asFunction<GlDrawArraysInstancedBaseInstance>();
GlDrawElementsInstancedBaseInstance glDrawElementsInstancedBaseInstance = Pointer<NativeFunction<GlDrawElementsInstancedBaseInstanceNative>>.fromAddress(0).asFunction<GlDrawElementsInstancedBaseInstance>();
GlDrawElementsInstancedBaseVertexBaseInstance glDrawElementsInstancedBaseVertexBaseInstance = Pointer<NativeFunction<GlDrawElementsInstancedBaseVertexBaseInstanceNative>>.fromAddress(0).asFunction<GlDrawElementsInstancedBaseVertexBaseInstance>();
GlGetInternalformativ glGetInternalformativ = Pointer<NativeFunction<GlGetInternalformativNative>>.fromAddress(0).asFunction<GlGetInternalformativ>();
GlGetActiveAtomicCounterBufferiv glGetActiveAtomicCounterBufferiv = Pointer<NativeFunction<GlGetActiveAtomicCounterBufferivNative>>.fromAddress(0).asFunction<GlGetActiveAtomicCounterBufferiv>();
GlBindImageTexture glBindImageTexture = Pointer<NativeFunction<GlBindImageTextureNative>>.fromAddress(0).asFunction<GlBindImageTexture>();
GlMemoryBarrier glMemoryBarrier = Pointer<NativeFunction<GlMemoryBarrierNative>>.fromAddress(0).asFunction<GlMemoryBarrier>();
GlTexStorage1D glTexStorage1D = Pointer<NativeFunction<GlTexStorage1DNative>>.fromAddress(0).asFunction<GlTexStorage1D>();
GlTexStorage2D glTexStorage2D = Pointer<NativeFunction<GlTexStorage2DNative>>.fromAddress(0).asFunction<GlTexStorage2D>();
GlTexStorage3D glTexStorage3D = Pointer<NativeFunction<GlTexStorage3DNative>>.fromAddress(0).asFunction<GlTexStorage3D>();
GlDrawTransformFeedbackInstanced glDrawTransformFeedbackInstanced = Pointer<NativeFunction<GlDrawTransformFeedbackInstancedNative>>.fromAddress(0).asFunction<GlDrawTransformFeedbackInstanced>();
GlDrawTransformFeedbackStreamInstanced glDrawTransformFeedbackStreamInstanced = Pointer<NativeFunction<GlDrawTransformFeedbackStreamInstancedNative>>.fromAddress(0).asFunction<GlDrawTransformFeedbackStreamInstanced>();
GlClearBufferData glClearBufferData = Pointer<NativeFunction<GlClearBufferDataNative>>.fromAddress(0).asFunction<GlClearBufferData>();
GlClearBufferSubData glClearBufferSubData = Pointer<NativeFunction<GlClearBufferSubDataNative>>.fromAddress(0).asFunction<GlClearBufferSubData>();
GlDispatchCompute glDispatchCompute = Pointer<NativeFunction<GlDispatchComputeNative>>.fromAddress(0).asFunction<GlDispatchCompute>();
GlDispatchComputeIndirect glDispatchComputeIndirect = Pointer<NativeFunction<GlDispatchComputeIndirectNative>>.fromAddress(0).asFunction<GlDispatchComputeIndirect>();
GlCopyImageSubData glCopyImageSubData = Pointer<NativeFunction<GlCopyImageSubDataNative>>.fromAddress(0).asFunction<GlCopyImageSubData>();
GlFramebufferParameteri glFramebufferParameteri = Pointer<NativeFunction<GlFramebufferParameteriNative>>.fromAddress(0).asFunction<GlFramebufferParameteri>();
GlGetFramebufferParameteriv glGetFramebufferParameteriv = Pointer<NativeFunction<GlGetFramebufferParameterivNative>>.fromAddress(0).asFunction<GlGetFramebufferParameteriv>();
GlGetInternalformati64v glGetInternalformati64v = Pointer<NativeFunction<GlGetInternalformati64vNative>>.fromAddress(0).asFunction<GlGetInternalformati64v>();
GlInvalidateTexSubImage glInvalidateTexSubImage = Pointer<NativeFunction<GlInvalidateTexSubImageNative>>.fromAddress(0).asFunction<GlInvalidateTexSubImage>();
GlInvalidateTexImage glInvalidateTexImage = Pointer<NativeFunction<GlInvalidateTexImageNative>>.fromAddress(0).asFunction<GlInvalidateTexImage>();
GlInvalidateBufferSubData glInvalidateBufferSubData = Pointer<NativeFunction<GlInvalidateBufferSubDataNative>>.fromAddress(0).asFunction<GlInvalidateBufferSubData>();
GlInvalidateBufferData glInvalidateBufferData = Pointer<NativeFunction<GlInvalidateBufferDataNative>>.fromAddress(0).asFunction<GlInvalidateBufferData>();
GlInvalidateFramebuffer glInvalidateFramebuffer = Pointer<NativeFunction<GlInvalidateFramebufferNative>>.fromAddress(0).asFunction<GlInvalidateFramebuffer>();
GlInvalidateSubFramebuffer glInvalidateSubFramebuffer = Pointer<NativeFunction<GlInvalidateSubFramebufferNative>>.fromAddress(0).asFunction<GlInvalidateSubFramebuffer>();
GlMultiDrawArraysIndirect glMultiDrawArraysIndirect = Pointer<NativeFunction<GlMultiDrawArraysIndirectNative>>.fromAddress(0).asFunction<GlMultiDrawArraysIndirect>();
GlMultiDrawElementsIndirect glMultiDrawElementsIndirect = Pointer<NativeFunction<GlMultiDrawElementsIndirectNative>>.fromAddress(0).asFunction<GlMultiDrawElementsIndirect>();
GlGetProgramInterfaceiv glGetProgramInterfaceiv = Pointer<NativeFunction<GlGetProgramInterfaceivNative>>.fromAddress(0).asFunction<GlGetProgramInterfaceiv>();
GlGetProgramResourceIndex glGetProgramResourceIndex = Pointer<NativeFunction<GlGetProgramResourceIndexNative>>.fromAddress(0).asFunction<GlGetProgramResourceIndex>();
GlGetProgramResourceName glGetProgramResourceName = Pointer<NativeFunction<GlGetProgramResourceNameNative>>.fromAddress(0).asFunction<GlGetProgramResourceName>();
GlGetProgramResourceiv glGetProgramResourceiv = Pointer<NativeFunction<GlGetProgramResourceivNative>>.fromAddress(0).asFunction<GlGetProgramResourceiv>();
GlGetProgramResourceLocation glGetProgramResourceLocation = Pointer<NativeFunction<GlGetProgramResourceLocationNative>>.fromAddress(0).asFunction<GlGetProgramResourceLocation>();
GlGetProgramResourceLocationIndex glGetProgramResourceLocationIndex = Pointer<NativeFunction<GlGetProgramResourceLocationIndexNative>>.fromAddress(0).asFunction<GlGetProgramResourceLocationIndex>();
GlShaderStorageBlockBinding glShaderStorageBlockBinding = Pointer<NativeFunction<GlShaderStorageBlockBindingNative>>.fromAddress(0).asFunction<GlShaderStorageBlockBinding>();
GlTexBufferRange glTexBufferRange = Pointer<NativeFunction<GlTexBufferRangeNative>>.fromAddress(0).asFunction<GlTexBufferRange>();
GlTexStorage2DMultisample glTexStorage2DMultisample = Pointer<NativeFunction<GlTexStorage2DMultisampleNative>>.fromAddress(0).asFunction<GlTexStorage2DMultisample>();
GlTexStorage3DMultisample glTexStorage3DMultisample = Pointer<NativeFunction<GlTexStorage3DMultisampleNative>>.fromAddress(0).asFunction<GlTexStorage3DMultisample>();
GlTextureView glTextureView = Pointer<NativeFunction<GlTextureViewNative>>.fromAddress(0).asFunction<GlTextureView>();
GlBindVertexBuffer glBindVertexBuffer = Pointer<NativeFunction<GlBindVertexBufferNative>>.fromAddress(0).asFunction<GlBindVertexBuffer>();
GlVertexAttribFormat glVertexAttribFormat = Pointer<NativeFunction<GlVertexAttribFormatNative>>.fromAddress(0).asFunction<GlVertexAttribFormat>();
GlVertexAttribIFormat glVertexAttribIFormat = Pointer<NativeFunction<GlVertexAttribIFormatNative>>.fromAddress(0).asFunction<GlVertexAttribIFormat>();
GlVertexAttribLFormat glVertexAttribLFormat = Pointer<NativeFunction<GlVertexAttribLFormatNative>>.fromAddress(0).asFunction<GlVertexAttribLFormat>();
GlVertexAttribBinding glVertexAttribBinding = Pointer<NativeFunction<GlVertexAttribBindingNative>>.fromAddress(0).asFunction<GlVertexAttribBinding>();
GlVertexBindingDivisor glVertexBindingDivisor = Pointer<NativeFunction<GlVertexBindingDivisorNative>>.fromAddress(0).asFunction<GlVertexBindingDivisor>();
GlDebugMessageControl glDebugMessageControl = Pointer<NativeFunction<GlDebugMessageControlNative>>.fromAddress(0).asFunction<GlDebugMessageControl>();
GlDebugMessageInsert glDebugMessageInsert = Pointer<NativeFunction<GlDebugMessageInsertNative>>.fromAddress(0).asFunction<GlDebugMessageInsert>();
GlDebugMessageCallback glDebugMessageCallback = Pointer<NativeFunction<GlDebugMessageCallbackNative>>.fromAddress(0).asFunction<GlDebugMessageCallback>();
GlGetDebugMessageLog glGetDebugMessageLog = Pointer<NativeFunction<GlGetDebugMessageLogNative>>.fromAddress(0).asFunction<GlGetDebugMessageLog>();
GlPushDebugGroup glPushDebugGroup = Pointer<NativeFunction<GlPushDebugGroupNative>>.fromAddress(0).asFunction<GlPushDebugGroup>();
GlPopDebugGroup glPopDebugGroup = Pointer<NativeFunction<GlPopDebugGroupNative>>.fromAddress(0).asFunction<GlPopDebugGroup>();
GlObjectLabel glObjectLabel = Pointer<NativeFunction<GlObjectLabelNative>>.fromAddress(0).asFunction<GlObjectLabel>();
GlGetObjectLabel glGetObjectLabel = Pointer<NativeFunction<GlGetObjectLabelNative>>.fromAddress(0).asFunction<GlGetObjectLabel>();
GlObjectPtrLabel glObjectPtrLabel = Pointer<NativeFunction<GlObjectPtrLabelNative>>.fromAddress(0).asFunction<GlObjectPtrLabel>();
GlGetObjectPtrLabel glGetObjectPtrLabel = Pointer<NativeFunction<GlGetObjectPtrLabelNative>>.fromAddress(0).asFunction<GlGetObjectPtrLabel>();
GlBufferStorage glBufferStorage = Pointer<NativeFunction<GlBufferStorageNative>>.fromAddress(0).asFunction<GlBufferStorage>();
GlClearTexImage glClearTexImage = Pointer<NativeFunction<GlClearTexImageNative>>.fromAddress(0).asFunction<GlClearTexImage>();
GlClearTexSubImage glClearTexSubImage = Pointer<NativeFunction<GlClearTexSubImageNative>>.fromAddress(0).asFunction<GlClearTexSubImage>();
GlBindBuffersBase glBindBuffersBase = Pointer<NativeFunction<GlBindBuffersBaseNative>>.fromAddress(0).asFunction<GlBindBuffersBase>();
GlBindBuffersRange glBindBuffersRange = Pointer<NativeFunction<GlBindBuffersRangeNative>>.fromAddress(0).asFunction<GlBindBuffersRange>();
GlBindTextures glBindTextures = Pointer<NativeFunction<GlBindTexturesNative>>.fromAddress(0).asFunction<GlBindTextures>();
GlBindSamplers glBindSamplers = Pointer<NativeFunction<GlBindSamplersNative>>.fromAddress(0).asFunction<GlBindSamplers>();
GlBindImageTextures glBindImageTextures = Pointer<NativeFunction<GlBindImageTexturesNative>>.fromAddress(0).asFunction<GlBindImageTextures>();
GlBindVertexBuffers glBindVertexBuffers = Pointer<NativeFunction<GlBindVertexBuffersNative>>.fromAddress(0).asFunction<GlBindVertexBuffers>();
GlClipControl glClipControl = Pointer<NativeFunction<GlClipControlNative>>.fromAddress(0).asFunction<GlClipControl>();
GlCreateTransformFeedbacks glCreateTransformFeedbacks = Pointer<NativeFunction<GlCreateTransformFeedbacksNative>>.fromAddress(0).asFunction<GlCreateTransformFeedbacks>();
GlTransformFeedbackBufferBase glTransformFeedbackBufferBase = Pointer<NativeFunction<GlTransformFeedbackBufferBaseNative>>.fromAddress(0).asFunction<GlTransformFeedbackBufferBase>();
GlTransformFeedbackBufferRange glTransformFeedbackBufferRange = Pointer<NativeFunction<GlTransformFeedbackBufferRangeNative>>.fromAddress(0).asFunction<GlTransformFeedbackBufferRange>();
GlGetTransformFeedbackiv glGetTransformFeedbackiv = Pointer<NativeFunction<GlGetTransformFeedbackivNative>>.fromAddress(0).asFunction<GlGetTransformFeedbackiv>();
GlGetTransformFeedbacki_v glGetTransformFeedbacki_v = Pointer<NativeFunction<GlGetTransformFeedbacki_vNative>>.fromAddress(0).asFunction<GlGetTransformFeedbacki_v>();
GlGetTransformFeedbacki64_v glGetTransformFeedbacki64_v = Pointer<NativeFunction<GlGetTransformFeedbacki64_vNative>>.fromAddress(0).asFunction<GlGetTransformFeedbacki64_v>();
GlCreateBuffers glCreateBuffers = Pointer<NativeFunction<GlCreateBuffersNative>>.fromAddress(0).asFunction<GlCreateBuffers>();
GlNamedBufferStorage glNamedBufferStorage = Pointer<NativeFunction<GlNamedBufferStorageNative>>.fromAddress(0).asFunction<GlNamedBufferStorage>();
GlNamedBufferData glNamedBufferData = Pointer<NativeFunction<GlNamedBufferDataNative>>.fromAddress(0).asFunction<GlNamedBufferData>();
GlNamedBufferSubData glNamedBufferSubData = Pointer<NativeFunction<GlNamedBufferSubDataNative>>.fromAddress(0).asFunction<GlNamedBufferSubData>();
GlCopyNamedBufferSubData glCopyNamedBufferSubData = Pointer<NativeFunction<GlCopyNamedBufferSubDataNative>>.fromAddress(0).asFunction<GlCopyNamedBufferSubData>();
GlClearNamedBufferData glClearNamedBufferData = Pointer<NativeFunction<GlClearNamedBufferDataNative>>.fromAddress(0).asFunction<GlClearNamedBufferData>();
GlClearNamedBufferSubData glClearNamedBufferSubData = Pointer<NativeFunction<GlClearNamedBufferSubDataNative>>.fromAddress(0).asFunction<GlClearNamedBufferSubData>();
GlMapNamedBuffer glMapNamedBuffer = Pointer<NativeFunction<GlMapNamedBufferNative>>.fromAddress(0).asFunction<GlMapNamedBuffer>();
GlMapNamedBufferRange glMapNamedBufferRange = Pointer<NativeFunction<GlMapNamedBufferRangeNative>>.fromAddress(0).asFunction<GlMapNamedBufferRange>();
GlUnmapNamedBuffer glUnmapNamedBuffer = Pointer<NativeFunction<GlUnmapNamedBufferNative>>.fromAddress(0).asFunction<GlUnmapNamedBuffer>();
GlFlushMappedNamedBufferRange glFlushMappedNamedBufferRange = Pointer<NativeFunction<GlFlushMappedNamedBufferRangeNative>>.fromAddress(0).asFunction<GlFlushMappedNamedBufferRange>();
GlGetNamedBufferParameteriv glGetNamedBufferParameteriv = Pointer<NativeFunction<GlGetNamedBufferParameterivNative>>.fromAddress(0).asFunction<GlGetNamedBufferParameteriv>();
GlGetNamedBufferParameteri64v glGetNamedBufferParameteri64v = Pointer<NativeFunction<GlGetNamedBufferParameteri64vNative>>.fromAddress(0).asFunction<GlGetNamedBufferParameteri64v>();
GlGetNamedBufferPointerv glGetNamedBufferPointerv = Pointer<NativeFunction<GlGetNamedBufferPointervNative>>.fromAddress(0).asFunction<GlGetNamedBufferPointerv>();
GlGetNamedBufferSubData glGetNamedBufferSubData = Pointer<NativeFunction<GlGetNamedBufferSubDataNative>>.fromAddress(0).asFunction<GlGetNamedBufferSubData>();
GlCreateFramebuffers glCreateFramebuffers = Pointer<NativeFunction<GlCreateFramebuffersNative>>.fromAddress(0).asFunction<GlCreateFramebuffers>();
GlNamedFramebufferRenderbuffer glNamedFramebufferRenderbuffer = Pointer<NativeFunction<GlNamedFramebufferRenderbufferNative>>.fromAddress(0).asFunction<GlNamedFramebufferRenderbuffer>();
GlNamedFramebufferParameteri glNamedFramebufferParameteri = Pointer<NativeFunction<GlNamedFramebufferParameteriNative>>.fromAddress(0).asFunction<GlNamedFramebufferParameteri>();
GlNamedFramebufferTexture glNamedFramebufferTexture = Pointer<NativeFunction<GlNamedFramebufferTextureNative>>.fromAddress(0).asFunction<GlNamedFramebufferTexture>();
GlNamedFramebufferTextureLayer glNamedFramebufferTextureLayer = Pointer<NativeFunction<GlNamedFramebufferTextureLayerNative>>.fromAddress(0).asFunction<GlNamedFramebufferTextureLayer>();
GlNamedFramebufferDrawBuffer glNamedFramebufferDrawBuffer = Pointer<NativeFunction<GlNamedFramebufferDrawBufferNative>>.fromAddress(0).asFunction<GlNamedFramebufferDrawBuffer>();
GlNamedFramebufferDrawBuffers glNamedFramebufferDrawBuffers = Pointer<NativeFunction<GlNamedFramebufferDrawBuffersNative>>.fromAddress(0).asFunction<GlNamedFramebufferDrawBuffers>();
GlNamedFramebufferReadBuffer glNamedFramebufferReadBuffer = Pointer<NativeFunction<GlNamedFramebufferReadBufferNative>>.fromAddress(0).asFunction<GlNamedFramebufferReadBuffer>();
GlInvalidateNamedFramebufferData glInvalidateNamedFramebufferData = Pointer<NativeFunction<GlInvalidateNamedFramebufferDataNative>>.fromAddress(0).asFunction<GlInvalidateNamedFramebufferData>();
GlInvalidateNamedFramebufferSubData glInvalidateNamedFramebufferSubData = Pointer<NativeFunction<GlInvalidateNamedFramebufferSubDataNative>>.fromAddress(0).asFunction<GlInvalidateNamedFramebufferSubData>();
GlClearNamedFramebufferiv glClearNamedFramebufferiv = Pointer<NativeFunction<GlClearNamedFramebufferivNative>>.fromAddress(0).asFunction<GlClearNamedFramebufferiv>();
GlClearNamedFramebufferuiv glClearNamedFramebufferuiv = Pointer<NativeFunction<GlClearNamedFramebufferuivNative>>.fromAddress(0).asFunction<GlClearNamedFramebufferuiv>();
GlClearNamedFramebufferfv glClearNamedFramebufferfv = Pointer<NativeFunction<GlClearNamedFramebufferfvNative>>.fromAddress(0).asFunction<GlClearNamedFramebufferfv>();
GlClearNamedFramebufferfi glClearNamedFramebufferfi = Pointer<NativeFunction<GlClearNamedFramebufferfiNative>>.fromAddress(0).asFunction<GlClearNamedFramebufferfi>();
GlBlitNamedFramebuffer glBlitNamedFramebuffer = Pointer<NativeFunction<GlBlitNamedFramebufferNative>>.fromAddress(0).asFunction<GlBlitNamedFramebuffer>();
GlCheckNamedFramebufferStatus glCheckNamedFramebufferStatus = Pointer<NativeFunction<GlCheckNamedFramebufferStatusNative>>.fromAddress(0).asFunction<GlCheckNamedFramebufferStatus>();
GlGetNamedFramebufferParameteriv glGetNamedFramebufferParameteriv = Pointer<NativeFunction<GlGetNamedFramebufferParameterivNative>>.fromAddress(0).asFunction<GlGetNamedFramebufferParameteriv>();
GlGetNamedFramebufferAttachmentParameteriv glGetNamedFramebufferAttachmentParameteriv = Pointer<NativeFunction<GlGetNamedFramebufferAttachmentParameterivNative>>.fromAddress(0).asFunction<GlGetNamedFramebufferAttachmentParameteriv>();
GlCreateRenderbuffers glCreateRenderbuffers = Pointer<NativeFunction<GlCreateRenderbuffersNative>>.fromAddress(0).asFunction<GlCreateRenderbuffers>();
GlNamedRenderbufferStorage glNamedRenderbufferStorage = Pointer<NativeFunction<GlNamedRenderbufferStorageNative>>.fromAddress(0).asFunction<GlNamedRenderbufferStorage>();
GlNamedRenderbufferStorageMultisample glNamedRenderbufferStorageMultisample = Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleNative>>.fromAddress(0).asFunction<GlNamedRenderbufferStorageMultisample>();
GlGetNamedRenderbufferParameteriv glGetNamedRenderbufferParameteriv = Pointer<NativeFunction<GlGetNamedRenderbufferParameterivNative>>.fromAddress(0).asFunction<GlGetNamedRenderbufferParameteriv>();
GlCreateTextures glCreateTextures = Pointer<NativeFunction<GlCreateTexturesNative>>.fromAddress(0).asFunction<GlCreateTextures>();
GlTextureBuffer glTextureBuffer = Pointer<NativeFunction<GlTextureBufferNative>>.fromAddress(0).asFunction<GlTextureBuffer>();
GlTextureBufferRange glTextureBufferRange = Pointer<NativeFunction<GlTextureBufferRangeNative>>.fromAddress(0).asFunction<GlTextureBufferRange>();
GlTextureStorage1D glTextureStorage1D = Pointer<NativeFunction<GlTextureStorage1DNative>>.fromAddress(0).asFunction<GlTextureStorage1D>();
GlTextureStorage2D glTextureStorage2D = Pointer<NativeFunction<GlTextureStorage2DNative>>.fromAddress(0).asFunction<GlTextureStorage2D>();
GlTextureStorage3D glTextureStorage3D = Pointer<NativeFunction<GlTextureStorage3DNative>>.fromAddress(0).asFunction<GlTextureStorage3D>();
GlTextureStorage2DMultisample glTextureStorage2DMultisample = Pointer<NativeFunction<GlTextureStorage2DMultisampleNative>>.fromAddress(0).asFunction<GlTextureStorage2DMultisample>();
GlTextureStorage3DMultisample glTextureStorage3DMultisample = Pointer<NativeFunction<GlTextureStorage3DMultisampleNative>>.fromAddress(0).asFunction<GlTextureStorage3DMultisample>();
GlTextureSubImage1D glTextureSubImage1D = Pointer<NativeFunction<GlTextureSubImage1DNative>>.fromAddress(0).asFunction<GlTextureSubImage1D>();
GlTextureSubImage2D glTextureSubImage2D = Pointer<NativeFunction<GlTextureSubImage2DNative>>.fromAddress(0).asFunction<GlTextureSubImage2D>();
GlTextureSubImage3D glTextureSubImage3D = Pointer<NativeFunction<GlTextureSubImage3DNative>>.fromAddress(0).asFunction<GlTextureSubImage3D>();
GlCompressedTextureSubImage1D glCompressedTextureSubImage1D = Pointer<NativeFunction<GlCompressedTextureSubImage1DNative>>.fromAddress(0).asFunction<GlCompressedTextureSubImage1D>();
GlCompressedTextureSubImage2D glCompressedTextureSubImage2D = Pointer<NativeFunction<GlCompressedTextureSubImage2DNative>>.fromAddress(0).asFunction<GlCompressedTextureSubImage2D>();
GlCompressedTextureSubImage3D glCompressedTextureSubImage3D = Pointer<NativeFunction<GlCompressedTextureSubImage3DNative>>.fromAddress(0).asFunction<GlCompressedTextureSubImage3D>();
GlCopyTextureSubImage1D glCopyTextureSubImage1D = Pointer<NativeFunction<GlCopyTextureSubImage1DNative>>.fromAddress(0).asFunction<GlCopyTextureSubImage1D>();
GlCopyTextureSubImage2D glCopyTextureSubImage2D = Pointer<NativeFunction<GlCopyTextureSubImage2DNative>>.fromAddress(0).asFunction<GlCopyTextureSubImage2D>();
GlCopyTextureSubImage3D glCopyTextureSubImage3D = Pointer<NativeFunction<GlCopyTextureSubImage3DNative>>.fromAddress(0).asFunction<GlCopyTextureSubImage3D>();
GlTextureParameterf glTextureParameterf = Pointer<NativeFunction<GlTextureParameterfNative>>.fromAddress(0).asFunction<GlTextureParameterf>();
GlTextureParameterfv glTextureParameterfv = Pointer<NativeFunction<GlTextureParameterfvNative>>.fromAddress(0).asFunction<GlTextureParameterfv>();
GlTextureParameteri glTextureParameteri = Pointer<NativeFunction<GlTextureParameteriNative>>.fromAddress(0).asFunction<GlTextureParameteri>();
GlTextureParameterIiv glTextureParameterIiv = Pointer<NativeFunction<GlTextureParameterIivNative>>.fromAddress(0).asFunction<GlTextureParameterIiv>();
GlTextureParameterIuiv glTextureParameterIuiv = Pointer<NativeFunction<GlTextureParameterIuivNative>>.fromAddress(0).asFunction<GlTextureParameterIuiv>();
GlTextureParameteriv glTextureParameteriv = Pointer<NativeFunction<GlTextureParameterivNative>>.fromAddress(0).asFunction<GlTextureParameteriv>();
GlGenerateTextureMipmap glGenerateTextureMipmap = Pointer<NativeFunction<GlGenerateTextureMipmapNative>>.fromAddress(0).asFunction<GlGenerateTextureMipmap>();
GlBindTextureUnit glBindTextureUnit = Pointer<NativeFunction<GlBindTextureUnitNative>>.fromAddress(0).asFunction<GlBindTextureUnit>();
GlGetTextureImage glGetTextureImage = Pointer<NativeFunction<GlGetTextureImageNative>>.fromAddress(0).asFunction<GlGetTextureImage>();
GlGetCompressedTextureImage glGetCompressedTextureImage = Pointer<NativeFunction<GlGetCompressedTextureImageNative>>.fromAddress(0).asFunction<GlGetCompressedTextureImage>();
GlGetTextureLevelParameterfv glGetTextureLevelParameterfv = Pointer<NativeFunction<GlGetTextureLevelParameterfvNative>>.fromAddress(0).asFunction<GlGetTextureLevelParameterfv>();
GlGetTextureLevelParameteriv glGetTextureLevelParameteriv = Pointer<NativeFunction<GlGetTextureLevelParameterivNative>>.fromAddress(0).asFunction<GlGetTextureLevelParameteriv>();
GlGetTextureParameterfv glGetTextureParameterfv = Pointer<NativeFunction<GlGetTextureParameterfvNative>>.fromAddress(0).asFunction<GlGetTextureParameterfv>();
GlGetTextureParameterIiv glGetTextureParameterIiv = Pointer<NativeFunction<GlGetTextureParameterIivNative>>.fromAddress(0).asFunction<GlGetTextureParameterIiv>();
GlGetTextureParameterIuiv glGetTextureParameterIuiv = Pointer<NativeFunction<GlGetTextureParameterIuivNative>>.fromAddress(0).asFunction<GlGetTextureParameterIuiv>();
GlGetTextureParameteriv glGetTextureParameteriv = Pointer<NativeFunction<GlGetTextureParameterivNative>>.fromAddress(0).asFunction<GlGetTextureParameteriv>();
GlCreateVertexArrays glCreateVertexArrays = Pointer<NativeFunction<GlCreateVertexArraysNative>>.fromAddress(0).asFunction<GlCreateVertexArrays>();
GlDisableVertexArrayAttrib glDisableVertexArrayAttrib = Pointer<NativeFunction<GlDisableVertexArrayAttribNative>>.fromAddress(0).asFunction<GlDisableVertexArrayAttrib>();
GlEnableVertexArrayAttrib glEnableVertexArrayAttrib = Pointer<NativeFunction<GlEnableVertexArrayAttribNative>>.fromAddress(0).asFunction<GlEnableVertexArrayAttrib>();
GlVertexArrayElementBuffer glVertexArrayElementBuffer = Pointer<NativeFunction<GlVertexArrayElementBufferNative>>.fromAddress(0).asFunction<GlVertexArrayElementBuffer>();
GlVertexArrayVertexBuffer glVertexArrayVertexBuffer = Pointer<NativeFunction<GlVertexArrayVertexBufferNative>>.fromAddress(0).asFunction<GlVertexArrayVertexBuffer>();
GlVertexArrayVertexBuffers glVertexArrayVertexBuffers = Pointer<NativeFunction<GlVertexArrayVertexBuffersNative>>.fromAddress(0).asFunction<GlVertexArrayVertexBuffers>();
GlVertexArrayAttribBinding glVertexArrayAttribBinding = Pointer<NativeFunction<GlVertexArrayAttribBindingNative>>.fromAddress(0).asFunction<GlVertexArrayAttribBinding>();
GlVertexArrayAttribFormat glVertexArrayAttribFormat = Pointer<NativeFunction<GlVertexArrayAttribFormatNative>>.fromAddress(0).asFunction<GlVertexArrayAttribFormat>();
GlVertexArrayAttribIFormat glVertexArrayAttribIFormat = Pointer<NativeFunction<GlVertexArrayAttribIFormatNative>>.fromAddress(0).asFunction<GlVertexArrayAttribIFormat>();
GlVertexArrayAttribLFormat glVertexArrayAttribLFormat = Pointer<NativeFunction<GlVertexArrayAttribLFormatNative>>.fromAddress(0).asFunction<GlVertexArrayAttribLFormat>();
GlVertexArrayBindingDivisor glVertexArrayBindingDivisor = Pointer<NativeFunction<GlVertexArrayBindingDivisorNative>>.fromAddress(0).asFunction<GlVertexArrayBindingDivisor>();
GlGetVertexArrayiv glGetVertexArrayiv = Pointer<NativeFunction<GlGetVertexArrayivNative>>.fromAddress(0).asFunction<GlGetVertexArrayiv>();
GlGetVertexArrayIndexediv glGetVertexArrayIndexediv = Pointer<NativeFunction<GlGetVertexArrayIndexedivNative>>.fromAddress(0).asFunction<GlGetVertexArrayIndexediv>();
GlGetVertexArrayIndexed64iv glGetVertexArrayIndexed64iv = Pointer<NativeFunction<GlGetVertexArrayIndexed64ivNative>>.fromAddress(0).asFunction<GlGetVertexArrayIndexed64iv>();
GlCreateSamplers glCreateSamplers = Pointer<NativeFunction<GlCreateSamplersNative>>.fromAddress(0).asFunction<GlCreateSamplers>();
GlCreateProgramPipelines glCreateProgramPipelines = Pointer<NativeFunction<GlCreateProgramPipelinesNative>>.fromAddress(0).asFunction<GlCreateProgramPipelines>();
GlCreateQueries glCreateQueries = Pointer<NativeFunction<GlCreateQueriesNative>>.fromAddress(0).asFunction<GlCreateQueries>();
GlGetQueryBufferObjecti64v glGetQueryBufferObjecti64v = Pointer<NativeFunction<GlGetQueryBufferObjecti64vNative>>.fromAddress(0).asFunction<GlGetQueryBufferObjecti64v>();
GlGetQueryBufferObjectiv glGetQueryBufferObjectiv = Pointer<NativeFunction<GlGetQueryBufferObjectivNative>>.fromAddress(0).asFunction<GlGetQueryBufferObjectiv>();
GlGetQueryBufferObjectui64v glGetQueryBufferObjectui64v = Pointer<NativeFunction<GlGetQueryBufferObjectui64vNative>>.fromAddress(0).asFunction<GlGetQueryBufferObjectui64v>();
GlGetQueryBufferObjectuiv glGetQueryBufferObjectuiv = Pointer<NativeFunction<GlGetQueryBufferObjectuivNative>>.fromAddress(0).asFunction<GlGetQueryBufferObjectuiv>();
GlMemoryBarrierByRegion glMemoryBarrierByRegion = Pointer<NativeFunction<GlMemoryBarrierByRegionNative>>.fromAddress(0).asFunction<GlMemoryBarrierByRegion>();
GlGetTextureSubImage glGetTextureSubImage = Pointer<NativeFunction<GlGetTextureSubImageNative>>.fromAddress(0).asFunction<GlGetTextureSubImage>();
GlGetCompressedTextureSubImage glGetCompressedTextureSubImage = Pointer<NativeFunction<GlGetCompressedTextureSubImageNative>>.fromAddress(0).asFunction<GlGetCompressedTextureSubImage>();
GlGetGraphicsResetStatus glGetGraphicsResetStatus = Pointer<NativeFunction<GlGetGraphicsResetStatusNative>>.fromAddress(0).asFunction<GlGetGraphicsResetStatus>();
GlGetnCompressedTexImage glGetnCompressedTexImage = Pointer<NativeFunction<GlGetnCompressedTexImageNative>>.fromAddress(0).asFunction<GlGetnCompressedTexImage>();
GlGetnTexImage glGetnTexImage = Pointer<NativeFunction<GlGetnTexImageNative>>.fromAddress(0).asFunction<GlGetnTexImage>();
GlGetnUniformdv glGetnUniformdv = Pointer<NativeFunction<GlGetnUniformdvNative>>.fromAddress(0).asFunction<GlGetnUniformdv>();
GlGetnUniformfv glGetnUniformfv = Pointer<NativeFunction<GlGetnUniformfvNative>>.fromAddress(0).asFunction<GlGetnUniformfv>();
GlGetnUniformiv glGetnUniformiv = Pointer<NativeFunction<GlGetnUniformivNative>>.fromAddress(0).asFunction<GlGetnUniformiv>();
GlGetnUniformuiv glGetnUniformuiv = Pointer<NativeFunction<GlGetnUniformuivNative>>.fromAddress(0).asFunction<GlGetnUniformuiv>();
GlReadnPixels glReadnPixels = Pointer<NativeFunction<GlReadnPixelsNative>>.fromAddress(0).asFunction<GlReadnPixels>();
GlTextureBarrier glTextureBarrier = Pointer<NativeFunction<GlTextureBarrierNative>>.fromAddress(0).asFunction<GlTextureBarrier>();
GlSpecializeShader glSpecializeShader = Pointer<NativeFunction<GlSpecializeShaderNative>>.fromAddress(0).asFunction<GlSpecializeShader>();
GlMultiDrawArraysIndirectCount glMultiDrawArraysIndirectCount = Pointer<NativeFunction<GlMultiDrawArraysIndirectCountNative>>.fromAddress(0).asFunction<GlMultiDrawArraysIndirectCount>();
GlMultiDrawElementsIndirectCount glMultiDrawElementsIndirectCount = Pointer<NativeFunction<GlMultiDrawElementsIndirectCountNative>>.fromAddress(0).asFunction<GlMultiDrawElementsIndirectCount>();
GlPolygonOffsetClamp glPolygonOffsetClamp = Pointer<NativeFunction<GlPolygonOffsetClampNative>>.fromAddress(0).asFunction<GlPolygonOffsetClamp>();
GlPrimitiveBoundingBoxARB glPrimitiveBoundingBoxARB = Pointer<NativeFunction<GlPrimitiveBoundingBoxARBNative>>.fromAddress(0).asFunction<GlPrimitiveBoundingBoxARB>();
GlGetTextureHandleARB glGetTextureHandleARB = Pointer<NativeFunction<GlGetTextureHandleARBNative>>.fromAddress(0).asFunction<GlGetTextureHandleARB>();
GlGetTextureSamplerHandleARB glGetTextureSamplerHandleARB = Pointer<NativeFunction<GlGetTextureSamplerHandleARBNative>>.fromAddress(0).asFunction<GlGetTextureSamplerHandleARB>();
GlMakeTextureHandleResidentARB glMakeTextureHandleResidentARB = Pointer<NativeFunction<GlMakeTextureHandleResidentARBNative>>.fromAddress(0).asFunction<GlMakeTextureHandleResidentARB>();
GlMakeTextureHandleNonResidentARB glMakeTextureHandleNonResidentARB = Pointer<NativeFunction<GlMakeTextureHandleNonResidentARBNative>>.fromAddress(0).asFunction<GlMakeTextureHandleNonResidentARB>();
GlGetImageHandleARB glGetImageHandleARB = Pointer<NativeFunction<GlGetImageHandleARBNative>>.fromAddress(0).asFunction<GlGetImageHandleARB>();
GlMakeImageHandleResidentARB glMakeImageHandleResidentARB = Pointer<NativeFunction<GlMakeImageHandleResidentARBNative>>.fromAddress(0).asFunction<GlMakeImageHandleResidentARB>();
GlMakeImageHandleNonResidentARB glMakeImageHandleNonResidentARB = Pointer<NativeFunction<GlMakeImageHandleNonResidentARBNative>>.fromAddress(0).asFunction<GlMakeImageHandleNonResidentARB>();
GlUniformHandleui64ARB glUniformHandleui64ARB = Pointer<NativeFunction<GlUniformHandleui64ARBNative>>.fromAddress(0).asFunction<GlUniformHandleui64ARB>();
GlUniformHandleui64vARB glUniformHandleui64vARB = Pointer<NativeFunction<GlUniformHandleui64vARBNative>>.fromAddress(0).asFunction<GlUniformHandleui64vARB>();
GlProgramUniformHandleui64ARB glProgramUniformHandleui64ARB = Pointer<NativeFunction<GlProgramUniformHandleui64ARBNative>>.fromAddress(0).asFunction<GlProgramUniformHandleui64ARB>();
GlProgramUniformHandleui64vARB glProgramUniformHandleui64vARB = Pointer<NativeFunction<GlProgramUniformHandleui64vARBNative>>.fromAddress(0).asFunction<GlProgramUniformHandleui64vARB>();
GlIsTextureHandleResidentARB glIsTextureHandleResidentARB = Pointer<NativeFunction<GlIsTextureHandleResidentARBNative>>.fromAddress(0).asFunction<GlIsTextureHandleResidentARB>();
GlIsImageHandleResidentARB glIsImageHandleResidentARB = Pointer<NativeFunction<GlIsImageHandleResidentARBNative>>.fromAddress(0).asFunction<GlIsImageHandleResidentARB>();
GlVertexAttribL1ui64ARB glVertexAttribL1ui64ARB = Pointer<NativeFunction<GlVertexAttribL1ui64ARBNative>>.fromAddress(0).asFunction<GlVertexAttribL1ui64ARB>();
GlVertexAttribL1ui64vARB glVertexAttribL1ui64vARB = Pointer<NativeFunction<GlVertexAttribL1ui64vARBNative>>.fromAddress(0).asFunction<GlVertexAttribL1ui64vARB>();
GlGetVertexAttribLui64vARB glGetVertexAttribLui64vARB = Pointer<NativeFunction<GlGetVertexAttribLui64vARBNative>>.fromAddress(0).asFunction<GlGetVertexAttribLui64vARB>();
GlCreateSyncFromCLeventARB glCreateSyncFromCLeventARB = Pointer<NativeFunction<GlCreateSyncFromCLeventARBNative>>.fromAddress(0).asFunction<GlCreateSyncFromCLeventARB>();
GlDispatchComputeGroupSizeARB glDispatchComputeGroupSizeARB = Pointer<NativeFunction<GlDispatchComputeGroupSizeARBNative>>.fromAddress(0).asFunction<GlDispatchComputeGroupSizeARB>();
GlDebugMessageControlARB glDebugMessageControlARB = Pointer<NativeFunction<GlDebugMessageControlARBNative>>.fromAddress(0).asFunction<GlDebugMessageControlARB>();
GlDebugMessageInsertARB glDebugMessageInsertARB = Pointer<NativeFunction<GlDebugMessageInsertARBNative>>.fromAddress(0).asFunction<GlDebugMessageInsertARB>();
GlDebugMessageCallbackARB glDebugMessageCallbackARB = Pointer<NativeFunction<GlDebugMessageCallbackARBNative>>.fromAddress(0).asFunction<GlDebugMessageCallbackARB>();
GlGetDebugMessageLogARB glGetDebugMessageLogARB = Pointer<NativeFunction<GlGetDebugMessageLogARBNative>>.fromAddress(0).asFunction<GlGetDebugMessageLogARB>();
GlBlendEquationiARB glBlendEquationiARB = Pointer<NativeFunction<GlBlendEquationiARBNative>>.fromAddress(0).asFunction<GlBlendEquationiARB>();
GlBlendEquationSeparateiARB glBlendEquationSeparateiARB = Pointer<NativeFunction<GlBlendEquationSeparateiARBNative>>.fromAddress(0).asFunction<GlBlendEquationSeparateiARB>();
GlBlendFunciARB glBlendFunciARB = Pointer<NativeFunction<GlBlendFunciARBNative>>.fromAddress(0).asFunction<GlBlendFunciARB>();
GlBlendFuncSeparateiARB glBlendFuncSeparateiARB = Pointer<NativeFunction<GlBlendFuncSeparateiARBNative>>.fromAddress(0).asFunction<GlBlendFuncSeparateiARB>();
GlDrawArraysInstancedARB glDrawArraysInstancedARB = Pointer<NativeFunction<GlDrawArraysInstancedARBNative>>.fromAddress(0).asFunction<GlDrawArraysInstancedARB>();
GlDrawElementsInstancedARB glDrawElementsInstancedARB = Pointer<NativeFunction<GlDrawElementsInstancedARBNative>>.fromAddress(0).asFunction<GlDrawElementsInstancedARB>();
GlProgramParameteriARB glProgramParameteriARB = Pointer<NativeFunction<GlProgramParameteriARBNative>>.fromAddress(0).asFunction<GlProgramParameteriARB>();
GlFramebufferTextureARB glFramebufferTextureARB = Pointer<NativeFunction<GlFramebufferTextureARBNative>>.fromAddress(0).asFunction<GlFramebufferTextureARB>();
GlFramebufferTextureLayerARB glFramebufferTextureLayerARB = Pointer<NativeFunction<GlFramebufferTextureLayerARBNative>>.fromAddress(0).asFunction<GlFramebufferTextureLayerARB>();
GlFramebufferTextureFaceARB glFramebufferTextureFaceARB = Pointer<NativeFunction<GlFramebufferTextureFaceARBNative>>.fromAddress(0).asFunction<GlFramebufferTextureFaceARB>();
GlSpecializeShaderARB glSpecializeShaderARB = Pointer<NativeFunction<GlSpecializeShaderARBNative>>.fromAddress(0).asFunction<GlSpecializeShaderARB>();
GlUniform1i64ARB glUniform1i64ARB = Pointer<NativeFunction<GlUniform1i64ARBNative>>.fromAddress(0).asFunction<GlUniform1i64ARB>();
GlUniform2i64ARB glUniform2i64ARB = Pointer<NativeFunction<GlUniform2i64ARBNative>>.fromAddress(0).asFunction<GlUniform2i64ARB>();
GlUniform3i64ARB glUniform3i64ARB = Pointer<NativeFunction<GlUniform3i64ARBNative>>.fromAddress(0).asFunction<GlUniform3i64ARB>();
GlUniform4i64ARB glUniform4i64ARB = Pointer<NativeFunction<GlUniform4i64ARBNative>>.fromAddress(0).asFunction<GlUniform4i64ARB>();
GlUniform1i64vARB glUniform1i64vARB = Pointer<NativeFunction<GlUniform1i64vARBNative>>.fromAddress(0).asFunction<GlUniform1i64vARB>();
GlUniform2i64vARB glUniform2i64vARB = Pointer<NativeFunction<GlUniform2i64vARBNative>>.fromAddress(0).asFunction<GlUniform2i64vARB>();
GlUniform3i64vARB glUniform3i64vARB = Pointer<NativeFunction<GlUniform3i64vARBNative>>.fromAddress(0).asFunction<GlUniform3i64vARB>();
GlUniform4i64vARB glUniform4i64vARB = Pointer<NativeFunction<GlUniform4i64vARBNative>>.fromAddress(0).asFunction<GlUniform4i64vARB>();
GlUniform1ui64ARB glUniform1ui64ARB = Pointer<NativeFunction<GlUniform1ui64ARBNative>>.fromAddress(0).asFunction<GlUniform1ui64ARB>();
GlUniform2ui64ARB glUniform2ui64ARB = Pointer<NativeFunction<GlUniform2ui64ARBNative>>.fromAddress(0).asFunction<GlUniform2ui64ARB>();
GlUniform3ui64ARB glUniform3ui64ARB = Pointer<NativeFunction<GlUniform3ui64ARBNative>>.fromAddress(0).asFunction<GlUniform3ui64ARB>();
GlUniform4ui64ARB glUniform4ui64ARB = Pointer<NativeFunction<GlUniform4ui64ARBNative>>.fromAddress(0).asFunction<GlUniform4ui64ARB>();
GlUniform1ui64vARB glUniform1ui64vARB = Pointer<NativeFunction<GlUniform1ui64vARBNative>>.fromAddress(0).asFunction<GlUniform1ui64vARB>();
GlUniform2ui64vARB glUniform2ui64vARB = Pointer<NativeFunction<GlUniform2ui64vARBNative>>.fromAddress(0).asFunction<GlUniform2ui64vARB>();
GlUniform3ui64vARB glUniform3ui64vARB = Pointer<NativeFunction<GlUniform3ui64vARBNative>>.fromAddress(0).asFunction<GlUniform3ui64vARB>();
GlUniform4ui64vARB glUniform4ui64vARB = Pointer<NativeFunction<GlUniform4ui64vARBNative>>.fromAddress(0).asFunction<GlUniform4ui64vARB>();
GlGetUniformi64vARB glGetUniformi64vARB = Pointer<NativeFunction<GlGetUniformi64vARBNative>>.fromAddress(0).asFunction<GlGetUniformi64vARB>();
GlGetUniformui64vARB glGetUniformui64vARB = Pointer<NativeFunction<GlGetUniformui64vARBNative>>.fromAddress(0).asFunction<GlGetUniformui64vARB>();
GlGetnUniformi64vARB glGetnUniformi64vARB = Pointer<NativeFunction<GlGetnUniformi64vARBNative>>.fromAddress(0).asFunction<GlGetnUniformi64vARB>();
GlGetnUniformui64vARB glGetnUniformui64vARB = Pointer<NativeFunction<GlGetnUniformui64vARBNative>>.fromAddress(0).asFunction<GlGetnUniformui64vARB>();
GlProgramUniform1i64ARB glProgramUniform1i64ARB = Pointer<NativeFunction<GlProgramUniform1i64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform1i64ARB>();
GlProgramUniform2i64ARB glProgramUniform2i64ARB = Pointer<NativeFunction<GlProgramUniform2i64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform2i64ARB>();
GlProgramUniform3i64ARB glProgramUniform3i64ARB = Pointer<NativeFunction<GlProgramUniform3i64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform3i64ARB>();
GlProgramUniform4i64ARB glProgramUniform4i64ARB = Pointer<NativeFunction<GlProgramUniform4i64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform4i64ARB>();
GlProgramUniform1i64vARB glProgramUniform1i64vARB = Pointer<NativeFunction<GlProgramUniform1i64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform1i64vARB>();
GlProgramUniform2i64vARB glProgramUniform2i64vARB = Pointer<NativeFunction<GlProgramUniform2i64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform2i64vARB>();
GlProgramUniform3i64vARB glProgramUniform3i64vARB = Pointer<NativeFunction<GlProgramUniform3i64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform3i64vARB>();
GlProgramUniform4i64vARB glProgramUniform4i64vARB = Pointer<NativeFunction<GlProgramUniform4i64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform4i64vARB>();
GlProgramUniform1ui64ARB glProgramUniform1ui64ARB = Pointer<NativeFunction<GlProgramUniform1ui64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform1ui64ARB>();
GlProgramUniform2ui64ARB glProgramUniform2ui64ARB = Pointer<NativeFunction<GlProgramUniform2ui64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform2ui64ARB>();
GlProgramUniform3ui64ARB glProgramUniform3ui64ARB = Pointer<NativeFunction<GlProgramUniform3ui64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform3ui64ARB>();
GlProgramUniform4ui64ARB glProgramUniform4ui64ARB = Pointer<NativeFunction<GlProgramUniform4ui64ARBNative>>.fromAddress(0).asFunction<GlProgramUniform4ui64ARB>();
GlProgramUniform1ui64vARB glProgramUniform1ui64vARB = Pointer<NativeFunction<GlProgramUniform1ui64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform1ui64vARB>();
GlProgramUniform2ui64vARB glProgramUniform2ui64vARB = Pointer<NativeFunction<GlProgramUniform2ui64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform2ui64vARB>();
GlProgramUniform3ui64vARB glProgramUniform3ui64vARB = Pointer<NativeFunction<GlProgramUniform3ui64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform3ui64vARB>();
GlProgramUniform4ui64vARB glProgramUniform4ui64vARB = Pointer<NativeFunction<GlProgramUniform4ui64vARBNative>>.fromAddress(0).asFunction<GlProgramUniform4ui64vARB>();
GlMultiDrawArraysIndirectCountARB glMultiDrawArraysIndirectCountARB = Pointer<NativeFunction<GlMultiDrawArraysIndirectCountARBNative>>.fromAddress(0).asFunction<GlMultiDrawArraysIndirectCountARB>();
GlMultiDrawElementsIndirectCountARB glMultiDrawElementsIndirectCountARB = Pointer<NativeFunction<GlMultiDrawElementsIndirectCountARBNative>>.fromAddress(0).asFunction<GlMultiDrawElementsIndirectCountARB>();
GlVertexAttribDivisorARB glVertexAttribDivisorARB = Pointer<NativeFunction<GlVertexAttribDivisorARBNative>>.fromAddress(0).asFunction<GlVertexAttribDivisorARB>();
GlMaxShaderCompilerThreadsARB glMaxShaderCompilerThreadsARB = Pointer<NativeFunction<GlMaxShaderCompilerThreadsARBNative>>.fromAddress(0).asFunction<GlMaxShaderCompilerThreadsARB>();
GlGetGraphicsResetStatusARB glGetGraphicsResetStatusARB = Pointer<NativeFunction<GlGetGraphicsResetStatusARBNative>>.fromAddress(0).asFunction<GlGetGraphicsResetStatusARB>();
GlGetnTexImageARB glGetnTexImageARB = Pointer<NativeFunction<GlGetnTexImageARBNative>>.fromAddress(0).asFunction<GlGetnTexImageARB>();
GlReadnPixelsARB glReadnPixelsARB = Pointer<NativeFunction<GlReadnPixelsARBNative>>.fromAddress(0).asFunction<GlReadnPixelsARB>();
GlGetnCompressedTexImageARB glGetnCompressedTexImageARB = Pointer<NativeFunction<GlGetnCompressedTexImageARBNative>>.fromAddress(0).asFunction<GlGetnCompressedTexImageARB>();
GlGetnUniformfvARB glGetnUniformfvARB = Pointer<NativeFunction<GlGetnUniformfvARBNative>>.fromAddress(0).asFunction<GlGetnUniformfvARB>();
GlGetnUniformivARB glGetnUniformivARB = Pointer<NativeFunction<GlGetnUniformivARBNative>>.fromAddress(0).asFunction<GlGetnUniformivARB>();
GlGetnUniformuivARB glGetnUniformuivARB = Pointer<NativeFunction<GlGetnUniformuivARBNative>>.fromAddress(0).asFunction<GlGetnUniformuivARB>();
GlGetnUniformdvARB glGetnUniformdvARB = Pointer<NativeFunction<GlGetnUniformdvARBNative>>.fromAddress(0).asFunction<GlGetnUniformdvARB>();
GlFramebufferSampleLocationsfvARB glFramebufferSampleLocationsfvARB = Pointer<NativeFunction<GlFramebufferSampleLocationsfvARBNative>>.fromAddress(0).asFunction<GlFramebufferSampleLocationsfvARB>();
GlNamedFramebufferSampleLocationsfvARB glNamedFramebufferSampleLocationsfvARB = Pointer<NativeFunction<GlNamedFramebufferSampleLocationsfvARBNative>>.fromAddress(0).asFunction<GlNamedFramebufferSampleLocationsfvARB>();
GlEvaluateDepthValuesARB glEvaluateDepthValuesARB = Pointer<NativeFunction<GlEvaluateDepthValuesARBNative>>.fromAddress(0).asFunction<GlEvaluateDepthValuesARB>();
GlMinSampleShadingARB glMinSampleShadingARB = Pointer<NativeFunction<GlMinSampleShadingARBNative>>.fromAddress(0).asFunction<GlMinSampleShadingARB>();
GlNamedStringARB glNamedStringARB = Pointer<NativeFunction<GlNamedStringARBNative>>.fromAddress(0).asFunction<GlNamedStringARB>();
GlDeleteNamedStringARB glDeleteNamedStringARB = Pointer<NativeFunction<GlDeleteNamedStringARBNative>>.fromAddress(0).asFunction<GlDeleteNamedStringARB>();
GlCompileShaderIncludeARB glCompileShaderIncludeARB = Pointer<NativeFunction<GlCompileShaderIncludeARBNative>>.fromAddress(0).asFunction<GlCompileShaderIncludeARB>();
GlIsNamedStringARB glIsNamedStringARB = Pointer<NativeFunction<GlIsNamedStringARBNative>>.fromAddress(0).asFunction<GlIsNamedStringARB>();
GlGetNamedStringARB glGetNamedStringARB = Pointer<NativeFunction<GlGetNamedStringARBNative>>.fromAddress(0).asFunction<GlGetNamedStringARB>();
GlGetNamedStringivARB glGetNamedStringivARB = Pointer<NativeFunction<GlGetNamedStringivARBNative>>.fromAddress(0).asFunction<GlGetNamedStringivARB>();
GlBufferPageCommitmentARB glBufferPageCommitmentARB = Pointer<NativeFunction<GlBufferPageCommitmentARBNative>>.fromAddress(0).asFunction<GlBufferPageCommitmentARB>();
GlNamedBufferPageCommitmentEXT glNamedBufferPageCommitmentEXT = Pointer<NativeFunction<GlNamedBufferPageCommitmentEXTNative>>.fromAddress(0).asFunction<GlNamedBufferPageCommitmentEXT>();
GlNamedBufferPageCommitmentARB glNamedBufferPageCommitmentARB = Pointer<NativeFunction<GlNamedBufferPageCommitmentARBNative>>.fromAddress(0).asFunction<GlNamedBufferPageCommitmentARB>();
GlTexPageCommitmentARB glTexPageCommitmentARB = Pointer<NativeFunction<GlTexPageCommitmentARBNative>>.fromAddress(0).asFunction<GlTexPageCommitmentARB>();
GlTexBufferARB glTexBufferARB = Pointer<NativeFunction<GlTexBufferARBNative>>.fromAddress(0).asFunction<GlTexBufferARB>();
GlDepthRangeArraydvNV glDepthRangeArraydvNV = Pointer<NativeFunction<GlDepthRangeArraydvNVNative>>.fromAddress(0).asFunction<GlDepthRangeArraydvNV>();
GlDepthRangeIndexeddNV glDepthRangeIndexeddNV = Pointer<NativeFunction<GlDepthRangeIndexeddNVNative>>.fromAddress(0).asFunction<GlDepthRangeIndexeddNV>();
GlBlendBarrierKHR glBlendBarrierKHR = Pointer<NativeFunction<GlBlendBarrierKHRNative>>.fromAddress(0).asFunction<GlBlendBarrierKHR>();
GlMaxShaderCompilerThreadsKHR glMaxShaderCompilerThreadsKHR = Pointer<NativeFunction<GlMaxShaderCompilerThreadsKHRNative>>.fromAddress(0).asFunction<GlMaxShaderCompilerThreadsKHR>();
GlRenderbufferStorageMultisampleAdvancedAMD glRenderbufferStorageMultisampleAdvancedAMD = Pointer<NativeFunction<GlRenderbufferStorageMultisampleAdvancedAMDNative>>.fromAddress(0).asFunction<GlRenderbufferStorageMultisampleAdvancedAMD>();
GlNamedRenderbufferStorageMultisampleAdvancedAMD glNamedRenderbufferStorageMultisampleAdvancedAMD = Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleAdvancedAMDNative>>.fromAddress(0).asFunction<GlNamedRenderbufferStorageMultisampleAdvancedAMD>();
GlGetPerfMonitorGroupsAMD glGetPerfMonitorGroupsAMD = Pointer<NativeFunction<GlGetPerfMonitorGroupsAMDNative>>.fromAddress(0).asFunction<GlGetPerfMonitorGroupsAMD>();
GlGetPerfMonitorCountersAMD glGetPerfMonitorCountersAMD = Pointer<NativeFunction<GlGetPerfMonitorCountersAMDNative>>.fromAddress(0).asFunction<GlGetPerfMonitorCountersAMD>();
GlGetPerfMonitorGroupStringAMD glGetPerfMonitorGroupStringAMD = Pointer<NativeFunction<GlGetPerfMonitorGroupStringAMDNative>>.fromAddress(0).asFunction<GlGetPerfMonitorGroupStringAMD>();
GlGetPerfMonitorCounterStringAMD glGetPerfMonitorCounterStringAMD = Pointer<NativeFunction<GlGetPerfMonitorCounterStringAMDNative>>.fromAddress(0).asFunction<GlGetPerfMonitorCounterStringAMD>();
GlGetPerfMonitorCounterInfoAMD glGetPerfMonitorCounterInfoAMD = Pointer<NativeFunction<GlGetPerfMonitorCounterInfoAMDNative>>.fromAddress(0).asFunction<GlGetPerfMonitorCounterInfoAMD>();
GlGenPerfMonitorsAMD glGenPerfMonitorsAMD = Pointer<NativeFunction<GlGenPerfMonitorsAMDNative>>.fromAddress(0).asFunction<GlGenPerfMonitorsAMD>();
GlDeletePerfMonitorsAMD glDeletePerfMonitorsAMD = Pointer<NativeFunction<GlDeletePerfMonitorsAMDNative>>.fromAddress(0).asFunction<GlDeletePerfMonitorsAMD>();
GlSelectPerfMonitorCountersAMD glSelectPerfMonitorCountersAMD = Pointer<NativeFunction<GlSelectPerfMonitorCountersAMDNative>>.fromAddress(0).asFunction<GlSelectPerfMonitorCountersAMD>();
GlBeginPerfMonitorAMD glBeginPerfMonitorAMD = Pointer<NativeFunction<GlBeginPerfMonitorAMDNative>>.fromAddress(0).asFunction<GlBeginPerfMonitorAMD>();
GlEndPerfMonitorAMD glEndPerfMonitorAMD = Pointer<NativeFunction<GlEndPerfMonitorAMDNative>>.fromAddress(0).asFunction<GlEndPerfMonitorAMD>();
GlGetPerfMonitorCounterDataAMD glGetPerfMonitorCounterDataAMD = Pointer<NativeFunction<GlGetPerfMonitorCounterDataAMDNative>>.fromAddress(0).asFunction<GlGetPerfMonitorCounterDataAMD>();
GlEGLImageTargetTexStorageEXT glEGLImageTargetTexStorageEXT = Pointer<NativeFunction<GlEGLImageTargetTexStorageEXTNative>>.fromAddress(0).asFunction<GlEGLImageTargetTexStorageEXT>();
GlEGLImageTargetTextureStorageEXT glEGLImageTargetTextureStorageEXT = Pointer<NativeFunction<GlEGLImageTargetTextureStorageEXTNative>>.fromAddress(0).asFunction<GlEGLImageTargetTextureStorageEXT>();
GlLabelObjectEXT glLabelObjectEXT = Pointer<NativeFunction<GlLabelObjectEXTNative>>.fromAddress(0).asFunction<GlLabelObjectEXT>();
GlGetObjectLabelEXT glGetObjectLabelEXT = Pointer<NativeFunction<GlGetObjectLabelEXTNative>>.fromAddress(0).asFunction<GlGetObjectLabelEXT>();
GlInsertEventMarkerEXT glInsertEventMarkerEXT = Pointer<NativeFunction<GlInsertEventMarkerEXTNative>>.fromAddress(0).asFunction<GlInsertEventMarkerEXT>();
GlPushGroupMarkerEXT glPushGroupMarkerEXT = Pointer<NativeFunction<GlPushGroupMarkerEXTNative>>.fromAddress(0).asFunction<GlPushGroupMarkerEXT>();
GlPopGroupMarkerEXT glPopGroupMarkerEXT = Pointer<NativeFunction<GlPopGroupMarkerEXTNative>>.fromAddress(0).asFunction<GlPopGroupMarkerEXT>();
GlMatrixLoadfEXT glMatrixLoadfEXT = Pointer<NativeFunction<GlMatrixLoadfEXTNative>>.fromAddress(0).asFunction<GlMatrixLoadfEXT>();
GlMatrixLoaddEXT glMatrixLoaddEXT = Pointer<NativeFunction<GlMatrixLoaddEXTNative>>.fromAddress(0).asFunction<GlMatrixLoaddEXT>();
GlMatrixMultfEXT glMatrixMultfEXT = Pointer<NativeFunction<GlMatrixMultfEXTNative>>.fromAddress(0).asFunction<GlMatrixMultfEXT>();
GlMatrixMultdEXT glMatrixMultdEXT = Pointer<NativeFunction<GlMatrixMultdEXTNative>>.fromAddress(0).asFunction<GlMatrixMultdEXT>();
GlMatrixLoadIdentityEXT glMatrixLoadIdentityEXT = Pointer<NativeFunction<GlMatrixLoadIdentityEXTNative>>.fromAddress(0).asFunction<GlMatrixLoadIdentityEXT>();
GlMatrixRotatefEXT glMatrixRotatefEXT = Pointer<NativeFunction<GlMatrixRotatefEXTNative>>.fromAddress(0).asFunction<GlMatrixRotatefEXT>();
GlMatrixRotatedEXT glMatrixRotatedEXT = Pointer<NativeFunction<GlMatrixRotatedEXTNative>>.fromAddress(0).asFunction<GlMatrixRotatedEXT>();
GlMatrixScalefEXT glMatrixScalefEXT = Pointer<NativeFunction<GlMatrixScalefEXTNative>>.fromAddress(0).asFunction<GlMatrixScalefEXT>();
GlMatrixScaledEXT glMatrixScaledEXT = Pointer<NativeFunction<GlMatrixScaledEXTNative>>.fromAddress(0).asFunction<GlMatrixScaledEXT>();
GlMatrixTranslatefEXT glMatrixTranslatefEXT = Pointer<NativeFunction<GlMatrixTranslatefEXTNative>>.fromAddress(0).asFunction<GlMatrixTranslatefEXT>();
GlMatrixTranslatedEXT glMatrixTranslatedEXT = Pointer<NativeFunction<GlMatrixTranslatedEXTNative>>.fromAddress(0).asFunction<GlMatrixTranslatedEXT>();
GlMatrixFrustumEXT glMatrixFrustumEXT = Pointer<NativeFunction<GlMatrixFrustumEXTNative>>.fromAddress(0).asFunction<GlMatrixFrustumEXT>();
GlMatrixOrthoEXT glMatrixOrthoEXT = Pointer<NativeFunction<GlMatrixOrthoEXTNative>>.fromAddress(0).asFunction<GlMatrixOrthoEXT>();
GlMatrixPopEXT glMatrixPopEXT = Pointer<NativeFunction<GlMatrixPopEXTNative>>.fromAddress(0).asFunction<GlMatrixPopEXT>();
GlMatrixPushEXT glMatrixPushEXT = Pointer<NativeFunction<GlMatrixPushEXTNative>>.fromAddress(0).asFunction<GlMatrixPushEXT>();
GlClientAttribDefaultEXT glClientAttribDefaultEXT = Pointer<NativeFunction<GlClientAttribDefaultEXTNative>>.fromAddress(0).asFunction<GlClientAttribDefaultEXT>();
GlPushClientAttribDefaultEXT glPushClientAttribDefaultEXT = Pointer<NativeFunction<GlPushClientAttribDefaultEXTNative>>.fromAddress(0).asFunction<GlPushClientAttribDefaultEXT>();
GlTextureParameterfEXT glTextureParameterfEXT = Pointer<NativeFunction<GlTextureParameterfEXTNative>>.fromAddress(0).asFunction<GlTextureParameterfEXT>();
GlTextureParameterfvEXT glTextureParameterfvEXT = Pointer<NativeFunction<GlTextureParameterfvEXTNative>>.fromAddress(0).asFunction<GlTextureParameterfvEXT>();
GlTextureParameteriEXT glTextureParameteriEXT = Pointer<NativeFunction<GlTextureParameteriEXTNative>>.fromAddress(0).asFunction<GlTextureParameteriEXT>();
GlTextureParameterivEXT glTextureParameterivEXT = Pointer<NativeFunction<GlTextureParameterivEXTNative>>.fromAddress(0).asFunction<GlTextureParameterivEXT>();
GlTextureImage1DEXT glTextureImage1DEXT = Pointer<NativeFunction<GlTextureImage1DEXTNative>>.fromAddress(0).asFunction<GlTextureImage1DEXT>();
GlTextureImage2DEXT glTextureImage2DEXT = Pointer<NativeFunction<GlTextureImage2DEXTNative>>.fromAddress(0).asFunction<GlTextureImage2DEXT>();
GlTextureSubImage1DEXT glTextureSubImage1DEXT = Pointer<NativeFunction<GlTextureSubImage1DEXTNative>>.fromAddress(0).asFunction<GlTextureSubImage1DEXT>();
GlTextureSubImage2DEXT glTextureSubImage2DEXT = Pointer<NativeFunction<GlTextureSubImage2DEXTNative>>.fromAddress(0).asFunction<GlTextureSubImage2DEXT>();
GlCopyTextureImage1DEXT glCopyTextureImage1DEXT = Pointer<NativeFunction<GlCopyTextureImage1DEXTNative>>.fromAddress(0).asFunction<GlCopyTextureImage1DEXT>();
GlCopyTextureImage2DEXT glCopyTextureImage2DEXT = Pointer<NativeFunction<GlCopyTextureImage2DEXTNative>>.fromAddress(0).asFunction<GlCopyTextureImage2DEXT>();
GlCopyTextureSubImage1DEXT glCopyTextureSubImage1DEXT = Pointer<NativeFunction<GlCopyTextureSubImage1DEXTNative>>.fromAddress(0).asFunction<GlCopyTextureSubImage1DEXT>();
GlCopyTextureSubImage2DEXT glCopyTextureSubImage2DEXT = Pointer<NativeFunction<GlCopyTextureSubImage2DEXTNative>>.fromAddress(0).asFunction<GlCopyTextureSubImage2DEXT>();
GlGetTextureImageEXT glGetTextureImageEXT = Pointer<NativeFunction<GlGetTextureImageEXTNative>>.fromAddress(0).asFunction<GlGetTextureImageEXT>();
GlGetTextureParameterfvEXT glGetTextureParameterfvEXT = Pointer<NativeFunction<GlGetTextureParameterfvEXTNative>>.fromAddress(0).asFunction<GlGetTextureParameterfvEXT>();
GlGetTextureParameterivEXT glGetTextureParameterivEXT = Pointer<NativeFunction<GlGetTextureParameterivEXTNative>>.fromAddress(0).asFunction<GlGetTextureParameterivEXT>();
GlGetTextureLevelParameterfvEXT glGetTextureLevelParameterfvEXT = Pointer<NativeFunction<GlGetTextureLevelParameterfvEXTNative>>.fromAddress(0).asFunction<GlGetTextureLevelParameterfvEXT>();
GlGetTextureLevelParameterivEXT glGetTextureLevelParameterivEXT = Pointer<NativeFunction<GlGetTextureLevelParameterivEXTNative>>.fromAddress(0).asFunction<GlGetTextureLevelParameterivEXT>();
GlTextureImage3DEXT glTextureImage3DEXT = Pointer<NativeFunction<GlTextureImage3DEXTNative>>.fromAddress(0).asFunction<GlTextureImage3DEXT>();
GlTextureSubImage3DEXT glTextureSubImage3DEXT = Pointer<NativeFunction<GlTextureSubImage3DEXTNative>>.fromAddress(0).asFunction<GlTextureSubImage3DEXT>();
GlCopyTextureSubImage3DEXT glCopyTextureSubImage3DEXT = Pointer<NativeFunction<GlCopyTextureSubImage3DEXTNative>>.fromAddress(0).asFunction<GlCopyTextureSubImage3DEXT>();
GlBindMultiTextureEXT glBindMultiTextureEXT = Pointer<NativeFunction<GlBindMultiTextureEXTNative>>.fromAddress(0).asFunction<GlBindMultiTextureEXT>();
GlMultiTexCoordPointerEXT glMultiTexCoordPointerEXT = Pointer<NativeFunction<GlMultiTexCoordPointerEXTNative>>.fromAddress(0).asFunction<GlMultiTexCoordPointerEXT>();
GlMultiTexEnvfEXT glMultiTexEnvfEXT = Pointer<NativeFunction<GlMultiTexEnvfEXTNative>>.fromAddress(0).asFunction<GlMultiTexEnvfEXT>();
GlMultiTexEnvfvEXT glMultiTexEnvfvEXT = Pointer<NativeFunction<GlMultiTexEnvfvEXTNative>>.fromAddress(0).asFunction<GlMultiTexEnvfvEXT>();
GlMultiTexEnviEXT glMultiTexEnviEXT = Pointer<NativeFunction<GlMultiTexEnviEXTNative>>.fromAddress(0).asFunction<GlMultiTexEnviEXT>();
GlMultiTexEnvivEXT glMultiTexEnvivEXT = Pointer<NativeFunction<GlMultiTexEnvivEXTNative>>.fromAddress(0).asFunction<GlMultiTexEnvivEXT>();
GlMultiTexGendEXT glMultiTexGendEXT = Pointer<NativeFunction<GlMultiTexGendEXTNative>>.fromAddress(0).asFunction<GlMultiTexGendEXT>();
GlMultiTexGendvEXT glMultiTexGendvEXT = Pointer<NativeFunction<GlMultiTexGendvEXTNative>>.fromAddress(0).asFunction<GlMultiTexGendvEXT>();
GlMultiTexGenfEXT glMultiTexGenfEXT = Pointer<NativeFunction<GlMultiTexGenfEXTNative>>.fromAddress(0).asFunction<GlMultiTexGenfEXT>();
GlMultiTexGenfvEXT glMultiTexGenfvEXT = Pointer<NativeFunction<GlMultiTexGenfvEXTNative>>.fromAddress(0).asFunction<GlMultiTexGenfvEXT>();
GlMultiTexGeniEXT glMultiTexGeniEXT = Pointer<NativeFunction<GlMultiTexGeniEXTNative>>.fromAddress(0).asFunction<GlMultiTexGeniEXT>();
GlMultiTexGenivEXT glMultiTexGenivEXT = Pointer<NativeFunction<GlMultiTexGenivEXTNative>>.fromAddress(0).asFunction<GlMultiTexGenivEXT>();
GlGetMultiTexEnvfvEXT glGetMultiTexEnvfvEXT = Pointer<NativeFunction<GlGetMultiTexEnvfvEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexEnvfvEXT>();
GlGetMultiTexEnvivEXT glGetMultiTexEnvivEXT = Pointer<NativeFunction<GlGetMultiTexEnvivEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexEnvivEXT>();
GlGetMultiTexGendvEXT glGetMultiTexGendvEXT = Pointer<NativeFunction<GlGetMultiTexGendvEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexGendvEXT>();
GlGetMultiTexGenfvEXT glGetMultiTexGenfvEXT = Pointer<NativeFunction<GlGetMultiTexGenfvEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexGenfvEXT>();
GlGetMultiTexGenivEXT glGetMultiTexGenivEXT = Pointer<NativeFunction<GlGetMultiTexGenivEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexGenivEXT>();
GlMultiTexParameteriEXT glMultiTexParameteriEXT = Pointer<NativeFunction<GlMultiTexParameteriEXTNative>>.fromAddress(0).asFunction<GlMultiTexParameteriEXT>();
GlMultiTexParameterivEXT glMultiTexParameterivEXT = Pointer<NativeFunction<GlMultiTexParameterivEXTNative>>.fromAddress(0).asFunction<GlMultiTexParameterivEXT>();
GlMultiTexParameterfEXT glMultiTexParameterfEXT = Pointer<NativeFunction<GlMultiTexParameterfEXTNative>>.fromAddress(0).asFunction<GlMultiTexParameterfEXT>();
GlMultiTexParameterfvEXT glMultiTexParameterfvEXT = Pointer<NativeFunction<GlMultiTexParameterfvEXTNative>>.fromAddress(0).asFunction<GlMultiTexParameterfvEXT>();
GlMultiTexImage1DEXT glMultiTexImage1DEXT = Pointer<NativeFunction<GlMultiTexImage1DEXTNative>>.fromAddress(0).asFunction<GlMultiTexImage1DEXT>();
GlMultiTexImage2DEXT glMultiTexImage2DEXT = Pointer<NativeFunction<GlMultiTexImage2DEXTNative>>.fromAddress(0).asFunction<GlMultiTexImage2DEXT>();
GlMultiTexSubImage1DEXT glMultiTexSubImage1DEXT = Pointer<NativeFunction<GlMultiTexSubImage1DEXTNative>>.fromAddress(0).asFunction<GlMultiTexSubImage1DEXT>();
GlMultiTexSubImage2DEXT glMultiTexSubImage2DEXT = Pointer<NativeFunction<GlMultiTexSubImage2DEXTNative>>.fromAddress(0).asFunction<GlMultiTexSubImage2DEXT>();
GlCopyMultiTexImage1DEXT glCopyMultiTexImage1DEXT = Pointer<NativeFunction<GlCopyMultiTexImage1DEXTNative>>.fromAddress(0).asFunction<GlCopyMultiTexImage1DEXT>();
GlCopyMultiTexImage2DEXT glCopyMultiTexImage2DEXT = Pointer<NativeFunction<GlCopyMultiTexImage2DEXTNative>>.fromAddress(0).asFunction<GlCopyMultiTexImage2DEXT>();
GlCopyMultiTexSubImage1DEXT glCopyMultiTexSubImage1DEXT = Pointer<NativeFunction<GlCopyMultiTexSubImage1DEXTNative>>.fromAddress(0).asFunction<GlCopyMultiTexSubImage1DEXT>();
GlCopyMultiTexSubImage2DEXT glCopyMultiTexSubImage2DEXT = Pointer<NativeFunction<GlCopyMultiTexSubImage2DEXTNative>>.fromAddress(0).asFunction<GlCopyMultiTexSubImage2DEXT>();
GlGetMultiTexImageEXT glGetMultiTexImageEXT = Pointer<NativeFunction<GlGetMultiTexImageEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexImageEXT>();
GlGetMultiTexParameterfvEXT glGetMultiTexParameterfvEXT = Pointer<NativeFunction<GlGetMultiTexParameterfvEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexParameterfvEXT>();
GlGetMultiTexParameterivEXT glGetMultiTexParameterivEXT = Pointer<NativeFunction<GlGetMultiTexParameterivEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexParameterivEXT>();
GlGetMultiTexLevelParameterfvEXT glGetMultiTexLevelParameterfvEXT = Pointer<NativeFunction<GlGetMultiTexLevelParameterfvEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexLevelParameterfvEXT>();
GlGetMultiTexLevelParameterivEXT glGetMultiTexLevelParameterivEXT = Pointer<NativeFunction<GlGetMultiTexLevelParameterivEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexLevelParameterivEXT>();
GlMultiTexImage3DEXT glMultiTexImage3DEXT = Pointer<NativeFunction<GlMultiTexImage3DEXTNative>>.fromAddress(0).asFunction<GlMultiTexImage3DEXT>();
GlMultiTexSubImage3DEXT glMultiTexSubImage3DEXT = Pointer<NativeFunction<GlMultiTexSubImage3DEXTNative>>.fromAddress(0).asFunction<GlMultiTexSubImage3DEXT>();
GlCopyMultiTexSubImage3DEXT glCopyMultiTexSubImage3DEXT = Pointer<NativeFunction<GlCopyMultiTexSubImage3DEXTNative>>.fromAddress(0).asFunction<GlCopyMultiTexSubImage3DEXT>();
GlEnableClientStateIndexedEXT glEnableClientStateIndexedEXT = Pointer<NativeFunction<GlEnableClientStateIndexedEXTNative>>.fromAddress(0).asFunction<GlEnableClientStateIndexedEXT>();
GlDisableClientStateIndexedEXT glDisableClientStateIndexedEXT = Pointer<NativeFunction<GlDisableClientStateIndexedEXTNative>>.fromAddress(0).asFunction<GlDisableClientStateIndexedEXT>();
GlGetFloatIndexedvEXT glGetFloatIndexedvEXT = Pointer<NativeFunction<GlGetFloatIndexedvEXTNative>>.fromAddress(0).asFunction<GlGetFloatIndexedvEXT>();
GlGetDoubleIndexedvEXT glGetDoubleIndexedvEXT = Pointer<NativeFunction<GlGetDoubleIndexedvEXTNative>>.fromAddress(0).asFunction<GlGetDoubleIndexedvEXT>();
GlGetPointerIndexedvEXT glGetPointerIndexedvEXT = Pointer<NativeFunction<GlGetPointerIndexedvEXTNative>>.fromAddress(0).asFunction<GlGetPointerIndexedvEXT>();
GlEnableIndexedEXT glEnableIndexedEXT = Pointer<NativeFunction<GlEnableIndexedEXTNative>>.fromAddress(0).asFunction<GlEnableIndexedEXT>();
GlDisableIndexedEXT glDisableIndexedEXT = Pointer<NativeFunction<GlDisableIndexedEXTNative>>.fromAddress(0).asFunction<GlDisableIndexedEXT>();
GlIsEnabledIndexedEXT glIsEnabledIndexedEXT = Pointer<NativeFunction<GlIsEnabledIndexedEXTNative>>.fromAddress(0).asFunction<GlIsEnabledIndexedEXT>();
GlGetIntegerIndexedvEXT glGetIntegerIndexedvEXT = Pointer<NativeFunction<GlGetIntegerIndexedvEXTNative>>.fromAddress(0).asFunction<GlGetIntegerIndexedvEXT>();
GlGetBooleanIndexedvEXT glGetBooleanIndexedvEXT = Pointer<NativeFunction<GlGetBooleanIndexedvEXTNative>>.fromAddress(0).asFunction<GlGetBooleanIndexedvEXT>();
GlCompressedTextureImage3DEXT glCompressedTextureImage3DEXT = Pointer<NativeFunction<GlCompressedTextureImage3DEXTNative>>.fromAddress(0).asFunction<GlCompressedTextureImage3DEXT>();
GlCompressedTextureImage2DEXT glCompressedTextureImage2DEXT = Pointer<NativeFunction<GlCompressedTextureImage2DEXTNative>>.fromAddress(0).asFunction<GlCompressedTextureImage2DEXT>();
GlCompressedTextureImage1DEXT glCompressedTextureImage1DEXT = Pointer<NativeFunction<GlCompressedTextureImage1DEXTNative>>.fromAddress(0).asFunction<GlCompressedTextureImage1DEXT>();
GlCompressedTextureSubImage3DEXT glCompressedTextureSubImage3DEXT = Pointer<NativeFunction<GlCompressedTextureSubImage3DEXTNative>>.fromAddress(0).asFunction<GlCompressedTextureSubImage3DEXT>();
GlCompressedTextureSubImage2DEXT glCompressedTextureSubImage2DEXT = Pointer<NativeFunction<GlCompressedTextureSubImage2DEXTNative>>.fromAddress(0).asFunction<GlCompressedTextureSubImage2DEXT>();
GlCompressedTextureSubImage1DEXT glCompressedTextureSubImage1DEXT = Pointer<NativeFunction<GlCompressedTextureSubImage1DEXTNative>>.fromAddress(0).asFunction<GlCompressedTextureSubImage1DEXT>();
GlGetCompressedTextureImageEXT glGetCompressedTextureImageEXT = Pointer<NativeFunction<GlGetCompressedTextureImageEXTNative>>.fromAddress(0).asFunction<GlGetCompressedTextureImageEXT>();
GlCompressedMultiTexImage3DEXT glCompressedMultiTexImage3DEXT = Pointer<NativeFunction<GlCompressedMultiTexImage3DEXTNative>>.fromAddress(0).asFunction<GlCompressedMultiTexImage3DEXT>();
GlCompressedMultiTexImage2DEXT glCompressedMultiTexImage2DEXT = Pointer<NativeFunction<GlCompressedMultiTexImage2DEXTNative>>.fromAddress(0).asFunction<GlCompressedMultiTexImage2DEXT>();
GlCompressedMultiTexImage1DEXT glCompressedMultiTexImage1DEXT = Pointer<NativeFunction<GlCompressedMultiTexImage1DEXTNative>>.fromAddress(0).asFunction<GlCompressedMultiTexImage1DEXT>();
GlCompressedMultiTexSubImage3DEXT glCompressedMultiTexSubImage3DEXT = Pointer<NativeFunction<GlCompressedMultiTexSubImage3DEXTNative>>.fromAddress(0).asFunction<GlCompressedMultiTexSubImage3DEXT>();
GlCompressedMultiTexSubImage2DEXT glCompressedMultiTexSubImage2DEXT = Pointer<NativeFunction<GlCompressedMultiTexSubImage2DEXTNative>>.fromAddress(0).asFunction<GlCompressedMultiTexSubImage2DEXT>();
GlCompressedMultiTexSubImage1DEXT glCompressedMultiTexSubImage1DEXT = Pointer<NativeFunction<GlCompressedMultiTexSubImage1DEXTNative>>.fromAddress(0).asFunction<GlCompressedMultiTexSubImage1DEXT>();
GlGetCompressedMultiTexImageEXT glGetCompressedMultiTexImageEXT = Pointer<NativeFunction<GlGetCompressedMultiTexImageEXTNative>>.fromAddress(0).asFunction<GlGetCompressedMultiTexImageEXT>();
GlMatrixLoadTransposefEXT glMatrixLoadTransposefEXT = Pointer<NativeFunction<GlMatrixLoadTransposefEXTNative>>.fromAddress(0).asFunction<GlMatrixLoadTransposefEXT>();
GlMatrixLoadTransposedEXT glMatrixLoadTransposedEXT = Pointer<NativeFunction<GlMatrixLoadTransposedEXTNative>>.fromAddress(0).asFunction<GlMatrixLoadTransposedEXT>();
GlMatrixMultTransposefEXT glMatrixMultTransposefEXT = Pointer<NativeFunction<GlMatrixMultTransposefEXTNative>>.fromAddress(0).asFunction<GlMatrixMultTransposefEXT>();
GlMatrixMultTransposedEXT glMatrixMultTransposedEXT = Pointer<NativeFunction<GlMatrixMultTransposedEXTNative>>.fromAddress(0).asFunction<GlMatrixMultTransposedEXT>();
GlNamedBufferDataEXT glNamedBufferDataEXT = Pointer<NativeFunction<GlNamedBufferDataEXTNative>>.fromAddress(0).asFunction<GlNamedBufferDataEXT>();
GlNamedBufferSubDataEXT glNamedBufferSubDataEXT = Pointer<NativeFunction<GlNamedBufferSubDataEXTNative>>.fromAddress(0).asFunction<GlNamedBufferSubDataEXT>();
GlMapNamedBufferEXT glMapNamedBufferEXT = Pointer<NativeFunction<GlMapNamedBufferEXTNative>>.fromAddress(0).asFunction<GlMapNamedBufferEXT>();
GlUnmapNamedBufferEXT glUnmapNamedBufferEXT = Pointer<NativeFunction<GlUnmapNamedBufferEXTNative>>.fromAddress(0).asFunction<GlUnmapNamedBufferEXT>();
GlGetNamedBufferParameterivEXT glGetNamedBufferParameterivEXT = Pointer<NativeFunction<GlGetNamedBufferParameterivEXTNative>>.fromAddress(0).asFunction<GlGetNamedBufferParameterivEXT>();
GlGetNamedBufferPointervEXT glGetNamedBufferPointervEXT = Pointer<NativeFunction<GlGetNamedBufferPointervEXTNative>>.fromAddress(0).asFunction<GlGetNamedBufferPointervEXT>();
GlGetNamedBufferSubDataEXT glGetNamedBufferSubDataEXT = Pointer<NativeFunction<GlGetNamedBufferSubDataEXTNative>>.fromAddress(0).asFunction<GlGetNamedBufferSubDataEXT>();
GlProgramUniform1fEXT glProgramUniform1fEXT = Pointer<NativeFunction<GlProgramUniform1fEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1fEXT>();
GlProgramUniform2fEXT glProgramUniform2fEXT = Pointer<NativeFunction<GlProgramUniform2fEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2fEXT>();
GlProgramUniform3fEXT glProgramUniform3fEXT = Pointer<NativeFunction<GlProgramUniform3fEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3fEXT>();
GlProgramUniform4fEXT glProgramUniform4fEXT = Pointer<NativeFunction<GlProgramUniform4fEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4fEXT>();
GlProgramUniform1iEXT glProgramUniform1iEXT = Pointer<NativeFunction<GlProgramUniform1iEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1iEXT>();
GlProgramUniform2iEXT glProgramUniform2iEXT = Pointer<NativeFunction<GlProgramUniform2iEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2iEXT>();
GlProgramUniform3iEXT glProgramUniform3iEXT = Pointer<NativeFunction<GlProgramUniform3iEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3iEXT>();
GlProgramUniform4iEXT glProgramUniform4iEXT = Pointer<NativeFunction<GlProgramUniform4iEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4iEXT>();
GlProgramUniform1fvEXT glProgramUniform1fvEXT = Pointer<NativeFunction<GlProgramUniform1fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1fvEXT>();
GlProgramUniform2fvEXT glProgramUniform2fvEXT = Pointer<NativeFunction<GlProgramUniform2fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2fvEXT>();
GlProgramUniform3fvEXT glProgramUniform3fvEXT = Pointer<NativeFunction<GlProgramUniform3fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3fvEXT>();
GlProgramUniform4fvEXT glProgramUniform4fvEXT = Pointer<NativeFunction<GlProgramUniform4fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4fvEXT>();
GlProgramUniform1ivEXT glProgramUniform1ivEXT = Pointer<NativeFunction<GlProgramUniform1ivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1ivEXT>();
GlProgramUniform2ivEXT glProgramUniform2ivEXT = Pointer<NativeFunction<GlProgramUniform2ivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2ivEXT>();
GlProgramUniform3ivEXT glProgramUniform3ivEXT = Pointer<NativeFunction<GlProgramUniform3ivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3ivEXT>();
GlProgramUniform4ivEXT glProgramUniform4ivEXT = Pointer<NativeFunction<GlProgramUniform4ivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4ivEXT>();
GlProgramUniformMatrix2fvEXT glProgramUniformMatrix2fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix2fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2fvEXT>();
GlProgramUniformMatrix3fvEXT glProgramUniformMatrix3fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix3fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3fvEXT>();
GlProgramUniformMatrix4fvEXT glProgramUniformMatrix4fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix4fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4fvEXT>();
GlProgramUniformMatrix2x3fvEXT glProgramUniformMatrix2x3fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix2x3fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x3fvEXT>();
GlProgramUniformMatrix3x2fvEXT glProgramUniformMatrix3x2fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix3x2fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x2fvEXT>();
GlProgramUniformMatrix2x4fvEXT glProgramUniformMatrix2x4fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix2x4fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x4fvEXT>();
GlProgramUniformMatrix4x2fvEXT glProgramUniformMatrix4x2fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix4x2fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x2fvEXT>();
GlProgramUniformMatrix3x4fvEXT glProgramUniformMatrix3x4fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix3x4fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x4fvEXT>();
GlProgramUniformMatrix4x3fvEXT glProgramUniformMatrix4x3fvEXT = Pointer<NativeFunction<GlProgramUniformMatrix4x3fvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x3fvEXT>();
GlTextureBufferEXT glTextureBufferEXT = Pointer<NativeFunction<GlTextureBufferEXTNative>>.fromAddress(0).asFunction<GlTextureBufferEXT>();
GlMultiTexBufferEXT glMultiTexBufferEXT = Pointer<NativeFunction<GlMultiTexBufferEXTNative>>.fromAddress(0).asFunction<GlMultiTexBufferEXT>();
GlTextureParameterIivEXT glTextureParameterIivEXT = Pointer<NativeFunction<GlTextureParameterIivEXTNative>>.fromAddress(0).asFunction<GlTextureParameterIivEXT>();
GlTextureParameterIuivEXT glTextureParameterIuivEXT = Pointer<NativeFunction<GlTextureParameterIuivEXTNative>>.fromAddress(0).asFunction<GlTextureParameterIuivEXT>();
GlGetTextureParameterIivEXT glGetTextureParameterIivEXT = Pointer<NativeFunction<GlGetTextureParameterIivEXTNative>>.fromAddress(0).asFunction<GlGetTextureParameterIivEXT>();
GlGetTextureParameterIuivEXT glGetTextureParameterIuivEXT = Pointer<NativeFunction<GlGetTextureParameterIuivEXTNative>>.fromAddress(0).asFunction<GlGetTextureParameterIuivEXT>();
GlMultiTexParameterIivEXT glMultiTexParameterIivEXT = Pointer<NativeFunction<GlMultiTexParameterIivEXTNative>>.fromAddress(0).asFunction<GlMultiTexParameterIivEXT>();
GlMultiTexParameterIuivEXT glMultiTexParameterIuivEXT = Pointer<NativeFunction<GlMultiTexParameterIuivEXTNative>>.fromAddress(0).asFunction<GlMultiTexParameterIuivEXT>();
GlGetMultiTexParameterIivEXT glGetMultiTexParameterIivEXT = Pointer<NativeFunction<GlGetMultiTexParameterIivEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexParameterIivEXT>();
GlGetMultiTexParameterIuivEXT glGetMultiTexParameterIuivEXT = Pointer<NativeFunction<GlGetMultiTexParameterIuivEXTNative>>.fromAddress(0).asFunction<GlGetMultiTexParameterIuivEXT>();
GlProgramUniform1uiEXT glProgramUniform1uiEXT = Pointer<NativeFunction<GlProgramUniform1uiEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1uiEXT>();
GlProgramUniform2uiEXT glProgramUniform2uiEXT = Pointer<NativeFunction<GlProgramUniform2uiEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2uiEXT>();
GlProgramUniform3uiEXT glProgramUniform3uiEXT = Pointer<NativeFunction<GlProgramUniform3uiEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3uiEXT>();
GlProgramUniform4uiEXT glProgramUniform4uiEXT = Pointer<NativeFunction<GlProgramUniform4uiEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4uiEXT>();
GlProgramUniform1uivEXT glProgramUniform1uivEXT = Pointer<NativeFunction<GlProgramUniform1uivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1uivEXT>();
GlProgramUniform2uivEXT glProgramUniform2uivEXT = Pointer<NativeFunction<GlProgramUniform2uivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2uivEXT>();
GlProgramUniform3uivEXT glProgramUniform3uivEXT = Pointer<NativeFunction<GlProgramUniform3uivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3uivEXT>();
GlProgramUniform4uivEXT glProgramUniform4uivEXT = Pointer<NativeFunction<GlProgramUniform4uivEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4uivEXT>();
GlNamedProgramLocalParameters4fvEXT glNamedProgramLocalParameters4fvEXT = Pointer<NativeFunction<GlNamedProgramLocalParameters4fvEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameters4fvEXT>();
GlNamedProgramLocalParameterI4iEXT glNamedProgramLocalParameterI4iEXT = Pointer<NativeFunction<GlNamedProgramLocalParameterI4iEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameterI4iEXT>();
GlNamedProgramLocalParameterI4ivEXT glNamedProgramLocalParameterI4ivEXT = Pointer<NativeFunction<GlNamedProgramLocalParameterI4ivEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameterI4ivEXT>();
GlNamedProgramLocalParametersI4ivEXT glNamedProgramLocalParametersI4ivEXT = Pointer<NativeFunction<GlNamedProgramLocalParametersI4ivEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParametersI4ivEXT>();
GlNamedProgramLocalParameterI4uiEXT glNamedProgramLocalParameterI4uiEXT = Pointer<NativeFunction<GlNamedProgramLocalParameterI4uiEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameterI4uiEXT>();
GlNamedProgramLocalParameterI4uivEXT glNamedProgramLocalParameterI4uivEXT = Pointer<NativeFunction<GlNamedProgramLocalParameterI4uivEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameterI4uivEXT>();
GlNamedProgramLocalParametersI4uivEXT glNamedProgramLocalParametersI4uivEXT = Pointer<NativeFunction<GlNamedProgramLocalParametersI4uivEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParametersI4uivEXT>();
GlGetNamedProgramLocalParameterIivEXT glGetNamedProgramLocalParameterIivEXT = Pointer<NativeFunction<GlGetNamedProgramLocalParameterIivEXTNative>>.fromAddress(0).asFunction<GlGetNamedProgramLocalParameterIivEXT>();
GlGetNamedProgramLocalParameterIuivEXT glGetNamedProgramLocalParameterIuivEXT = Pointer<NativeFunction<GlGetNamedProgramLocalParameterIuivEXTNative>>.fromAddress(0).asFunction<GlGetNamedProgramLocalParameterIuivEXT>();
GlEnableClientStateiEXT glEnableClientStateiEXT = Pointer<NativeFunction<GlEnableClientStateiEXTNative>>.fromAddress(0).asFunction<GlEnableClientStateiEXT>();
GlDisableClientStateiEXT glDisableClientStateiEXT = Pointer<NativeFunction<GlDisableClientStateiEXTNative>>.fromAddress(0).asFunction<GlDisableClientStateiEXT>();
GlGetFloati_vEXT glGetFloati_vEXT = Pointer<NativeFunction<GlGetFloati_vEXTNative>>.fromAddress(0).asFunction<GlGetFloati_vEXT>();
GlGetDoublei_vEXT glGetDoublei_vEXT = Pointer<NativeFunction<GlGetDoublei_vEXTNative>>.fromAddress(0).asFunction<GlGetDoublei_vEXT>();
GlGetPointeri_vEXT glGetPointeri_vEXT = Pointer<NativeFunction<GlGetPointeri_vEXTNative>>.fromAddress(0).asFunction<GlGetPointeri_vEXT>();
GlNamedProgramStringEXT glNamedProgramStringEXT = Pointer<NativeFunction<GlNamedProgramStringEXTNative>>.fromAddress(0).asFunction<GlNamedProgramStringEXT>();
GlNamedProgramLocalParameter4dEXT glNamedProgramLocalParameter4dEXT = Pointer<NativeFunction<GlNamedProgramLocalParameter4dEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameter4dEXT>();
GlNamedProgramLocalParameter4dvEXT glNamedProgramLocalParameter4dvEXT = Pointer<NativeFunction<GlNamedProgramLocalParameter4dvEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameter4dvEXT>();
GlNamedProgramLocalParameter4fEXT glNamedProgramLocalParameter4fEXT = Pointer<NativeFunction<GlNamedProgramLocalParameter4fEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameter4fEXT>();
GlNamedProgramLocalParameter4fvEXT glNamedProgramLocalParameter4fvEXT = Pointer<NativeFunction<GlNamedProgramLocalParameter4fvEXTNative>>.fromAddress(0).asFunction<GlNamedProgramLocalParameter4fvEXT>();
GlGetNamedProgramLocalParameterdvEXT glGetNamedProgramLocalParameterdvEXT = Pointer<NativeFunction<GlGetNamedProgramLocalParameterdvEXTNative>>.fromAddress(0).asFunction<GlGetNamedProgramLocalParameterdvEXT>();
GlGetNamedProgramLocalParameterfvEXT glGetNamedProgramLocalParameterfvEXT = Pointer<NativeFunction<GlGetNamedProgramLocalParameterfvEXTNative>>.fromAddress(0).asFunction<GlGetNamedProgramLocalParameterfvEXT>();
GlGetNamedProgramivEXT glGetNamedProgramivEXT = Pointer<NativeFunction<GlGetNamedProgramivEXTNative>>.fromAddress(0).asFunction<GlGetNamedProgramivEXT>();
GlGetNamedProgramStringEXT glGetNamedProgramStringEXT = Pointer<NativeFunction<GlGetNamedProgramStringEXTNative>>.fromAddress(0).asFunction<GlGetNamedProgramStringEXT>();
GlNamedRenderbufferStorageEXT glNamedRenderbufferStorageEXT = Pointer<NativeFunction<GlNamedRenderbufferStorageEXTNative>>.fromAddress(0).asFunction<GlNamedRenderbufferStorageEXT>();
GlGetNamedRenderbufferParameterivEXT glGetNamedRenderbufferParameterivEXT = Pointer<NativeFunction<GlGetNamedRenderbufferParameterivEXTNative>>.fromAddress(0).asFunction<GlGetNamedRenderbufferParameterivEXT>();
GlNamedRenderbufferStorageMultisampleEXT glNamedRenderbufferStorageMultisampleEXT = Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleEXTNative>>.fromAddress(0).asFunction<GlNamedRenderbufferStorageMultisampleEXT>();
GlNamedRenderbufferStorageMultisampleCoverageEXT glNamedRenderbufferStorageMultisampleCoverageEXT = Pointer<NativeFunction<GlNamedRenderbufferStorageMultisampleCoverageEXTNative>>.fromAddress(0).asFunction<GlNamedRenderbufferStorageMultisampleCoverageEXT>();
GlCheckNamedFramebufferStatusEXT glCheckNamedFramebufferStatusEXT = Pointer<NativeFunction<GlCheckNamedFramebufferStatusEXTNative>>.fromAddress(0).asFunction<GlCheckNamedFramebufferStatusEXT>();
GlNamedFramebufferTexture1DEXT glNamedFramebufferTexture1DEXT = Pointer<NativeFunction<GlNamedFramebufferTexture1DEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferTexture1DEXT>();
GlNamedFramebufferTexture2DEXT glNamedFramebufferTexture2DEXT = Pointer<NativeFunction<GlNamedFramebufferTexture2DEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferTexture2DEXT>();
GlNamedFramebufferTexture3DEXT glNamedFramebufferTexture3DEXT = Pointer<NativeFunction<GlNamedFramebufferTexture3DEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferTexture3DEXT>();
GlNamedFramebufferRenderbufferEXT glNamedFramebufferRenderbufferEXT = Pointer<NativeFunction<GlNamedFramebufferRenderbufferEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferRenderbufferEXT>();
GlGetNamedFramebufferAttachmentParameterivEXT glGetNamedFramebufferAttachmentParameterivEXT = Pointer<NativeFunction<GlGetNamedFramebufferAttachmentParameterivEXTNative>>.fromAddress(0).asFunction<GlGetNamedFramebufferAttachmentParameterivEXT>();
GlGenerateTextureMipmapEXT glGenerateTextureMipmapEXT = Pointer<NativeFunction<GlGenerateTextureMipmapEXTNative>>.fromAddress(0).asFunction<GlGenerateTextureMipmapEXT>();
GlGenerateMultiTexMipmapEXT glGenerateMultiTexMipmapEXT = Pointer<NativeFunction<GlGenerateMultiTexMipmapEXTNative>>.fromAddress(0).asFunction<GlGenerateMultiTexMipmapEXT>();
GlFramebufferDrawBufferEXT glFramebufferDrawBufferEXT = Pointer<NativeFunction<GlFramebufferDrawBufferEXTNative>>.fromAddress(0).asFunction<GlFramebufferDrawBufferEXT>();
GlFramebufferDrawBuffersEXT glFramebufferDrawBuffersEXT = Pointer<NativeFunction<GlFramebufferDrawBuffersEXTNative>>.fromAddress(0).asFunction<GlFramebufferDrawBuffersEXT>();
GlFramebufferReadBufferEXT glFramebufferReadBufferEXT = Pointer<NativeFunction<GlFramebufferReadBufferEXTNative>>.fromAddress(0).asFunction<GlFramebufferReadBufferEXT>();
GlGetFramebufferParameterivEXT glGetFramebufferParameterivEXT = Pointer<NativeFunction<GlGetFramebufferParameterivEXTNative>>.fromAddress(0).asFunction<GlGetFramebufferParameterivEXT>();
GlNamedCopyBufferSubDataEXT glNamedCopyBufferSubDataEXT = Pointer<NativeFunction<GlNamedCopyBufferSubDataEXTNative>>.fromAddress(0).asFunction<GlNamedCopyBufferSubDataEXT>();
GlNamedFramebufferTextureEXT glNamedFramebufferTextureEXT = Pointer<NativeFunction<GlNamedFramebufferTextureEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferTextureEXT>();
GlNamedFramebufferTextureLayerEXT glNamedFramebufferTextureLayerEXT = Pointer<NativeFunction<GlNamedFramebufferTextureLayerEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferTextureLayerEXT>();
GlNamedFramebufferTextureFaceEXT glNamedFramebufferTextureFaceEXT = Pointer<NativeFunction<GlNamedFramebufferTextureFaceEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferTextureFaceEXT>();
GlTextureRenderbufferEXT glTextureRenderbufferEXT = Pointer<NativeFunction<GlTextureRenderbufferEXTNative>>.fromAddress(0).asFunction<GlTextureRenderbufferEXT>();
GlMultiTexRenderbufferEXT glMultiTexRenderbufferEXT = Pointer<NativeFunction<GlMultiTexRenderbufferEXTNative>>.fromAddress(0).asFunction<GlMultiTexRenderbufferEXT>();
GlVertexArrayVertexOffsetEXT glVertexArrayVertexOffsetEXT = Pointer<NativeFunction<GlVertexArrayVertexOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexOffsetEXT>();
GlVertexArrayColorOffsetEXT glVertexArrayColorOffsetEXT = Pointer<NativeFunction<GlVertexArrayColorOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayColorOffsetEXT>();
GlVertexArrayEdgeFlagOffsetEXT glVertexArrayEdgeFlagOffsetEXT = Pointer<NativeFunction<GlVertexArrayEdgeFlagOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayEdgeFlagOffsetEXT>();
GlVertexArrayIndexOffsetEXT glVertexArrayIndexOffsetEXT = Pointer<NativeFunction<GlVertexArrayIndexOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayIndexOffsetEXT>();
GlVertexArrayNormalOffsetEXT glVertexArrayNormalOffsetEXT = Pointer<NativeFunction<GlVertexArrayNormalOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayNormalOffsetEXT>();
GlVertexArrayTexCoordOffsetEXT glVertexArrayTexCoordOffsetEXT = Pointer<NativeFunction<GlVertexArrayTexCoordOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayTexCoordOffsetEXT>();
GlVertexArrayMultiTexCoordOffsetEXT glVertexArrayMultiTexCoordOffsetEXT = Pointer<NativeFunction<GlVertexArrayMultiTexCoordOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayMultiTexCoordOffsetEXT>();
GlVertexArrayFogCoordOffsetEXT glVertexArrayFogCoordOffsetEXT = Pointer<NativeFunction<GlVertexArrayFogCoordOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayFogCoordOffsetEXT>();
GlVertexArraySecondaryColorOffsetEXT glVertexArraySecondaryColorOffsetEXT = Pointer<NativeFunction<GlVertexArraySecondaryColorOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArraySecondaryColorOffsetEXT>();
GlVertexArrayVertexAttribOffsetEXT glVertexArrayVertexAttribOffsetEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribOffsetEXT>();
GlVertexArrayVertexAttribIOffsetEXT glVertexArrayVertexAttribIOffsetEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribIOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribIOffsetEXT>();
GlEnableVertexArrayEXT glEnableVertexArrayEXT = Pointer<NativeFunction<GlEnableVertexArrayEXTNative>>.fromAddress(0).asFunction<GlEnableVertexArrayEXT>();
GlDisableVertexArrayEXT glDisableVertexArrayEXT = Pointer<NativeFunction<GlDisableVertexArrayEXTNative>>.fromAddress(0).asFunction<GlDisableVertexArrayEXT>();
GlEnableVertexArrayAttribEXT glEnableVertexArrayAttribEXT = Pointer<NativeFunction<GlEnableVertexArrayAttribEXTNative>>.fromAddress(0).asFunction<GlEnableVertexArrayAttribEXT>();
GlDisableVertexArrayAttribEXT glDisableVertexArrayAttribEXT = Pointer<NativeFunction<GlDisableVertexArrayAttribEXTNative>>.fromAddress(0).asFunction<GlDisableVertexArrayAttribEXT>();
GlGetVertexArrayIntegervEXT glGetVertexArrayIntegervEXT = Pointer<NativeFunction<GlGetVertexArrayIntegervEXTNative>>.fromAddress(0).asFunction<GlGetVertexArrayIntegervEXT>();
GlGetVertexArrayPointervEXT glGetVertexArrayPointervEXT = Pointer<NativeFunction<GlGetVertexArrayPointervEXTNative>>.fromAddress(0).asFunction<GlGetVertexArrayPointervEXT>();
GlGetVertexArrayIntegeri_vEXT glGetVertexArrayIntegeri_vEXT = Pointer<NativeFunction<GlGetVertexArrayIntegeri_vEXTNative>>.fromAddress(0).asFunction<GlGetVertexArrayIntegeri_vEXT>();
GlGetVertexArrayPointeri_vEXT glGetVertexArrayPointeri_vEXT = Pointer<NativeFunction<GlGetVertexArrayPointeri_vEXTNative>>.fromAddress(0).asFunction<GlGetVertexArrayPointeri_vEXT>();
GlMapNamedBufferRangeEXT glMapNamedBufferRangeEXT = Pointer<NativeFunction<GlMapNamedBufferRangeEXTNative>>.fromAddress(0).asFunction<GlMapNamedBufferRangeEXT>();
GlFlushMappedNamedBufferRangeEXT glFlushMappedNamedBufferRangeEXT = Pointer<NativeFunction<GlFlushMappedNamedBufferRangeEXTNative>>.fromAddress(0).asFunction<GlFlushMappedNamedBufferRangeEXT>();
GlNamedBufferStorageEXT glNamedBufferStorageEXT = Pointer<NativeFunction<GlNamedBufferStorageEXTNative>>.fromAddress(0).asFunction<GlNamedBufferStorageEXT>();
GlClearNamedBufferDataEXT glClearNamedBufferDataEXT = Pointer<NativeFunction<GlClearNamedBufferDataEXTNative>>.fromAddress(0).asFunction<GlClearNamedBufferDataEXT>();
GlClearNamedBufferSubDataEXT glClearNamedBufferSubDataEXT = Pointer<NativeFunction<GlClearNamedBufferSubDataEXTNative>>.fromAddress(0).asFunction<GlClearNamedBufferSubDataEXT>();
GlNamedFramebufferParameteriEXT glNamedFramebufferParameteriEXT = Pointer<NativeFunction<GlNamedFramebufferParameteriEXTNative>>.fromAddress(0).asFunction<GlNamedFramebufferParameteriEXT>();
GlGetNamedFramebufferParameterivEXT glGetNamedFramebufferParameterivEXT = Pointer<NativeFunction<GlGetNamedFramebufferParameterivEXTNative>>.fromAddress(0).asFunction<GlGetNamedFramebufferParameterivEXT>();
GlProgramUniform1dEXT glProgramUniform1dEXT = Pointer<NativeFunction<GlProgramUniform1dEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1dEXT>();
GlProgramUniform2dEXT glProgramUniform2dEXT = Pointer<NativeFunction<GlProgramUniform2dEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2dEXT>();
GlProgramUniform3dEXT glProgramUniform3dEXT = Pointer<NativeFunction<GlProgramUniform3dEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3dEXT>();
GlProgramUniform4dEXT glProgramUniform4dEXT = Pointer<NativeFunction<GlProgramUniform4dEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4dEXT>();
GlProgramUniform1dvEXT glProgramUniform1dvEXT = Pointer<NativeFunction<GlProgramUniform1dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform1dvEXT>();
GlProgramUniform2dvEXT glProgramUniform2dvEXT = Pointer<NativeFunction<GlProgramUniform2dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform2dvEXT>();
GlProgramUniform3dvEXT glProgramUniform3dvEXT = Pointer<NativeFunction<GlProgramUniform3dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform3dvEXT>();
GlProgramUniform4dvEXT glProgramUniform4dvEXT = Pointer<NativeFunction<GlProgramUniform4dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniform4dvEXT>();
GlProgramUniformMatrix2dvEXT glProgramUniformMatrix2dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix2dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2dvEXT>();
GlProgramUniformMatrix3dvEXT glProgramUniformMatrix3dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix3dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3dvEXT>();
GlProgramUniformMatrix4dvEXT glProgramUniformMatrix4dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix4dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4dvEXT>();
GlProgramUniformMatrix2x3dvEXT glProgramUniformMatrix2x3dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix2x3dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x3dvEXT>();
GlProgramUniformMatrix2x4dvEXT glProgramUniformMatrix2x4dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix2x4dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix2x4dvEXT>();
GlProgramUniformMatrix3x2dvEXT glProgramUniformMatrix3x2dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix3x2dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x2dvEXT>();
GlProgramUniformMatrix3x4dvEXT glProgramUniformMatrix3x4dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix3x4dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix3x4dvEXT>();
GlProgramUniformMatrix4x2dvEXT glProgramUniformMatrix4x2dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix4x2dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x2dvEXT>();
GlProgramUniformMatrix4x3dvEXT glProgramUniformMatrix4x3dvEXT = Pointer<NativeFunction<GlProgramUniformMatrix4x3dvEXTNative>>.fromAddress(0).asFunction<GlProgramUniformMatrix4x3dvEXT>();
GlTextureBufferRangeEXT glTextureBufferRangeEXT = Pointer<NativeFunction<GlTextureBufferRangeEXTNative>>.fromAddress(0).asFunction<GlTextureBufferRangeEXT>();
GlTextureStorage1DEXT glTextureStorage1DEXT = Pointer<NativeFunction<GlTextureStorage1DEXTNative>>.fromAddress(0).asFunction<GlTextureStorage1DEXT>();
GlTextureStorage2DEXT glTextureStorage2DEXT = Pointer<NativeFunction<GlTextureStorage2DEXTNative>>.fromAddress(0).asFunction<GlTextureStorage2DEXT>();
GlTextureStorage3DEXT glTextureStorage3DEXT = Pointer<NativeFunction<GlTextureStorage3DEXTNative>>.fromAddress(0).asFunction<GlTextureStorage3DEXT>();
GlTextureStorage2DMultisampleEXT glTextureStorage2DMultisampleEXT = Pointer<NativeFunction<GlTextureStorage2DMultisampleEXTNative>>.fromAddress(0).asFunction<GlTextureStorage2DMultisampleEXT>();
GlTextureStorage3DMultisampleEXT glTextureStorage3DMultisampleEXT = Pointer<NativeFunction<GlTextureStorage3DMultisampleEXTNative>>.fromAddress(0).asFunction<GlTextureStorage3DMultisampleEXT>();
GlVertexArrayBindVertexBufferEXT glVertexArrayBindVertexBufferEXT = Pointer<NativeFunction<GlVertexArrayBindVertexBufferEXTNative>>.fromAddress(0).asFunction<GlVertexArrayBindVertexBufferEXT>();
GlVertexArrayVertexAttribFormatEXT glVertexArrayVertexAttribFormatEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribFormatEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribFormatEXT>();
GlVertexArrayVertexAttribIFormatEXT glVertexArrayVertexAttribIFormatEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribIFormatEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribIFormatEXT>();
GlVertexArrayVertexAttribLFormatEXT glVertexArrayVertexAttribLFormatEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribLFormatEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribLFormatEXT>();
GlVertexArrayVertexAttribBindingEXT glVertexArrayVertexAttribBindingEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribBindingEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribBindingEXT>();
GlVertexArrayVertexBindingDivisorEXT glVertexArrayVertexBindingDivisorEXT = Pointer<NativeFunction<GlVertexArrayVertexBindingDivisorEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexBindingDivisorEXT>();
GlVertexArrayVertexAttribLOffsetEXT glVertexArrayVertexAttribLOffsetEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribLOffsetEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribLOffsetEXT>();
GlTexturePageCommitmentEXT glTexturePageCommitmentEXT = Pointer<NativeFunction<GlTexturePageCommitmentEXTNative>>.fromAddress(0).asFunction<GlTexturePageCommitmentEXT>();
GlVertexArrayVertexAttribDivisorEXT glVertexArrayVertexAttribDivisorEXT = Pointer<NativeFunction<GlVertexArrayVertexAttribDivisorEXTNative>>.fromAddress(0).asFunction<GlVertexArrayVertexAttribDivisorEXT>();
GlDrawArraysInstancedEXT glDrawArraysInstancedEXT = Pointer<NativeFunction<GlDrawArraysInstancedEXTNative>>.fromAddress(0).asFunction<GlDrawArraysInstancedEXT>();
GlDrawElementsInstancedEXT glDrawElementsInstancedEXT = Pointer<NativeFunction<GlDrawElementsInstancedEXTNative>>.fromAddress(0).asFunction<GlDrawElementsInstancedEXT>();
GlPolygonOffsetClampEXT glPolygonOffsetClampEXT = Pointer<NativeFunction<GlPolygonOffsetClampEXTNative>>.fromAddress(0).asFunction<GlPolygonOffsetClampEXT>();
GlRasterSamplesEXT glRasterSamplesEXT = Pointer<NativeFunction<GlRasterSamplesEXTNative>>.fromAddress(0).asFunction<GlRasterSamplesEXT>();
GlUseShaderProgramEXT glUseShaderProgramEXT = Pointer<NativeFunction<GlUseShaderProgramEXTNative>>.fromAddress(0).asFunction<GlUseShaderProgramEXT>();
GlActiveProgramEXT glActiveProgramEXT = Pointer<NativeFunction<GlActiveProgramEXTNative>>.fromAddress(0).asFunction<GlActiveProgramEXT>();
GlCreateShaderProgramEXT glCreateShaderProgramEXT = Pointer<NativeFunction<GlCreateShaderProgramEXTNative>>.fromAddress(0).asFunction<GlCreateShaderProgramEXT>();
GlFramebufferFetchBarrierEXT glFramebufferFetchBarrierEXT = Pointer<NativeFunction<GlFramebufferFetchBarrierEXTNative>>.fromAddress(0).asFunction<GlFramebufferFetchBarrierEXT>();
GlWindowRectanglesEXT glWindowRectanglesEXT = Pointer<NativeFunction<GlWindowRectanglesEXTNative>>.fromAddress(0).asFunction<GlWindowRectanglesEXT>();
GlApplyFramebufferAttachmentCMAAINTEL glApplyFramebufferAttachmentCMAAINTEL = Pointer<NativeFunction<GlApplyFramebufferAttachmentCMAAINTELNative>>.fromAddress(0).asFunction<GlApplyFramebufferAttachmentCMAAINTEL>();
GlBeginPerfQueryINTEL glBeginPerfQueryINTEL = Pointer<NativeFunction<GlBeginPerfQueryINTELNative>>.fromAddress(0).asFunction<GlBeginPerfQueryINTEL>();
GlCreatePerfQueryINTEL glCreatePerfQueryINTEL = Pointer<NativeFunction<GlCreatePerfQueryINTELNative>>.fromAddress(0).asFunction<GlCreatePerfQueryINTEL>();
GlDeletePerfQueryINTEL glDeletePerfQueryINTEL = Pointer<NativeFunction<GlDeletePerfQueryINTELNative>>.fromAddress(0).asFunction<GlDeletePerfQueryINTEL>();
GlEndPerfQueryINTEL glEndPerfQueryINTEL = Pointer<NativeFunction<GlEndPerfQueryINTELNative>>.fromAddress(0).asFunction<GlEndPerfQueryINTEL>();
GlGetFirstPerfQueryIdINTEL glGetFirstPerfQueryIdINTEL = Pointer<NativeFunction<GlGetFirstPerfQueryIdINTELNative>>.fromAddress(0).asFunction<GlGetFirstPerfQueryIdINTEL>();
GlGetNextPerfQueryIdINTEL glGetNextPerfQueryIdINTEL = Pointer<NativeFunction<GlGetNextPerfQueryIdINTELNative>>.fromAddress(0).asFunction<GlGetNextPerfQueryIdINTEL>();
GlGetPerfCounterInfoINTEL glGetPerfCounterInfoINTEL = Pointer<NativeFunction<GlGetPerfCounterInfoINTELNative>>.fromAddress(0).asFunction<GlGetPerfCounterInfoINTEL>();
GlGetPerfQueryDataINTEL glGetPerfQueryDataINTEL = Pointer<NativeFunction<GlGetPerfQueryDataINTELNative>>.fromAddress(0).asFunction<GlGetPerfQueryDataINTEL>();
GlGetPerfQueryIdByNameINTEL glGetPerfQueryIdByNameINTEL = Pointer<NativeFunction<GlGetPerfQueryIdByNameINTELNative>>.fromAddress(0).asFunction<GlGetPerfQueryIdByNameINTEL>();
GlGetPerfQueryInfoINTEL glGetPerfQueryInfoINTEL = Pointer<NativeFunction<GlGetPerfQueryInfoINTELNative>>.fromAddress(0).asFunction<GlGetPerfQueryInfoINTEL>();
GlFramebufferParameteriMESA glFramebufferParameteriMESA = Pointer<NativeFunction<GlFramebufferParameteriMESANative>>.fromAddress(0).asFunction<GlFramebufferParameteriMESA>();
GlGetFramebufferParameterivMESA glGetFramebufferParameterivMESA = Pointer<NativeFunction<GlGetFramebufferParameterivMESANative>>.fromAddress(0).asFunction<GlGetFramebufferParameterivMESA>();
GlMultiDrawArraysIndirectBindlessNV glMultiDrawArraysIndirectBindlessNV = Pointer<NativeFunction<GlMultiDrawArraysIndirectBindlessNVNative>>.fromAddress(0).asFunction<GlMultiDrawArraysIndirectBindlessNV>();
GlMultiDrawElementsIndirectBindlessNV glMultiDrawElementsIndirectBindlessNV = Pointer<NativeFunction<GlMultiDrawElementsIndirectBindlessNVNative>>.fromAddress(0).asFunction<GlMultiDrawElementsIndirectBindlessNV>();
GlMultiDrawArraysIndirectBindlessCountNV glMultiDrawArraysIndirectBindlessCountNV = Pointer<NativeFunction<GlMultiDrawArraysIndirectBindlessCountNVNative>>.fromAddress(0).asFunction<GlMultiDrawArraysIndirectBindlessCountNV>();
GlMultiDrawElementsIndirectBindlessCountNV glMultiDrawElementsIndirectBindlessCountNV = Pointer<NativeFunction<GlMultiDrawElementsIndirectBindlessCountNVNative>>.fromAddress(0).asFunction<GlMultiDrawElementsIndirectBindlessCountNV>();
GlGetTextureHandleNV glGetTextureHandleNV = Pointer<NativeFunction<GlGetTextureHandleNVNative>>.fromAddress(0).asFunction<GlGetTextureHandleNV>();
GlGetTextureSamplerHandleNV glGetTextureSamplerHandleNV = Pointer<NativeFunction<GlGetTextureSamplerHandleNVNative>>.fromAddress(0).asFunction<GlGetTextureSamplerHandleNV>();
GlMakeTextureHandleResidentNV glMakeTextureHandleResidentNV = Pointer<NativeFunction<GlMakeTextureHandleResidentNVNative>>.fromAddress(0).asFunction<GlMakeTextureHandleResidentNV>();
GlMakeTextureHandleNonResidentNV glMakeTextureHandleNonResidentNV = Pointer<NativeFunction<GlMakeTextureHandleNonResidentNVNative>>.fromAddress(0).asFunction<GlMakeTextureHandleNonResidentNV>();
GlGetImageHandleNV glGetImageHandleNV = Pointer<NativeFunction<GlGetImageHandleNVNative>>.fromAddress(0).asFunction<GlGetImageHandleNV>();
GlMakeImageHandleResidentNV glMakeImageHandleResidentNV = Pointer<NativeFunction<GlMakeImageHandleResidentNVNative>>.fromAddress(0).asFunction<GlMakeImageHandleResidentNV>();
GlMakeImageHandleNonResidentNV glMakeImageHandleNonResidentNV = Pointer<NativeFunction<GlMakeImageHandleNonResidentNVNative>>.fromAddress(0).asFunction<GlMakeImageHandleNonResidentNV>();
GlUniformHandleui64NV glUniformHandleui64NV = Pointer<NativeFunction<GlUniformHandleui64NVNative>>.fromAddress(0).asFunction<GlUniformHandleui64NV>();
GlUniformHandleui64vNV glUniformHandleui64vNV = Pointer<NativeFunction<GlUniformHandleui64vNVNative>>.fromAddress(0).asFunction<GlUniformHandleui64vNV>();
GlProgramUniformHandleui64NV glProgramUniformHandleui64NV = Pointer<NativeFunction<GlProgramUniformHandleui64NVNative>>.fromAddress(0).asFunction<GlProgramUniformHandleui64NV>();
GlProgramUniformHandleui64vNV glProgramUniformHandleui64vNV = Pointer<NativeFunction<GlProgramUniformHandleui64vNVNative>>.fromAddress(0).asFunction<GlProgramUniformHandleui64vNV>();
GlIsTextureHandleResidentNV glIsTextureHandleResidentNV = Pointer<NativeFunction<GlIsTextureHandleResidentNVNative>>.fromAddress(0).asFunction<GlIsTextureHandleResidentNV>();
GlIsImageHandleResidentNV glIsImageHandleResidentNV = Pointer<NativeFunction<GlIsImageHandleResidentNVNative>>.fromAddress(0).asFunction<GlIsImageHandleResidentNV>();
GlBlendParameteriNV glBlendParameteriNV = Pointer<NativeFunction<GlBlendParameteriNVNative>>.fromAddress(0).asFunction<GlBlendParameteriNV>();
GlBlendBarrierNV glBlendBarrierNV = Pointer<NativeFunction<GlBlendBarrierNVNative>>.fromAddress(0).asFunction<GlBlendBarrierNV>();
GlViewportPositionWScaleNV glViewportPositionWScaleNV = Pointer<NativeFunction<GlViewportPositionWScaleNVNative>>.fromAddress(0).asFunction<GlViewportPositionWScaleNV>();
GlCreateStatesNV glCreateStatesNV = Pointer<NativeFunction<GlCreateStatesNVNative>>.fromAddress(0).asFunction<GlCreateStatesNV>();
GlDeleteStatesNV glDeleteStatesNV = Pointer<NativeFunction<GlDeleteStatesNVNative>>.fromAddress(0).asFunction<GlDeleteStatesNV>();
GlIsStateNV glIsStateNV = Pointer<NativeFunction<GlIsStateNVNative>>.fromAddress(0).asFunction<GlIsStateNV>();
GlStateCaptureNV glStateCaptureNV = Pointer<NativeFunction<GlStateCaptureNVNative>>.fromAddress(0).asFunction<GlStateCaptureNV>();
GlGetCommandHeaderNV glGetCommandHeaderNV = Pointer<NativeFunction<GlGetCommandHeaderNVNative>>.fromAddress(0).asFunction<GlGetCommandHeaderNV>();
GlGetStageIndexNV glGetStageIndexNV = Pointer<NativeFunction<GlGetStageIndexNVNative>>.fromAddress(0).asFunction<GlGetStageIndexNV>();
GlDrawCommandsNV glDrawCommandsNV = Pointer<NativeFunction<GlDrawCommandsNVNative>>.fromAddress(0).asFunction<GlDrawCommandsNV>();
GlDrawCommandsAddressNV glDrawCommandsAddressNV = Pointer<NativeFunction<GlDrawCommandsAddressNVNative>>.fromAddress(0).asFunction<GlDrawCommandsAddressNV>();
GlDrawCommandsStatesNV glDrawCommandsStatesNV = Pointer<NativeFunction<GlDrawCommandsStatesNVNative>>.fromAddress(0).asFunction<GlDrawCommandsStatesNV>();
GlDrawCommandsStatesAddressNV glDrawCommandsStatesAddressNV = Pointer<NativeFunction<GlDrawCommandsStatesAddressNVNative>>.fromAddress(0).asFunction<GlDrawCommandsStatesAddressNV>();
GlCreateCommandListsNV glCreateCommandListsNV = Pointer<NativeFunction<GlCreateCommandListsNVNative>>.fromAddress(0).asFunction<GlCreateCommandListsNV>();
GlDeleteCommandListsNV glDeleteCommandListsNV = Pointer<NativeFunction<GlDeleteCommandListsNVNative>>.fromAddress(0).asFunction<GlDeleteCommandListsNV>();
GlIsCommandListNV glIsCommandListNV = Pointer<NativeFunction<GlIsCommandListNVNative>>.fromAddress(0).asFunction<GlIsCommandListNV>();
GlListDrawCommandsStatesClientNV glListDrawCommandsStatesClientNV = Pointer<NativeFunction<GlListDrawCommandsStatesClientNVNative>>.fromAddress(0).asFunction<GlListDrawCommandsStatesClientNV>();
GlCommandListSegmentsNV glCommandListSegmentsNV = Pointer<NativeFunction<GlCommandListSegmentsNVNative>>.fromAddress(0).asFunction<GlCommandListSegmentsNV>();
GlCompileCommandListNV glCompileCommandListNV = Pointer<NativeFunction<GlCompileCommandListNVNative>>.fromAddress(0).asFunction<GlCompileCommandListNV>();
GlCallCommandListNV glCallCommandListNV = Pointer<NativeFunction<GlCallCommandListNVNative>>.fromAddress(0).asFunction<GlCallCommandListNV>();
GlBeginConditionalRenderNV glBeginConditionalRenderNV = Pointer<NativeFunction<GlBeginConditionalRenderNVNative>>.fromAddress(0).asFunction<GlBeginConditionalRenderNV>();
GlEndConditionalRenderNV glEndConditionalRenderNV = Pointer<NativeFunction<GlEndConditionalRenderNVNative>>.fromAddress(0).asFunction<GlEndConditionalRenderNV>();
GlSubpixelPrecisionBiasNV glSubpixelPrecisionBiasNV = Pointer<NativeFunction<GlSubpixelPrecisionBiasNVNative>>.fromAddress(0).asFunction<GlSubpixelPrecisionBiasNV>();
GlConservativeRasterParameterfNV glConservativeRasterParameterfNV = Pointer<NativeFunction<GlConservativeRasterParameterfNVNative>>.fromAddress(0).asFunction<GlConservativeRasterParameterfNV>();
GlConservativeRasterParameteriNV glConservativeRasterParameteriNV = Pointer<NativeFunction<GlConservativeRasterParameteriNVNative>>.fromAddress(0).asFunction<GlConservativeRasterParameteriNV>();
GlDepthRangedNV glDepthRangedNV = Pointer<NativeFunction<GlDepthRangedNVNative>>.fromAddress(0).asFunction<GlDepthRangedNV>();
GlClearDepthdNV glClearDepthdNV = Pointer<NativeFunction<GlClearDepthdNVNative>>.fromAddress(0).asFunction<GlClearDepthdNV>();
GlDepthBoundsdNV glDepthBoundsdNV = Pointer<NativeFunction<GlDepthBoundsdNVNative>>.fromAddress(0).asFunction<GlDepthBoundsdNV>();
GlDrawVkImageNV glDrawVkImageNV = Pointer<NativeFunction<GlDrawVkImageNVNative>>.fromAddress(0).asFunction<GlDrawVkImageNV>();
GlGetVkProcAddrNV glGetVkProcAddrNV = Pointer<NativeFunction<GlGetVkProcAddrNVNative>>.fromAddress(0).asFunction<GlGetVkProcAddrNV>();
GlWaitVkSemaphoreNV glWaitVkSemaphoreNV = Pointer<NativeFunction<GlWaitVkSemaphoreNVNative>>.fromAddress(0).asFunction<GlWaitVkSemaphoreNV>();
GlSignalVkSemaphoreNV glSignalVkSemaphoreNV = Pointer<NativeFunction<GlSignalVkSemaphoreNVNative>>.fromAddress(0).asFunction<GlSignalVkSemaphoreNV>();
GlSignalVkFenceNV glSignalVkFenceNV = Pointer<NativeFunction<GlSignalVkFenceNVNative>>.fromAddress(0).asFunction<GlSignalVkFenceNV>();
GlFragmentCoverageColorNV glFragmentCoverageColorNV = Pointer<NativeFunction<GlFragmentCoverageColorNVNative>>.fromAddress(0).asFunction<GlFragmentCoverageColorNV>();
GlCoverageModulationTableNV glCoverageModulationTableNV = Pointer<NativeFunction<GlCoverageModulationTableNVNative>>.fromAddress(0).asFunction<GlCoverageModulationTableNV>();
GlGetCoverageModulationTableNV glGetCoverageModulationTableNV = Pointer<NativeFunction<GlGetCoverageModulationTableNVNative>>.fromAddress(0).asFunction<GlGetCoverageModulationTableNV>();
GlCoverageModulationNV glCoverageModulationNV = Pointer<NativeFunction<GlCoverageModulationNVNative>>.fromAddress(0).asFunction<GlCoverageModulationNV>();
GlRenderbufferStorageMultisampleCoverageNV glRenderbufferStorageMultisampleCoverageNV = Pointer<NativeFunction<GlRenderbufferStorageMultisampleCoverageNVNative>>.fromAddress(0).asFunction<GlRenderbufferStorageMultisampleCoverageNV>();
GlUniform1i64NV glUniform1i64NV = Pointer<NativeFunction<GlUniform1i64NVNative>>.fromAddress(0).asFunction<GlUniform1i64NV>();
GlUniform2i64NV glUniform2i64NV = Pointer<NativeFunction<GlUniform2i64NVNative>>.fromAddress(0).asFunction<GlUniform2i64NV>();
GlUniform3i64NV glUniform3i64NV = Pointer<NativeFunction<GlUniform3i64NVNative>>.fromAddress(0).asFunction<GlUniform3i64NV>();
GlUniform4i64NV glUniform4i64NV = Pointer<NativeFunction<GlUniform4i64NVNative>>.fromAddress(0).asFunction<GlUniform4i64NV>();
GlUniform1i64vNV glUniform1i64vNV = Pointer<NativeFunction<GlUniform1i64vNVNative>>.fromAddress(0).asFunction<GlUniform1i64vNV>();
GlUniform2i64vNV glUniform2i64vNV = Pointer<NativeFunction<GlUniform2i64vNVNative>>.fromAddress(0).asFunction<GlUniform2i64vNV>();
GlUniform3i64vNV glUniform3i64vNV = Pointer<NativeFunction<GlUniform3i64vNVNative>>.fromAddress(0).asFunction<GlUniform3i64vNV>();
GlUniform4i64vNV glUniform4i64vNV = Pointer<NativeFunction<GlUniform4i64vNVNative>>.fromAddress(0).asFunction<GlUniform4i64vNV>();
GlUniform1ui64NV glUniform1ui64NV = Pointer<NativeFunction<GlUniform1ui64NVNative>>.fromAddress(0).asFunction<GlUniform1ui64NV>();
GlUniform2ui64NV glUniform2ui64NV = Pointer<NativeFunction<GlUniform2ui64NVNative>>.fromAddress(0).asFunction<GlUniform2ui64NV>();
GlUniform3ui64NV glUniform3ui64NV = Pointer<NativeFunction<GlUniform3ui64NVNative>>.fromAddress(0).asFunction<GlUniform3ui64NV>();
GlUniform4ui64NV glUniform4ui64NV = Pointer<NativeFunction<GlUniform4ui64NVNative>>.fromAddress(0).asFunction<GlUniform4ui64NV>();
GlUniform1ui64vNV glUniform1ui64vNV = Pointer<NativeFunction<GlUniform1ui64vNVNative>>.fromAddress(0).asFunction<GlUniform1ui64vNV>();
GlUniform2ui64vNV glUniform2ui64vNV = Pointer<NativeFunction<GlUniform2ui64vNVNative>>.fromAddress(0).asFunction<GlUniform2ui64vNV>();
GlUniform3ui64vNV glUniform3ui64vNV = Pointer<NativeFunction<GlUniform3ui64vNVNative>>.fromAddress(0).asFunction<GlUniform3ui64vNV>();
GlUniform4ui64vNV glUniform4ui64vNV = Pointer<NativeFunction<GlUniform4ui64vNVNative>>.fromAddress(0).asFunction<GlUniform4ui64vNV>();
GlGetUniformi64vNV glGetUniformi64vNV = Pointer<NativeFunction<GlGetUniformi64vNVNative>>.fromAddress(0).asFunction<GlGetUniformi64vNV>();
GlProgramUniform1i64NV glProgramUniform1i64NV = Pointer<NativeFunction<GlProgramUniform1i64NVNative>>.fromAddress(0).asFunction<GlProgramUniform1i64NV>();
GlProgramUniform2i64NV glProgramUniform2i64NV = Pointer<NativeFunction<GlProgramUniform2i64NVNative>>.fromAddress(0).asFunction<GlProgramUniform2i64NV>();
GlProgramUniform3i64NV glProgramUniform3i64NV = Pointer<NativeFunction<GlProgramUniform3i64NVNative>>.fromAddress(0).asFunction<GlProgramUniform3i64NV>();
GlProgramUniform4i64NV glProgramUniform4i64NV = Pointer<NativeFunction<GlProgramUniform4i64NVNative>>.fromAddress(0).asFunction<GlProgramUniform4i64NV>();
GlProgramUniform1i64vNV glProgramUniform1i64vNV = Pointer<NativeFunction<GlProgramUniform1i64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform1i64vNV>();
GlProgramUniform2i64vNV glProgramUniform2i64vNV = Pointer<NativeFunction<GlProgramUniform2i64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform2i64vNV>();
GlProgramUniform3i64vNV glProgramUniform3i64vNV = Pointer<NativeFunction<GlProgramUniform3i64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform3i64vNV>();
GlProgramUniform4i64vNV glProgramUniform4i64vNV = Pointer<NativeFunction<GlProgramUniform4i64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform4i64vNV>();
GlProgramUniform1ui64NV glProgramUniform1ui64NV = Pointer<NativeFunction<GlProgramUniform1ui64NVNative>>.fromAddress(0).asFunction<GlProgramUniform1ui64NV>();
GlProgramUniform2ui64NV glProgramUniform2ui64NV = Pointer<NativeFunction<GlProgramUniform2ui64NVNative>>.fromAddress(0).asFunction<GlProgramUniform2ui64NV>();
GlProgramUniform3ui64NV glProgramUniform3ui64NV = Pointer<NativeFunction<GlProgramUniform3ui64NVNative>>.fromAddress(0).asFunction<GlProgramUniform3ui64NV>();
GlProgramUniform4ui64NV glProgramUniform4ui64NV = Pointer<NativeFunction<GlProgramUniform4ui64NVNative>>.fromAddress(0).asFunction<GlProgramUniform4ui64NV>();
GlProgramUniform1ui64vNV glProgramUniform1ui64vNV = Pointer<NativeFunction<GlProgramUniform1ui64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform1ui64vNV>();
GlProgramUniform2ui64vNV glProgramUniform2ui64vNV = Pointer<NativeFunction<GlProgramUniform2ui64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform2ui64vNV>();
GlProgramUniform3ui64vNV glProgramUniform3ui64vNV = Pointer<NativeFunction<GlProgramUniform3ui64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform3ui64vNV>();
GlProgramUniform4ui64vNV glProgramUniform4ui64vNV = Pointer<NativeFunction<GlProgramUniform4ui64vNVNative>>.fromAddress(0).asFunction<GlProgramUniform4ui64vNV>();
GlGetInternalformatSampleivNV glGetInternalformatSampleivNV = Pointer<NativeFunction<GlGetInternalformatSampleivNVNative>>.fromAddress(0).asFunction<GlGetInternalformatSampleivNV>();
GlGetMemoryObjectDetachedResourcesuivNV glGetMemoryObjectDetachedResourcesuivNV = Pointer<NativeFunction<GlGetMemoryObjectDetachedResourcesuivNVNative>>.fromAddress(0).asFunction<GlGetMemoryObjectDetachedResourcesuivNV>();
GlResetMemoryObjectParameterNV glResetMemoryObjectParameterNV = Pointer<NativeFunction<GlResetMemoryObjectParameterNVNative>>.fromAddress(0).asFunction<GlResetMemoryObjectParameterNV>();
GlTexAttachMemoryNV glTexAttachMemoryNV = Pointer<NativeFunction<GlTexAttachMemoryNVNative>>.fromAddress(0).asFunction<GlTexAttachMemoryNV>();
GlBufferAttachMemoryNV glBufferAttachMemoryNV = Pointer<NativeFunction<GlBufferAttachMemoryNVNative>>.fromAddress(0).asFunction<GlBufferAttachMemoryNV>();
GlTextureAttachMemoryNV glTextureAttachMemoryNV = Pointer<NativeFunction<GlTextureAttachMemoryNVNative>>.fromAddress(0).asFunction<GlTextureAttachMemoryNV>();
GlNamedBufferAttachMemoryNV glNamedBufferAttachMemoryNV = Pointer<NativeFunction<GlNamedBufferAttachMemoryNVNative>>.fromAddress(0).asFunction<GlNamedBufferAttachMemoryNV>();
GlBufferPageCommitmentMemNV glBufferPageCommitmentMemNV = Pointer<NativeFunction<GlBufferPageCommitmentMemNVNative>>.fromAddress(0).asFunction<GlBufferPageCommitmentMemNV>();
GlTexPageCommitmentMemNV glTexPageCommitmentMemNV = Pointer<NativeFunction<GlTexPageCommitmentMemNVNative>>.fromAddress(0).asFunction<GlTexPageCommitmentMemNV>();
GlNamedBufferPageCommitmentMemNV glNamedBufferPageCommitmentMemNV = Pointer<NativeFunction<GlNamedBufferPageCommitmentMemNVNative>>.fromAddress(0).asFunction<GlNamedBufferPageCommitmentMemNV>();
GlTexturePageCommitmentMemNV glTexturePageCommitmentMemNV = Pointer<NativeFunction<GlTexturePageCommitmentMemNVNative>>.fromAddress(0).asFunction<GlTexturePageCommitmentMemNV>();
GlDrawMeshTasksNV glDrawMeshTasksNV = Pointer<NativeFunction<GlDrawMeshTasksNVNative>>.fromAddress(0).asFunction<GlDrawMeshTasksNV>();
GlDrawMeshTasksIndirectNV glDrawMeshTasksIndirectNV = Pointer<NativeFunction<GlDrawMeshTasksIndirectNVNative>>.fromAddress(0).asFunction<GlDrawMeshTasksIndirectNV>();
GlMultiDrawMeshTasksIndirectNV glMultiDrawMeshTasksIndirectNV = Pointer<NativeFunction<GlMultiDrawMeshTasksIndirectNVNative>>.fromAddress(0).asFunction<GlMultiDrawMeshTasksIndirectNV>();
GlMultiDrawMeshTasksIndirectCountNV glMultiDrawMeshTasksIndirectCountNV = Pointer<NativeFunction<GlMultiDrawMeshTasksIndirectCountNVNative>>.fromAddress(0).asFunction<GlMultiDrawMeshTasksIndirectCountNV>();
GlGenPathsNV glGenPathsNV = Pointer<NativeFunction<GlGenPathsNVNative>>.fromAddress(0).asFunction<GlGenPathsNV>();
GlDeletePathsNV glDeletePathsNV = Pointer<NativeFunction<GlDeletePathsNVNative>>.fromAddress(0).asFunction<GlDeletePathsNV>();
GlIsPathNV glIsPathNV = Pointer<NativeFunction<GlIsPathNVNative>>.fromAddress(0).asFunction<GlIsPathNV>();
GlPathCommandsNV glPathCommandsNV = Pointer<NativeFunction<GlPathCommandsNVNative>>.fromAddress(0).asFunction<GlPathCommandsNV>();
GlPathCoordsNV glPathCoordsNV = Pointer<NativeFunction<GlPathCoordsNVNative>>.fromAddress(0).asFunction<GlPathCoordsNV>();
GlPathSubCommandsNV glPathSubCommandsNV = Pointer<NativeFunction<GlPathSubCommandsNVNative>>.fromAddress(0).asFunction<GlPathSubCommandsNV>();
GlPathSubCoordsNV glPathSubCoordsNV = Pointer<NativeFunction<GlPathSubCoordsNVNative>>.fromAddress(0).asFunction<GlPathSubCoordsNV>();
GlPathStringNV glPathStringNV = Pointer<NativeFunction<GlPathStringNVNative>>.fromAddress(0).asFunction<GlPathStringNV>();
GlPathGlyphsNV glPathGlyphsNV = Pointer<NativeFunction<GlPathGlyphsNVNative>>.fromAddress(0).asFunction<GlPathGlyphsNV>();
GlPathGlyphRangeNV glPathGlyphRangeNV = Pointer<NativeFunction<GlPathGlyphRangeNVNative>>.fromAddress(0).asFunction<GlPathGlyphRangeNV>();
GlWeightPathsNV glWeightPathsNV = Pointer<NativeFunction<GlWeightPathsNVNative>>.fromAddress(0).asFunction<GlWeightPathsNV>();
GlCopyPathNV glCopyPathNV = Pointer<NativeFunction<GlCopyPathNVNative>>.fromAddress(0).asFunction<GlCopyPathNV>();
GlInterpolatePathsNV glInterpolatePathsNV = Pointer<NativeFunction<GlInterpolatePathsNVNative>>.fromAddress(0).asFunction<GlInterpolatePathsNV>();
GlTransformPathNV glTransformPathNV = Pointer<NativeFunction<GlTransformPathNVNative>>.fromAddress(0).asFunction<GlTransformPathNV>();
GlPathParameterivNV glPathParameterivNV = Pointer<NativeFunction<GlPathParameterivNVNative>>.fromAddress(0).asFunction<GlPathParameterivNV>();
GlPathParameteriNV glPathParameteriNV = Pointer<NativeFunction<GlPathParameteriNVNative>>.fromAddress(0).asFunction<GlPathParameteriNV>();
GlPathParameterfvNV glPathParameterfvNV = Pointer<NativeFunction<GlPathParameterfvNVNative>>.fromAddress(0).asFunction<GlPathParameterfvNV>();
GlPathParameterfNV glPathParameterfNV = Pointer<NativeFunction<GlPathParameterfNVNative>>.fromAddress(0).asFunction<GlPathParameterfNV>();
GlPathDashArrayNV glPathDashArrayNV = Pointer<NativeFunction<GlPathDashArrayNVNative>>.fromAddress(0).asFunction<GlPathDashArrayNV>();
GlPathStencilFuncNV glPathStencilFuncNV = Pointer<NativeFunction<GlPathStencilFuncNVNative>>.fromAddress(0).asFunction<GlPathStencilFuncNV>();
GlPathStencilDepthOffsetNV glPathStencilDepthOffsetNV = Pointer<NativeFunction<GlPathStencilDepthOffsetNVNative>>.fromAddress(0).asFunction<GlPathStencilDepthOffsetNV>();
GlStencilFillPathNV glStencilFillPathNV = Pointer<NativeFunction<GlStencilFillPathNVNative>>.fromAddress(0).asFunction<GlStencilFillPathNV>();
GlStencilStrokePathNV glStencilStrokePathNV = Pointer<NativeFunction<GlStencilStrokePathNVNative>>.fromAddress(0).asFunction<GlStencilStrokePathNV>();
GlStencilFillPathInstancedNV glStencilFillPathInstancedNV = Pointer<NativeFunction<GlStencilFillPathInstancedNVNative>>.fromAddress(0).asFunction<GlStencilFillPathInstancedNV>();
GlStencilStrokePathInstancedNV glStencilStrokePathInstancedNV = Pointer<NativeFunction<GlStencilStrokePathInstancedNVNative>>.fromAddress(0).asFunction<GlStencilStrokePathInstancedNV>();
GlPathCoverDepthFuncNV glPathCoverDepthFuncNV = Pointer<NativeFunction<GlPathCoverDepthFuncNVNative>>.fromAddress(0).asFunction<GlPathCoverDepthFuncNV>();
GlCoverFillPathNV glCoverFillPathNV = Pointer<NativeFunction<GlCoverFillPathNVNative>>.fromAddress(0).asFunction<GlCoverFillPathNV>();
GlCoverStrokePathNV glCoverStrokePathNV = Pointer<NativeFunction<GlCoverStrokePathNVNative>>.fromAddress(0).asFunction<GlCoverStrokePathNV>();
GlCoverFillPathInstancedNV glCoverFillPathInstancedNV = Pointer<NativeFunction<GlCoverFillPathInstancedNVNative>>.fromAddress(0).asFunction<GlCoverFillPathInstancedNV>();
GlCoverStrokePathInstancedNV glCoverStrokePathInstancedNV = Pointer<NativeFunction<GlCoverStrokePathInstancedNVNative>>.fromAddress(0).asFunction<GlCoverStrokePathInstancedNV>();
GlGetPathParameterivNV glGetPathParameterivNV = Pointer<NativeFunction<GlGetPathParameterivNVNative>>.fromAddress(0).asFunction<GlGetPathParameterivNV>();
GlGetPathParameterfvNV glGetPathParameterfvNV = Pointer<NativeFunction<GlGetPathParameterfvNVNative>>.fromAddress(0).asFunction<GlGetPathParameterfvNV>();
GlGetPathCommandsNV glGetPathCommandsNV = Pointer<NativeFunction<GlGetPathCommandsNVNative>>.fromAddress(0).asFunction<GlGetPathCommandsNV>();
GlGetPathCoordsNV glGetPathCoordsNV = Pointer<NativeFunction<GlGetPathCoordsNVNative>>.fromAddress(0).asFunction<GlGetPathCoordsNV>();
GlGetPathDashArrayNV glGetPathDashArrayNV = Pointer<NativeFunction<GlGetPathDashArrayNVNative>>.fromAddress(0).asFunction<GlGetPathDashArrayNV>();
GlGetPathMetricsNV glGetPathMetricsNV = Pointer<NativeFunction<GlGetPathMetricsNVNative>>.fromAddress(0).asFunction<GlGetPathMetricsNV>();
GlGetPathMetricRangeNV glGetPathMetricRangeNV = Pointer<NativeFunction<GlGetPathMetricRangeNVNative>>.fromAddress(0).asFunction<GlGetPathMetricRangeNV>();
GlGetPathSpacingNV glGetPathSpacingNV = Pointer<NativeFunction<GlGetPathSpacingNVNative>>.fromAddress(0).asFunction<GlGetPathSpacingNV>();
GlIsPointInFillPathNV glIsPointInFillPathNV = Pointer<NativeFunction<GlIsPointInFillPathNVNative>>.fromAddress(0).asFunction<GlIsPointInFillPathNV>();
GlIsPointInStrokePathNV glIsPointInStrokePathNV = Pointer<NativeFunction<GlIsPointInStrokePathNVNative>>.fromAddress(0).asFunction<GlIsPointInStrokePathNV>();
GlGetPathLengthNV glGetPathLengthNV = Pointer<NativeFunction<GlGetPathLengthNVNative>>.fromAddress(0).asFunction<GlGetPathLengthNV>();
GlPointAlongPathNV glPointAlongPathNV = Pointer<NativeFunction<GlPointAlongPathNVNative>>.fromAddress(0).asFunction<GlPointAlongPathNV>();
GlMatrixLoad3x2fNV glMatrixLoad3x2fNV = Pointer<NativeFunction<GlMatrixLoad3x2fNVNative>>.fromAddress(0).asFunction<GlMatrixLoad3x2fNV>();
GlMatrixLoad3x3fNV glMatrixLoad3x3fNV = Pointer<NativeFunction<GlMatrixLoad3x3fNVNative>>.fromAddress(0).asFunction<GlMatrixLoad3x3fNV>();
GlMatrixLoadTranspose3x3fNV glMatrixLoadTranspose3x3fNV = Pointer<NativeFunction<GlMatrixLoadTranspose3x3fNVNative>>.fromAddress(0).asFunction<GlMatrixLoadTranspose3x3fNV>();
GlMatrixMult3x2fNV glMatrixMult3x2fNV = Pointer<NativeFunction<GlMatrixMult3x2fNVNative>>.fromAddress(0).asFunction<GlMatrixMult3x2fNV>();
GlMatrixMult3x3fNV glMatrixMult3x3fNV = Pointer<NativeFunction<GlMatrixMult3x3fNVNative>>.fromAddress(0).asFunction<GlMatrixMult3x3fNV>();
GlMatrixMultTranspose3x3fNV glMatrixMultTranspose3x3fNV = Pointer<NativeFunction<GlMatrixMultTranspose3x3fNVNative>>.fromAddress(0).asFunction<GlMatrixMultTranspose3x3fNV>();
GlStencilThenCoverFillPathNV glStencilThenCoverFillPathNV = Pointer<NativeFunction<GlStencilThenCoverFillPathNVNative>>.fromAddress(0).asFunction<GlStencilThenCoverFillPathNV>();
GlStencilThenCoverStrokePathNV glStencilThenCoverStrokePathNV = Pointer<NativeFunction<GlStencilThenCoverStrokePathNVNative>>.fromAddress(0).asFunction<GlStencilThenCoverStrokePathNV>();
GlStencilThenCoverFillPathInstancedNV glStencilThenCoverFillPathInstancedNV = Pointer<NativeFunction<GlStencilThenCoverFillPathInstancedNVNative>>.fromAddress(0).asFunction<GlStencilThenCoverFillPathInstancedNV>();
GlStencilThenCoverStrokePathInstancedNV glStencilThenCoverStrokePathInstancedNV = Pointer<NativeFunction<GlStencilThenCoverStrokePathInstancedNVNative>>.fromAddress(0).asFunction<GlStencilThenCoverStrokePathInstancedNV>();
GlPathGlyphIndexRangeNV glPathGlyphIndexRangeNV = Pointer<NativeFunction<GlPathGlyphIndexRangeNVNative>>.fromAddress(0).asFunction<GlPathGlyphIndexRangeNV>();
GlPathGlyphIndexArrayNV glPathGlyphIndexArrayNV = Pointer<NativeFunction<GlPathGlyphIndexArrayNVNative>>.fromAddress(0).asFunction<GlPathGlyphIndexArrayNV>();
GlPathMemoryGlyphIndexArrayNV glPathMemoryGlyphIndexArrayNV = Pointer<NativeFunction<GlPathMemoryGlyphIndexArrayNVNative>>.fromAddress(0).asFunction<GlPathMemoryGlyphIndexArrayNV>();
GlProgramPathFragmentInputGenNV glProgramPathFragmentInputGenNV = Pointer<NativeFunction<GlProgramPathFragmentInputGenNVNative>>.fromAddress(0).asFunction<GlProgramPathFragmentInputGenNV>();
GlGetProgramResourcefvNV glGetProgramResourcefvNV = Pointer<NativeFunction<GlGetProgramResourcefvNVNative>>.fromAddress(0).asFunction<GlGetProgramResourcefvNV>();
GlFramebufferSampleLocationsfvNV glFramebufferSampleLocationsfvNV = Pointer<NativeFunction<GlFramebufferSampleLocationsfvNVNative>>.fromAddress(0).asFunction<GlFramebufferSampleLocationsfvNV>();
GlNamedFramebufferSampleLocationsfvNV glNamedFramebufferSampleLocationsfvNV = Pointer<NativeFunction<GlNamedFramebufferSampleLocationsfvNVNative>>.fromAddress(0).asFunction<GlNamedFramebufferSampleLocationsfvNV>();
GlResolveDepthValuesNV glResolveDepthValuesNV = Pointer<NativeFunction<GlResolveDepthValuesNVNative>>.fromAddress(0).asFunction<GlResolveDepthValuesNV>();
GlScissorExclusiveNV glScissorExclusiveNV = Pointer<NativeFunction<GlScissorExclusiveNVNative>>.fromAddress(0).asFunction<GlScissorExclusiveNV>();
GlScissorExclusiveArrayvNV glScissorExclusiveArrayvNV = Pointer<NativeFunction<GlScissorExclusiveArrayvNVNative>>.fromAddress(0).asFunction<GlScissorExclusiveArrayvNV>();
GlMakeBufferResidentNV glMakeBufferResidentNV = Pointer<NativeFunction<GlMakeBufferResidentNVNative>>.fromAddress(0).asFunction<GlMakeBufferResidentNV>();
GlMakeBufferNonResidentNV glMakeBufferNonResidentNV = Pointer<NativeFunction<GlMakeBufferNonResidentNVNative>>.fromAddress(0).asFunction<GlMakeBufferNonResidentNV>();
GlIsBufferResidentNV glIsBufferResidentNV = Pointer<NativeFunction<GlIsBufferResidentNVNative>>.fromAddress(0).asFunction<GlIsBufferResidentNV>();
GlMakeNamedBufferResidentNV glMakeNamedBufferResidentNV = Pointer<NativeFunction<GlMakeNamedBufferResidentNVNative>>.fromAddress(0).asFunction<GlMakeNamedBufferResidentNV>();
GlMakeNamedBufferNonResidentNV glMakeNamedBufferNonResidentNV = Pointer<NativeFunction<GlMakeNamedBufferNonResidentNVNative>>.fromAddress(0).asFunction<GlMakeNamedBufferNonResidentNV>();
GlIsNamedBufferResidentNV glIsNamedBufferResidentNV = Pointer<NativeFunction<GlIsNamedBufferResidentNVNative>>.fromAddress(0).asFunction<GlIsNamedBufferResidentNV>();
GlGetBufferParameterui64vNV glGetBufferParameterui64vNV = Pointer<NativeFunction<GlGetBufferParameterui64vNVNative>>.fromAddress(0).asFunction<GlGetBufferParameterui64vNV>();
GlGetNamedBufferParameterui64vNV glGetNamedBufferParameterui64vNV = Pointer<NativeFunction<GlGetNamedBufferParameterui64vNVNative>>.fromAddress(0).asFunction<GlGetNamedBufferParameterui64vNV>();
GlGetIntegerui64vNV glGetIntegerui64vNV = Pointer<NativeFunction<GlGetIntegerui64vNVNative>>.fromAddress(0).asFunction<GlGetIntegerui64vNV>();
GlUniformui64NV glUniformui64NV = Pointer<NativeFunction<GlUniformui64NVNative>>.fromAddress(0).asFunction<GlUniformui64NV>();
GlUniformui64vNV glUniformui64vNV = Pointer<NativeFunction<GlUniformui64vNVNative>>.fromAddress(0).asFunction<GlUniformui64vNV>();
GlGetUniformui64vNV glGetUniformui64vNV = Pointer<NativeFunction<GlGetUniformui64vNVNative>>.fromAddress(0).asFunction<GlGetUniformui64vNV>();
GlProgramUniformui64NV glProgramUniformui64NV = Pointer<NativeFunction<GlProgramUniformui64NVNative>>.fromAddress(0).asFunction<GlProgramUniformui64NV>();
GlProgramUniformui64vNV glProgramUniformui64vNV = Pointer<NativeFunction<GlProgramUniformui64vNVNative>>.fromAddress(0).asFunction<GlProgramUniformui64vNV>();
GlBindShadingRateImageNV glBindShadingRateImageNV = Pointer<NativeFunction<GlBindShadingRateImageNVNative>>.fromAddress(0).asFunction<GlBindShadingRateImageNV>();
GlGetShadingRateImagePaletteNV glGetShadingRateImagePaletteNV = Pointer<NativeFunction<GlGetShadingRateImagePaletteNVNative>>.fromAddress(0).asFunction<GlGetShadingRateImagePaletteNV>();
GlGetShadingRateSampleLocationivNV glGetShadingRateSampleLocationivNV = Pointer<NativeFunction<GlGetShadingRateSampleLocationivNVNative>>.fromAddress(0).asFunction<GlGetShadingRateSampleLocationivNV>();
GlShadingRateImageBarrierNV glShadingRateImageBarrierNV = Pointer<NativeFunction<GlShadingRateImageBarrierNVNative>>.fromAddress(0).asFunction<GlShadingRateImageBarrierNV>();
GlShadingRateImagePaletteNV glShadingRateImagePaletteNV = Pointer<NativeFunction<GlShadingRateImagePaletteNVNative>>.fromAddress(0).asFunction<GlShadingRateImagePaletteNV>();
GlShadingRateSampleOrderNV glShadingRateSampleOrderNV = Pointer<NativeFunction<GlShadingRateSampleOrderNVNative>>.fromAddress(0).asFunction<GlShadingRateSampleOrderNV>();
GlShadingRateSampleOrderCustomNV glShadingRateSampleOrderCustomNV = Pointer<NativeFunction<GlShadingRateSampleOrderCustomNVNative>>.fromAddress(0).asFunction<GlShadingRateSampleOrderCustomNV>();
GlTextureBarrierNV glTextureBarrierNV = Pointer<NativeFunction<GlTextureBarrierNVNative>>.fromAddress(0).asFunction<GlTextureBarrierNV>();
GlVertexAttribL1i64NV glVertexAttribL1i64NV = Pointer<NativeFunction<GlVertexAttribL1i64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL1i64NV>();
GlVertexAttribL2i64NV glVertexAttribL2i64NV = Pointer<NativeFunction<GlVertexAttribL2i64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL2i64NV>();
GlVertexAttribL3i64NV glVertexAttribL3i64NV = Pointer<NativeFunction<GlVertexAttribL3i64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL3i64NV>();
GlVertexAttribL4i64NV glVertexAttribL4i64NV = Pointer<NativeFunction<GlVertexAttribL4i64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL4i64NV>();
GlVertexAttribL1i64vNV glVertexAttribL1i64vNV = Pointer<NativeFunction<GlVertexAttribL1i64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL1i64vNV>();
GlVertexAttribL2i64vNV glVertexAttribL2i64vNV = Pointer<NativeFunction<GlVertexAttribL2i64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL2i64vNV>();
GlVertexAttribL3i64vNV glVertexAttribL3i64vNV = Pointer<NativeFunction<GlVertexAttribL3i64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL3i64vNV>();
GlVertexAttribL4i64vNV glVertexAttribL4i64vNV = Pointer<NativeFunction<GlVertexAttribL4i64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL4i64vNV>();
GlVertexAttribL1ui64NV glVertexAttribL1ui64NV = Pointer<NativeFunction<GlVertexAttribL1ui64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL1ui64NV>();
GlVertexAttribL2ui64NV glVertexAttribL2ui64NV = Pointer<NativeFunction<GlVertexAttribL2ui64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL2ui64NV>();
GlVertexAttribL3ui64NV glVertexAttribL3ui64NV = Pointer<NativeFunction<GlVertexAttribL3ui64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL3ui64NV>();
GlVertexAttribL4ui64NV glVertexAttribL4ui64NV = Pointer<NativeFunction<GlVertexAttribL4ui64NVNative>>.fromAddress(0).asFunction<GlVertexAttribL4ui64NV>();
GlVertexAttribL1ui64vNV glVertexAttribL1ui64vNV = Pointer<NativeFunction<GlVertexAttribL1ui64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL1ui64vNV>();
GlVertexAttribL2ui64vNV glVertexAttribL2ui64vNV = Pointer<NativeFunction<GlVertexAttribL2ui64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL2ui64vNV>();
GlVertexAttribL3ui64vNV glVertexAttribL3ui64vNV = Pointer<NativeFunction<GlVertexAttribL3ui64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL3ui64vNV>();
GlVertexAttribL4ui64vNV glVertexAttribL4ui64vNV = Pointer<NativeFunction<GlVertexAttribL4ui64vNVNative>>.fromAddress(0).asFunction<GlVertexAttribL4ui64vNV>();
GlGetVertexAttribLi64vNV glGetVertexAttribLi64vNV = Pointer<NativeFunction<GlGetVertexAttribLi64vNVNative>>.fromAddress(0).asFunction<GlGetVertexAttribLi64vNV>();
GlGetVertexAttribLui64vNV glGetVertexAttribLui64vNV = Pointer<NativeFunction<GlGetVertexAttribLui64vNVNative>>.fromAddress(0).asFunction<GlGetVertexAttribLui64vNV>();
GlVertexAttribLFormatNV glVertexAttribLFormatNV = Pointer<NativeFunction<GlVertexAttribLFormatNVNative>>.fromAddress(0).asFunction<GlVertexAttribLFormatNV>();
GlBufferAddressRangeNV glBufferAddressRangeNV = Pointer<NativeFunction<GlBufferAddressRangeNVNative>>.fromAddress(0).asFunction<GlBufferAddressRangeNV>();
GlVertexFormatNV glVertexFormatNV = Pointer<NativeFunction<GlVertexFormatNVNative>>.fromAddress(0).asFunction<GlVertexFormatNV>();
GlNormalFormatNV glNormalFormatNV = Pointer<NativeFunction<GlNormalFormatNVNative>>.fromAddress(0).asFunction<GlNormalFormatNV>();
GlColorFormatNV glColorFormatNV = Pointer<NativeFunction<GlColorFormatNVNative>>.fromAddress(0).asFunction<GlColorFormatNV>();
GlIndexFormatNV glIndexFormatNV = Pointer<NativeFunction<GlIndexFormatNVNative>>.fromAddress(0).asFunction<GlIndexFormatNV>();
GlTexCoordFormatNV glTexCoordFormatNV = Pointer<NativeFunction<GlTexCoordFormatNVNative>>.fromAddress(0).asFunction<GlTexCoordFormatNV>();
GlEdgeFlagFormatNV glEdgeFlagFormatNV = Pointer<NativeFunction<GlEdgeFlagFormatNVNative>>.fromAddress(0).asFunction<GlEdgeFlagFormatNV>();
GlSecondaryColorFormatNV glSecondaryColorFormatNV = Pointer<NativeFunction<GlSecondaryColorFormatNVNative>>.fromAddress(0).asFunction<GlSecondaryColorFormatNV>();
GlFogCoordFormatNV glFogCoordFormatNV = Pointer<NativeFunction<GlFogCoordFormatNVNative>>.fromAddress(0).asFunction<GlFogCoordFormatNV>();
GlVertexAttribFormatNV glVertexAttribFormatNV = Pointer<NativeFunction<GlVertexAttribFormatNVNative>>.fromAddress(0).asFunction<GlVertexAttribFormatNV>();
GlVertexAttribIFormatNV glVertexAttribIFormatNV = Pointer<NativeFunction<GlVertexAttribIFormatNVNative>>.fromAddress(0).asFunction<GlVertexAttribIFormatNV>();
GlGetIntegerui64i_vNV glGetIntegerui64i_vNV = Pointer<NativeFunction<GlGetIntegerui64i_vNVNative>>.fromAddress(0).asFunction<GlGetIntegerui64i_vNV>();
GlViewportSwizzleNV glViewportSwizzleNV = Pointer<NativeFunction<GlViewportSwizzleNVNative>>.fromAddress(0).asFunction<GlViewportSwizzleNV>();
GlFramebufferTextureMultiviewOVR glFramebufferTextureMultiviewOVR = Pointer<NativeFunction<GlFramebufferTextureMultiviewOVRNative>>.fromAddress(0).asFunction<GlFramebufferTextureMultiviewOVR>();

void initOpenGL() {
  final lib = loadLibrary();
  glCullFace = loadFunction<GlCullFaceNative>(lib, 'glCullFace').asFunction<GlCullFace>();
  glFrontFace = loadFunction<GlFrontFaceNative>(lib, 'glFrontFace').asFunction<GlFrontFace>();
  glHint = loadFunction<GlHintNative>(lib, 'glHint').asFunction<GlHint>();
  glLineWidth = loadFunction<GlLineWidthNative>(lib, 'glLineWidth').asFunction<GlLineWidth>();
  glPointSize = loadFunction<GlPointSizeNative>(lib, 'glPointSize').asFunction<GlPointSize>();
  glPolygonMode = loadFunction<GlPolygonModeNative>(lib, 'glPolygonMode').asFunction<GlPolygonMode>();
  glScissor = loadFunction<GlScissorNative>(lib, 'glScissor').asFunction<GlScissor>();
  glTexParameterf = loadFunction<GlTexParameterfNative>(lib, 'glTexParameterf').asFunction<GlTexParameterf>();
  glTexParameterfv = loadFunction<GlTexParameterfvNative>(lib, 'glTexParameterfv').asFunction<GlTexParameterfv>();
  glTexParameteri = loadFunction<GlTexParameteriNative>(lib, 'glTexParameteri').asFunction<GlTexParameteri>();
  glTexParameteriv = loadFunction<GlTexParameterivNative>(lib, 'glTexParameteriv').asFunction<GlTexParameteriv>();
  glTexImage1D = loadFunction<GlTexImage1DNative>(lib, 'glTexImage1D').asFunction<GlTexImage1D>();
  glTexImage2D = loadFunction<GlTexImage2DNative>(lib, 'glTexImage2D').asFunction<GlTexImage2D>();
  glDrawBuffer = loadFunction<GlDrawBufferNative>(lib, 'glDrawBuffer').asFunction<GlDrawBuffer>();
  glClear = loadFunction<GlClearNative>(lib, 'glClear').asFunction<GlClear>();
  glClearColor = loadFunction<GlClearColorNative>(lib, 'glClearColor').asFunction<GlClearColor>();
  glClearStencil = loadFunction<GlClearStencilNative>(lib, 'glClearStencil').asFunction<GlClearStencil>();
  glClearDepth = loadFunction<GlClearDepthNative>(lib, 'glClearDepth').asFunction<GlClearDepth>();
  glStencilMask = loadFunction<GlStencilMaskNative>(lib, 'glStencilMask').asFunction<GlStencilMask>();
  glColorMask = loadFunction<GlColorMaskNative>(lib, 'glColorMask').asFunction<GlColorMask>();
  glDepthMask = loadFunction<GlDepthMaskNative>(lib, 'glDepthMask').asFunction<GlDepthMask>();
  glDisable = loadFunction<GlDisableNative>(lib, 'glDisable').asFunction<GlDisable>();
  glEnable = loadFunction<GlEnableNative>(lib, 'glEnable').asFunction<GlEnable>();
  glFinish = loadFunction<GlFinishNative>(lib, 'glFinish').asFunction<GlFinish>();
  glFlush = loadFunction<GlFlushNative>(lib, 'glFlush').asFunction<GlFlush>();
  glBlendFunc = loadFunction<GlBlendFuncNative>(lib, 'glBlendFunc').asFunction<GlBlendFunc>();
  glLogicOp = loadFunction<GlLogicOpNative>(lib, 'glLogicOp').asFunction<GlLogicOp>();
  glStencilFunc = loadFunction<GlStencilFuncNative>(lib, 'glStencilFunc').asFunction<GlStencilFunc>();
  glStencilOp = loadFunction<GlStencilOpNative>(lib, 'glStencilOp').asFunction<GlStencilOp>();
  glDepthFunc = loadFunction<GlDepthFuncNative>(lib, 'glDepthFunc').asFunction<GlDepthFunc>();
  glPixelStoref = loadFunction<GlPixelStorefNative>(lib, 'glPixelStoref').asFunction<GlPixelStoref>();
  glPixelStorei = loadFunction<GlPixelStoreiNative>(lib, 'glPixelStorei').asFunction<GlPixelStorei>();
  glReadBuffer = loadFunction<GlReadBufferNative>(lib, 'glReadBuffer').asFunction<GlReadBuffer>();
  glReadPixels = loadFunction<GlReadPixelsNative>(lib, 'glReadPixels').asFunction<GlReadPixels>();
  glGetBooleanv = loadFunction<GlGetBooleanvNative>(lib, 'glGetBooleanv').asFunction<GlGetBooleanv>();
  glGetDoublev = loadFunction<GlGetDoublevNative>(lib, 'glGetDoublev').asFunction<GlGetDoublev>();
  glGetError = loadFunction<GlGetErrorNative>(lib, 'glGetError').asFunction<GlGetError>();
  glGetFloatv = loadFunction<GlGetFloatvNative>(lib, 'glGetFloatv').asFunction<GlGetFloatv>();
  glGetIntegerv = loadFunction<GlGetIntegervNative>(lib, 'glGetIntegerv').asFunction<GlGetIntegerv>();
  glGetString = loadFunction<GlGetStringNative>(lib, 'glGetString').asFunction<GlGetString>();
  glGetTexImage = loadFunction<GlGetTexImageNative>(lib, 'glGetTexImage').asFunction<GlGetTexImage>();
  glGetTexParameterfv = loadFunction<GlGetTexParameterfvNative>(lib, 'glGetTexParameterfv').asFunction<GlGetTexParameterfv>();
  glGetTexParameteriv = loadFunction<GlGetTexParameterivNative>(lib, 'glGetTexParameteriv').asFunction<GlGetTexParameteriv>();
  glGetTexLevelParameterfv = loadFunction<GlGetTexLevelParameterfvNative>(lib, 'glGetTexLevelParameterfv').asFunction<GlGetTexLevelParameterfv>();
  glGetTexLevelParameteriv = loadFunction<GlGetTexLevelParameterivNative>(lib, 'glGetTexLevelParameteriv').asFunction<GlGetTexLevelParameteriv>();
  glIsEnabled = loadFunction<GlIsEnabledNative>(lib, 'glIsEnabled').asFunction<GlIsEnabled>();
  glDepthRange = loadFunction<GlDepthRangeNative>(lib, 'glDepthRange').asFunction<GlDepthRange>();
  glViewport = loadFunction<GlViewportNative>(lib, 'glViewport').asFunction<GlViewport>();
  glDrawArrays = loadFunction<GlDrawArraysNative>(lib, 'glDrawArrays').asFunction<GlDrawArrays>();
  glDrawElements = loadFunction<GlDrawElementsNative>(lib, 'glDrawElements').asFunction<GlDrawElements>();
  glGetPointerv = loadFunction<GlGetPointervNative>(lib, 'glGetPointerv').asFunction<GlGetPointerv>();
  glPolygonOffset = loadFunction<GlPolygonOffsetNative>(lib, 'glPolygonOffset').asFunction<GlPolygonOffset>();
  glCopyTexImage1D = loadFunction<GlCopyTexImage1DNative>(lib, 'glCopyTexImage1D').asFunction<GlCopyTexImage1D>();
  glCopyTexImage2D = loadFunction<GlCopyTexImage2DNative>(lib, 'glCopyTexImage2D').asFunction<GlCopyTexImage2D>();
  glCopyTexSubImage1D = loadFunction<GlCopyTexSubImage1DNative>(lib, 'glCopyTexSubImage1D').asFunction<GlCopyTexSubImage1D>();
  glCopyTexSubImage2D = loadFunction<GlCopyTexSubImage2DNative>(lib, 'glCopyTexSubImage2D').asFunction<GlCopyTexSubImage2D>();
  glTexSubImage1D = loadFunction<GlTexSubImage1DNative>(lib, 'glTexSubImage1D').asFunction<GlTexSubImage1D>();
  glTexSubImage2D = loadFunction<GlTexSubImage2DNative>(lib, 'glTexSubImage2D').asFunction<GlTexSubImage2D>();
  glBindTexture = loadFunction<GlBindTextureNative>(lib, 'glBindTexture').asFunction<GlBindTexture>();
  glDeleteTextures = loadFunction<GlDeleteTexturesNative>(lib, 'glDeleteTextures').asFunction<GlDeleteTextures>();
  glGenTextures = loadFunction<GlGenTexturesNative>(lib, 'glGenTextures').asFunction<GlGenTextures>();
  glIsTexture = loadFunction<GlIsTextureNative>(lib, 'glIsTexture').asFunction<GlIsTexture>();
  glDrawRangeElements = loadFunction<GlDrawRangeElementsNative>(lib, 'glDrawRangeElements').asFunction<GlDrawRangeElements>();
  glTexImage3D = loadFunction<GlTexImage3DNative>(lib, 'glTexImage3D').asFunction<GlTexImage3D>();
  glTexSubImage3D = loadFunction<GlTexSubImage3DNative>(lib, 'glTexSubImage3D').asFunction<GlTexSubImage3D>();
  glCopyTexSubImage3D = loadFunction<GlCopyTexSubImage3DNative>(lib, 'glCopyTexSubImage3D').asFunction<GlCopyTexSubImage3D>();
  glActiveTexture = loadFunction<GlActiveTextureNative>(lib, 'glActiveTexture').asFunction<GlActiveTexture>();
  glSampleCoverage = loadFunction<GlSampleCoverageNative>(lib, 'glSampleCoverage').asFunction<GlSampleCoverage>();
  glCompressedTexImage3D = loadFunction<GlCompressedTexImage3DNative>(lib, 'glCompressedTexImage3D').asFunction<GlCompressedTexImage3D>();
  glCompressedTexImage2D = loadFunction<GlCompressedTexImage2DNative>(lib, 'glCompressedTexImage2D').asFunction<GlCompressedTexImage2D>();
  glCompressedTexImage1D = loadFunction<GlCompressedTexImage1DNative>(lib, 'glCompressedTexImage1D').asFunction<GlCompressedTexImage1D>();
  glCompressedTexSubImage3D = loadFunction<GlCompressedTexSubImage3DNative>(lib, 'glCompressedTexSubImage3D').asFunction<GlCompressedTexSubImage3D>();
  glCompressedTexSubImage2D = loadFunction<GlCompressedTexSubImage2DNative>(lib, 'glCompressedTexSubImage2D').asFunction<GlCompressedTexSubImage2D>();
  glCompressedTexSubImage1D = loadFunction<GlCompressedTexSubImage1DNative>(lib, 'glCompressedTexSubImage1D').asFunction<GlCompressedTexSubImage1D>();
  glGetCompressedTexImage = loadFunction<GlGetCompressedTexImageNative>(lib, 'glGetCompressedTexImage').asFunction<GlGetCompressedTexImage>();
  glBlendFuncSeparate = loadFunction<GlBlendFuncSeparateNative>(lib, 'glBlendFuncSeparate').asFunction<GlBlendFuncSeparate>();
  glMultiDrawArrays = loadFunction<GlMultiDrawArraysNative>(lib, 'glMultiDrawArrays').asFunction<GlMultiDrawArrays>();
  glMultiDrawElements = loadFunction<GlMultiDrawElementsNative>(lib, 'glMultiDrawElements').asFunction<GlMultiDrawElements>();
  glPointParameterf = loadFunction<GlPointParameterfNative>(lib, 'glPointParameterf').asFunction<GlPointParameterf>();
  glPointParameterfv = loadFunction<GlPointParameterfvNative>(lib, 'glPointParameterfv').asFunction<GlPointParameterfv>();
  glPointParameteri = loadFunction<GlPointParameteriNative>(lib, 'glPointParameteri').asFunction<GlPointParameteri>();
  glPointParameteriv = loadFunction<GlPointParameterivNative>(lib, 'glPointParameteriv').asFunction<GlPointParameteriv>();
  glBlendColor = loadFunction<GlBlendColorNative>(lib, 'glBlendColor').asFunction<GlBlendColor>();
  glBlendEquation = loadFunction<GlBlendEquationNative>(lib, 'glBlendEquation').asFunction<GlBlendEquation>();
  glGenQueries = loadFunction<GlGenQueriesNative>(lib, 'glGenQueries').asFunction<GlGenQueries>();
  glDeleteQueries = loadFunction<GlDeleteQueriesNative>(lib, 'glDeleteQueries').asFunction<GlDeleteQueries>();
  glIsQuery = loadFunction<GlIsQueryNative>(lib, 'glIsQuery').asFunction<GlIsQuery>();
  glBeginQuery = loadFunction<GlBeginQueryNative>(lib, 'glBeginQuery').asFunction<GlBeginQuery>();
  glEndQuery = loadFunction<GlEndQueryNative>(lib, 'glEndQuery').asFunction<GlEndQuery>();
  glGetQueryiv = loadFunction<GlGetQueryivNative>(lib, 'glGetQueryiv').asFunction<GlGetQueryiv>();
  glGetQueryObjectiv = loadFunction<GlGetQueryObjectivNative>(lib, 'glGetQueryObjectiv').asFunction<GlGetQueryObjectiv>();
  glGetQueryObjectuiv = loadFunction<GlGetQueryObjectuivNative>(lib, 'glGetQueryObjectuiv').asFunction<GlGetQueryObjectuiv>();
  glBindBuffer = loadFunction<GlBindBufferNative>(lib, 'glBindBuffer').asFunction<GlBindBuffer>();
  glDeleteBuffers = loadFunction<GlDeleteBuffersNative>(lib, 'glDeleteBuffers').asFunction<GlDeleteBuffers>();
  glGenBuffers = loadFunction<GlGenBuffersNative>(lib, 'glGenBuffers').asFunction<GlGenBuffers>();
  glIsBuffer = loadFunction<GlIsBufferNative>(lib, 'glIsBuffer').asFunction<GlIsBuffer>();
  glBufferData = loadFunction<GlBufferDataNative>(lib, 'glBufferData').asFunction<GlBufferData>();
  glBufferSubData = loadFunction<GlBufferSubDataNative>(lib, 'glBufferSubData').asFunction<GlBufferSubData>();
  glGetBufferSubData = loadFunction<GlGetBufferSubDataNative>(lib, 'glGetBufferSubData').asFunction<GlGetBufferSubData>();
  glMapBuffer = loadFunction<GlMapBufferNative>(lib, 'glMapBuffer').asFunction<GlMapBuffer>();
  glUnmapBuffer = loadFunction<GlUnmapBufferNative>(lib, 'glUnmapBuffer').asFunction<GlUnmapBuffer>();
  glGetBufferParameteriv = loadFunction<GlGetBufferParameterivNative>(lib, 'glGetBufferParameteriv').asFunction<GlGetBufferParameteriv>();
  glGetBufferPointerv = loadFunction<GlGetBufferPointervNative>(lib, 'glGetBufferPointerv').asFunction<GlGetBufferPointerv>();
  glBlendEquationSeparate = loadFunction<GlBlendEquationSeparateNative>(lib, 'glBlendEquationSeparate').asFunction<GlBlendEquationSeparate>();
  glDrawBuffers = loadFunction<GlDrawBuffersNative>(lib, 'glDrawBuffers').asFunction<GlDrawBuffers>();
  glStencilOpSeparate = loadFunction<GlStencilOpSeparateNative>(lib, 'glStencilOpSeparate').asFunction<GlStencilOpSeparate>();
  glStencilFuncSeparate = loadFunction<GlStencilFuncSeparateNative>(lib, 'glStencilFuncSeparate').asFunction<GlStencilFuncSeparate>();
  glStencilMaskSeparate = loadFunction<GlStencilMaskSeparateNative>(lib, 'glStencilMaskSeparate').asFunction<GlStencilMaskSeparate>();
  glAttachShader = loadFunction<GlAttachShaderNative>(lib, 'glAttachShader').asFunction<GlAttachShader>();
  glBindAttribLocation = loadFunction<GlBindAttribLocationNative>(lib, 'glBindAttribLocation').asFunction<GlBindAttribLocation>();
  glCompileShader = loadFunction<GlCompileShaderNative>(lib, 'glCompileShader').asFunction<GlCompileShader>();
  glCreateProgram = loadFunction<GlCreateProgramNative>(lib, 'glCreateProgram').asFunction<GlCreateProgram>();
  glCreateShader = loadFunction<GlCreateShaderNative>(lib, 'glCreateShader').asFunction<GlCreateShader>();
  glDeleteProgram = loadFunction<GlDeleteProgramNative>(lib, 'glDeleteProgram').asFunction<GlDeleteProgram>();
  glDeleteShader = loadFunction<GlDeleteShaderNative>(lib, 'glDeleteShader').asFunction<GlDeleteShader>();
  glDetachShader = loadFunction<GlDetachShaderNative>(lib, 'glDetachShader').asFunction<GlDetachShader>();
  glDisableVertexAttribArray = loadFunction<GlDisableVertexAttribArrayNative>(lib, 'glDisableVertexAttribArray').asFunction<GlDisableVertexAttribArray>();
  glEnableVertexAttribArray = loadFunction<GlEnableVertexAttribArrayNative>(lib, 'glEnableVertexAttribArray').asFunction<GlEnableVertexAttribArray>();
  glGetActiveAttrib = loadFunction<GlGetActiveAttribNative>(lib, 'glGetActiveAttrib').asFunction<GlGetActiveAttrib>();
  glGetActiveUniform = loadFunction<GlGetActiveUniformNative>(lib, 'glGetActiveUniform').asFunction<GlGetActiveUniform>();
  glGetAttachedShaders = loadFunction<GlGetAttachedShadersNative>(lib, 'glGetAttachedShaders').asFunction<GlGetAttachedShaders>();
  glGetAttribLocation = loadFunction<GlGetAttribLocationNative>(lib, 'glGetAttribLocation').asFunction<GlGetAttribLocation>();
  glGetProgramiv = loadFunction<GlGetProgramivNative>(lib, 'glGetProgramiv').asFunction<GlGetProgramiv>();
  glGetProgramInfoLog = loadFunction<GlGetProgramInfoLogNative>(lib, 'glGetProgramInfoLog').asFunction<GlGetProgramInfoLog>();
  glGetShaderiv = loadFunction<GlGetShaderivNative>(lib, 'glGetShaderiv').asFunction<GlGetShaderiv>();
  glGetShaderInfoLog = loadFunction<GlGetShaderInfoLogNative>(lib, 'glGetShaderInfoLog').asFunction<GlGetShaderInfoLog>();
  glGetShaderSource = loadFunction<GlGetShaderSourceNative>(lib, 'glGetShaderSource').asFunction<GlGetShaderSource>();
  glGetUniformLocation = loadFunction<GlGetUniformLocationNative>(lib, 'glGetUniformLocation').asFunction<GlGetUniformLocation>();
  glGetUniformfv = loadFunction<GlGetUniformfvNative>(lib, 'glGetUniformfv').asFunction<GlGetUniformfv>();
  glGetUniformiv = loadFunction<GlGetUniformivNative>(lib, 'glGetUniformiv').asFunction<GlGetUniformiv>();
  glGetVertexAttribdv = loadFunction<GlGetVertexAttribdvNative>(lib, 'glGetVertexAttribdv').asFunction<GlGetVertexAttribdv>();
  glGetVertexAttribfv = loadFunction<GlGetVertexAttribfvNative>(lib, 'glGetVertexAttribfv').asFunction<GlGetVertexAttribfv>();
  glGetVertexAttribiv = loadFunction<GlGetVertexAttribivNative>(lib, 'glGetVertexAttribiv').asFunction<GlGetVertexAttribiv>();
  glGetVertexAttribPointerv = loadFunction<GlGetVertexAttribPointervNative>(lib, 'glGetVertexAttribPointerv').asFunction<GlGetVertexAttribPointerv>();
  glIsProgram = loadFunction<GlIsProgramNative>(lib, 'glIsProgram').asFunction<GlIsProgram>();
  glIsShader = loadFunction<GlIsShaderNative>(lib, 'glIsShader').asFunction<GlIsShader>();
  glLinkProgram = loadFunction<GlLinkProgramNative>(lib, 'glLinkProgram').asFunction<GlLinkProgram>();
  glShaderSource = loadFunction<GlShaderSourceNative>(lib, 'glShaderSource').asFunction<GlShaderSource>();
  glUseProgram = loadFunction<GlUseProgramNative>(lib, 'glUseProgram').asFunction<GlUseProgram>();
  glUniform1f = loadFunction<GlUniform1fNative>(lib, 'glUniform1f').asFunction<GlUniform1f>();
  glUniform2f = loadFunction<GlUniform2fNative>(lib, 'glUniform2f').asFunction<GlUniform2f>();
  glUniform3f = loadFunction<GlUniform3fNative>(lib, 'glUniform3f').asFunction<GlUniform3f>();
  glUniform4f = loadFunction<GlUniform4fNative>(lib, 'glUniform4f').asFunction<GlUniform4f>();
  glUniform1i = loadFunction<GlUniform1iNative>(lib, 'glUniform1i').asFunction<GlUniform1i>();
  glUniform2i = loadFunction<GlUniform2iNative>(lib, 'glUniform2i').asFunction<GlUniform2i>();
  glUniform3i = loadFunction<GlUniform3iNative>(lib, 'glUniform3i').asFunction<GlUniform3i>();
  glUniform4i = loadFunction<GlUniform4iNative>(lib, 'glUniform4i').asFunction<GlUniform4i>();
  glUniform1fv = loadFunction<GlUniform1fvNative>(lib, 'glUniform1fv').asFunction<GlUniform1fv>();
  glUniform2fv = loadFunction<GlUniform2fvNative>(lib, 'glUniform2fv').asFunction<GlUniform2fv>();
  glUniform3fv = loadFunction<GlUniform3fvNative>(lib, 'glUniform3fv').asFunction<GlUniform3fv>();
  glUniform4fv = loadFunction<GlUniform4fvNative>(lib, 'glUniform4fv').asFunction<GlUniform4fv>();
  glUniform1iv = loadFunction<GlUniform1ivNative>(lib, 'glUniform1iv').asFunction<GlUniform1iv>();
  glUniform2iv = loadFunction<GlUniform2ivNative>(lib, 'glUniform2iv').asFunction<GlUniform2iv>();
  glUniform3iv = loadFunction<GlUniform3ivNative>(lib, 'glUniform3iv').asFunction<GlUniform3iv>();
  glUniform4iv = loadFunction<GlUniform4ivNative>(lib, 'glUniform4iv').asFunction<GlUniform4iv>();
  glUniformMatrix2fv = loadFunction<GlUniformMatrix2fvNative>(lib, 'glUniformMatrix2fv').asFunction<GlUniformMatrix2fv>();
  glUniformMatrix3fv = loadFunction<GlUniformMatrix3fvNative>(lib, 'glUniformMatrix3fv').asFunction<GlUniformMatrix3fv>();
  glUniformMatrix4fv = loadFunction<GlUniformMatrix4fvNative>(lib, 'glUniformMatrix4fv').asFunction<GlUniformMatrix4fv>();
  glValidateProgram = loadFunction<GlValidateProgramNative>(lib, 'glValidateProgram').asFunction<GlValidateProgram>();
  glVertexAttrib1d = loadFunction<GlVertexAttrib1dNative>(lib, 'glVertexAttrib1d').asFunction<GlVertexAttrib1d>();
  glVertexAttrib1dv = loadFunction<GlVertexAttrib1dvNative>(lib, 'glVertexAttrib1dv').asFunction<GlVertexAttrib1dv>();
  glVertexAttrib1f = loadFunction<GlVertexAttrib1fNative>(lib, 'glVertexAttrib1f').asFunction<GlVertexAttrib1f>();
  glVertexAttrib1fv = loadFunction<GlVertexAttrib1fvNative>(lib, 'glVertexAttrib1fv').asFunction<GlVertexAttrib1fv>();
  glVertexAttrib1s = loadFunction<GlVertexAttrib1sNative>(lib, 'glVertexAttrib1s').asFunction<GlVertexAttrib1s>();
  glVertexAttrib1sv = loadFunction<GlVertexAttrib1svNative>(lib, 'glVertexAttrib1sv').asFunction<GlVertexAttrib1sv>();
  glVertexAttrib2d = loadFunction<GlVertexAttrib2dNative>(lib, 'glVertexAttrib2d').asFunction<GlVertexAttrib2d>();
  glVertexAttrib2dv = loadFunction<GlVertexAttrib2dvNative>(lib, 'glVertexAttrib2dv').asFunction<GlVertexAttrib2dv>();
  glVertexAttrib2f = loadFunction<GlVertexAttrib2fNative>(lib, 'glVertexAttrib2f').asFunction<GlVertexAttrib2f>();
  glVertexAttrib2fv = loadFunction<GlVertexAttrib2fvNative>(lib, 'glVertexAttrib2fv').asFunction<GlVertexAttrib2fv>();
  glVertexAttrib2s = loadFunction<GlVertexAttrib2sNative>(lib, 'glVertexAttrib2s').asFunction<GlVertexAttrib2s>();
  glVertexAttrib2sv = loadFunction<GlVertexAttrib2svNative>(lib, 'glVertexAttrib2sv').asFunction<GlVertexAttrib2sv>();
  glVertexAttrib3d = loadFunction<GlVertexAttrib3dNative>(lib, 'glVertexAttrib3d').asFunction<GlVertexAttrib3d>();
  glVertexAttrib3dv = loadFunction<GlVertexAttrib3dvNative>(lib, 'glVertexAttrib3dv').asFunction<GlVertexAttrib3dv>();
  glVertexAttrib3f = loadFunction<GlVertexAttrib3fNative>(lib, 'glVertexAttrib3f').asFunction<GlVertexAttrib3f>();
  glVertexAttrib3fv = loadFunction<GlVertexAttrib3fvNative>(lib, 'glVertexAttrib3fv').asFunction<GlVertexAttrib3fv>();
  glVertexAttrib3s = loadFunction<GlVertexAttrib3sNative>(lib, 'glVertexAttrib3s').asFunction<GlVertexAttrib3s>();
  glVertexAttrib3sv = loadFunction<GlVertexAttrib3svNative>(lib, 'glVertexAttrib3sv').asFunction<GlVertexAttrib3sv>();
  glVertexAttrib4Nbv = loadFunction<GlVertexAttrib4NbvNative>(lib, 'glVertexAttrib4Nbv').asFunction<GlVertexAttrib4Nbv>();
  glVertexAttrib4Niv = loadFunction<GlVertexAttrib4NivNative>(lib, 'glVertexAttrib4Niv').asFunction<GlVertexAttrib4Niv>();
  glVertexAttrib4Nsv = loadFunction<GlVertexAttrib4NsvNative>(lib, 'glVertexAttrib4Nsv').asFunction<GlVertexAttrib4Nsv>();
  glVertexAttrib4Nub = loadFunction<GlVertexAttrib4NubNative>(lib, 'glVertexAttrib4Nub').asFunction<GlVertexAttrib4Nub>();
  glVertexAttrib4Nubv = loadFunction<GlVertexAttrib4NubvNative>(lib, 'glVertexAttrib4Nubv').asFunction<GlVertexAttrib4Nubv>();
  glVertexAttrib4Nuiv = loadFunction<GlVertexAttrib4NuivNative>(lib, 'glVertexAttrib4Nuiv').asFunction<GlVertexAttrib4Nuiv>();
  glVertexAttrib4Nusv = loadFunction<GlVertexAttrib4NusvNative>(lib, 'glVertexAttrib4Nusv').asFunction<GlVertexAttrib4Nusv>();
  glVertexAttrib4bv = loadFunction<GlVertexAttrib4bvNative>(lib, 'glVertexAttrib4bv').asFunction<GlVertexAttrib4bv>();
  glVertexAttrib4d = loadFunction<GlVertexAttrib4dNative>(lib, 'glVertexAttrib4d').asFunction<GlVertexAttrib4d>();
  glVertexAttrib4dv = loadFunction<GlVertexAttrib4dvNative>(lib, 'glVertexAttrib4dv').asFunction<GlVertexAttrib4dv>();
  glVertexAttrib4f = loadFunction<GlVertexAttrib4fNative>(lib, 'glVertexAttrib4f').asFunction<GlVertexAttrib4f>();
  glVertexAttrib4fv = loadFunction<GlVertexAttrib4fvNative>(lib, 'glVertexAttrib4fv').asFunction<GlVertexAttrib4fv>();
  glVertexAttrib4iv = loadFunction<GlVertexAttrib4ivNative>(lib, 'glVertexAttrib4iv').asFunction<GlVertexAttrib4iv>();
  glVertexAttrib4s = loadFunction<GlVertexAttrib4sNative>(lib, 'glVertexAttrib4s').asFunction<GlVertexAttrib4s>();
  glVertexAttrib4sv = loadFunction<GlVertexAttrib4svNative>(lib, 'glVertexAttrib4sv').asFunction<GlVertexAttrib4sv>();
  glVertexAttrib4ubv = loadFunction<GlVertexAttrib4ubvNative>(lib, 'glVertexAttrib4ubv').asFunction<GlVertexAttrib4ubv>();
  glVertexAttrib4uiv = loadFunction<GlVertexAttrib4uivNative>(lib, 'glVertexAttrib4uiv').asFunction<GlVertexAttrib4uiv>();
  glVertexAttrib4usv = loadFunction<GlVertexAttrib4usvNative>(lib, 'glVertexAttrib4usv').asFunction<GlVertexAttrib4usv>();
  glVertexAttribPointer = loadFunction<GlVertexAttribPointerNative>(lib, 'glVertexAttribPointer').asFunction<GlVertexAttribPointer>();
  glUniformMatrix2x3fv = loadFunction<GlUniformMatrix2x3fvNative>(lib, 'glUniformMatrix2x3fv').asFunction<GlUniformMatrix2x3fv>();
  glUniformMatrix3x2fv = loadFunction<GlUniformMatrix3x2fvNative>(lib, 'glUniformMatrix3x2fv').asFunction<GlUniformMatrix3x2fv>();
  glUniformMatrix2x4fv = loadFunction<GlUniformMatrix2x4fvNative>(lib, 'glUniformMatrix2x4fv').asFunction<GlUniformMatrix2x4fv>();
  glUniformMatrix4x2fv = loadFunction<GlUniformMatrix4x2fvNative>(lib, 'glUniformMatrix4x2fv').asFunction<GlUniformMatrix4x2fv>();
  glUniformMatrix3x4fv = loadFunction<GlUniformMatrix3x4fvNative>(lib, 'glUniformMatrix3x4fv').asFunction<GlUniformMatrix3x4fv>();
  glUniformMatrix4x3fv = loadFunction<GlUniformMatrix4x3fvNative>(lib, 'glUniformMatrix4x3fv').asFunction<GlUniformMatrix4x3fv>();
  glColorMaski = loadFunction<GlColorMaskiNative>(lib, 'glColorMaski').asFunction<GlColorMaski>();
  glGetBooleani_v = loadFunction<GlGetBooleani_vNative>(lib, 'glGetBooleani_v').asFunction<GlGetBooleani_v>();
  glGetIntegeri_v = loadFunction<GlGetIntegeri_vNative>(lib, 'glGetIntegeri_v').asFunction<GlGetIntegeri_v>();
  glEnablei = loadFunction<GlEnableiNative>(lib, 'glEnablei').asFunction<GlEnablei>();
  glDisablei = loadFunction<GlDisableiNative>(lib, 'glDisablei').asFunction<GlDisablei>();
  glIsEnabledi = loadFunction<GlIsEnablediNative>(lib, 'glIsEnabledi').asFunction<GlIsEnabledi>();
  glBeginTransformFeedback = loadFunction<GlBeginTransformFeedbackNative>(lib, 'glBeginTransformFeedback').asFunction<GlBeginTransformFeedback>();
  glEndTransformFeedback = loadFunction<GlEndTransformFeedbackNative>(lib, 'glEndTransformFeedback').asFunction<GlEndTransformFeedback>();
  glBindBufferRange = loadFunction<GlBindBufferRangeNative>(lib, 'glBindBufferRange').asFunction<GlBindBufferRange>();
  glBindBufferBase = loadFunction<GlBindBufferBaseNative>(lib, 'glBindBufferBase').asFunction<GlBindBufferBase>();
  glTransformFeedbackVaryings = loadFunction<GlTransformFeedbackVaryingsNative>(lib, 'glTransformFeedbackVaryings').asFunction<GlTransformFeedbackVaryings>();
  glGetTransformFeedbackVarying = loadFunction<GlGetTransformFeedbackVaryingNative>(lib, 'glGetTransformFeedbackVarying').asFunction<GlGetTransformFeedbackVarying>();
  glClampColor = loadFunction<GlClampColorNative>(lib, 'glClampColor').asFunction<GlClampColor>();
  glBeginConditionalRender = loadFunction<GlBeginConditionalRenderNative>(lib, 'glBeginConditionalRender').asFunction<GlBeginConditionalRender>();
  glEndConditionalRender = loadFunction<GlEndConditionalRenderNative>(lib, 'glEndConditionalRender').asFunction<GlEndConditionalRender>();
  glVertexAttribIPointer = loadFunction<GlVertexAttribIPointerNative>(lib, 'glVertexAttribIPointer').asFunction<GlVertexAttribIPointer>();
  glGetVertexAttribIiv = loadFunction<GlGetVertexAttribIivNative>(lib, 'glGetVertexAttribIiv').asFunction<GlGetVertexAttribIiv>();
  glGetVertexAttribIuiv = loadFunction<GlGetVertexAttribIuivNative>(lib, 'glGetVertexAttribIuiv').asFunction<GlGetVertexAttribIuiv>();
  glVertexAttribI1i = loadFunction<GlVertexAttribI1iNative>(lib, 'glVertexAttribI1i').asFunction<GlVertexAttribI1i>();
  glVertexAttribI2i = loadFunction<GlVertexAttribI2iNative>(lib, 'glVertexAttribI2i').asFunction<GlVertexAttribI2i>();
  glVertexAttribI3i = loadFunction<GlVertexAttribI3iNative>(lib, 'glVertexAttribI3i').asFunction<GlVertexAttribI3i>();
  glVertexAttribI4i = loadFunction<GlVertexAttribI4iNative>(lib, 'glVertexAttribI4i').asFunction<GlVertexAttribI4i>();
  glVertexAttribI1ui = loadFunction<GlVertexAttribI1uiNative>(lib, 'glVertexAttribI1ui').asFunction<GlVertexAttribI1ui>();
  glVertexAttribI2ui = loadFunction<GlVertexAttribI2uiNative>(lib, 'glVertexAttribI2ui').asFunction<GlVertexAttribI2ui>();
  glVertexAttribI3ui = loadFunction<GlVertexAttribI3uiNative>(lib, 'glVertexAttribI3ui').asFunction<GlVertexAttribI3ui>();
  glVertexAttribI4ui = loadFunction<GlVertexAttribI4uiNative>(lib, 'glVertexAttribI4ui').asFunction<GlVertexAttribI4ui>();
  glVertexAttribI1iv = loadFunction<GlVertexAttribI1ivNative>(lib, 'glVertexAttribI1iv').asFunction<GlVertexAttribI1iv>();
  glVertexAttribI2iv = loadFunction<GlVertexAttribI2ivNative>(lib, 'glVertexAttribI2iv').asFunction<GlVertexAttribI2iv>();
  glVertexAttribI3iv = loadFunction<GlVertexAttribI3ivNative>(lib, 'glVertexAttribI3iv').asFunction<GlVertexAttribI3iv>();
  glVertexAttribI4iv = loadFunction<GlVertexAttribI4ivNative>(lib, 'glVertexAttribI4iv').asFunction<GlVertexAttribI4iv>();
  glVertexAttribI1uiv = loadFunction<GlVertexAttribI1uivNative>(lib, 'glVertexAttribI1uiv').asFunction<GlVertexAttribI1uiv>();
  glVertexAttribI2uiv = loadFunction<GlVertexAttribI2uivNative>(lib, 'glVertexAttribI2uiv').asFunction<GlVertexAttribI2uiv>();
  glVertexAttribI3uiv = loadFunction<GlVertexAttribI3uivNative>(lib, 'glVertexAttribI3uiv').asFunction<GlVertexAttribI3uiv>();
  glVertexAttribI4uiv = loadFunction<GlVertexAttribI4uivNative>(lib, 'glVertexAttribI4uiv').asFunction<GlVertexAttribI4uiv>();
  glVertexAttribI4bv = loadFunction<GlVertexAttribI4bvNative>(lib, 'glVertexAttribI4bv').asFunction<GlVertexAttribI4bv>();
  glVertexAttribI4sv = loadFunction<GlVertexAttribI4svNative>(lib, 'glVertexAttribI4sv').asFunction<GlVertexAttribI4sv>();
  glVertexAttribI4ubv = loadFunction<GlVertexAttribI4ubvNative>(lib, 'glVertexAttribI4ubv').asFunction<GlVertexAttribI4ubv>();
  glVertexAttribI4usv = loadFunction<GlVertexAttribI4usvNative>(lib, 'glVertexAttribI4usv').asFunction<GlVertexAttribI4usv>();
  glGetUniformuiv = loadFunction<GlGetUniformuivNative>(lib, 'glGetUniformuiv').asFunction<GlGetUniformuiv>();
  glBindFragDataLocation = loadFunction<GlBindFragDataLocationNative>(lib, 'glBindFragDataLocation').asFunction<GlBindFragDataLocation>();
  glGetFragDataLocation = loadFunction<GlGetFragDataLocationNative>(lib, 'glGetFragDataLocation').asFunction<GlGetFragDataLocation>();
  glUniform1ui = loadFunction<GlUniform1uiNative>(lib, 'glUniform1ui').asFunction<GlUniform1ui>();
  glUniform2ui = loadFunction<GlUniform2uiNative>(lib, 'glUniform2ui').asFunction<GlUniform2ui>();
  glUniform3ui = loadFunction<GlUniform3uiNative>(lib, 'glUniform3ui').asFunction<GlUniform3ui>();
  glUniform4ui = loadFunction<GlUniform4uiNative>(lib, 'glUniform4ui').asFunction<GlUniform4ui>();
  glUniform1uiv = loadFunction<GlUniform1uivNative>(lib, 'glUniform1uiv').asFunction<GlUniform1uiv>();
  glUniform2uiv = loadFunction<GlUniform2uivNative>(lib, 'glUniform2uiv').asFunction<GlUniform2uiv>();
  glUniform3uiv = loadFunction<GlUniform3uivNative>(lib, 'glUniform3uiv').asFunction<GlUniform3uiv>();
  glUniform4uiv = loadFunction<GlUniform4uivNative>(lib, 'glUniform4uiv').asFunction<GlUniform4uiv>();
  glTexParameterIiv = loadFunction<GlTexParameterIivNative>(lib, 'glTexParameterIiv').asFunction<GlTexParameterIiv>();
  glTexParameterIuiv = loadFunction<GlTexParameterIuivNative>(lib, 'glTexParameterIuiv').asFunction<GlTexParameterIuiv>();
  glGetTexParameterIiv = loadFunction<GlGetTexParameterIivNative>(lib, 'glGetTexParameterIiv').asFunction<GlGetTexParameterIiv>();
  glGetTexParameterIuiv = loadFunction<GlGetTexParameterIuivNative>(lib, 'glGetTexParameterIuiv').asFunction<GlGetTexParameterIuiv>();
  glClearBufferiv = loadFunction<GlClearBufferivNative>(lib, 'glClearBufferiv').asFunction<GlClearBufferiv>();
  glClearBufferuiv = loadFunction<GlClearBufferuivNative>(lib, 'glClearBufferuiv').asFunction<GlClearBufferuiv>();
  glClearBufferfv = loadFunction<GlClearBufferfvNative>(lib, 'glClearBufferfv').asFunction<GlClearBufferfv>();
  glClearBufferfi = loadFunction<GlClearBufferfiNative>(lib, 'glClearBufferfi').asFunction<GlClearBufferfi>();
  glGetStringi = loadFunction<GlGetStringiNative>(lib, 'glGetStringi').asFunction<GlGetStringi>();
  glIsRenderbuffer = loadFunction<GlIsRenderbufferNative>(lib, 'glIsRenderbuffer').asFunction<GlIsRenderbuffer>();
  glBindRenderbuffer = loadFunction<GlBindRenderbufferNative>(lib, 'glBindRenderbuffer').asFunction<GlBindRenderbuffer>();
  glDeleteRenderbuffers = loadFunction<GlDeleteRenderbuffersNative>(lib, 'glDeleteRenderbuffers').asFunction<GlDeleteRenderbuffers>();
  glGenRenderbuffers = loadFunction<GlGenRenderbuffersNative>(lib, 'glGenRenderbuffers').asFunction<GlGenRenderbuffers>();
  glRenderbufferStorage = loadFunction<GlRenderbufferStorageNative>(lib, 'glRenderbufferStorage').asFunction<GlRenderbufferStorage>();
  glGetRenderbufferParameteriv = loadFunction<GlGetRenderbufferParameterivNative>(lib, 'glGetRenderbufferParameteriv').asFunction<GlGetRenderbufferParameteriv>();
  glIsFramebuffer = loadFunction<GlIsFramebufferNative>(lib, 'glIsFramebuffer').asFunction<GlIsFramebuffer>();
  glBindFramebuffer = loadFunction<GlBindFramebufferNative>(lib, 'glBindFramebuffer').asFunction<GlBindFramebuffer>();
  glDeleteFramebuffers = loadFunction<GlDeleteFramebuffersNative>(lib, 'glDeleteFramebuffers').asFunction<GlDeleteFramebuffers>();
  glGenFramebuffers = loadFunction<GlGenFramebuffersNative>(lib, 'glGenFramebuffers').asFunction<GlGenFramebuffers>();
  glCheckFramebufferStatus = loadFunction<GlCheckFramebufferStatusNative>(lib, 'glCheckFramebufferStatus').asFunction<GlCheckFramebufferStatus>();
  glFramebufferTexture1D = loadFunction<GlFramebufferTexture1DNative>(lib, 'glFramebufferTexture1D').asFunction<GlFramebufferTexture1D>();
  glFramebufferTexture2D = loadFunction<GlFramebufferTexture2DNative>(lib, 'glFramebufferTexture2D').asFunction<GlFramebufferTexture2D>();
  glFramebufferTexture3D = loadFunction<GlFramebufferTexture3DNative>(lib, 'glFramebufferTexture3D').asFunction<GlFramebufferTexture3D>();
  glFramebufferRenderbuffer = loadFunction<GlFramebufferRenderbufferNative>(lib, 'glFramebufferRenderbuffer').asFunction<GlFramebufferRenderbuffer>();
  glGetFramebufferAttachmentParameteriv = loadFunction<GlGetFramebufferAttachmentParameterivNative>(lib, 'glGetFramebufferAttachmentParameteriv').asFunction<GlGetFramebufferAttachmentParameteriv>();
  glGenerateMipmap = loadFunction<GlGenerateMipmapNative>(lib, 'glGenerateMipmap').asFunction<GlGenerateMipmap>();
  glBlitFramebuffer = loadFunction<GlBlitFramebufferNative>(lib, 'glBlitFramebuffer').asFunction<GlBlitFramebuffer>();
  glRenderbufferStorageMultisample = loadFunction<GlRenderbufferStorageMultisampleNative>(lib, 'glRenderbufferStorageMultisample').asFunction<GlRenderbufferStorageMultisample>();
  glFramebufferTextureLayer = loadFunction<GlFramebufferTextureLayerNative>(lib, 'glFramebufferTextureLayer').asFunction<GlFramebufferTextureLayer>();
  glMapBufferRange = loadFunction<GlMapBufferRangeNative>(lib, 'glMapBufferRange').asFunction<GlMapBufferRange>();
  glFlushMappedBufferRange = loadFunction<GlFlushMappedBufferRangeNative>(lib, 'glFlushMappedBufferRange').asFunction<GlFlushMappedBufferRange>();
  glBindVertexArray = loadFunction<GlBindVertexArrayNative>(lib, 'glBindVertexArray').asFunction<GlBindVertexArray>();
  glDeleteVertexArrays = loadFunction<GlDeleteVertexArraysNative>(lib, 'glDeleteVertexArrays').asFunction<GlDeleteVertexArrays>();
  glGenVertexArrays = loadFunction<GlGenVertexArraysNative>(lib, 'glGenVertexArrays').asFunction<GlGenVertexArrays>();
  glIsVertexArray = loadFunction<GlIsVertexArrayNative>(lib, 'glIsVertexArray').asFunction<GlIsVertexArray>();
  glDrawArraysInstanced = loadFunction<GlDrawArraysInstancedNative>(lib, 'glDrawArraysInstanced').asFunction<GlDrawArraysInstanced>();
  glDrawElementsInstanced = loadFunction<GlDrawElementsInstancedNative>(lib, 'glDrawElementsInstanced').asFunction<GlDrawElementsInstanced>();
  glTexBuffer = loadFunction<GlTexBufferNative>(lib, 'glTexBuffer').asFunction<GlTexBuffer>();
  glPrimitiveRestartIndex = loadFunction<GlPrimitiveRestartIndexNative>(lib, 'glPrimitiveRestartIndex').asFunction<GlPrimitiveRestartIndex>();
  glCopyBufferSubData = loadFunction<GlCopyBufferSubDataNative>(lib, 'glCopyBufferSubData').asFunction<GlCopyBufferSubData>();
  glGetUniformIndices = loadFunction<GlGetUniformIndicesNative>(lib, 'glGetUniformIndices').asFunction<GlGetUniformIndices>();
  glGetActiveUniformsiv = loadFunction<GlGetActiveUniformsivNative>(lib, 'glGetActiveUniformsiv').asFunction<GlGetActiveUniformsiv>();
  glGetActiveUniformName = loadFunction<GlGetActiveUniformNameNative>(lib, 'glGetActiveUniformName').asFunction<GlGetActiveUniformName>();
  glGetUniformBlockIndex = loadFunction<GlGetUniformBlockIndexNative>(lib, 'glGetUniformBlockIndex').asFunction<GlGetUniformBlockIndex>();
  glGetActiveUniformBlockiv = loadFunction<GlGetActiveUniformBlockivNative>(lib, 'glGetActiveUniformBlockiv').asFunction<GlGetActiveUniformBlockiv>();
  glGetActiveUniformBlockName = loadFunction<GlGetActiveUniformBlockNameNative>(lib, 'glGetActiveUniformBlockName').asFunction<GlGetActiveUniformBlockName>();
  glUniformBlockBinding = loadFunction<GlUniformBlockBindingNative>(lib, 'glUniformBlockBinding').asFunction<GlUniformBlockBinding>();
  glDrawElementsBaseVertex = loadFunction<GlDrawElementsBaseVertexNative>(lib, 'glDrawElementsBaseVertex').asFunction<GlDrawElementsBaseVertex>();
  glDrawRangeElementsBaseVertex = loadFunction<GlDrawRangeElementsBaseVertexNative>(lib, 'glDrawRangeElementsBaseVertex').asFunction<GlDrawRangeElementsBaseVertex>();
  glDrawElementsInstancedBaseVertex = loadFunction<GlDrawElementsInstancedBaseVertexNative>(lib, 'glDrawElementsInstancedBaseVertex').asFunction<GlDrawElementsInstancedBaseVertex>();
  glMultiDrawElementsBaseVertex = loadFunction<GlMultiDrawElementsBaseVertexNative>(lib, 'glMultiDrawElementsBaseVertex').asFunction<GlMultiDrawElementsBaseVertex>();
  glProvokingVertex = loadFunction<GlProvokingVertexNative>(lib, 'glProvokingVertex').asFunction<GlProvokingVertex>();
  glFenceSync = loadFunction<GlFenceSyncNative>(lib, 'glFenceSync').asFunction<GlFenceSync>();
  glIsSync = loadFunction<GlIsSyncNative>(lib, 'glIsSync').asFunction<GlIsSync>();
  glDeleteSync = loadFunction<GlDeleteSyncNative>(lib, 'glDeleteSync').asFunction<GlDeleteSync>();
  glClientWaitSync = loadFunction<GlClientWaitSyncNative>(lib, 'glClientWaitSync').asFunction<GlClientWaitSync>();
  glWaitSync = loadFunction<GlWaitSyncNative>(lib, 'glWaitSync').asFunction<GlWaitSync>();
  glGetInteger64v = loadFunction<GlGetInteger64vNative>(lib, 'glGetInteger64v').asFunction<GlGetInteger64v>();
  glGetSynciv = loadFunction<GlGetSyncivNative>(lib, 'glGetSynciv').asFunction<GlGetSynciv>();
  glGetInteger64i_v = loadFunction<GlGetInteger64i_vNative>(lib, 'glGetInteger64i_v').asFunction<GlGetInteger64i_v>();
  glGetBufferParameteri64v = loadFunction<GlGetBufferParameteri64vNative>(lib, 'glGetBufferParameteri64v').asFunction<GlGetBufferParameteri64v>();
  glFramebufferTexture = loadFunction<GlFramebufferTextureNative>(lib, 'glFramebufferTexture').asFunction<GlFramebufferTexture>();
  glTexImage2DMultisample = loadFunction<GlTexImage2DMultisampleNative>(lib, 'glTexImage2DMultisample').asFunction<GlTexImage2DMultisample>();
  glTexImage3DMultisample = loadFunction<GlTexImage3DMultisampleNative>(lib, 'glTexImage3DMultisample').asFunction<GlTexImage3DMultisample>();
  glGetMultisamplefv = loadFunction<GlGetMultisamplefvNative>(lib, 'glGetMultisamplefv').asFunction<GlGetMultisamplefv>();
  glSampleMaski = loadFunction<GlSampleMaskiNative>(lib, 'glSampleMaski').asFunction<GlSampleMaski>();
  glBindFragDataLocationIndexed = loadFunction<GlBindFragDataLocationIndexedNative>(lib, 'glBindFragDataLocationIndexed').asFunction<GlBindFragDataLocationIndexed>();
  glGetFragDataIndex = loadFunction<GlGetFragDataIndexNative>(lib, 'glGetFragDataIndex').asFunction<GlGetFragDataIndex>();
  glGenSamplers = loadFunction<GlGenSamplersNative>(lib, 'glGenSamplers').asFunction<GlGenSamplers>();
  glDeleteSamplers = loadFunction<GlDeleteSamplersNative>(lib, 'glDeleteSamplers').asFunction<GlDeleteSamplers>();
  glIsSampler = loadFunction<GlIsSamplerNative>(lib, 'glIsSampler').asFunction<GlIsSampler>();
  glBindSampler = loadFunction<GlBindSamplerNative>(lib, 'glBindSampler').asFunction<GlBindSampler>();
  glSamplerParameteri = loadFunction<GlSamplerParameteriNative>(lib, 'glSamplerParameteri').asFunction<GlSamplerParameteri>();
  glSamplerParameteriv = loadFunction<GlSamplerParameterivNative>(lib, 'glSamplerParameteriv').asFunction<GlSamplerParameteriv>();
  glSamplerParameterf = loadFunction<GlSamplerParameterfNative>(lib, 'glSamplerParameterf').asFunction<GlSamplerParameterf>();
  glSamplerParameterfv = loadFunction<GlSamplerParameterfvNative>(lib, 'glSamplerParameterfv').asFunction<GlSamplerParameterfv>();
  glSamplerParameterIiv = loadFunction<GlSamplerParameterIivNative>(lib, 'glSamplerParameterIiv').asFunction<GlSamplerParameterIiv>();
  glSamplerParameterIuiv = loadFunction<GlSamplerParameterIuivNative>(lib, 'glSamplerParameterIuiv').asFunction<GlSamplerParameterIuiv>();
  glGetSamplerParameteriv = loadFunction<GlGetSamplerParameterivNative>(lib, 'glGetSamplerParameteriv').asFunction<GlGetSamplerParameteriv>();
  glGetSamplerParameterIiv = loadFunction<GlGetSamplerParameterIivNative>(lib, 'glGetSamplerParameterIiv').asFunction<GlGetSamplerParameterIiv>();
  glGetSamplerParameterfv = loadFunction<GlGetSamplerParameterfvNative>(lib, 'glGetSamplerParameterfv').asFunction<GlGetSamplerParameterfv>();
  glGetSamplerParameterIuiv = loadFunction<GlGetSamplerParameterIuivNative>(lib, 'glGetSamplerParameterIuiv').asFunction<GlGetSamplerParameterIuiv>();
  glQueryCounter = loadFunction<GlQueryCounterNative>(lib, 'glQueryCounter').asFunction<GlQueryCounter>();
  glGetQueryObjecti64v = loadFunction<GlGetQueryObjecti64vNative>(lib, 'glGetQueryObjecti64v').asFunction<GlGetQueryObjecti64v>();
  glGetQueryObjectui64v = loadFunction<GlGetQueryObjectui64vNative>(lib, 'glGetQueryObjectui64v').asFunction<GlGetQueryObjectui64v>();
  glVertexAttribDivisor = loadFunction<GlVertexAttribDivisorNative>(lib, 'glVertexAttribDivisor').asFunction<GlVertexAttribDivisor>();
  glVertexAttribP1ui = loadFunction<GlVertexAttribP1uiNative>(lib, 'glVertexAttribP1ui').asFunction<GlVertexAttribP1ui>();
  glVertexAttribP1uiv = loadFunction<GlVertexAttribP1uivNative>(lib, 'glVertexAttribP1uiv').asFunction<GlVertexAttribP1uiv>();
  glVertexAttribP2ui = loadFunction<GlVertexAttribP2uiNative>(lib, 'glVertexAttribP2ui').asFunction<GlVertexAttribP2ui>();
  glVertexAttribP2uiv = loadFunction<GlVertexAttribP2uivNative>(lib, 'glVertexAttribP2uiv').asFunction<GlVertexAttribP2uiv>();
  glVertexAttribP3ui = loadFunction<GlVertexAttribP3uiNative>(lib, 'glVertexAttribP3ui').asFunction<GlVertexAttribP3ui>();
  glVertexAttribP3uiv = loadFunction<GlVertexAttribP3uivNative>(lib, 'glVertexAttribP3uiv').asFunction<GlVertexAttribP3uiv>();
  glVertexAttribP4ui = loadFunction<GlVertexAttribP4uiNative>(lib, 'glVertexAttribP4ui').asFunction<GlVertexAttribP4ui>();
  glVertexAttribP4uiv = loadFunction<GlVertexAttribP4uivNative>(lib, 'glVertexAttribP4uiv').asFunction<GlVertexAttribP4uiv>();
  glMinSampleShading = loadFunction<GlMinSampleShadingNative>(lib, 'glMinSampleShading').asFunction<GlMinSampleShading>();
  glBlendEquationi = loadFunction<GlBlendEquationiNative>(lib, 'glBlendEquationi').asFunction<GlBlendEquationi>();
  glBlendEquationSeparatei = loadFunction<GlBlendEquationSeparateiNative>(lib, 'glBlendEquationSeparatei').asFunction<GlBlendEquationSeparatei>();
  glBlendFunci = loadFunction<GlBlendFunciNative>(lib, 'glBlendFunci').asFunction<GlBlendFunci>();
  glBlendFuncSeparatei = loadFunction<GlBlendFuncSeparateiNative>(lib, 'glBlendFuncSeparatei').asFunction<GlBlendFuncSeparatei>();
  glDrawArraysIndirect = loadFunction<GlDrawArraysIndirectNative>(lib, 'glDrawArraysIndirect').asFunction<GlDrawArraysIndirect>();
  glDrawElementsIndirect = loadFunction<GlDrawElementsIndirectNative>(lib, 'glDrawElementsIndirect').asFunction<GlDrawElementsIndirect>();
  glUniform1d = loadFunction<GlUniform1dNative>(lib, 'glUniform1d').asFunction<GlUniform1d>();
  glUniform2d = loadFunction<GlUniform2dNative>(lib, 'glUniform2d').asFunction<GlUniform2d>();
  glUniform3d = loadFunction<GlUniform3dNative>(lib, 'glUniform3d').asFunction<GlUniform3d>();
  glUniform4d = loadFunction<GlUniform4dNative>(lib, 'glUniform4d').asFunction<GlUniform4d>();
  glUniform1dv = loadFunction<GlUniform1dvNative>(lib, 'glUniform1dv').asFunction<GlUniform1dv>();
  glUniform2dv = loadFunction<GlUniform2dvNative>(lib, 'glUniform2dv').asFunction<GlUniform2dv>();
  glUniform3dv = loadFunction<GlUniform3dvNative>(lib, 'glUniform3dv').asFunction<GlUniform3dv>();
  glUniform4dv = loadFunction<GlUniform4dvNative>(lib, 'glUniform4dv').asFunction<GlUniform4dv>();
  glUniformMatrix2dv = loadFunction<GlUniformMatrix2dvNative>(lib, 'glUniformMatrix2dv').asFunction<GlUniformMatrix2dv>();
  glUniformMatrix3dv = loadFunction<GlUniformMatrix3dvNative>(lib, 'glUniformMatrix3dv').asFunction<GlUniformMatrix3dv>();
  glUniformMatrix4dv = loadFunction<GlUniformMatrix4dvNative>(lib, 'glUniformMatrix4dv').asFunction<GlUniformMatrix4dv>();
  glUniformMatrix2x3dv = loadFunction<GlUniformMatrix2x3dvNative>(lib, 'glUniformMatrix2x3dv').asFunction<GlUniformMatrix2x3dv>();
  glUniformMatrix2x4dv = loadFunction<GlUniformMatrix2x4dvNative>(lib, 'glUniformMatrix2x4dv').asFunction<GlUniformMatrix2x4dv>();
  glUniformMatrix3x2dv = loadFunction<GlUniformMatrix3x2dvNative>(lib, 'glUniformMatrix3x2dv').asFunction<GlUniformMatrix3x2dv>();
  glUniformMatrix3x4dv = loadFunction<GlUniformMatrix3x4dvNative>(lib, 'glUniformMatrix3x4dv').asFunction<GlUniformMatrix3x4dv>();
  glUniformMatrix4x2dv = loadFunction<GlUniformMatrix4x2dvNative>(lib, 'glUniformMatrix4x2dv').asFunction<GlUniformMatrix4x2dv>();
  glUniformMatrix4x3dv = loadFunction<GlUniformMatrix4x3dvNative>(lib, 'glUniformMatrix4x3dv').asFunction<GlUniformMatrix4x3dv>();
  glGetUniformdv = loadFunction<GlGetUniformdvNative>(lib, 'glGetUniformdv').asFunction<GlGetUniformdv>();
  glGetSubroutineUniformLocation = loadFunction<GlGetSubroutineUniformLocationNative>(lib, 'glGetSubroutineUniformLocation').asFunction<GlGetSubroutineUniformLocation>();
  glGetSubroutineIndex = loadFunction<GlGetSubroutineIndexNative>(lib, 'glGetSubroutineIndex').asFunction<GlGetSubroutineIndex>();
  glGetActiveSubroutineUniformiv = loadFunction<GlGetActiveSubroutineUniformivNative>(lib, 'glGetActiveSubroutineUniformiv').asFunction<GlGetActiveSubroutineUniformiv>();
  glGetActiveSubroutineUniformName = loadFunction<GlGetActiveSubroutineUniformNameNative>(lib, 'glGetActiveSubroutineUniformName').asFunction<GlGetActiveSubroutineUniformName>();
  glGetActiveSubroutineName = loadFunction<GlGetActiveSubroutineNameNative>(lib, 'glGetActiveSubroutineName').asFunction<GlGetActiveSubroutineName>();
  glUniformSubroutinesuiv = loadFunction<GlUniformSubroutinesuivNative>(lib, 'glUniformSubroutinesuiv').asFunction<GlUniformSubroutinesuiv>();
  glGetUniformSubroutineuiv = loadFunction<GlGetUniformSubroutineuivNative>(lib, 'glGetUniformSubroutineuiv').asFunction<GlGetUniformSubroutineuiv>();
  glGetProgramStageiv = loadFunction<GlGetProgramStageivNative>(lib, 'glGetProgramStageiv').asFunction<GlGetProgramStageiv>();
  glPatchParameteri = loadFunction<GlPatchParameteriNative>(lib, 'glPatchParameteri').asFunction<GlPatchParameteri>();
  glPatchParameterfv = loadFunction<GlPatchParameterfvNative>(lib, 'glPatchParameterfv').asFunction<GlPatchParameterfv>();
  glBindTransformFeedback = loadFunction<GlBindTransformFeedbackNative>(lib, 'glBindTransformFeedback').asFunction<GlBindTransformFeedback>();
  glDeleteTransformFeedbacks = loadFunction<GlDeleteTransformFeedbacksNative>(lib, 'glDeleteTransformFeedbacks').asFunction<GlDeleteTransformFeedbacks>();
  glGenTransformFeedbacks = loadFunction<GlGenTransformFeedbacksNative>(lib, 'glGenTransformFeedbacks').asFunction<GlGenTransformFeedbacks>();
  glIsTransformFeedback = loadFunction<GlIsTransformFeedbackNative>(lib, 'glIsTransformFeedback').asFunction<GlIsTransformFeedback>();
  glPauseTransformFeedback = loadFunction<GlPauseTransformFeedbackNative>(lib, 'glPauseTransformFeedback').asFunction<GlPauseTransformFeedback>();
  glResumeTransformFeedback = loadFunction<GlResumeTransformFeedbackNative>(lib, 'glResumeTransformFeedback').asFunction<GlResumeTransformFeedback>();
  glDrawTransformFeedback = loadFunction<GlDrawTransformFeedbackNative>(lib, 'glDrawTransformFeedback').asFunction<GlDrawTransformFeedback>();
  glDrawTransformFeedbackStream = loadFunction<GlDrawTransformFeedbackStreamNative>(lib, 'glDrawTransformFeedbackStream').asFunction<GlDrawTransformFeedbackStream>();
  glBeginQueryIndexed = loadFunction<GlBeginQueryIndexedNative>(lib, 'glBeginQueryIndexed').asFunction<GlBeginQueryIndexed>();
  glEndQueryIndexed = loadFunction<GlEndQueryIndexedNative>(lib, 'glEndQueryIndexed').asFunction<GlEndQueryIndexed>();
  glGetQueryIndexediv = loadFunction<GlGetQueryIndexedivNative>(lib, 'glGetQueryIndexediv').asFunction<GlGetQueryIndexediv>();
  glReleaseShaderCompiler = loadFunction<GlReleaseShaderCompilerNative>(lib, 'glReleaseShaderCompiler').asFunction<GlReleaseShaderCompiler>();
  glShaderBinary = loadFunction<GlShaderBinaryNative>(lib, 'glShaderBinary').asFunction<GlShaderBinary>();
  glGetShaderPrecisionFormat = loadFunction<GlGetShaderPrecisionFormatNative>(lib, 'glGetShaderPrecisionFormat').asFunction<GlGetShaderPrecisionFormat>();
  glDepthRangef = loadFunction<GlDepthRangefNative>(lib, 'glDepthRangef').asFunction<GlDepthRangef>();
  glClearDepthf = loadFunction<GlClearDepthfNative>(lib, 'glClearDepthf').asFunction<GlClearDepthf>();
  glGetProgramBinary = loadFunction<GlGetProgramBinaryNative>(lib, 'glGetProgramBinary').asFunction<GlGetProgramBinary>();
  glProgramBinary = loadFunction<GlProgramBinaryNative>(lib, 'glProgramBinary').asFunction<GlProgramBinary>();
  glProgramParameteri = loadFunction<GlProgramParameteriNative>(lib, 'glProgramParameteri').asFunction<GlProgramParameteri>();
  glUseProgramStages = loadFunction<GlUseProgramStagesNative>(lib, 'glUseProgramStages').asFunction<GlUseProgramStages>();
  glActiveShaderProgram = loadFunction<GlActiveShaderProgramNative>(lib, 'glActiveShaderProgram').asFunction<GlActiveShaderProgram>();
  glCreateShaderProgramv = loadFunction<GlCreateShaderProgramvNative>(lib, 'glCreateShaderProgramv').asFunction<GlCreateShaderProgramv>();
  glBindProgramPipeline = loadFunction<GlBindProgramPipelineNative>(lib, 'glBindProgramPipeline').asFunction<GlBindProgramPipeline>();
  glDeleteProgramPipelines = loadFunction<GlDeleteProgramPipelinesNative>(lib, 'glDeleteProgramPipelines').asFunction<GlDeleteProgramPipelines>();
  glGenProgramPipelines = loadFunction<GlGenProgramPipelinesNative>(lib, 'glGenProgramPipelines').asFunction<GlGenProgramPipelines>();
  glIsProgramPipeline = loadFunction<GlIsProgramPipelineNative>(lib, 'glIsProgramPipeline').asFunction<GlIsProgramPipeline>();
  glGetProgramPipelineiv = loadFunction<GlGetProgramPipelineivNative>(lib, 'glGetProgramPipelineiv').asFunction<GlGetProgramPipelineiv>();
  glProgramUniform1i = loadFunction<GlProgramUniform1iNative>(lib, 'glProgramUniform1i').asFunction<GlProgramUniform1i>();
  glProgramUniform1iv = loadFunction<GlProgramUniform1ivNative>(lib, 'glProgramUniform1iv').asFunction<GlProgramUniform1iv>();
  glProgramUniform1f = loadFunction<GlProgramUniform1fNative>(lib, 'glProgramUniform1f').asFunction<GlProgramUniform1f>();
  glProgramUniform1fv = loadFunction<GlProgramUniform1fvNative>(lib, 'glProgramUniform1fv').asFunction<GlProgramUniform1fv>();
  glProgramUniform1d = loadFunction<GlProgramUniform1dNative>(lib, 'glProgramUniform1d').asFunction<GlProgramUniform1d>();
  glProgramUniform1dv = loadFunction<GlProgramUniform1dvNative>(lib, 'glProgramUniform1dv').asFunction<GlProgramUniform1dv>();
  glProgramUniform1ui = loadFunction<GlProgramUniform1uiNative>(lib, 'glProgramUniform1ui').asFunction<GlProgramUniform1ui>();
  glProgramUniform1uiv = loadFunction<GlProgramUniform1uivNative>(lib, 'glProgramUniform1uiv').asFunction<GlProgramUniform1uiv>();
  glProgramUniform2i = loadFunction<GlProgramUniform2iNative>(lib, 'glProgramUniform2i').asFunction<GlProgramUniform2i>();
  glProgramUniform2iv = loadFunction<GlProgramUniform2ivNative>(lib, 'glProgramUniform2iv').asFunction<GlProgramUniform2iv>();
  glProgramUniform2f = loadFunction<GlProgramUniform2fNative>(lib, 'glProgramUniform2f').asFunction<GlProgramUniform2f>();
  glProgramUniform2fv = loadFunction<GlProgramUniform2fvNative>(lib, 'glProgramUniform2fv').asFunction<GlProgramUniform2fv>();
  glProgramUniform2d = loadFunction<GlProgramUniform2dNative>(lib, 'glProgramUniform2d').asFunction<GlProgramUniform2d>();
  glProgramUniform2dv = loadFunction<GlProgramUniform2dvNative>(lib, 'glProgramUniform2dv').asFunction<GlProgramUniform2dv>();
  glProgramUniform2ui = loadFunction<GlProgramUniform2uiNative>(lib, 'glProgramUniform2ui').asFunction<GlProgramUniform2ui>();
  glProgramUniform2uiv = loadFunction<GlProgramUniform2uivNative>(lib, 'glProgramUniform2uiv').asFunction<GlProgramUniform2uiv>();
  glProgramUniform3i = loadFunction<GlProgramUniform3iNative>(lib, 'glProgramUniform3i').asFunction<GlProgramUniform3i>();
  glProgramUniform3iv = loadFunction<GlProgramUniform3ivNative>(lib, 'glProgramUniform3iv').asFunction<GlProgramUniform3iv>();
  glProgramUniform3f = loadFunction<GlProgramUniform3fNative>(lib, 'glProgramUniform3f').asFunction<GlProgramUniform3f>();
  glProgramUniform3fv = loadFunction<GlProgramUniform3fvNative>(lib, 'glProgramUniform3fv').asFunction<GlProgramUniform3fv>();
  glProgramUniform3d = loadFunction<GlProgramUniform3dNative>(lib, 'glProgramUniform3d').asFunction<GlProgramUniform3d>();
  glProgramUniform3dv = loadFunction<GlProgramUniform3dvNative>(lib, 'glProgramUniform3dv').asFunction<GlProgramUniform3dv>();
  glProgramUniform3ui = loadFunction<GlProgramUniform3uiNative>(lib, 'glProgramUniform3ui').asFunction<GlProgramUniform3ui>();
  glProgramUniform3uiv = loadFunction<GlProgramUniform3uivNative>(lib, 'glProgramUniform3uiv').asFunction<GlProgramUniform3uiv>();
  glProgramUniform4i = loadFunction<GlProgramUniform4iNative>(lib, 'glProgramUniform4i').asFunction<GlProgramUniform4i>();
  glProgramUniform4iv = loadFunction<GlProgramUniform4ivNative>(lib, 'glProgramUniform4iv').asFunction<GlProgramUniform4iv>();
  glProgramUniform4f = loadFunction<GlProgramUniform4fNative>(lib, 'glProgramUniform4f').asFunction<GlProgramUniform4f>();
  glProgramUniform4fv = loadFunction<GlProgramUniform4fvNative>(lib, 'glProgramUniform4fv').asFunction<GlProgramUniform4fv>();
  glProgramUniform4d = loadFunction<GlProgramUniform4dNative>(lib, 'glProgramUniform4d').asFunction<GlProgramUniform4d>();
  glProgramUniform4dv = loadFunction<GlProgramUniform4dvNative>(lib, 'glProgramUniform4dv').asFunction<GlProgramUniform4dv>();
  glProgramUniform4ui = loadFunction<GlProgramUniform4uiNative>(lib, 'glProgramUniform4ui').asFunction<GlProgramUniform4ui>();
  glProgramUniform4uiv = loadFunction<GlProgramUniform4uivNative>(lib, 'glProgramUniform4uiv').asFunction<GlProgramUniform4uiv>();
  glProgramUniformMatrix2fv = loadFunction<GlProgramUniformMatrix2fvNative>(lib, 'glProgramUniformMatrix2fv').asFunction<GlProgramUniformMatrix2fv>();
  glProgramUniformMatrix3fv = loadFunction<GlProgramUniformMatrix3fvNative>(lib, 'glProgramUniformMatrix3fv').asFunction<GlProgramUniformMatrix3fv>();
  glProgramUniformMatrix4fv = loadFunction<GlProgramUniformMatrix4fvNative>(lib, 'glProgramUniformMatrix4fv').asFunction<GlProgramUniformMatrix4fv>();
  glProgramUniformMatrix2dv = loadFunction<GlProgramUniformMatrix2dvNative>(lib, 'glProgramUniformMatrix2dv').asFunction<GlProgramUniformMatrix2dv>();
  glProgramUniformMatrix3dv = loadFunction<GlProgramUniformMatrix3dvNative>(lib, 'glProgramUniformMatrix3dv').asFunction<GlProgramUniformMatrix3dv>();
  glProgramUniformMatrix4dv = loadFunction<GlProgramUniformMatrix4dvNative>(lib, 'glProgramUniformMatrix4dv').asFunction<GlProgramUniformMatrix4dv>();
  glProgramUniformMatrix2x3fv = loadFunction<GlProgramUniformMatrix2x3fvNative>(lib, 'glProgramUniformMatrix2x3fv').asFunction<GlProgramUniformMatrix2x3fv>();
  glProgramUniformMatrix3x2fv = loadFunction<GlProgramUniformMatrix3x2fvNative>(lib, 'glProgramUniformMatrix3x2fv').asFunction<GlProgramUniformMatrix3x2fv>();
  glProgramUniformMatrix2x4fv = loadFunction<GlProgramUniformMatrix2x4fvNative>(lib, 'glProgramUniformMatrix2x4fv').asFunction<GlProgramUniformMatrix2x4fv>();
  glProgramUniformMatrix4x2fv = loadFunction<GlProgramUniformMatrix4x2fvNative>(lib, 'glProgramUniformMatrix4x2fv').asFunction<GlProgramUniformMatrix4x2fv>();
  glProgramUniformMatrix3x4fv = loadFunction<GlProgramUniformMatrix3x4fvNative>(lib, 'glProgramUniformMatrix3x4fv').asFunction<GlProgramUniformMatrix3x4fv>();
  glProgramUniformMatrix4x3fv = loadFunction<GlProgramUniformMatrix4x3fvNative>(lib, 'glProgramUniformMatrix4x3fv').asFunction<GlProgramUniformMatrix4x3fv>();
  glProgramUniformMatrix2x3dv = loadFunction<GlProgramUniformMatrix2x3dvNative>(lib, 'glProgramUniformMatrix2x3dv').asFunction<GlProgramUniformMatrix2x3dv>();
  glProgramUniformMatrix3x2dv = loadFunction<GlProgramUniformMatrix3x2dvNative>(lib, 'glProgramUniformMatrix3x2dv').asFunction<GlProgramUniformMatrix3x2dv>();
  glProgramUniformMatrix2x4dv = loadFunction<GlProgramUniformMatrix2x4dvNative>(lib, 'glProgramUniformMatrix2x4dv').asFunction<GlProgramUniformMatrix2x4dv>();
  glProgramUniformMatrix4x2dv = loadFunction<GlProgramUniformMatrix4x2dvNative>(lib, 'glProgramUniformMatrix4x2dv').asFunction<GlProgramUniformMatrix4x2dv>();
  glProgramUniformMatrix3x4dv = loadFunction<GlProgramUniformMatrix3x4dvNative>(lib, 'glProgramUniformMatrix3x4dv').asFunction<GlProgramUniformMatrix3x4dv>();
  glProgramUniformMatrix4x3dv = loadFunction<GlProgramUniformMatrix4x3dvNative>(lib, 'glProgramUniformMatrix4x3dv').asFunction<GlProgramUniformMatrix4x3dv>();
  glValidateProgramPipeline = loadFunction<GlValidateProgramPipelineNative>(lib, 'glValidateProgramPipeline').asFunction<GlValidateProgramPipeline>();
  glGetProgramPipelineInfoLog = loadFunction<GlGetProgramPipelineInfoLogNative>(lib, 'glGetProgramPipelineInfoLog').asFunction<GlGetProgramPipelineInfoLog>();
  glVertexAttribL1d = loadFunction<GlVertexAttribL1dNative>(lib, 'glVertexAttribL1d').asFunction<GlVertexAttribL1d>();
  glVertexAttribL2d = loadFunction<GlVertexAttribL2dNative>(lib, 'glVertexAttribL2d').asFunction<GlVertexAttribL2d>();
  glVertexAttribL3d = loadFunction<GlVertexAttribL3dNative>(lib, 'glVertexAttribL3d').asFunction<GlVertexAttribL3d>();
  glVertexAttribL4d = loadFunction<GlVertexAttribL4dNative>(lib, 'glVertexAttribL4d').asFunction<GlVertexAttribL4d>();
  glVertexAttribL1dv = loadFunction<GlVertexAttribL1dvNative>(lib, 'glVertexAttribL1dv').asFunction<GlVertexAttribL1dv>();
  glVertexAttribL2dv = loadFunction<GlVertexAttribL2dvNative>(lib, 'glVertexAttribL2dv').asFunction<GlVertexAttribL2dv>();
  glVertexAttribL3dv = loadFunction<GlVertexAttribL3dvNative>(lib, 'glVertexAttribL3dv').asFunction<GlVertexAttribL3dv>();
  glVertexAttribL4dv = loadFunction<GlVertexAttribL4dvNative>(lib, 'glVertexAttribL4dv').asFunction<GlVertexAttribL4dv>();
  glVertexAttribLPointer = loadFunction<GlVertexAttribLPointerNative>(lib, 'glVertexAttribLPointer').asFunction<GlVertexAttribLPointer>();
  glGetVertexAttribLdv = loadFunction<GlGetVertexAttribLdvNative>(lib, 'glGetVertexAttribLdv').asFunction<GlGetVertexAttribLdv>();
  glViewportArrayv = loadFunction<GlViewportArrayvNative>(lib, 'glViewportArrayv').asFunction<GlViewportArrayv>();
  glViewportIndexedf = loadFunction<GlViewportIndexedfNative>(lib, 'glViewportIndexedf').asFunction<GlViewportIndexedf>();
  glViewportIndexedfv = loadFunction<GlViewportIndexedfvNative>(lib, 'glViewportIndexedfv').asFunction<GlViewportIndexedfv>();
  glScissorArrayv = loadFunction<GlScissorArrayvNative>(lib, 'glScissorArrayv').asFunction<GlScissorArrayv>();
  glScissorIndexed = loadFunction<GlScissorIndexedNative>(lib, 'glScissorIndexed').asFunction<GlScissorIndexed>();
  glScissorIndexedv = loadFunction<GlScissorIndexedvNative>(lib, 'glScissorIndexedv').asFunction<GlScissorIndexedv>();
  glDepthRangeArrayv = loadFunction<GlDepthRangeArrayvNative>(lib, 'glDepthRangeArrayv').asFunction<GlDepthRangeArrayv>();
  glDepthRangeIndexed = loadFunction<GlDepthRangeIndexedNative>(lib, 'glDepthRangeIndexed').asFunction<GlDepthRangeIndexed>();
  glGetFloati_v = loadFunction<GlGetFloati_vNative>(lib, 'glGetFloati_v').asFunction<GlGetFloati_v>();
  glGetDoublei_v = loadFunction<GlGetDoublei_vNative>(lib, 'glGetDoublei_v').asFunction<GlGetDoublei_v>();
  glDrawArraysInstancedBaseInstance = loadFunction<GlDrawArraysInstancedBaseInstanceNative>(lib, 'glDrawArraysInstancedBaseInstance').asFunction<GlDrawArraysInstancedBaseInstance>();
  glDrawElementsInstancedBaseInstance = loadFunction<GlDrawElementsInstancedBaseInstanceNative>(lib, 'glDrawElementsInstancedBaseInstance').asFunction<GlDrawElementsInstancedBaseInstance>();
  glDrawElementsInstancedBaseVertexBaseInstance = loadFunction<GlDrawElementsInstancedBaseVertexBaseInstanceNative>(lib, 'glDrawElementsInstancedBaseVertexBaseInstance').asFunction<GlDrawElementsInstancedBaseVertexBaseInstance>();
  glGetInternalformativ = loadFunction<GlGetInternalformativNative>(lib, 'glGetInternalformativ').asFunction<GlGetInternalformativ>();
  glGetActiveAtomicCounterBufferiv = loadFunction<GlGetActiveAtomicCounterBufferivNative>(lib, 'glGetActiveAtomicCounterBufferiv').asFunction<GlGetActiveAtomicCounterBufferiv>();
  glBindImageTexture = loadFunction<GlBindImageTextureNative>(lib, 'glBindImageTexture').asFunction<GlBindImageTexture>();
  glMemoryBarrier = loadFunction<GlMemoryBarrierNative>(lib, 'glMemoryBarrier').asFunction<GlMemoryBarrier>();
  glTexStorage1D = loadFunction<GlTexStorage1DNative>(lib, 'glTexStorage1D').asFunction<GlTexStorage1D>();
  glTexStorage2D = loadFunction<GlTexStorage2DNative>(lib, 'glTexStorage2D').asFunction<GlTexStorage2D>();
  glTexStorage3D = loadFunction<GlTexStorage3DNative>(lib, 'glTexStorage3D').asFunction<GlTexStorage3D>();
  glDrawTransformFeedbackInstanced = loadFunction<GlDrawTransformFeedbackInstancedNative>(lib, 'glDrawTransformFeedbackInstanced').asFunction<GlDrawTransformFeedbackInstanced>();
  glDrawTransformFeedbackStreamInstanced = loadFunction<GlDrawTransformFeedbackStreamInstancedNative>(lib, 'glDrawTransformFeedbackStreamInstanced').asFunction<GlDrawTransformFeedbackStreamInstanced>();
  glClearBufferData = loadFunction<GlClearBufferDataNative>(lib, 'glClearBufferData').asFunction<GlClearBufferData>();
  glClearBufferSubData = loadFunction<GlClearBufferSubDataNative>(lib, 'glClearBufferSubData').asFunction<GlClearBufferSubData>();
  glDispatchCompute = loadFunction<GlDispatchComputeNative>(lib, 'glDispatchCompute').asFunction<GlDispatchCompute>();
  glDispatchComputeIndirect = loadFunction<GlDispatchComputeIndirectNative>(lib, 'glDispatchComputeIndirect').asFunction<GlDispatchComputeIndirect>();
  glCopyImageSubData = loadFunction<GlCopyImageSubDataNative>(lib, 'glCopyImageSubData').asFunction<GlCopyImageSubData>();
  glFramebufferParameteri = loadFunction<GlFramebufferParameteriNative>(lib, 'glFramebufferParameteri').asFunction<GlFramebufferParameteri>();
  glGetFramebufferParameteriv = loadFunction<GlGetFramebufferParameterivNative>(lib, 'glGetFramebufferParameteriv').asFunction<GlGetFramebufferParameteriv>();
  glGetInternalformati64v = loadFunction<GlGetInternalformati64vNative>(lib, 'glGetInternalformati64v').asFunction<GlGetInternalformati64v>();
  glInvalidateTexSubImage = loadFunction<GlInvalidateTexSubImageNative>(lib, 'glInvalidateTexSubImage').asFunction<GlInvalidateTexSubImage>();
  glInvalidateTexImage = loadFunction<GlInvalidateTexImageNative>(lib, 'glInvalidateTexImage').asFunction<GlInvalidateTexImage>();
  glInvalidateBufferSubData = loadFunction<GlInvalidateBufferSubDataNative>(lib, 'glInvalidateBufferSubData').asFunction<GlInvalidateBufferSubData>();
  glInvalidateBufferData = loadFunction<GlInvalidateBufferDataNative>(lib, 'glInvalidateBufferData').asFunction<GlInvalidateBufferData>();
  glInvalidateFramebuffer = loadFunction<GlInvalidateFramebufferNative>(lib, 'glInvalidateFramebuffer').asFunction<GlInvalidateFramebuffer>();
  glInvalidateSubFramebuffer = loadFunction<GlInvalidateSubFramebufferNative>(lib, 'glInvalidateSubFramebuffer').asFunction<GlInvalidateSubFramebuffer>();
  glMultiDrawArraysIndirect = loadFunction<GlMultiDrawArraysIndirectNative>(lib, 'glMultiDrawArraysIndirect').asFunction<GlMultiDrawArraysIndirect>();
  glMultiDrawElementsIndirect = loadFunction<GlMultiDrawElementsIndirectNative>(lib, 'glMultiDrawElementsIndirect').asFunction<GlMultiDrawElementsIndirect>();
  glGetProgramInterfaceiv = loadFunction<GlGetProgramInterfaceivNative>(lib, 'glGetProgramInterfaceiv').asFunction<GlGetProgramInterfaceiv>();
  glGetProgramResourceIndex = loadFunction<GlGetProgramResourceIndexNative>(lib, 'glGetProgramResourceIndex').asFunction<GlGetProgramResourceIndex>();
  glGetProgramResourceName = loadFunction<GlGetProgramResourceNameNative>(lib, 'glGetProgramResourceName').asFunction<GlGetProgramResourceName>();
  glGetProgramResourceiv = loadFunction<GlGetProgramResourceivNative>(lib, 'glGetProgramResourceiv').asFunction<GlGetProgramResourceiv>();
  glGetProgramResourceLocation = loadFunction<GlGetProgramResourceLocationNative>(lib, 'glGetProgramResourceLocation').asFunction<GlGetProgramResourceLocation>();
  glGetProgramResourceLocationIndex = loadFunction<GlGetProgramResourceLocationIndexNative>(lib, 'glGetProgramResourceLocationIndex').asFunction<GlGetProgramResourceLocationIndex>();
  glShaderStorageBlockBinding = loadFunction<GlShaderStorageBlockBindingNative>(lib, 'glShaderStorageBlockBinding').asFunction<GlShaderStorageBlockBinding>();
  glTexBufferRange = loadFunction<GlTexBufferRangeNative>(lib, 'glTexBufferRange').asFunction<GlTexBufferRange>();
  glTexStorage2DMultisample = loadFunction<GlTexStorage2DMultisampleNative>(lib, 'glTexStorage2DMultisample').asFunction<GlTexStorage2DMultisample>();
  glTexStorage3DMultisample = loadFunction<GlTexStorage3DMultisampleNative>(lib, 'glTexStorage3DMultisample').asFunction<GlTexStorage3DMultisample>();
  glTextureView = loadFunction<GlTextureViewNative>(lib, 'glTextureView').asFunction<GlTextureView>();
  glBindVertexBuffer = loadFunction<GlBindVertexBufferNative>(lib, 'glBindVertexBuffer').asFunction<GlBindVertexBuffer>();
  glVertexAttribFormat = loadFunction<GlVertexAttribFormatNative>(lib, 'glVertexAttribFormat').asFunction<GlVertexAttribFormat>();
  glVertexAttribIFormat = loadFunction<GlVertexAttribIFormatNative>(lib, 'glVertexAttribIFormat').asFunction<GlVertexAttribIFormat>();
  glVertexAttribLFormat = loadFunction<GlVertexAttribLFormatNative>(lib, 'glVertexAttribLFormat').asFunction<GlVertexAttribLFormat>();
  glVertexAttribBinding = loadFunction<GlVertexAttribBindingNative>(lib, 'glVertexAttribBinding').asFunction<GlVertexAttribBinding>();
  glVertexBindingDivisor = loadFunction<GlVertexBindingDivisorNative>(lib, 'glVertexBindingDivisor').asFunction<GlVertexBindingDivisor>();
  glDebugMessageControl = loadFunction<GlDebugMessageControlNative>(lib, 'glDebugMessageControl').asFunction<GlDebugMessageControl>();
  glDebugMessageInsert = loadFunction<GlDebugMessageInsertNative>(lib, 'glDebugMessageInsert').asFunction<GlDebugMessageInsert>();
  glDebugMessageCallback = loadFunction<GlDebugMessageCallbackNative>(lib, 'glDebugMessageCallback').asFunction<GlDebugMessageCallback>();
  glGetDebugMessageLog = loadFunction<GlGetDebugMessageLogNative>(lib, 'glGetDebugMessageLog').asFunction<GlGetDebugMessageLog>();
  glPushDebugGroup = loadFunction<GlPushDebugGroupNative>(lib, 'glPushDebugGroup').asFunction<GlPushDebugGroup>();
  glPopDebugGroup = loadFunction<GlPopDebugGroupNative>(lib, 'glPopDebugGroup').asFunction<GlPopDebugGroup>();
  glObjectLabel = loadFunction<GlObjectLabelNative>(lib, 'glObjectLabel').asFunction<GlObjectLabel>();
  glGetObjectLabel = loadFunction<GlGetObjectLabelNative>(lib, 'glGetObjectLabel').asFunction<GlGetObjectLabel>();
  glObjectPtrLabel = loadFunction<GlObjectPtrLabelNative>(lib, 'glObjectPtrLabel').asFunction<GlObjectPtrLabel>();
  glGetObjectPtrLabel = loadFunction<GlGetObjectPtrLabelNative>(lib, 'glGetObjectPtrLabel').asFunction<GlGetObjectPtrLabel>();
  glBufferStorage = loadFunction<GlBufferStorageNative>(lib, 'glBufferStorage').asFunction<GlBufferStorage>();
  glClearTexImage = loadFunction<GlClearTexImageNative>(lib, 'glClearTexImage').asFunction<GlClearTexImage>();
  glClearTexSubImage = loadFunction<GlClearTexSubImageNative>(lib, 'glClearTexSubImage').asFunction<GlClearTexSubImage>();
  glBindBuffersBase = loadFunction<GlBindBuffersBaseNative>(lib, 'glBindBuffersBase').asFunction<GlBindBuffersBase>();
  glBindBuffersRange = loadFunction<GlBindBuffersRangeNative>(lib, 'glBindBuffersRange').asFunction<GlBindBuffersRange>();
  glBindTextures = loadFunction<GlBindTexturesNative>(lib, 'glBindTextures').asFunction<GlBindTextures>();
  glBindSamplers = loadFunction<GlBindSamplersNative>(lib, 'glBindSamplers').asFunction<GlBindSamplers>();
  glBindImageTextures = loadFunction<GlBindImageTexturesNative>(lib, 'glBindImageTextures').asFunction<GlBindImageTextures>();
  glBindVertexBuffers = loadFunction<GlBindVertexBuffersNative>(lib, 'glBindVertexBuffers').asFunction<GlBindVertexBuffers>();
  glClipControl = loadFunction<GlClipControlNative>(lib, 'glClipControl').asFunction<GlClipControl>();
  glCreateTransformFeedbacks = loadFunction<GlCreateTransformFeedbacksNative>(lib, 'glCreateTransformFeedbacks').asFunction<GlCreateTransformFeedbacks>();
  glTransformFeedbackBufferBase = loadFunction<GlTransformFeedbackBufferBaseNative>(lib, 'glTransformFeedbackBufferBase').asFunction<GlTransformFeedbackBufferBase>();
  glTransformFeedbackBufferRange = loadFunction<GlTransformFeedbackBufferRangeNative>(lib, 'glTransformFeedbackBufferRange').asFunction<GlTransformFeedbackBufferRange>();
  glGetTransformFeedbackiv = loadFunction<GlGetTransformFeedbackivNative>(lib, 'glGetTransformFeedbackiv').asFunction<GlGetTransformFeedbackiv>();
  glGetTransformFeedbacki_v = loadFunction<GlGetTransformFeedbacki_vNative>(lib, 'glGetTransformFeedbacki_v').asFunction<GlGetTransformFeedbacki_v>();
  glGetTransformFeedbacki64_v = loadFunction<GlGetTransformFeedbacki64_vNative>(lib, 'glGetTransformFeedbacki64_v').asFunction<GlGetTransformFeedbacki64_v>();
  glCreateBuffers = loadFunction<GlCreateBuffersNative>(lib, 'glCreateBuffers').asFunction<GlCreateBuffers>();
  glNamedBufferStorage = loadFunction<GlNamedBufferStorageNative>(lib, 'glNamedBufferStorage').asFunction<GlNamedBufferStorage>();
  glNamedBufferData = loadFunction<GlNamedBufferDataNative>(lib, 'glNamedBufferData').asFunction<GlNamedBufferData>();
  glNamedBufferSubData = loadFunction<GlNamedBufferSubDataNative>(lib, 'glNamedBufferSubData').asFunction<GlNamedBufferSubData>();
  glCopyNamedBufferSubData = loadFunction<GlCopyNamedBufferSubDataNative>(lib, 'glCopyNamedBufferSubData').asFunction<GlCopyNamedBufferSubData>();
  glClearNamedBufferData = loadFunction<GlClearNamedBufferDataNative>(lib, 'glClearNamedBufferData').asFunction<GlClearNamedBufferData>();
  glClearNamedBufferSubData = loadFunction<GlClearNamedBufferSubDataNative>(lib, 'glClearNamedBufferSubData').asFunction<GlClearNamedBufferSubData>();
  glMapNamedBuffer = loadFunction<GlMapNamedBufferNative>(lib, 'glMapNamedBuffer').asFunction<GlMapNamedBuffer>();
  glMapNamedBufferRange = loadFunction<GlMapNamedBufferRangeNative>(lib, 'glMapNamedBufferRange').asFunction<GlMapNamedBufferRange>();
  glUnmapNamedBuffer = loadFunction<GlUnmapNamedBufferNative>(lib, 'glUnmapNamedBuffer').asFunction<GlUnmapNamedBuffer>();
  glFlushMappedNamedBufferRange = loadFunction<GlFlushMappedNamedBufferRangeNative>(lib, 'glFlushMappedNamedBufferRange').asFunction<GlFlushMappedNamedBufferRange>();
  glGetNamedBufferParameteriv = loadFunction<GlGetNamedBufferParameterivNative>(lib, 'glGetNamedBufferParameteriv').asFunction<GlGetNamedBufferParameteriv>();
  glGetNamedBufferParameteri64v = loadFunction<GlGetNamedBufferParameteri64vNative>(lib, 'glGetNamedBufferParameteri64v').asFunction<GlGetNamedBufferParameteri64v>();
  glGetNamedBufferPointerv = loadFunction<GlGetNamedBufferPointervNative>(lib, 'glGetNamedBufferPointerv').asFunction<GlGetNamedBufferPointerv>();
  glGetNamedBufferSubData = loadFunction<GlGetNamedBufferSubDataNative>(lib, 'glGetNamedBufferSubData').asFunction<GlGetNamedBufferSubData>();
  glCreateFramebuffers = loadFunction<GlCreateFramebuffersNative>(lib, 'glCreateFramebuffers').asFunction<GlCreateFramebuffers>();
  glNamedFramebufferRenderbuffer = loadFunction<GlNamedFramebufferRenderbufferNative>(lib, 'glNamedFramebufferRenderbuffer').asFunction<GlNamedFramebufferRenderbuffer>();
  glNamedFramebufferParameteri = loadFunction<GlNamedFramebufferParameteriNative>(lib, 'glNamedFramebufferParameteri').asFunction<GlNamedFramebufferParameteri>();
  glNamedFramebufferTexture = loadFunction<GlNamedFramebufferTextureNative>(lib, 'glNamedFramebufferTexture').asFunction<GlNamedFramebufferTexture>();
  glNamedFramebufferTextureLayer = loadFunction<GlNamedFramebufferTextureLayerNative>(lib, 'glNamedFramebufferTextureLayer').asFunction<GlNamedFramebufferTextureLayer>();
  glNamedFramebufferDrawBuffer = loadFunction<GlNamedFramebufferDrawBufferNative>(lib, 'glNamedFramebufferDrawBuffer').asFunction<GlNamedFramebufferDrawBuffer>();
  glNamedFramebufferDrawBuffers = loadFunction<GlNamedFramebufferDrawBuffersNative>(lib, 'glNamedFramebufferDrawBuffers').asFunction<GlNamedFramebufferDrawBuffers>();
  glNamedFramebufferReadBuffer = loadFunction<GlNamedFramebufferReadBufferNative>(lib, 'glNamedFramebufferReadBuffer').asFunction<GlNamedFramebufferReadBuffer>();
  glInvalidateNamedFramebufferData = loadFunction<GlInvalidateNamedFramebufferDataNative>(lib, 'glInvalidateNamedFramebufferData').asFunction<GlInvalidateNamedFramebufferData>();
  glInvalidateNamedFramebufferSubData = loadFunction<GlInvalidateNamedFramebufferSubDataNative>(lib, 'glInvalidateNamedFramebufferSubData').asFunction<GlInvalidateNamedFramebufferSubData>();
  glClearNamedFramebufferiv = loadFunction<GlClearNamedFramebufferivNative>(lib, 'glClearNamedFramebufferiv').asFunction<GlClearNamedFramebufferiv>();
  glClearNamedFramebufferuiv = loadFunction<GlClearNamedFramebufferuivNative>(lib, 'glClearNamedFramebufferuiv').asFunction<GlClearNamedFramebufferuiv>();
  glClearNamedFramebufferfv = loadFunction<GlClearNamedFramebufferfvNative>(lib, 'glClearNamedFramebufferfv').asFunction<GlClearNamedFramebufferfv>();
  glClearNamedFramebufferfi = loadFunction<GlClearNamedFramebufferfiNative>(lib, 'glClearNamedFramebufferfi').asFunction<GlClearNamedFramebufferfi>();
  glBlitNamedFramebuffer = loadFunction<GlBlitNamedFramebufferNative>(lib, 'glBlitNamedFramebuffer').asFunction<GlBlitNamedFramebuffer>();
  glCheckNamedFramebufferStatus = loadFunction<GlCheckNamedFramebufferStatusNative>(lib, 'glCheckNamedFramebufferStatus').asFunction<GlCheckNamedFramebufferStatus>();
  glGetNamedFramebufferParameteriv = loadFunction<GlGetNamedFramebufferParameterivNative>(lib, 'glGetNamedFramebufferParameteriv').asFunction<GlGetNamedFramebufferParameteriv>();
  glGetNamedFramebufferAttachmentParameteriv = loadFunction<GlGetNamedFramebufferAttachmentParameterivNative>(lib, 'glGetNamedFramebufferAttachmentParameteriv').asFunction<GlGetNamedFramebufferAttachmentParameteriv>();
  glCreateRenderbuffers = loadFunction<GlCreateRenderbuffersNative>(lib, 'glCreateRenderbuffers').asFunction<GlCreateRenderbuffers>();
  glNamedRenderbufferStorage = loadFunction<GlNamedRenderbufferStorageNative>(lib, 'glNamedRenderbufferStorage').asFunction<GlNamedRenderbufferStorage>();
  glNamedRenderbufferStorageMultisample = loadFunction<GlNamedRenderbufferStorageMultisampleNative>(lib, 'glNamedRenderbufferStorageMultisample').asFunction<GlNamedRenderbufferStorageMultisample>();
  glGetNamedRenderbufferParameteriv = loadFunction<GlGetNamedRenderbufferParameterivNative>(lib, 'glGetNamedRenderbufferParameteriv').asFunction<GlGetNamedRenderbufferParameteriv>();
  glCreateTextures = loadFunction<GlCreateTexturesNative>(lib, 'glCreateTextures').asFunction<GlCreateTextures>();
  glTextureBuffer = loadFunction<GlTextureBufferNative>(lib, 'glTextureBuffer').asFunction<GlTextureBuffer>();
  glTextureBufferRange = loadFunction<GlTextureBufferRangeNative>(lib, 'glTextureBufferRange').asFunction<GlTextureBufferRange>();
  glTextureStorage1D = loadFunction<GlTextureStorage1DNative>(lib, 'glTextureStorage1D').asFunction<GlTextureStorage1D>();
  glTextureStorage2D = loadFunction<GlTextureStorage2DNative>(lib, 'glTextureStorage2D').asFunction<GlTextureStorage2D>();
  glTextureStorage3D = loadFunction<GlTextureStorage3DNative>(lib, 'glTextureStorage3D').asFunction<GlTextureStorage3D>();
  glTextureStorage2DMultisample = loadFunction<GlTextureStorage2DMultisampleNative>(lib, 'glTextureStorage2DMultisample').asFunction<GlTextureStorage2DMultisample>();
  glTextureStorage3DMultisample = loadFunction<GlTextureStorage3DMultisampleNative>(lib, 'glTextureStorage3DMultisample').asFunction<GlTextureStorage3DMultisample>();
  glTextureSubImage1D = loadFunction<GlTextureSubImage1DNative>(lib, 'glTextureSubImage1D').asFunction<GlTextureSubImage1D>();
  glTextureSubImage2D = loadFunction<GlTextureSubImage2DNative>(lib, 'glTextureSubImage2D').asFunction<GlTextureSubImage2D>();
  glTextureSubImage3D = loadFunction<GlTextureSubImage3DNative>(lib, 'glTextureSubImage3D').asFunction<GlTextureSubImage3D>();
  glCompressedTextureSubImage1D = loadFunction<GlCompressedTextureSubImage1DNative>(lib, 'glCompressedTextureSubImage1D').asFunction<GlCompressedTextureSubImage1D>();
  glCompressedTextureSubImage2D = loadFunction<GlCompressedTextureSubImage2DNative>(lib, 'glCompressedTextureSubImage2D').asFunction<GlCompressedTextureSubImage2D>();
  glCompressedTextureSubImage3D = loadFunction<GlCompressedTextureSubImage3DNative>(lib, 'glCompressedTextureSubImage3D').asFunction<GlCompressedTextureSubImage3D>();
  glCopyTextureSubImage1D = loadFunction<GlCopyTextureSubImage1DNative>(lib, 'glCopyTextureSubImage1D').asFunction<GlCopyTextureSubImage1D>();
  glCopyTextureSubImage2D = loadFunction<GlCopyTextureSubImage2DNative>(lib, 'glCopyTextureSubImage2D').asFunction<GlCopyTextureSubImage2D>();
  glCopyTextureSubImage3D = loadFunction<GlCopyTextureSubImage3DNative>(lib, 'glCopyTextureSubImage3D').asFunction<GlCopyTextureSubImage3D>();
  glTextureParameterf = loadFunction<GlTextureParameterfNative>(lib, 'glTextureParameterf').asFunction<GlTextureParameterf>();
  glTextureParameterfv = loadFunction<GlTextureParameterfvNative>(lib, 'glTextureParameterfv').asFunction<GlTextureParameterfv>();
  glTextureParameteri = loadFunction<GlTextureParameteriNative>(lib, 'glTextureParameteri').asFunction<GlTextureParameteri>();
  glTextureParameterIiv = loadFunction<GlTextureParameterIivNative>(lib, 'glTextureParameterIiv').asFunction<GlTextureParameterIiv>();
  glTextureParameterIuiv = loadFunction<GlTextureParameterIuivNative>(lib, 'glTextureParameterIuiv').asFunction<GlTextureParameterIuiv>();
  glTextureParameteriv = loadFunction<GlTextureParameterivNative>(lib, 'glTextureParameteriv').asFunction<GlTextureParameteriv>();
  glGenerateTextureMipmap = loadFunction<GlGenerateTextureMipmapNative>(lib, 'glGenerateTextureMipmap').asFunction<GlGenerateTextureMipmap>();
  glBindTextureUnit = loadFunction<GlBindTextureUnitNative>(lib, 'glBindTextureUnit').asFunction<GlBindTextureUnit>();
  glGetTextureImage = loadFunction<GlGetTextureImageNative>(lib, 'glGetTextureImage').asFunction<GlGetTextureImage>();
  glGetCompressedTextureImage = loadFunction<GlGetCompressedTextureImageNative>(lib, 'glGetCompressedTextureImage').asFunction<GlGetCompressedTextureImage>();
  glGetTextureLevelParameterfv = loadFunction<GlGetTextureLevelParameterfvNative>(lib, 'glGetTextureLevelParameterfv').asFunction<GlGetTextureLevelParameterfv>();
  glGetTextureLevelParameteriv = loadFunction<GlGetTextureLevelParameterivNative>(lib, 'glGetTextureLevelParameteriv').asFunction<GlGetTextureLevelParameteriv>();
  glGetTextureParameterfv = loadFunction<GlGetTextureParameterfvNative>(lib, 'glGetTextureParameterfv').asFunction<GlGetTextureParameterfv>();
  glGetTextureParameterIiv = loadFunction<GlGetTextureParameterIivNative>(lib, 'glGetTextureParameterIiv').asFunction<GlGetTextureParameterIiv>();
  glGetTextureParameterIuiv = loadFunction<GlGetTextureParameterIuivNative>(lib, 'glGetTextureParameterIuiv').asFunction<GlGetTextureParameterIuiv>();
  glGetTextureParameteriv = loadFunction<GlGetTextureParameterivNative>(lib, 'glGetTextureParameteriv').asFunction<GlGetTextureParameteriv>();
  glCreateVertexArrays = loadFunction<GlCreateVertexArraysNative>(lib, 'glCreateVertexArrays').asFunction<GlCreateVertexArrays>();
  glDisableVertexArrayAttrib = loadFunction<GlDisableVertexArrayAttribNative>(lib, 'glDisableVertexArrayAttrib').asFunction<GlDisableVertexArrayAttrib>();
  glEnableVertexArrayAttrib = loadFunction<GlEnableVertexArrayAttribNative>(lib, 'glEnableVertexArrayAttrib').asFunction<GlEnableVertexArrayAttrib>();
  glVertexArrayElementBuffer = loadFunction<GlVertexArrayElementBufferNative>(lib, 'glVertexArrayElementBuffer').asFunction<GlVertexArrayElementBuffer>();
  glVertexArrayVertexBuffer = loadFunction<GlVertexArrayVertexBufferNative>(lib, 'glVertexArrayVertexBuffer').asFunction<GlVertexArrayVertexBuffer>();
  glVertexArrayVertexBuffers = loadFunction<GlVertexArrayVertexBuffersNative>(lib, 'glVertexArrayVertexBuffers').asFunction<GlVertexArrayVertexBuffers>();
  glVertexArrayAttribBinding = loadFunction<GlVertexArrayAttribBindingNative>(lib, 'glVertexArrayAttribBinding').asFunction<GlVertexArrayAttribBinding>();
  glVertexArrayAttribFormat = loadFunction<GlVertexArrayAttribFormatNative>(lib, 'glVertexArrayAttribFormat').asFunction<GlVertexArrayAttribFormat>();
  glVertexArrayAttribIFormat = loadFunction<GlVertexArrayAttribIFormatNative>(lib, 'glVertexArrayAttribIFormat').asFunction<GlVertexArrayAttribIFormat>();
  glVertexArrayAttribLFormat = loadFunction<GlVertexArrayAttribLFormatNative>(lib, 'glVertexArrayAttribLFormat').asFunction<GlVertexArrayAttribLFormat>();
  glVertexArrayBindingDivisor = loadFunction<GlVertexArrayBindingDivisorNative>(lib, 'glVertexArrayBindingDivisor').asFunction<GlVertexArrayBindingDivisor>();
  glGetVertexArrayiv = loadFunction<GlGetVertexArrayivNative>(lib, 'glGetVertexArrayiv').asFunction<GlGetVertexArrayiv>();
  glGetVertexArrayIndexediv = loadFunction<GlGetVertexArrayIndexedivNative>(lib, 'glGetVertexArrayIndexediv').asFunction<GlGetVertexArrayIndexediv>();
  glGetVertexArrayIndexed64iv = loadFunction<GlGetVertexArrayIndexed64ivNative>(lib, 'glGetVertexArrayIndexed64iv').asFunction<GlGetVertexArrayIndexed64iv>();
  glCreateSamplers = loadFunction<GlCreateSamplersNative>(lib, 'glCreateSamplers').asFunction<GlCreateSamplers>();
  glCreateProgramPipelines = loadFunction<GlCreateProgramPipelinesNative>(lib, 'glCreateProgramPipelines').asFunction<GlCreateProgramPipelines>();
  glCreateQueries = loadFunction<GlCreateQueriesNative>(lib, 'glCreateQueries').asFunction<GlCreateQueries>();
  glGetQueryBufferObjecti64v = loadFunction<GlGetQueryBufferObjecti64vNative>(lib, 'glGetQueryBufferObjecti64v').asFunction<GlGetQueryBufferObjecti64v>();
  glGetQueryBufferObjectiv = loadFunction<GlGetQueryBufferObjectivNative>(lib, 'glGetQueryBufferObjectiv').asFunction<GlGetQueryBufferObjectiv>();
  glGetQueryBufferObjectui64v = loadFunction<GlGetQueryBufferObjectui64vNative>(lib, 'glGetQueryBufferObjectui64v').asFunction<GlGetQueryBufferObjectui64v>();
  glGetQueryBufferObjectuiv = loadFunction<GlGetQueryBufferObjectuivNative>(lib, 'glGetQueryBufferObjectuiv').asFunction<GlGetQueryBufferObjectuiv>();
  glMemoryBarrierByRegion = loadFunction<GlMemoryBarrierByRegionNative>(lib, 'glMemoryBarrierByRegion').asFunction<GlMemoryBarrierByRegion>();
  glGetTextureSubImage = loadFunction<GlGetTextureSubImageNative>(lib, 'glGetTextureSubImage').asFunction<GlGetTextureSubImage>();
  glGetCompressedTextureSubImage = loadFunction<GlGetCompressedTextureSubImageNative>(lib, 'glGetCompressedTextureSubImage').asFunction<GlGetCompressedTextureSubImage>();
  glGetGraphicsResetStatus = loadFunction<GlGetGraphicsResetStatusNative>(lib, 'glGetGraphicsResetStatus').asFunction<GlGetGraphicsResetStatus>();
  glGetnCompressedTexImage = loadFunction<GlGetnCompressedTexImageNative>(lib, 'glGetnCompressedTexImage').asFunction<GlGetnCompressedTexImage>();
  glGetnTexImage = loadFunction<GlGetnTexImageNative>(lib, 'glGetnTexImage').asFunction<GlGetnTexImage>();
  glGetnUniformdv = loadFunction<GlGetnUniformdvNative>(lib, 'glGetnUniformdv').asFunction<GlGetnUniformdv>();
  glGetnUniformfv = loadFunction<GlGetnUniformfvNative>(lib, 'glGetnUniformfv').asFunction<GlGetnUniformfv>();
  glGetnUniformiv = loadFunction<GlGetnUniformivNative>(lib, 'glGetnUniformiv').asFunction<GlGetnUniformiv>();
  glGetnUniformuiv = loadFunction<GlGetnUniformuivNative>(lib, 'glGetnUniformuiv').asFunction<GlGetnUniformuiv>();
  glReadnPixels = loadFunction<GlReadnPixelsNative>(lib, 'glReadnPixels').asFunction<GlReadnPixels>();
  glTextureBarrier = loadFunction<GlTextureBarrierNative>(lib, 'glTextureBarrier').asFunction<GlTextureBarrier>();
  glSpecializeShader = loadFunction<GlSpecializeShaderNative>(lib, 'glSpecializeShader').asFunction<GlSpecializeShader>();
  glMultiDrawArraysIndirectCount = loadFunction<GlMultiDrawArraysIndirectCountNative>(lib, 'glMultiDrawArraysIndirectCount').asFunction<GlMultiDrawArraysIndirectCount>();
  glMultiDrawElementsIndirectCount = loadFunction<GlMultiDrawElementsIndirectCountNative>(lib, 'glMultiDrawElementsIndirectCount').asFunction<GlMultiDrawElementsIndirectCount>();
  glPolygonOffsetClamp = loadFunction<GlPolygonOffsetClampNative>(lib, 'glPolygonOffsetClamp').asFunction<GlPolygonOffsetClamp>();
  glPrimitiveBoundingBoxARB = loadFunction<GlPrimitiveBoundingBoxARBNative>(lib, 'glPrimitiveBoundingBoxARB').asFunction<GlPrimitiveBoundingBoxARB>();
  glGetTextureHandleARB = loadFunction<GlGetTextureHandleARBNative>(lib, 'glGetTextureHandleARB').asFunction<GlGetTextureHandleARB>();
  glGetTextureSamplerHandleARB = loadFunction<GlGetTextureSamplerHandleARBNative>(lib, 'glGetTextureSamplerHandleARB').asFunction<GlGetTextureSamplerHandleARB>();
  glMakeTextureHandleResidentARB = loadFunction<GlMakeTextureHandleResidentARBNative>(lib, 'glMakeTextureHandleResidentARB').asFunction<GlMakeTextureHandleResidentARB>();
  glMakeTextureHandleNonResidentARB = loadFunction<GlMakeTextureHandleNonResidentARBNative>(lib, 'glMakeTextureHandleNonResidentARB').asFunction<GlMakeTextureHandleNonResidentARB>();
  glGetImageHandleARB = loadFunction<GlGetImageHandleARBNative>(lib, 'glGetImageHandleARB').asFunction<GlGetImageHandleARB>();
  glMakeImageHandleResidentARB = loadFunction<GlMakeImageHandleResidentARBNative>(lib, 'glMakeImageHandleResidentARB').asFunction<GlMakeImageHandleResidentARB>();
  glMakeImageHandleNonResidentARB = loadFunction<GlMakeImageHandleNonResidentARBNative>(lib, 'glMakeImageHandleNonResidentARB').asFunction<GlMakeImageHandleNonResidentARB>();
  glUniformHandleui64ARB = loadFunction<GlUniformHandleui64ARBNative>(lib, 'glUniformHandleui64ARB').asFunction<GlUniformHandleui64ARB>();
  glUniformHandleui64vARB = loadFunction<GlUniformHandleui64vARBNative>(lib, 'glUniformHandleui64vARB').asFunction<GlUniformHandleui64vARB>();
  glProgramUniformHandleui64ARB = loadFunction<GlProgramUniformHandleui64ARBNative>(lib, 'glProgramUniformHandleui64ARB').asFunction<GlProgramUniformHandleui64ARB>();
  glProgramUniformHandleui64vARB = loadFunction<GlProgramUniformHandleui64vARBNative>(lib, 'glProgramUniformHandleui64vARB').asFunction<GlProgramUniformHandleui64vARB>();
  glIsTextureHandleResidentARB = loadFunction<GlIsTextureHandleResidentARBNative>(lib, 'glIsTextureHandleResidentARB').asFunction<GlIsTextureHandleResidentARB>();
  glIsImageHandleResidentARB = loadFunction<GlIsImageHandleResidentARBNative>(lib, 'glIsImageHandleResidentARB').asFunction<GlIsImageHandleResidentARB>();
  glVertexAttribL1ui64ARB = loadFunction<GlVertexAttribL1ui64ARBNative>(lib, 'glVertexAttribL1ui64ARB').asFunction<GlVertexAttribL1ui64ARB>();
  glVertexAttribL1ui64vARB = loadFunction<GlVertexAttribL1ui64vARBNative>(lib, 'glVertexAttribL1ui64vARB').asFunction<GlVertexAttribL1ui64vARB>();
  glGetVertexAttribLui64vARB = loadFunction<GlGetVertexAttribLui64vARBNative>(lib, 'glGetVertexAttribLui64vARB').asFunction<GlGetVertexAttribLui64vARB>();
  glCreateSyncFromCLeventARB = loadFunction<GlCreateSyncFromCLeventARBNative>(lib, 'glCreateSyncFromCLeventARB').asFunction<GlCreateSyncFromCLeventARB>();
  glDispatchComputeGroupSizeARB = loadFunction<GlDispatchComputeGroupSizeARBNative>(lib, 'glDispatchComputeGroupSizeARB').asFunction<GlDispatchComputeGroupSizeARB>();
  glDebugMessageControlARB = loadFunction<GlDebugMessageControlARBNative>(lib, 'glDebugMessageControlARB').asFunction<GlDebugMessageControlARB>();
  glDebugMessageInsertARB = loadFunction<GlDebugMessageInsertARBNative>(lib, 'glDebugMessageInsertARB').asFunction<GlDebugMessageInsertARB>();
  glDebugMessageCallbackARB = loadFunction<GlDebugMessageCallbackARBNative>(lib, 'glDebugMessageCallbackARB').asFunction<GlDebugMessageCallbackARB>();
  glGetDebugMessageLogARB = loadFunction<GlGetDebugMessageLogARBNative>(lib, 'glGetDebugMessageLogARB').asFunction<GlGetDebugMessageLogARB>();
  glBlendEquationiARB = loadFunction<GlBlendEquationiARBNative>(lib, 'glBlendEquationiARB').asFunction<GlBlendEquationiARB>();
  glBlendEquationSeparateiARB = loadFunction<GlBlendEquationSeparateiARBNative>(lib, 'glBlendEquationSeparateiARB').asFunction<GlBlendEquationSeparateiARB>();
  glBlendFunciARB = loadFunction<GlBlendFunciARBNative>(lib, 'glBlendFunciARB').asFunction<GlBlendFunciARB>();
  glBlendFuncSeparateiARB = loadFunction<GlBlendFuncSeparateiARBNative>(lib, 'glBlendFuncSeparateiARB').asFunction<GlBlendFuncSeparateiARB>();
  glDrawArraysInstancedARB = loadFunction<GlDrawArraysInstancedARBNative>(lib, 'glDrawArraysInstancedARB').asFunction<GlDrawArraysInstancedARB>();
  glDrawElementsInstancedARB = loadFunction<GlDrawElementsInstancedARBNative>(lib, 'glDrawElementsInstancedARB').asFunction<GlDrawElementsInstancedARB>();
  glProgramParameteriARB = loadFunction<GlProgramParameteriARBNative>(lib, 'glProgramParameteriARB').asFunction<GlProgramParameteriARB>();
  glFramebufferTextureARB = loadFunction<GlFramebufferTextureARBNative>(lib, 'glFramebufferTextureARB').asFunction<GlFramebufferTextureARB>();
  glFramebufferTextureLayerARB = loadFunction<GlFramebufferTextureLayerARBNative>(lib, 'glFramebufferTextureLayerARB').asFunction<GlFramebufferTextureLayerARB>();
  glFramebufferTextureFaceARB = loadFunction<GlFramebufferTextureFaceARBNative>(lib, 'glFramebufferTextureFaceARB').asFunction<GlFramebufferTextureFaceARB>();
  glSpecializeShaderARB = loadFunction<GlSpecializeShaderARBNative>(lib, 'glSpecializeShaderARB').asFunction<GlSpecializeShaderARB>();
  glUniform1i64ARB = loadFunction<GlUniform1i64ARBNative>(lib, 'glUniform1i64ARB').asFunction<GlUniform1i64ARB>();
  glUniform2i64ARB = loadFunction<GlUniform2i64ARBNative>(lib, 'glUniform2i64ARB').asFunction<GlUniform2i64ARB>();
  glUniform3i64ARB = loadFunction<GlUniform3i64ARBNative>(lib, 'glUniform3i64ARB').asFunction<GlUniform3i64ARB>();
  glUniform4i64ARB = loadFunction<GlUniform4i64ARBNative>(lib, 'glUniform4i64ARB').asFunction<GlUniform4i64ARB>();
  glUniform1i64vARB = loadFunction<GlUniform1i64vARBNative>(lib, 'glUniform1i64vARB').asFunction<GlUniform1i64vARB>();
  glUniform2i64vARB = loadFunction<GlUniform2i64vARBNative>(lib, 'glUniform2i64vARB').asFunction<GlUniform2i64vARB>();
  glUniform3i64vARB = loadFunction<GlUniform3i64vARBNative>(lib, 'glUniform3i64vARB').asFunction<GlUniform3i64vARB>();
  glUniform4i64vARB = loadFunction<GlUniform4i64vARBNative>(lib, 'glUniform4i64vARB').asFunction<GlUniform4i64vARB>();
  glUniform1ui64ARB = loadFunction<GlUniform1ui64ARBNative>(lib, 'glUniform1ui64ARB').asFunction<GlUniform1ui64ARB>();
  glUniform2ui64ARB = loadFunction<GlUniform2ui64ARBNative>(lib, 'glUniform2ui64ARB').asFunction<GlUniform2ui64ARB>();
  glUniform3ui64ARB = loadFunction<GlUniform3ui64ARBNative>(lib, 'glUniform3ui64ARB').asFunction<GlUniform3ui64ARB>();
  glUniform4ui64ARB = loadFunction<GlUniform4ui64ARBNative>(lib, 'glUniform4ui64ARB').asFunction<GlUniform4ui64ARB>();
  glUniform1ui64vARB = loadFunction<GlUniform1ui64vARBNative>(lib, 'glUniform1ui64vARB').asFunction<GlUniform1ui64vARB>();
  glUniform2ui64vARB = loadFunction<GlUniform2ui64vARBNative>(lib, 'glUniform2ui64vARB').asFunction<GlUniform2ui64vARB>();
  glUniform3ui64vARB = loadFunction<GlUniform3ui64vARBNative>(lib, 'glUniform3ui64vARB').asFunction<GlUniform3ui64vARB>();
  glUniform4ui64vARB = loadFunction<GlUniform4ui64vARBNative>(lib, 'glUniform4ui64vARB').asFunction<GlUniform4ui64vARB>();
  glGetUniformi64vARB = loadFunction<GlGetUniformi64vARBNative>(lib, 'glGetUniformi64vARB').asFunction<GlGetUniformi64vARB>();
  glGetUniformui64vARB = loadFunction<GlGetUniformui64vARBNative>(lib, 'glGetUniformui64vARB').asFunction<GlGetUniformui64vARB>();
  glGetnUniformi64vARB = loadFunction<GlGetnUniformi64vARBNative>(lib, 'glGetnUniformi64vARB').asFunction<GlGetnUniformi64vARB>();
  glGetnUniformui64vARB = loadFunction<GlGetnUniformui64vARBNative>(lib, 'glGetnUniformui64vARB').asFunction<GlGetnUniformui64vARB>();
  glProgramUniform1i64ARB = loadFunction<GlProgramUniform1i64ARBNative>(lib, 'glProgramUniform1i64ARB').asFunction<GlProgramUniform1i64ARB>();
  glProgramUniform2i64ARB = loadFunction<GlProgramUniform2i64ARBNative>(lib, 'glProgramUniform2i64ARB').asFunction<GlProgramUniform2i64ARB>();
  glProgramUniform3i64ARB = loadFunction<GlProgramUniform3i64ARBNative>(lib, 'glProgramUniform3i64ARB').asFunction<GlProgramUniform3i64ARB>();
  glProgramUniform4i64ARB = loadFunction<GlProgramUniform4i64ARBNative>(lib, 'glProgramUniform4i64ARB').asFunction<GlProgramUniform4i64ARB>();
  glProgramUniform1i64vARB = loadFunction<GlProgramUniform1i64vARBNative>(lib, 'glProgramUniform1i64vARB').asFunction<GlProgramUniform1i64vARB>();
  glProgramUniform2i64vARB = loadFunction<GlProgramUniform2i64vARBNative>(lib, 'glProgramUniform2i64vARB').asFunction<GlProgramUniform2i64vARB>();
  glProgramUniform3i64vARB = loadFunction<GlProgramUniform3i64vARBNative>(lib, 'glProgramUniform3i64vARB').asFunction<GlProgramUniform3i64vARB>();
  glProgramUniform4i64vARB = loadFunction<GlProgramUniform4i64vARBNative>(lib, 'glProgramUniform4i64vARB').asFunction<GlProgramUniform4i64vARB>();
  glProgramUniform1ui64ARB = loadFunction<GlProgramUniform1ui64ARBNative>(lib, 'glProgramUniform1ui64ARB').asFunction<GlProgramUniform1ui64ARB>();
  glProgramUniform2ui64ARB = loadFunction<GlProgramUniform2ui64ARBNative>(lib, 'glProgramUniform2ui64ARB').asFunction<GlProgramUniform2ui64ARB>();
  glProgramUniform3ui64ARB = loadFunction<GlProgramUniform3ui64ARBNative>(lib, 'glProgramUniform3ui64ARB').asFunction<GlProgramUniform3ui64ARB>();
  glProgramUniform4ui64ARB = loadFunction<GlProgramUniform4ui64ARBNative>(lib, 'glProgramUniform4ui64ARB').asFunction<GlProgramUniform4ui64ARB>();
  glProgramUniform1ui64vARB = loadFunction<GlProgramUniform1ui64vARBNative>(lib, 'glProgramUniform1ui64vARB').asFunction<GlProgramUniform1ui64vARB>();
  glProgramUniform2ui64vARB = loadFunction<GlProgramUniform2ui64vARBNative>(lib, 'glProgramUniform2ui64vARB').asFunction<GlProgramUniform2ui64vARB>();
  glProgramUniform3ui64vARB = loadFunction<GlProgramUniform3ui64vARBNative>(lib, 'glProgramUniform3ui64vARB').asFunction<GlProgramUniform3ui64vARB>();
  glProgramUniform4ui64vARB = loadFunction<GlProgramUniform4ui64vARBNative>(lib, 'glProgramUniform4ui64vARB').asFunction<GlProgramUniform4ui64vARB>();
  glMultiDrawArraysIndirectCountARB = loadFunction<GlMultiDrawArraysIndirectCountARBNative>(lib, 'glMultiDrawArraysIndirectCountARB').asFunction<GlMultiDrawArraysIndirectCountARB>();
  glMultiDrawElementsIndirectCountARB = loadFunction<GlMultiDrawElementsIndirectCountARBNative>(lib, 'glMultiDrawElementsIndirectCountARB').asFunction<GlMultiDrawElementsIndirectCountARB>();
  glVertexAttribDivisorARB = loadFunction<GlVertexAttribDivisorARBNative>(lib, 'glVertexAttribDivisorARB').asFunction<GlVertexAttribDivisorARB>();
  glMaxShaderCompilerThreadsARB = loadFunction<GlMaxShaderCompilerThreadsARBNative>(lib, 'glMaxShaderCompilerThreadsARB').asFunction<GlMaxShaderCompilerThreadsARB>();
  glGetGraphicsResetStatusARB = loadFunction<GlGetGraphicsResetStatusARBNative>(lib, 'glGetGraphicsResetStatusARB').asFunction<GlGetGraphicsResetStatusARB>();
  glGetnTexImageARB = loadFunction<GlGetnTexImageARBNative>(lib, 'glGetnTexImageARB').asFunction<GlGetnTexImageARB>();
  glReadnPixelsARB = loadFunction<GlReadnPixelsARBNative>(lib, 'glReadnPixelsARB').asFunction<GlReadnPixelsARB>();
  glGetnCompressedTexImageARB = loadFunction<GlGetnCompressedTexImageARBNative>(lib, 'glGetnCompressedTexImageARB').asFunction<GlGetnCompressedTexImageARB>();
  glGetnUniformfvARB = loadFunction<GlGetnUniformfvARBNative>(lib, 'glGetnUniformfvARB').asFunction<GlGetnUniformfvARB>();
  glGetnUniformivARB = loadFunction<GlGetnUniformivARBNative>(lib, 'glGetnUniformivARB').asFunction<GlGetnUniformivARB>();
  glGetnUniformuivARB = loadFunction<GlGetnUniformuivARBNative>(lib, 'glGetnUniformuivARB').asFunction<GlGetnUniformuivARB>();
  glGetnUniformdvARB = loadFunction<GlGetnUniformdvARBNative>(lib, 'glGetnUniformdvARB').asFunction<GlGetnUniformdvARB>();
  glFramebufferSampleLocationsfvARB = loadFunction<GlFramebufferSampleLocationsfvARBNative>(lib, 'glFramebufferSampleLocationsfvARB').asFunction<GlFramebufferSampleLocationsfvARB>();
  glNamedFramebufferSampleLocationsfvARB = loadFunction<GlNamedFramebufferSampleLocationsfvARBNative>(lib, 'glNamedFramebufferSampleLocationsfvARB').asFunction<GlNamedFramebufferSampleLocationsfvARB>();
  glEvaluateDepthValuesARB = loadFunction<GlEvaluateDepthValuesARBNative>(lib, 'glEvaluateDepthValuesARB').asFunction<GlEvaluateDepthValuesARB>();
  glMinSampleShadingARB = loadFunction<GlMinSampleShadingARBNative>(lib, 'glMinSampleShadingARB').asFunction<GlMinSampleShadingARB>();
  glNamedStringARB = loadFunction<GlNamedStringARBNative>(lib, 'glNamedStringARB').asFunction<GlNamedStringARB>();
  glDeleteNamedStringARB = loadFunction<GlDeleteNamedStringARBNative>(lib, 'glDeleteNamedStringARB').asFunction<GlDeleteNamedStringARB>();
  glCompileShaderIncludeARB = loadFunction<GlCompileShaderIncludeARBNative>(lib, 'glCompileShaderIncludeARB').asFunction<GlCompileShaderIncludeARB>();
  glIsNamedStringARB = loadFunction<GlIsNamedStringARBNative>(lib, 'glIsNamedStringARB').asFunction<GlIsNamedStringARB>();
  glGetNamedStringARB = loadFunction<GlGetNamedStringARBNative>(lib, 'glGetNamedStringARB').asFunction<GlGetNamedStringARB>();
  glGetNamedStringivARB = loadFunction<GlGetNamedStringivARBNative>(lib, 'glGetNamedStringivARB').asFunction<GlGetNamedStringivARB>();
  glBufferPageCommitmentARB = loadFunction<GlBufferPageCommitmentARBNative>(lib, 'glBufferPageCommitmentARB').asFunction<GlBufferPageCommitmentARB>();
  glNamedBufferPageCommitmentEXT = loadFunction<GlNamedBufferPageCommitmentEXTNative>(lib, 'glNamedBufferPageCommitmentEXT').asFunction<GlNamedBufferPageCommitmentEXT>();
  glNamedBufferPageCommitmentARB = loadFunction<GlNamedBufferPageCommitmentARBNative>(lib, 'glNamedBufferPageCommitmentARB').asFunction<GlNamedBufferPageCommitmentARB>();
  glTexPageCommitmentARB = loadFunction<GlTexPageCommitmentARBNative>(lib, 'glTexPageCommitmentARB').asFunction<GlTexPageCommitmentARB>();
  glTexBufferARB = loadFunction<GlTexBufferARBNative>(lib, 'glTexBufferARB').asFunction<GlTexBufferARB>();
  glDepthRangeArraydvNV = loadFunction<GlDepthRangeArraydvNVNative>(lib, 'glDepthRangeArraydvNV').asFunction<GlDepthRangeArraydvNV>();
  glDepthRangeIndexeddNV = loadFunction<GlDepthRangeIndexeddNVNative>(lib, 'glDepthRangeIndexeddNV').asFunction<GlDepthRangeIndexeddNV>();
  glBlendBarrierKHR = loadFunction<GlBlendBarrierKHRNative>(lib, 'glBlendBarrierKHR').asFunction<GlBlendBarrierKHR>();
  glMaxShaderCompilerThreadsKHR = loadFunction<GlMaxShaderCompilerThreadsKHRNative>(lib, 'glMaxShaderCompilerThreadsKHR').asFunction<GlMaxShaderCompilerThreadsKHR>();
  glRenderbufferStorageMultisampleAdvancedAMD = loadFunction<GlRenderbufferStorageMultisampleAdvancedAMDNative>(lib, 'glRenderbufferStorageMultisampleAdvancedAMD').asFunction<GlRenderbufferStorageMultisampleAdvancedAMD>();
  glNamedRenderbufferStorageMultisampleAdvancedAMD = loadFunction<GlNamedRenderbufferStorageMultisampleAdvancedAMDNative>(lib, 'glNamedRenderbufferStorageMultisampleAdvancedAMD').asFunction<GlNamedRenderbufferStorageMultisampleAdvancedAMD>();
  glGetPerfMonitorGroupsAMD = loadFunction<GlGetPerfMonitorGroupsAMDNative>(lib, 'glGetPerfMonitorGroupsAMD').asFunction<GlGetPerfMonitorGroupsAMD>();
  glGetPerfMonitorCountersAMD = loadFunction<GlGetPerfMonitorCountersAMDNative>(lib, 'glGetPerfMonitorCountersAMD').asFunction<GlGetPerfMonitorCountersAMD>();
  glGetPerfMonitorGroupStringAMD = loadFunction<GlGetPerfMonitorGroupStringAMDNative>(lib, 'glGetPerfMonitorGroupStringAMD').asFunction<GlGetPerfMonitorGroupStringAMD>();
  glGetPerfMonitorCounterStringAMD = loadFunction<GlGetPerfMonitorCounterStringAMDNative>(lib, 'glGetPerfMonitorCounterStringAMD').asFunction<GlGetPerfMonitorCounterStringAMD>();
  glGetPerfMonitorCounterInfoAMD = loadFunction<GlGetPerfMonitorCounterInfoAMDNative>(lib, 'glGetPerfMonitorCounterInfoAMD').asFunction<GlGetPerfMonitorCounterInfoAMD>();
  glGenPerfMonitorsAMD = loadFunction<GlGenPerfMonitorsAMDNative>(lib, 'glGenPerfMonitorsAMD').asFunction<GlGenPerfMonitorsAMD>();
  glDeletePerfMonitorsAMD = loadFunction<GlDeletePerfMonitorsAMDNative>(lib, 'glDeletePerfMonitorsAMD').asFunction<GlDeletePerfMonitorsAMD>();
  glSelectPerfMonitorCountersAMD = loadFunction<GlSelectPerfMonitorCountersAMDNative>(lib, 'glSelectPerfMonitorCountersAMD').asFunction<GlSelectPerfMonitorCountersAMD>();
  glBeginPerfMonitorAMD = loadFunction<GlBeginPerfMonitorAMDNative>(lib, 'glBeginPerfMonitorAMD').asFunction<GlBeginPerfMonitorAMD>();
  glEndPerfMonitorAMD = loadFunction<GlEndPerfMonitorAMDNative>(lib, 'glEndPerfMonitorAMD').asFunction<GlEndPerfMonitorAMD>();
  glGetPerfMonitorCounterDataAMD = loadFunction<GlGetPerfMonitorCounterDataAMDNative>(lib, 'glGetPerfMonitorCounterDataAMD').asFunction<GlGetPerfMonitorCounterDataAMD>();
  glEGLImageTargetTexStorageEXT = loadFunction<GlEGLImageTargetTexStorageEXTNative>(lib, 'glEGLImageTargetTexStorageEXT').asFunction<GlEGLImageTargetTexStorageEXT>();
  glEGLImageTargetTextureStorageEXT = loadFunction<GlEGLImageTargetTextureStorageEXTNative>(lib, 'glEGLImageTargetTextureStorageEXT').asFunction<GlEGLImageTargetTextureStorageEXT>();
  glLabelObjectEXT = loadFunction<GlLabelObjectEXTNative>(lib, 'glLabelObjectEXT').asFunction<GlLabelObjectEXT>();
  glGetObjectLabelEXT = loadFunction<GlGetObjectLabelEXTNative>(lib, 'glGetObjectLabelEXT').asFunction<GlGetObjectLabelEXT>();
  glInsertEventMarkerEXT = loadFunction<GlInsertEventMarkerEXTNative>(lib, 'glInsertEventMarkerEXT').asFunction<GlInsertEventMarkerEXT>();
  glPushGroupMarkerEXT = loadFunction<GlPushGroupMarkerEXTNative>(lib, 'glPushGroupMarkerEXT').asFunction<GlPushGroupMarkerEXT>();
  glPopGroupMarkerEXT = loadFunction<GlPopGroupMarkerEXTNative>(lib, 'glPopGroupMarkerEXT').asFunction<GlPopGroupMarkerEXT>();
  glMatrixLoadfEXT = loadFunction<GlMatrixLoadfEXTNative>(lib, 'glMatrixLoadfEXT').asFunction<GlMatrixLoadfEXT>();
  glMatrixLoaddEXT = loadFunction<GlMatrixLoaddEXTNative>(lib, 'glMatrixLoaddEXT').asFunction<GlMatrixLoaddEXT>();
  glMatrixMultfEXT = loadFunction<GlMatrixMultfEXTNative>(lib, 'glMatrixMultfEXT').asFunction<GlMatrixMultfEXT>();
  glMatrixMultdEXT = loadFunction<GlMatrixMultdEXTNative>(lib, 'glMatrixMultdEXT').asFunction<GlMatrixMultdEXT>();
  glMatrixLoadIdentityEXT = loadFunction<GlMatrixLoadIdentityEXTNative>(lib, 'glMatrixLoadIdentityEXT').asFunction<GlMatrixLoadIdentityEXT>();
  glMatrixRotatefEXT = loadFunction<GlMatrixRotatefEXTNative>(lib, 'glMatrixRotatefEXT').asFunction<GlMatrixRotatefEXT>();
  glMatrixRotatedEXT = loadFunction<GlMatrixRotatedEXTNative>(lib, 'glMatrixRotatedEXT').asFunction<GlMatrixRotatedEXT>();
  glMatrixScalefEXT = loadFunction<GlMatrixScalefEXTNative>(lib, 'glMatrixScalefEXT').asFunction<GlMatrixScalefEXT>();
  glMatrixScaledEXT = loadFunction<GlMatrixScaledEXTNative>(lib, 'glMatrixScaledEXT').asFunction<GlMatrixScaledEXT>();
  glMatrixTranslatefEXT = loadFunction<GlMatrixTranslatefEXTNative>(lib, 'glMatrixTranslatefEXT').asFunction<GlMatrixTranslatefEXT>();
  glMatrixTranslatedEXT = loadFunction<GlMatrixTranslatedEXTNative>(lib, 'glMatrixTranslatedEXT').asFunction<GlMatrixTranslatedEXT>();
  glMatrixFrustumEXT = loadFunction<GlMatrixFrustumEXTNative>(lib, 'glMatrixFrustumEXT').asFunction<GlMatrixFrustumEXT>();
  glMatrixOrthoEXT = loadFunction<GlMatrixOrthoEXTNative>(lib, 'glMatrixOrthoEXT').asFunction<GlMatrixOrthoEXT>();
  glMatrixPopEXT = loadFunction<GlMatrixPopEXTNative>(lib, 'glMatrixPopEXT').asFunction<GlMatrixPopEXT>();
  glMatrixPushEXT = loadFunction<GlMatrixPushEXTNative>(lib, 'glMatrixPushEXT').asFunction<GlMatrixPushEXT>();
  glClientAttribDefaultEXT = loadFunction<GlClientAttribDefaultEXTNative>(lib, 'glClientAttribDefaultEXT').asFunction<GlClientAttribDefaultEXT>();
  glPushClientAttribDefaultEXT = loadFunction<GlPushClientAttribDefaultEXTNative>(lib, 'glPushClientAttribDefaultEXT').asFunction<GlPushClientAttribDefaultEXT>();
  glTextureParameterfEXT = loadFunction<GlTextureParameterfEXTNative>(lib, 'glTextureParameterfEXT').asFunction<GlTextureParameterfEXT>();
  glTextureParameterfvEXT = loadFunction<GlTextureParameterfvEXTNative>(lib, 'glTextureParameterfvEXT').asFunction<GlTextureParameterfvEXT>();
  glTextureParameteriEXT = loadFunction<GlTextureParameteriEXTNative>(lib, 'glTextureParameteriEXT').asFunction<GlTextureParameteriEXT>();
  glTextureParameterivEXT = loadFunction<GlTextureParameterivEXTNative>(lib, 'glTextureParameterivEXT').asFunction<GlTextureParameterivEXT>();
  glTextureImage1DEXT = loadFunction<GlTextureImage1DEXTNative>(lib, 'glTextureImage1DEXT').asFunction<GlTextureImage1DEXT>();
  glTextureImage2DEXT = loadFunction<GlTextureImage2DEXTNative>(lib, 'glTextureImage2DEXT').asFunction<GlTextureImage2DEXT>();
  glTextureSubImage1DEXT = loadFunction<GlTextureSubImage1DEXTNative>(lib, 'glTextureSubImage1DEXT').asFunction<GlTextureSubImage1DEXT>();
  glTextureSubImage2DEXT = loadFunction<GlTextureSubImage2DEXTNative>(lib, 'glTextureSubImage2DEXT').asFunction<GlTextureSubImage2DEXT>();
  glCopyTextureImage1DEXT = loadFunction<GlCopyTextureImage1DEXTNative>(lib, 'glCopyTextureImage1DEXT').asFunction<GlCopyTextureImage1DEXT>();
  glCopyTextureImage2DEXT = loadFunction<GlCopyTextureImage2DEXTNative>(lib, 'glCopyTextureImage2DEXT').asFunction<GlCopyTextureImage2DEXT>();
  glCopyTextureSubImage1DEXT = loadFunction<GlCopyTextureSubImage1DEXTNative>(lib, 'glCopyTextureSubImage1DEXT').asFunction<GlCopyTextureSubImage1DEXT>();
  glCopyTextureSubImage2DEXT = loadFunction<GlCopyTextureSubImage2DEXTNative>(lib, 'glCopyTextureSubImage2DEXT').asFunction<GlCopyTextureSubImage2DEXT>();
  glGetTextureImageEXT = loadFunction<GlGetTextureImageEXTNative>(lib, 'glGetTextureImageEXT').asFunction<GlGetTextureImageEXT>();
  glGetTextureParameterfvEXT = loadFunction<GlGetTextureParameterfvEXTNative>(lib, 'glGetTextureParameterfvEXT').asFunction<GlGetTextureParameterfvEXT>();
  glGetTextureParameterivEXT = loadFunction<GlGetTextureParameterivEXTNative>(lib, 'glGetTextureParameterivEXT').asFunction<GlGetTextureParameterivEXT>();
  glGetTextureLevelParameterfvEXT = loadFunction<GlGetTextureLevelParameterfvEXTNative>(lib, 'glGetTextureLevelParameterfvEXT').asFunction<GlGetTextureLevelParameterfvEXT>();
  glGetTextureLevelParameterivEXT = loadFunction<GlGetTextureLevelParameterivEXTNative>(lib, 'glGetTextureLevelParameterivEXT').asFunction<GlGetTextureLevelParameterivEXT>();
  glTextureImage3DEXT = loadFunction<GlTextureImage3DEXTNative>(lib, 'glTextureImage3DEXT').asFunction<GlTextureImage3DEXT>();
  glTextureSubImage3DEXT = loadFunction<GlTextureSubImage3DEXTNative>(lib, 'glTextureSubImage3DEXT').asFunction<GlTextureSubImage3DEXT>();
  glCopyTextureSubImage3DEXT = loadFunction<GlCopyTextureSubImage3DEXTNative>(lib, 'glCopyTextureSubImage3DEXT').asFunction<GlCopyTextureSubImage3DEXT>();
  glBindMultiTextureEXT = loadFunction<GlBindMultiTextureEXTNative>(lib, 'glBindMultiTextureEXT').asFunction<GlBindMultiTextureEXT>();
  glMultiTexCoordPointerEXT = loadFunction<GlMultiTexCoordPointerEXTNative>(lib, 'glMultiTexCoordPointerEXT').asFunction<GlMultiTexCoordPointerEXT>();
  glMultiTexEnvfEXT = loadFunction<GlMultiTexEnvfEXTNative>(lib, 'glMultiTexEnvfEXT').asFunction<GlMultiTexEnvfEXT>();
  glMultiTexEnvfvEXT = loadFunction<GlMultiTexEnvfvEXTNative>(lib, 'glMultiTexEnvfvEXT').asFunction<GlMultiTexEnvfvEXT>();
  glMultiTexEnviEXT = loadFunction<GlMultiTexEnviEXTNative>(lib, 'glMultiTexEnviEXT').asFunction<GlMultiTexEnviEXT>();
  glMultiTexEnvivEXT = loadFunction<GlMultiTexEnvivEXTNative>(lib, 'glMultiTexEnvivEXT').asFunction<GlMultiTexEnvivEXT>();
  glMultiTexGendEXT = loadFunction<GlMultiTexGendEXTNative>(lib, 'glMultiTexGendEXT').asFunction<GlMultiTexGendEXT>();
  glMultiTexGendvEXT = loadFunction<GlMultiTexGendvEXTNative>(lib, 'glMultiTexGendvEXT').asFunction<GlMultiTexGendvEXT>();
  glMultiTexGenfEXT = loadFunction<GlMultiTexGenfEXTNative>(lib, 'glMultiTexGenfEXT').asFunction<GlMultiTexGenfEXT>();
  glMultiTexGenfvEXT = loadFunction<GlMultiTexGenfvEXTNative>(lib, 'glMultiTexGenfvEXT').asFunction<GlMultiTexGenfvEXT>();
  glMultiTexGeniEXT = loadFunction<GlMultiTexGeniEXTNative>(lib, 'glMultiTexGeniEXT').asFunction<GlMultiTexGeniEXT>();
  glMultiTexGenivEXT = loadFunction<GlMultiTexGenivEXTNative>(lib, 'glMultiTexGenivEXT').asFunction<GlMultiTexGenivEXT>();
  glGetMultiTexEnvfvEXT = loadFunction<GlGetMultiTexEnvfvEXTNative>(lib, 'glGetMultiTexEnvfvEXT').asFunction<GlGetMultiTexEnvfvEXT>();
  glGetMultiTexEnvivEXT = loadFunction<GlGetMultiTexEnvivEXTNative>(lib, 'glGetMultiTexEnvivEXT').asFunction<GlGetMultiTexEnvivEXT>();
  glGetMultiTexGendvEXT = loadFunction<GlGetMultiTexGendvEXTNative>(lib, 'glGetMultiTexGendvEXT').asFunction<GlGetMultiTexGendvEXT>();
  glGetMultiTexGenfvEXT = loadFunction<GlGetMultiTexGenfvEXTNative>(lib, 'glGetMultiTexGenfvEXT').asFunction<GlGetMultiTexGenfvEXT>();
  glGetMultiTexGenivEXT = loadFunction<GlGetMultiTexGenivEXTNative>(lib, 'glGetMultiTexGenivEXT').asFunction<GlGetMultiTexGenivEXT>();
  glMultiTexParameteriEXT = loadFunction<GlMultiTexParameteriEXTNative>(lib, 'glMultiTexParameteriEXT').asFunction<GlMultiTexParameteriEXT>();
  glMultiTexParameterivEXT = loadFunction<GlMultiTexParameterivEXTNative>(lib, 'glMultiTexParameterivEXT').asFunction<GlMultiTexParameterivEXT>();
  glMultiTexParameterfEXT = loadFunction<GlMultiTexParameterfEXTNative>(lib, 'glMultiTexParameterfEXT').asFunction<GlMultiTexParameterfEXT>();
  glMultiTexParameterfvEXT = loadFunction<GlMultiTexParameterfvEXTNative>(lib, 'glMultiTexParameterfvEXT').asFunction<GlMultiTexParameterfvEXT>();
  glMultiTexImage1DEXT = loadFunction<GlMultiTexImage1DEXTNative>(lib, 'glMultiTexImage1DEXT').asFunction<GlMultiTexImage1DEXT>();
  glMultiTexImage2DEXT = loadFunction<GlMultiTexImage2DEXTNative>(lib, 'glMultiTexImage2DEXT').asFunction<GlMultiTexImage2DEXT>();
  glMultiTexSubImage1DEXT = loadFunction<GlMultiTexSubImage1DEXTNative>(lib, 'glMultiTexSubImage1DEXT').asFunction<GlMultiTexSubImage1DEXT>();
  glMultiTexSubImage2DEXT = loadFunction<GlMultiTexSubImage2DEXTNative>(lib, 'glMultiTexSubImage2DEXT').asFunction<GlMultiTexSubImage2DEXT>();
  glCopyMultiTexImage1DEXT = loadFunction<GlCopyMultiTexImage1DEXTNative>(lib, 'glCopyMultiTexImage1DEXT').asFunction<GlCopyMultiTexImage1DEXT>();
  glCopyMultiTexImage2DEXT = loadFunction<GlCopyMultiTexImage2DEXTNative>(lib, 'glCopyMultiTexImage2DEXT').asFunction<GlCopyMultiTexImage2DEXT>();
  glCopyMultiTexSubImage1DEXT = loadFunction<GlCopyMultiTexSubImage1DEXTNative>(lib, 'glCopyMultiTexSubImage1DEXT').asFunction<GlCopyMultiTexSubImage1DEXT>();
  glCopyMultiTexSubImage2DEXT = loadFunction<GlCopyMultiTexSubImage2DEXTNative>(lib, 'glCopyMultiTexSubImage2DEXT').asFunction<GlCopyMultiTexSubImage2DEXT>();
  glGetMultiTexImageEXT = loadFunction<GlGetMultiTexImageEXTNative>(lib, 'glGetMultiTexImageEXT').asFunction<GlGetMultiTexImageEXT>();
  glGetMultiTexParameterfvEXT = loadFunction<GlGetMultiTexParameterfvEXTNative>(lib, 'glGetMultiTexParameterfvEXT').asFunction<GlGetMultiTexParameterfvEXT>();
  glGetMultiTexParameterivEXT = loadFunction<GlGetMultiTexParameterivEXTNative>(lib, 'glGetMultiTexParameterivEXT').asFunction<GlGetMultiTexParameterivEXT>();
  glGetMultiTexLevelParameterfvEXT = loadFunction<GlGetMultiTexLevelParameterfvEXTNative>(lib, 'glGetMultiTexLevelParameterfvEXT').asFunction<GlGetMultiTexLevelParameterfvEXT>();
  glGetMultiTexLevelParameterivEXT = loadFunction<GlGetMultiTexLevelParameterivEXTNative>(lib, 'glGetMultiTexLevelParameterivEXT').asFunction<GlGetMultiTexLevelParameterivEXT>();
  glMultiTexImage3DEXT = loadFunction<GlMultiTexImage3DEXTNative>(lib, 'glMultiTexImage3DEXT').asFunction<GlMultiTexImage3DEXT>();
  glMultiTexSubImage3DEXT = loadFunction<GlMultiTexSubImage3DEXTNative>(lib, 'glMultiTexSubImage3DEXT').asFunction<GlMultiTexSubImage3DEXT>();
  glCopyMultiTexSubImage3DEXT = loadFunction<GlCopyMultiTexSubImage3DEXTNative>(lib, 'glCopyMultiTexSubImage3DEXT').asFunction<GlCopyMultiTexSubImage3DEXT>();
  glEnableClientStateIndexedEXT = loadFunction<GlEnableClientStateIndexedEXTNative>(lib, 'glEnableClientStateIndexedEXT').asFunction<GlEnableClientStateIndexedEXT>();
  glDisableClientStateIndexedEXT = loadFunction<GlDisableClientStateIndexedEXTNative>(lib, 'glDisableClientStateIndexedEXT').asFunction<GlDisableClientStateIndexedEXT>();
  glGetFloatIndexedvEXT = loadFunction<GlGetFloatIndexedvEXTNative>(lib, 'glGetFloatIndexedvEXT').asFunction<GlGetFloatIndexedvEXT>();
  glGetDoubleIndexedvEXT = loadFunction<GlGetDoubleIndexedvEXTNative>(lib, 'glGetDoubleIndexedvEXT').asFunction<GlGetDoubleIndexedvEXT>();
  glGetPointerIndexedvEXT = loadFunction<GlGetPointerIndexedvEXTNative>(lib, 'glGetPointerIndexedvEXT').asFunction<GlGetPointerIndexedvEXT>();
  glEnableIndexedEXT = loadFunction<GlEnableIndexedEXTNative>(lib, 'glEnableIndexedEXT').asFunction<GlEnableIndexedEXT>();
  glDisableIndexedEXT = loadFunction<GlDisableIndexedEXTNative>(lib, 'glDisableIndexedEXT').asFunction<GlDisableIndexedEXT>();
  glIsEnabledIndexedEXT = loadFunction<GlIsEnabledIndexedEXTNative>(lib, 'glIsEnabledIndexedEXT').asFunction<GlIsEnabledIndexedEXT>();
  glGetIntegerIndexedvEXT = loadFunction<GlGetIntegerIndexedvEXTNative>(lib, 'glGetIntegerIndexedvEXT').asFunction<GlGetIntegerIndexedvEXT>();
  glGetBooleanIndexedvEXT = loadFunction<GlGetBooleanIndexedvEXTNative>(lib, 'glGetBooleanIndexedvEXT').asFunction<GlGetBooleanIndexedvEXT>();
  glCompressedTextureImage3DEXT = loadFunction<GlCompressedTextureImage3DEXTNative>(lib, 'glCompressedTextureImage3DEXT').asFunction<GlCompressedTextureImage3DEXT>();
  glCompressedTextureImage2DEXT = loadFunction<GlCompressedTextureImage2DEXTNative>(lib, 'glCompressedTextureImage2DEXT').asFunction<GlCompressedTextureImage2DEXT>();
  glCompressedTextureImage1DEXT = loadFunction<GlCompressedTextureImage1DEXTNative>(lib, 'glCompressedTextureImage1DEXT').asFunction<GlCompressedTextureImage1DEXT>();
  glCompressedTextureSubImage3DEXT = loadFunction<GlCompressedTextureSubImage3DEXTNative>(lib, 'glCompressedTextureSubImage3DEXT').asFunction<GlCompressedTextureSubImage3DEXT>();
  glCompressedTextureSubImage2DEXT = loadFunction<GlCompressedTextureSubImage2DEXTNative>(lib, 'glCompressedTextureSubImage2DEXT').asFunction<GlCompressedTextureSubImage2DEXT>();
  glCompressedTextureSubImage1DEXT = loadFunction<GlCompressedTextureSubImage1DEXTNative>(lib, 'glCompressedTextureSubImage1DEXT').asFunction<GlCompressedTextureSubImage1DEXT>();
  glGetCompressedTextureImageEXT = loadFunction<GlGetCompressedTextureImageEXTNative>(lib, 'glGetCompressedTextureImageEXT').asFunction<GlGetCompressedTextureImageEXT>();
  glCompressedMultiTexImage3DEXT = loadFunction<GlCompressedMultiTexImage3DEXTNative>(lib, 'glCompressedMultiTexImage3DEXT').asFunction<GlCompressedMultiTexImage3DEXT>();
  glCompressedMultiTexImage2DEXT = loadFunction<GlCompressedMultiTexImage2DEXTNative>(lib, 'glCompressedMultiTexImage2DEXT').asFunction<GlCompressedMultiTexImage2DEXT>();
  glCompressedMultiTexImage1DEXT = loadFunction<GlCompressedMultiTexImage1DEXTNative>(lib, 'glCompressedMultiTexImage1DEXT').asFunction<GlCompressedMultiTexImage1DEXT>();
  glCompressedMultiTexSubImage3DEXT = loadFunction<GlCompressedMultiTexSubImage3DEXTNative>(lib, 'glCompressedMultiTexSubImage3DEXT').asFunction<GlCompressedMultiTexSubImage3DEXT>();
  glCompressedMultiTexSubImage2DEXT = loadFunction<GlCompressedMultiTexSubImage2DEXTNative>(lib, 'glCompressedMultiTexSubImage2DEXT').asFunction<GlCompressedMultiTexSubImage2DEXT>();
  glCompressedMultiTexSubImage1DEXT = loadFunction<GlCompressedMultiTexSubImage1DEXTNative>(lib, 'glCompressedMultiTexSubImage1DEXT').asFunction<GlCompressedMultiTexSubImage1DEXT>();
  glGetCompressedMultiTexImageEXT = loadFunction<GlGetCompressedMultiTexImageEXTNative>(lib, 'glGetCompressedMultiTexImageEXT').asFunction<GlGetCompressedMultiTexImageEXT>();
  glMatrixLoadTransposefEXT = loadFunction<GlMatrixLoadTransposefEXTNative>(lib, 'glMatrixLoadTransposefEXT').asFunction<GlMatrixLoadTransposefEXT>();
  glMatrixLoadTransposedEXT = loadFunction<GlMatrixLoadTransposedEXTNative>(lib, 'glMatrixLoadTransposedEXT').asFunction<GlMatrixLoadTransposedEXT>();
  glMatrixMultTransposefEXT = loadFunction<GlMatrixMultTransposefEXTNative>(lib, 'glMatrixMultTransposefEXT').asFunction<GlMatrixMultTransposefEXT>();
  glMatrixMultTransposedEXT = loadFunction<GlMatrixMultTransposedEXTNative>(lib, 'glMatrixMultTransposedEXT').asFunction<GlMatrixMultTransposedEXT>();
  glNamedBufferDataEXT = loadFunction<GlNamedBufferDataEXTNative>(lib, 'glNamedBufferDataEXT').asFunction<GlNamedBufferDataEXT>();
  glNamedBufferSubDataEXT = loadFunction<GlNamedBufferSubDataEXTNative>(lib, 'glNamedBufferSubDataEXT').asFunction<GlNamedBufferSubDataEXT>();
  glMapNamedBufferEXT = loadFunction<GlMapNamedBufferEXTNative>(lib, 'glMapNamedBufferEXT').asFunction<GlMapNamedBufferEXT>();
  glUnmapNamedBufferEXT = loadFunction<GlUnmapNamedBufferEXTNative>(lib, 'glUnmapNamedBufferEXT').asFunction<GlUnmapNamedBufferEXT>();
  glGetNamedBufferParameterivEXT = loadFunction<GlGetNamedBufferParameterivEXTNative>(lib, 'glGetNamedBufferParameterivEXT').asFunction<GlGetNamedBufferParameterivEXT>();
  glGetNamedBufferPointervEXT = loadFunction<GlGetNamedBufferPointervEXTNative>(lib, 'glGetNamedBufferPointervEXT').asFunction<GlGetNamedBufferPointervEXT>();
  glGetNamedBufferSubDataEXT = loadFunction<GlGetNamedBufferSubDataEXTNative>(lib, 'glGetNamedBufferSubDataEXT').asFunction<GlGetNamedBufferSubDataEXT>();
  glProgramUniform1fEXT = loadFunction<GlProgramUniform1fEXTNative>(lib, 'glProgramUniform1fEXT').asFunction<GlProgramUniform1fEXT>();
  glProgramUniform2fEXT = loadFunction<GlProgramUniform2fEXTNative>(lib, 'glProgramUniform2fEXT').asFunction<GlProgramUniform2fEXT>();
  glProgramUniform3fEXT = loadFunction<GlProgramUniform3fEXTNative>(lib, 'glProgramUniform3fEXT').asFunction<GlProgramUniform3fEXT>();
  glProgramUniform4fEXT = loadFunction<GlProgramUniform4fEXTNative>(lib, 'glProgramUniform4fEXT').asFunction<GlProgramUniform4fEXT>();
  glProgramUniform1iEXT = loadFunction<GlProgramUniform1iEXTNative>(lib, 'glProgramUniform1iEXT').asFunction<GlProgramUniform1iEXT>();
  glProgramUniform2iEXT = loadFunction<GlProgramUniform2iEXTNative>(lib, 'glProgramUniform2iEXT').asFunction<GlProgramUniform2iEXT>();
  glProgramUniform3iEXT = loadFunction<GlProgramUniform3iEXTNative>(lib, 'glProgramUniform3iEXT').asFunction<GlProgramUniform3iEXT>();
  glProgramUniform4iEXT = loadFunction<GlProgramUniform4iEXTNative>(lib, 'glProgramUniform4iEXT').asFunction<GlProgramUniform4iEXT>();
  glProgramUniform1fvEXT = loadFunction<GlProgramUniform1fvEXTNative>(lib, 'glProgramUniform1fvEXT').asFunction<GlProgramUniform1fvEXT>();
  glProgramUniform2fvEXT = loadFunction<GlProgramUniform2fvEXTNative>(lib, 'glProgramUniform2fvEXT').asFunction<GlProgramUniform2fvEXT>();
  glProgramUniform3fvEXT = loadFunction<GlProgramUniform3fvEXTNative>(lib, 'glProgramUniform3fvEXT').asFunction<GlProgramUniform3fvEXT>();
  glProgramUniform4fvEXT = loadFunction<GlProgramUniform4fvEXTNative>(lib, 'glProgramUniform4fvEXT').asFunction<GlProgramUniform4fvEXT>();
  glProgramUniform1ivEXT = loadFunction<GlProgramUniform1ivEXTNative>(lib, 'glProgramUniform1ivEXT').asFunction<GlProgramUniform1ivEXT>();
  glProgramUniform2ivEXT = loadFunction<GlProgramUniform2ivEXTNative>(lib, 'glProgramUniform2ivEXT').asFunction<GlProgramUniform2ivEXT>();
  glProgramUniform3ivEXT = loadFunction<GlProgramUniform3ivEXTNative>(lib, 'glProgramUniform3ivEXT').asFunction<GlProgramUniform3ivEXT>();
  glProgramUniform4ivEXT = loadFunction<GlProgramUniform4ivEXTNative>(lib, 'glProgramUniform4ivEXT').asFunction<GlProgramUniform4ivEXT>();
  glProgramUniformMatrix2fvEXT = loadFunction<GlProgramUniformMatrix2fvEXTNative>(lib, 'glProgramUniformMatrix2fvEXT').asFunction<GlProgramUniformMatrix2fvEXT>();
  glProgramUniformMatrix3fvEXT = loadFunction<GlProgramUniformMatrix3fvEXTNative>(lib, 'glProgramUniformMatrix3fvEXT').asFunction<GlProgramUniformMatrix3fvEXT>();
  glProgramUniformMatrix4fvEXT = loadFunction<GlProgramUniformMatrix4fvEXTNative>(lib, 'glProgramUniformMatrix4fvEXT').asFunction<GlProgramUniformMatrix4fvEXT>();
  glProgramUniformMatrix2x3fvEXT = loadFunction<GlProgramUniformMatrix2x3fvEXTNative>(lib, 'glProgramUniformMatrix2x3fvEXT').asFunction<GlProgramUniformMatrix2x3fvEXT>();
  glProgramUniformMatrix3x2fvEXT = loadFunction<GlProgramUniformMatrix3x2fvEXTNative>(lib, 'glProgramUniformMatrix3x2fvEXT').asFunction<GlProgramUniformMatrix3x2fvEXT>();
  glProgramUniformMatrix2x4fvEXT = loadFunction<GlProgramUniformMatrix2x4fvEXTNative>(lib, 'glProgramUniformMatrix2x4fvEXT').asFunction<GlProgramUniformMatrix2x4fvEXT>();
  glProgramUniformMatrix4x2fvEXT = loadFunction<GlProgramUniformMatrix4x2fvEXTNative>(lib, 'glProgramUniformMatrix4x2fvEXT').asFunction<GlProgramUniformMatrix4x2fvEXT>();
  glProgramUniformMatrix3x4fvEXT = loadFunction<GlProgramUniformMatrix3x4fvEXTNative>(lib, 'glProgramUniformMatrix3x4fvEXT').asFunction<GlProgramUniformMatrix3x4fvEXT>();
  glProgramUniformMatrix4x3fvEXT = loadFunction<GlProgramUniformMatrix4x3fvEXTNative>(lib, 'glProgramUniformMatrix4x3fvEXT').asFunction<GlProgramUniformMatrix4x3fvEXT>();
  glTextureBufferEXT = loadFunction<GlTextureBufferEXTNative>(lib, 'glTextureBufferEXT').asFunction<GlTextureBufferEXT>();
  glMultiTexBufferEXT = loadFunction<GlMultiTexBufferEXTNative>(lib, 'glMultiTexBufferEXT').asFunction<GlMultiTexBufferEXT>();
  glTextureParameterIivEXT = loadFunction<GlTextureParameterIivEXTNative>(lib, 'glTextureParameterIivEXT').asFunction<GlTextureParameterIivEXT>();
  glTextureParameterIuivEXT = loadFunction<GlTextureParameterIuivEXTNative>(lib, 'glTextureParameterIuivEXT').asFunction<GlTextureParameterIuivEXT>();
  glGetTextureParameterIivEXT = loadFunction<GlGetTextureParameterIivEXTNative>(lib, 'glGetTextureParameterIivEXT').asFunction<GlGetTextureParameterIivEXT>();
  glGetTextureParameterIuivEXT = loadFunction<GlGetTextureParameterIuivEXTNative>(lib, 'glGetTextureParameterIuivEXT').asFunction<GlGetTextureParameterIuivEXT>();
  glMultiTexParameterIivEXT = loadFunction<GlMultiTexParameterIivEXTNative>(lib, 'glMultiTexParameterIivEXT').asFunction<GlMultiTexParameterIivEXT>();
  glMultiTexParameterIuivEXT = loadFunction<GlMultiTexParameterIuivEXTNative>(lib, 'glMultiTexParameterIuivEXT').asFunction<GlMultiTexParameterIuivEXT>();
  glGetMultiTexParameterIivEXT = loadFunction<GlGetMultiTexParameterIivEXTNative>(lib, 'glGetMultiTexParameterIivEXT').asFunction<GlGetMultiTexParameterIivEXT>();
  glGetMultiTexParameterIuivEXT = loadFunction<GlGetMultiTexParameterIuivEXTNative>(lib, 'glGetMultiTexParameterIuivEXT').asFunction<GlGetMultiTexParameterIuivEXT>();
  glProgramUniform1uiEXT = loadFunction<GlProgramUniform1uiEXTNative>(lib, 'glProgramUniform1uiEXT').asFunction<GlProgramUniform1uiEXT>();
  glProgramUniform2uiEXT = loadFunction<GlProgramUniform2uiEXTNative>(lib, 'glProgramUniform2uiEXT').asFunction<GlProgramUniform2uiEXT>();
  glProgramUniform3uiEXT = loadFunction<GlProgramUniform3uiEXTNative>(lib, 'glProgramUniform3uiEXT').asFunction<GlProgramUniform3uiEXT>();
  glProgramUniform4uiEXT = loadFunction<GlProgramUniform4uiEXTNative>(lib, 'glProgramUniform4uiEXT').asFunction<GlProgramUniform4uiEXT>();
  glProgramUniform1uivEXT = loadFunction<GlProgramUniform1uivEXTNative>(lib, 'glProgramUniform1uivEXT').asFunction<GlProgramUniform1uivEXT>();
  glProgramUniform2uivEXT = loadFunction<GlProgramUniform2uivEXTNative>(lib, 'glProgramUniform2uivEXT').asFunction<GlProgramUniform2uivEXT>();
  glProgramUniform3uivEXT = loadFunction<GlProgramUniform3uivEXTNative>(lib, 'glProgramUniform3uivEXT').asFunction<GlProgramUniform3uivEXT>();
  glProgramUniform4uivEXT = loadFunction<GlProgramUniform4uivEXTNative>(lib, 'glProgramUniform4uivEXT').asFunction<GlProgramUniform4uivEXT>();
  glNamedProgramLocalParameters4fvEXT = loadFunction<GlNamedProgramLocalParameters4fvEXTNative>(lib, 'glNamedProgramLocalParameters4fvEXT').asFunction<GlNamedProgramLocalParameters4fvEXT>();
  glNamedProgramLocalParameterI4iEXT = loadFunction<GlNamedProgramLocalParameterI4iEXTNative>(lib, 'glNamedProgramLocalParameterI4iEXT').asFunction<GlNamedProgramLocalParameterI4iEXT>();
  glNamedProgramLocalParameterI4ivEXT = loadFunction<GlNamedProgramLocalParameterI4ivEXTNative>(lib, 'glNamedProgramLocalParameterI4ivEXT').asFunction<GlNamedProgramLocalParameterI4ivEXT>();
  glNamedProgramLocalParametersI4ivEXT = loadFunction<GlNamedProgramLocalParametersI4ivEXTNative>(lib, 'glNamedProgramLocalParametersI4ivEXT').asFunction<GlNamedProgramLocalParametersI4ivEXT>();
  glNamedProgramLocalParameterI4uiEXT = loadFunction<GlNamedProgramLocalParameterI4uiEXTNative>(lib, 'glNamedProgramLocalParameterI4uiEXT').asFunction<GlNamedProgramLocalParameterI4uiEXT>();
  glNamedProgramLocalParameterI4uivEXT = loadFunction<GlNamedProgramLocalParameterI4uivEXTNative>(lib, 'glNamedProgramLocalParameterI4uivEXT').asFunction<GlNamedProgramLocalParameterI4uivEXT>();
  glNamedProgramLocalParametersI4uivEXT = loadFunction<GlNamedProgramLocalParametersI4uivEXTNative>(lib, 'glNamedProgramLocalParametersI4uivEXT').asFunction<GlNamedProgramLocalParametersI4uivEXT>();
  glGetNamedProgramLocalParameterIivEXT = loadFunction<GlGetNamedProgramLocalParameterIivEXTNative>(lib, 'glGetNamedProgramLocalParameterIivEXT').asFunction<GlGetNamedProgramLocalParameterIivEXT>();
  glGetNamedProgramLocalParameterIuivEXT = loadFunction<GlGetNamedProgramLocalParameterIuivEXTNative>(lib, 'glGetNamedProgramLocalParameterIuivEXT').asFunction<GlGetNamedProgramLocalParameterIuivEXT>();
  glEnableClientStateiEXT = loadFunction<GlEnableClientStateiEXTNative>(lib, 'glEnableClientStateiEXT').asFunction<GlEnableClientStateiEXT>();
  glDisableClientStateiEXT = loadFunction<GlDisableClientStateiEXTNative>(lib, 'glDisableClientStateiEXT').asFunction<GlDisableClientStateiEXT>();
  glGetFloati_vEXT = loadFunction<GlGetFloati_vEXTNative>(lib, 'glGetFloati_vEXT').asFunction<GlGetFloati_vEXT>();
  glGetDoublei_vEXT = loadFunction<GlGetDoublei_vEXTNative>(lib, 'glGetDoublei_vEXT').asFunction<GlGetDoublei_vEXT>();
  glGetPointeri_vEXT = loadFunction<GlGetPointeri_vEXTNative>(lib, 'glGetPointeri_vEXT').asFunction<GlGetPointeri_vEXT>();
  glNamedProgramStringEXT = loadFunction<GlNamedProgramStringEXTNative>(lib, 'glNamedProgramStringEXT').asFunction<GlNamedProgramStringEXT>();
  glNamedProgramLocalParameter4dEXT = loadFunction<GlNamedProgramLocalParameter4dEXTNative>(lib, 'glNamedProgramLocalParameter4dEXT').asFunction<GlNamedProgramLocalParameter4dEXT>();
  glNamedProgramLocalParameter4dvEXT = loadFunction<GlNamedProgramLocalParameter4dvEXTNative>(lib, 'glNamedProgramLocalParameter4dvEXT').asFunction<GlNamedProgramLocalParameter4dvEXT>();
  glNamedProgramLocalParameter4fEXT = loadFunction<GlNamedProgramLocalParameter4fEXTNative>(lib, 'glNamedProgramLocalParameter4fEXT').asFunction<GlNamedProgramLocalParameter4fEXT>();
  glNamedProgramLocalParameter4fvEXT = loadFunction<GlNamedProgramLocalParameter4fvEXTNative>(lib, 'glNamedProgramLocalParameter4fvEXT').asFunction<GlNamedProgramLocalParameter4fvEXT>();
  glGetNamedProgramLocalParameterdvEXT = loadFunction<GlGetNamedProgramLocalParameterdvEXTNative>(lib, 'glGetNamedProgramLocalParameterdvEXT').asFunction<GlGetNamedProgramLocalParameterdvEXT>();
  glGetNamedProgramLocalParameterfvEXT = loadFunction<GlGetNamedProgramLocalParameterfvEXTNative>(lib, 'glGetNamedProgramLocalParameterfvEXT').asFunction<GlGetNamedProgramLocalParameterfvEXT>();
  glGetNamedProgramivEXT = loadFunction<GlGetNamedProgramivEXTNative>(lib, 'glGetNamedProgramivEXT').asFunction<GlGetNamedProgramivEXT>();
  glGetNamedProgramStringEXT = loadFunction<GlGetNamedProgramStringEXTNative>(lib, 'glGetNamedProgramStringEXT').asFunction<GlGetNamedProgramStringEXT>();
  glNamedRenderbufferStorageEXT = loadFunction<GlNamedRenderbufferStorageEXTNative>(lib, 'glNamedRenderbufferStorageEXT').asFunction<GlNamedRenderbufferStorageEXT>();
  glGetNamedRenderbufferParameterivEXT = loadFunction<GlGetNamedRenderbufferParameterivEXTNative>(lib, 'glGetNamedRenderbufferParameterivEXT').asFunction<GlGetNamedRenderbufferParameterivEXT>();
  glNamedRenderbufferStorageMultisampleEXT = loadFunction<GlNamedRenderbufferStorageMultisampleEXTNative>(lib, 'glNamedRenderbufferStorageMultisampleEXT').asFunction<GlNamedRenderbufferStorageMultisampleEXT>();
  glNamedRenderbufferStorageMultisampleCoverageEXT = loadFunction<GlNamedRenderbufferStorageMultisampleCoverageEXTNative>(lib, 'glNamedRenderbufferStorageMultisampleCoverageEXT').asFunction<GlNamedRenderbufferStorageMultisampleCoverageEXT>();
  glCheckNamedFramebufferStatusEXT = loadFunction<GlCheckNamedFramebufferStatusEXTNative>(lib, 'glCheckNamedFramebufferStatusEXT').asFunction<GlCheckNamedFramebufferStatusEXT>();
  glNamedFramebufferTexture1DEXT = loadFunction<GlNamedFramebufferTexture1DEXTNative>(lib, 'glNamedFramebufferTexture1DEXT').asFunction<GlNamedFramebufferTexture1DEXT>();
  glNamedFramebufferTexture2DEXT = loadFunction<GlNamedFramebufferTexture2DEXTNative>(lib, 'glNamedFramebufferTexture2DEXT').asFunction<GlNamedFramebufferTexture2DEXT>();
  glNamedFramebufferTexture3DEXT = loadFunction<GlNamedFramebufferTexture3DEXTNative>(lib, 'glNamedFramebufferTexture3DEXT').asFunction<GlNamedFramebufferTexture3DEXT>();
  glNamedFramebufferRenderbufferEXT = loadFunction<GlNamedFramebufferRenderbufferEXTNative>(lib, 'glNamedFramebufferRenderbufferEXT').asFunction<GlNamedFramebufferRenderbufferEXT>();
  glGetNamedFramebufferAttachmentParameterivEXT = loadFunction<GlGetNamedFramebufferAttachmentParameterivEXTNative>(lib, 'glGetNamedFramebufferAttachmentParameterivEXT').asFunction<GlGetNamedFramebufferAttachmentParameterivEXT>();
  glGenerateTextureMipmapEXT = loadFunction<GlGenerateTextureMipmapEXTNative>(lib, 'glGenerateTextureMipmapEXT').asFunction<GlGenerateTextureMipmapEXT>();
  glGenerateMultiTexMipmapEXT = loadFunction<GlGenerateMultiTexMipmapEXTNative>(lib, 'glGenerateMultiTexMipmapEXT').asFunction<GlGenerateMultiTexMipmapEXT>();
  glFramebufferDrawBufferEXT = loadFunction<GlFramebufferDrawBufferEXTNative>(lib, 'glFramebufferDrawBufferEXT').asFunction<GlFramebufferDrawBufferEXT>();
  glFramebufferDrawBuffersEXT = loadFunction<GlFramebufferDrawBuffersEXTNative>(lib, 'glFramebufferDrawBuffersEXT').asFunction<GlFramebufferDrawBuffersEXT>();
  glFramebufferReadBufferEXT = loadFunction<GlFramebufferReadBufferEXTNative>(lib, 'glFramebufferReadBufferEXT').asFunction<GlFramebufferReadBufferEXT>();
  glGetFramebufferParameterivEXT = loadFunction<GlGetFramebufferParameterivEXTNative>(lib, 'glGetFramebufferParameterivEXT').asFunction<GlGetFramebufferParameterivEXT>();
  glNamedCopyBufferSubDataEXT = loadFunction<GlNamedCopyBufferSubDataEXTNative>(lib, 'glNamedCopyBufferSubDataEXT').asFunction<GlNamedCopyBufferSubDataEXT>();
  glNamedFramebufferTextureEXT = loadFunction<GlNamedFramebufferTextureEXTNative>(lib, 'glNamedFramebufferTextureEXT').asFunction<GlNamedFramebufferTextureEXT>();
  glNamedFramebufferTextureLayerEXT = loadFunction<GlNamedFramebufferTextureLayerEXTNative>(lib, 'glNamedFramebufferTextureLayerEXT').asFunction<GlNamedFramebufferTextureLayerEXT>();
  glNamedFramebufferTextureFaceEXT = loadFunction<GlNamedFramebufferTextureFaceEXTNative>(lib, 'glNamedFramebufferTextureFaceEXT').asFunction<GlNamedFramebufferTextureFaceEXT>();
  glTextureRenderbufferEXT = loadFunction<GlTextureRenderbufferEXTNative>(lib, 'glTextureRenderbufferEXT').asFunction<GlTextureRenderbufferEXT>();
  glMultiTexRenderbufferEXT = loadFunction<GlMultiTexRenderbufferEXTNative>(lib, 'glMultiTexRenderbufferEXT').asFunction<GlMultiTexRenderbufferEXT>();
  glVertexArrayVertexOffsetEXT = loadFunction<GlVertexArrayVertexOffsetEXTNative>(lib, 'glVertexArrayVertexOffsetEXT').asFunction<GlVertexArrayVertexOffsetEXT>();
  glVertexArrayColorOffsetEXT = loadFunction<GlVertexArrayColorOffsetEXTNative>(lib, 'glVertexArrayColorOffsetEXT').asFunction<GlVertexArrayColorOffsetEXT>();
  glVertexArrayEdgeFlagOffsetEXT = loadFunction<GlVertexArrayEdgeFlagOffsetEXTNative>(lib, 'glVertexArrayEdgeFlagOffsetEXT').asFunction<GlVertexArrayEdgeFlagOffsetEXT>();
  glVertexArrayIndexOffsetEXT = loadFunction<GlVertexArrayIndexOffsetEXTNative>(lib, 'glVertexArrayIndexOffsetEXT').asFunction<GlVertexArrayIndexOffsetEXT>();
  glVertexArrayNormalOffsetEXT = loadFunction<GlVertexArrayNormalOffsetEXTNative>(lib, 'glVertexArrayNormalOffsetEXT').asFunction<GlVertexArrayNormalOffsetEXT>();
  glVertexArrayTexCoordOffsetEXT = loadFunction<GlVertexArrayTexCoordOffsetEXTNative>(lib, 'glVertexArrayTexCoordOffsetEXT').asFunction<GlVertexArrayTexCoordOffsetEXT>();
  glVertexArrayMultiTexCoordOffsetEXT = loadFunction<GlVertexArrayMultiTexCoordOffsetEXTNative>(lib, 'glVertexArrayMultiTexCoordOffsetEXT').asFunction<GlVertexArrayMultiTexCoordOffsetEXT>();
  glVertexArrayFogCoordOffsetEXT = loadFunction<GlVertexArrayFogCoordOffsetEXTNative>(lib, 'glVertexArrayFogCoordOffsetEXT').asFunction<GlVertexArrayFogCoordOffsetEXT>();
  glVertexArraySecondaryColorOffsetEXT = loadFunction<GlVertexArraySecondaryColorOffsetEXTNative>(lib, 'glVertexArraySecondaryColorOffsetEXT').asFunction<GlVertexArraySecondaryColorOffsetEXT>();
  glVertexArrayVertexAttribOffsetEXT = loadFunction<GlVertexArrayVertexAttribOffsetEXTNative>(lib, 'glVertexArrayVertexAttribOffsetEXT').asFunction<GlVertexArrayVertexAttribOffsetEXT>();
  glVertexArrayVertexAttribIOffsetEXT = loadFunction<GlVertexArrayVertexAttribIOffsetEXTNative>(lib, 'glVertexArrayVertexAttribIOffsetEXT').asFunction<GlVertexArrayVertexAttribIOffsetEXT>();
  glEnableVertexArrayEXT = loadFunction<GlEnableVertexArrayEXTNative>(lib, 'glEnableVertexArrayEXT').asFunction<GlEnableVertexArrayEXT>();
  glDisableVertexArrayEXT = loadFunction<GlDisableVertexArrayEXTNative>(lib, 'glDisableVertexArrayEXT').asFunction<GlDisableVertexArrayEXT>();
  glEnableVertexArrayAttribEXT = loadFunction<GlEnableVertexArrayAttribEXTNative>(lib, 'glEnableVertexArrayAttribEXT').asFunction<GlEnableVertexArrayAttribEXT>();
  glDisableVertexArrayAttribEXT = loadFunction<GlDisableVertexArrayAttribEXTNative>(lib, 'glDisableVertexArrayAttribEXT').asFunction<GlDisableVertexArrayAttribEXT>();
  glGetVertexArrayIntegervEXT = loadFunction<GlGetVertexArrayIntegervEXTNative>(lib, 'glGetVertexArrayIntegervEXT').asFunction<GlGetVertexArrayIntegervEXT>();
  glGetVertexArrayPointervEXT = loadFunction<GlGetVertexArrayPointervEXTNative>(lib, 'glGetVertexArrayPointervEXT').asFunction<GlGetVertexArrayPointervEXT>();
  glGetVertexArrayIntegeri_vEXT = loadFunction<GlGetVertexArrayIntegeri_vEXTNative>(lib, 'glGetVertexArrayIntegeri_vEXT').asFunction<GlGetVertexArrayIntegeri_vEXT>();
  glGetVertexArrayPointeri_vEXT = loadFunction<GlGetVertexArrayPointeri_vEXTNative>(lib, 'glGetVertexArrayPointeri_vEXT').asFunction<GlGetVertexArrayPointeri_vEXT>();
  glMapNamedBufferRangeEXT = loadFunction<GlMapNamedBufferRangeEXTNative>(lib, 'glMapNamedBufferRangeEXT').asFunction<GlMapNamedBufferRangeEXT>();
  glFlushMappedNamedBufferRangeEXT = loadFunction<GlFlushMappedNamedBufferRangeEXTNative>(lib, 'glFlushMappedNamedBufferRangeEXT').asFunction<GlFlushMappedNamedBufferRangeEXT>();
  glNamedBufferStorageEXT = loadFunction<GlNamedBufferStorageEXTNative>(lib, 'glNamedBufferStorageEXT').asFunction<GlNamedBufferStorageEXT>();
  glClearNamedBufferDataEXT = loadFunction<GlClearNamedBufferDataEXTNative>(lib, 'glClearNamedBufferDataEXT').asFunction<GlClearNamedBufferDataEXT>();
  glClearNamedBufferSubDataEXT = loadFunction<GlClearNamedBufferSubDataEXTNative>(lib, 'glClearNamedBufferSubDataEXT').asFunction<GlClearNamedBufferSubDataEXT>();
  glNamedFramebufferParameteriEXT = loadFunction<GlNamedFramebufferParameteriEXTNative>(lib, 'glNamedFramebufferParameteriEXT').asFunction<GlNamedFramebufferParameteriEXT>();
  glGetNamedFramebufferParameterivEXT = loadFunction<GlGetNamedFramebufferParameterivEXTNative>(lib, 'glGetNamedFramebufferParameterivEXT').asFunction<GlGetNamedFramebufferParameterivEXT>();
  glProgramUniform1dEXT = loadFunction<GlProgramUniform1dEXTNative>(lib, 'glProgramUniform1dEXT').asFunction<GlProgramUniform1dEXT>();
  glProgramUniform2dEXT = loadFunction<GlProgramUniform2dEXTNative>(lib, 'glProgramUniform2dEXT').asFunction<GlProgramUniform2dEXT>();
  glProgramUniform3dEXT = loadFunction<GlProgramUniform3dEXTNative>(lib, 'glProgramUniform3dEXT').asFunction<GlProgramUniform3dEXT>();
  glProgramUniform4dEXT = loadFunction<GlProgramUniform4dEXTNative>(lib, 'glProgramUniform4dEXT').asFunction<GlProgramUniform4dEXT>();
  glProgramUniform1dvEXT = loadFunction<GlProgramUniform1dvEXTNative>(lib, 'glProgramUniform1dvEXT').asFunction<GlProgramUniform1dvEXT>();
  glProgramUniform2dvEXT = loadFunction<GlProgramUniform2dvEXTNative>(lib, 'glProgramUniform2dvEXT').asFunction<GlProgramUniform2dvEXT>();
  glProgramUniform3dvEXT = loadFunction<GlProgramUniform3dvEXTNative>(lib, 'glProgramUniform3dvEXT').asFunction<GlProgramUniform3dvEXT>();
  glProgramUniform4dvEXT = loadFunction<GlProgramUniform4dvEXTNative>(lib, 'glProgramUniform4dvEXT').asFunction<GlProgramUniform4dvEXT>();
  glProgramUniformMatrix2dvEXT = loadFunction<GlProgramUniformMatrix2dvEXTNative>(lib, 'glProgramUniformMatrix2dvEXT').asFunction<GlProgramUniformMatrix2dvEXT>();
  glProgramUniformMatrix3dvEXT = loadFunction<GlProgramUniformMatrix3dvEXTNative>(lib, 'glProgramUniformMatrix3dvEXT').asFunction<GlProgramUniformMatrix3dvEXT>();
  glProgramUniformMatrix4dvEXT = loadFunction<GlProgramUniformMatrix4dvEXTNative>(lib, 'glProgramUniformMatrix4dvEXT').asFunction<GlProgramUniformMatrix4dvEXT>();
  glProgramUniformMatrix2x3dvEXT = loadFunction<GlProgramUniformMatrix2x3dvEXTNative>(lib, 'glProgramUniformMatrix2x3dvEXT').asFunction<GlProgramUniformMatrix2x3dvEXT>();
  glProgramUniformMatrix2x4dvEXT = loadFunction<GlProgramUniformMatrix2x4dvEXTNative>(lib, 'glProgramUniformMatrix2x4dvEXT').asFunction<GlProgramUniformMatrix2x4dvEXT>();
  glProgramUniformMatrix3x2dvEXT = loadFunction<GlProgramUniformMatrix3x2dvEXTNative>(lib, 'glProgramUniformMatrix3x2dvEXT').asFunction<GlProgramUniformMatrix3x2dvEXT>();
  glProgramUniformMatrix3x4dvEXT = loadFunction<GlProgramUniformMatrix3x4dvEXTNative>(lib, 'glProgramUniformMatrix3x4dvEXT').asFunction<GlProgramUniformMatrix3x4dvEXT>();
  glProgramUniformMatrix4x2dvEXT = loadFunction<GlProgramUniformMatrix4x2dvEXTNative>(lib, 'glProgramUniformMatrix4x2dvEXT').asFunction<GlProgramUniformMatrix4x2dvEXT>();
  glProgramUniformMatrix4x3dvEXT = loadFunction<GlProgramUniformMatrix4x3dvEXTNative>(lib, 'glProgramUniformMatrix4x3dvEXT').asFunction<GlProgramUniformMatrix4x3dvEXT>();
  glTextureBufferRangeEXT = loadFunction<GlTextureBufferRangeEXTNative>(lib, 'glTextureBufferRangeEXT').asFunction<GlTextureBufferRangeEXT>();
  glTextureStorage1DEXT = loadFunction<GlTextureStorage1DEXTNative>(lib, 'glTextureStorage1DEXT').asFunction<GlTextureStorage1DEXT>();
  glTextureStorage2DEXT = loadFunction<GlTextureStorage2DEXTNative>(lib, 'glTextureStorage2DEXT').asFunction<GlTextureStorage2DEXT>();
  glTextureStorage3DEXT = loadFunction<GlTextureStorage3DEXTNative>(lib, 'glTextureStorage3DEXT').asFunction<GlTextureStorage3DEXT>();
  glTextureStorage2DMultisampleEXT = loadFunction<GlTextureStorage2DMultisampleEXTNative>(lib, 'glTextureStorage2DMultisampleEXT').asFunction<GlTextureStorage2DMultisampleEXT>();
  glTextureStorage3DMultisampleEXT = loadFunction<GlTextureStorage3DMultisampleEXTNative>(lib, 'glTextureStorage3DMultisampleEXT').asFunction<GlTextureStorage3DMultisampleEXT>();
  glVertexArrayBindVertexBufferEXT = loadFunction<GlVertexArrayBindVertexBufferEXTNative>(lib, 'glVertexArrayBindVertexBufferEXT').asFunction<GlVertexArrayBindVertexBufferEXT>();
  glVertexArrayVertexAttribFormatEXT = loadFunction<GlVertexArrayVertexAttribFormatEXTNative>(lib, 'glVertexArrayVertexAttribFormatEXT').asFunction<GlVertexArrayVertexAttribFormatEXT>();
  glVertexArrayVertexAttribIFormatEXT = loadFunction<GlVertexArrayVertexAttribIFormatEXTNative>(lib, 'glVertexArrayVertexAttribIFormatEXT').asFunction<GlVertexArrayVertexAttribIFormatEXT>();
  glVertexArrayVertexAttribLFormatEXT = loadFunction<GlVertexArrayVertexAttribLFormatEXTNative>(lib, 'glVertexArrayVertexAttribLFormatEXT').asFunction<GlVertexArrayVertexAttribLFormatEXT>();
  glVertexArrayVertexAttribBindingEXT = loadFunction<GlVertexArrayVertexAttribBindingEXTNative>(lib, 'glVertexArrayVertexAttribBindingEXT').asFunction<GlVertexArrayVertexAttribBindingEXT>();
  glVertexArrayVertexBindingDivisorEXT = loadFunction<GlVertexArrayVertexBindingDivisorEXTNative>(lib, 'glVertexArrayVertexBindingDivisorEXT').asFunction<GlVertexArrayVertexBindingDivisorEXT>();
  glVertexArrayVertexAttribLOffsetEXT = loadFunction<GlVertexArrayVertexAttribLOffsetEXTNative>(lib, 'glVertexArrayVertexAttribLOffsetEXT').asFunction<GlVertexArrayVertexAttribLOffsetEXT>();
  glTexturePageCommitmentEXT = loadFunction<GlTexturePageCommitmentEXTNative>(lib, 'glTexturePageCommitmentEXT').asFunction<GlTexturePageCommitmentEXT>();
  glVertexArrayVertexAttribDivisorEXT = loadFunction<GlVertexArrayVertexAttribDivisorEXTNative>(lib, 'glVertexArrayVertexAttribDivisorEXT').asFunction<GlVertexArrayVertexAttribDivisorEXT>();
  glDrawArraysInstancedEXT = loadFunction<GlDrawArraysInstancedEXTNative>(lib, 'glDrawArraysInstancedEXT').asFunction<GlDrawArraysInstancedEXT>();
  glDrawElementsInstancedEXT = loadFunction<GlDrawElementsInstancedEXTNative>(lib, 'glDrawElementsInstancedEXT').asFunction<GlDrawElementsInstancedEXT>();
  glPolygonOffsetClampEXT = loadFunction<GlPolygonOffsetClampEXTNative>(lib, 'glPolygonOffsetClampEXT').asFunction<GlPolygonOffsetClampEXT>();
  glRasterSamplesEXT = loadFunction<GlRasterSamplesEXTNative>(lib, 'glRasterSamplesEXT').asFunction<GlRasterSamplesEXT>();
  glUseShaderProgramEXT = loadFunction<GlUseShaderProgramEXTNative>(lib, 'glUseShaderProgramEXT').asFunction<GlUseShaderProgramEXT>();
  glActiveProgramEXT = loadFunction<GlActiveProgramEXTNative>(lib, 'glActiveProgramEXT').asFunction<GlActiveProgramEXT>();
  glCreateShaderProgramEXT = loadFunction<GlCreateShaderProgramEXTNative>(lib, 'glCreateShaderProgramEXT').asFunction<GlCreateShaderProgramEXT>();
  glFramebufferFetchBarrierEXT = loadFunction<GlFramebufferFetchBarrierEXTNative>(lib, 'glFramebufferFetchBarrierEXT').asFunction<GlFramebufferFetchBarrierEXT>();
  glWindowRectanglesEXT = loadFunction<GlWindowRectanglesEXTNative>(lib, 'glWindowRectanglesEXT').asFunction<GlWindowRectanglesEXT>();
  glApplyFramebufferAttachmentCMAAINTEL = loadFunction<GlApplyFramebufferAttachmentCMAAINTELNative>(lib, 'glApplyFramebufferAttachmentCMAAINTEL').asFunction<GlApplyFramebufferAttachmentCMAAINTEL>();
  glBeginPerfQueryINTEL = loadFunction<GlBeginPerfQueryINTELNative>(lib, 'glBeginPerfQueryINTEL').asFunction<GlBeginPerfQueryINTEL>();
  glCreatePerfQueryINTEL = loadFunction<GlCreatePerfQueryINTELNative>(lib, 'glCreatePerfQueryINTEL').asFunction<GlCreatePerfQueryINTEL>();
  glDeletePerfQueryINTEL = loadFunction<GlDeletePerfQueryINTELNative>(lib, 'glDeletePerfQueryINTEL').asFunction<GlDeletePerfQueryINTEL>();
  glEndPerfQueryINTEL = loadFunction<GlEndPerfQueryINTELNative>(lib, 'glEndPerfQueryINTEL').asFunction<GlEndPerfQueryINTEL>();
  glGetFirstPerfQueryIdINTEL = loadFunction<GlGetFirstPerfQueryIdINTELNative>(lib, 'glGetFirstPerfQueryIdINTEL').asFunction<GlGetFirstPerfQueryIdINTEL>();
  glGetNextPerfQueryIdINTEL = loadFunction<GlGetNextPerfQueryIdINTELNative>(lib, 'glGetNextPerfQueryIdINTEL').asFunction<GlGetNextPerfQueryIdINTEL>();
  glGetPerfCounterInfoINTEL = loadFunction<GlGetPerfCounterInfoINTELNative>(lib, 'glGetPerfCounterInfoINTEL').asFunction<GlGetPerfCounterInfoINTEL>();
  glGetPerfQueryDataINTEL = loadFunction<GlGetPerfQueryDataINTELNative>(lib, 'glGetPerfQueryDataINTEL').asFunction<GlGetPerfQueryDataINTEL>();
  glGetPerfQueryIdByNameINTEL = loadFunction<GlGetPerfQueryIdByNameINTELNative>(lib, 'glGetPerfQueryIdByNameINTEL').asFunction<GlGetPerfQueryIdByNameINTEL>();
  glGetPerfQueryInfoINTEL = loadFunction<GlGetPerfQueryInfoINTELNative>(lib, 'glGetPerfQueryInfoINTEL').asFunction<GlGetPerfQueryInfoINTEL>();
  glFramebufferParameteriMESA = loadFunction<GlFramebufferParameteriMESANative>(lib, 'glFramebufferParameteriMESA').asFunction<GlFramebufferParameteriMESA>();
  glGetFramebufferParameterivMESA = loadFunction<GlGetFramebufferParameterivMESANative>(lib, 'glGetFramebufferParameterivMESA').asFunction<GlGetFramebufferParameterivMESA>();
  glMultiDrawArraysIndirectBindlessNV = loadFunction<GlMultiDrawArraysIndirectBindlessNVNative>(lib, 'glMultiDrawArraysIndirectBindlessNV').asFunction<GlMultiDrawArraysIndirectBindlessNV>();
  glMultiDrawElementsIndirectBindlessNV = loadFunction<GlMultiDrawElementsIndirectBindlessNVNative>(lib, 'glMultiDrawElementsIndirectBindlessNV').asFunction<GlMultiDrawElementsIndirectBindlessNV>();
  glMultiDrawArraysIndirectBindlessCountNV = loadFunction<GlMultiDrawArraysIndirectBindlessCountNVNative>(lib, 'glMultiDrawArraysIndirectBindlessCountNV').asFunction<GlMultiDrawArraysIndirectBindlessCountNV>();
  glMultiDrawElementsIndirectBindlessCountNV = loadFunction<GlMultiDrawElementsIndirectBindlessCountNVNative>(lib, 'glMultiDrawElementsIndirectBindlessCountNV').asFunction<GlMultiDrawElementsIndirectBindlessCountNV>();
  glGetTextureHandleNV = loadFunction<GlGetTextureHandleNVNative>(lib, 'glGetTextureHandleNV').asFunction<GlGetTextureHandleNV>();
  glGetTextureSamplerHandleNV = loadFunction<GlGetTextureSamplerHandleNVNative>(lib, 'glGetTextureSamplerHandleNV').asFunction<GlGetTextureSamplerHandleNV>();
  glMakeTextureHandleResidentNV = loadFunction<GlMakeTextureHandleResidentNVNative>(lib, 'glMakeTextureHandleResidentNV').asFunction<GlMakeTextureHandleResidentNV>();
  glMakeTextureHandleNonResidentNV = loadFunction<GlMakeTextureHandleNonResidentNVNative>(lib, 'glMakeTextureHandleNonResidentNV').asFunction<GlMakeTextureHandleNonResidentNV>();
  glGetImageHandleNV = loadFunction<GlGetImageHandleNVNative>(lib, 'glGetImageHandleNV').asFunction<GlGetImageHandleNV>();
  glMakeImageHandleResidentNV = loadFunction<GlMakeImageHandleResidentNVNative>(lib, 'glMakeImageHandleResidentNV').asFunction<GlMakeImageHandleResidentNV>();
  glMakeImageHandleNonResidentNV = loadFunction<GlMakeImageHandleNonResidentNVNative>(lib, 'glMakeImageHandleNonResidentNV').asFunction<GlMakeImageHandleNonResidentNV>();
  glUniformHandleui64NV = loadFunction<GlUniformHandleui64NVNative>(lib, 'glUniformHandleui64NV').asFunction<GlUniformHandleui64NV>();
  glUniformHandleui64vNV = loadFunction<GlUniformHandleui64vNVNative>(lib, 'glUniformHandleui64vNV').asFunction<GlUniformHandleui64vNV>();
  glProgramUniformHandleui64NV = loadFunction<GlProgramUniformHandleui64NVNative>(lib, 'glProgramUniformHandleui64NV').asFunction<GlProgramUniformHandleui64NV>();
  glProgramUniformHandleui64vNV = loadFunction<GlProgramUniformHandleui64vNVNative>(lib, 'glProgramUniformHandleui64vNV').asFunction<GlProgramUniformHandleui64vNV>();
  glIsTextureHandleResidentNV = loadFunction<GlIsTextureHandleResidentNVNative>(lib, 'glIsTextureHandleResidentNV').asFunction<GlIsTextureHandleResidentNV>();
  glIsImageHandleResidentNV = loadFunction<GlIsImageHandleResidentNVNative>(lib, 'glIsImageHandleResidentNV').asFunction<GlIsImageHandleResidentNV>();
  glBlendParameteriNV = loadFunction<GlBlendParameteriNVNative>(lib, 'glBlendParameteriNV').asFunction<GlBlendParameteriNV>();
  glBlendBarrierNV = loadFunction<GlBlendBarrierNVNative>(lib, 'glBlendBarrierNV').asFunction<GlBlendBarrierNV>();
  glViewportPositionWScaleNV = loadFunction<GlViewportPositionWScaleNVNative>(lib, 'glViewportPositionWScaleNV').asFunction<GlViewportPositionWScaleNV>();
  glCreateStatesNV = loadFunction<GlCreateStatesNVNative>(lib, 'glCreateStatesNV').asFunction<GlCreateStatesNV>();
  glDeleteStatesNV = loadFunction<GlDeleteStatesNVNative>(lib, 'glDeleteStatesNV').asFunction<GlDeleteStatesNV>();
  glIsStateNV = loadFunction<GlIsStateNVNative>(lib, 'glIsStateNV').asFunction<GlIsStateNV>();
  glStateCaptureNV = loadFunction<GlStateCaptureNVNative>(lib, 'glStateCaptureNV').asFunction<GlStateCaptureNV>();
  glGetCommandHeaderNV = loadFunction<GlGetCommandHeaderNVNative>(lib, 'glGetCommandHeaderNV').asFunction<GlGetCommandHeaderNV>();
  glGetStageIndexNV = loadFunction<GlGetStageIndexNVNative>(lib, 'glGetStageIndexNV').asFunction<GlGetStageIndexNV>();
  glDrawCommandsNV = loadFunction<GlDrawCommandsNVNative>(lib, 'glDrawCommandsNV').asFunction<GlDrawCommandsNV>();
  glDrawCommandsAddressNV = loadFunction<GlDrawCommandsAddressNVNative>(lib, 'glDrawCommandsAddressNV').asFunction<GlDrawCommandsAddressNV>();
  glDrawCommandsStatesNV = loadFunction<GlDrawCommandsStatesNVNative>(lib, 'glDrawCommandsStatesNV').asFunction<GlDrawCommandsStatesNV>();
  glDrawCommandsStatesAddressNV = loadFunction<GlDrawCommandsStatesAddressNVNative>(lib, 'glDrawCommandsStatesAddressNV').asFunction<GlDrawCommandsStatesAddressNV>();
  glCreateCommandListsNV = loadFunction<GlCreateCommandListsNVNative>(lib, 'glCreateCommandListsNV').asFunction<GlCreateCommandListsNV>();
  glDeleteCommandListsNV = loadFunction<GlDeleteCommandListsNVNative>(lib, 'glDeleteCommandListsNV').asFunction<GlDeleteCommandListsNV>();
  glIsCommandListNV = loadFunction<GlIsCommandListNVNative>(lib, 'glIsCommandListNV').asFunction<GlIsCommandListNV>();
  glListDrawCommandsStatesClientNV = loadFunction<GlListDrawCommandsStatesClientNVNative>(lib, 'glListDrawCommandsStatesClientNV').asFunction<GlListDrawCommandsStatesClientNV>();
  glCommandListSegmentsNV = loadFunction<GlCommandListSegmentsNVNative>(lib, 'glCommandListSegmentsNV').asFunction<GlCommandListSegmentsNV>();
  glCompileCommandListNV = loadFunction<GlCompileCommandListNVNative>(lib, 'glCompileCommandListNV').asFunction<GlCompileCommandListNV>();
  glCallCommandListNV = loadFunction<GlCallCommandListNVNative>(lib, 'glCallCommandListNV').asFunction<GlCallCommandListNV>();
  glBeginConditionalRenderNV = loadFunction<GlBeginConditionalRenderNVNative>(lib, 'glBeginConditionalRenderNV').asFunction<GlBeginConditionalRenderNV>();
  glEndConditionalRenderNV = loadFunction<GlEndConditionalRenderNVNative>(lib, 'glEndConditionalRenderNV').asFunction<GlEndConditionalRenderNV>();
  glSubpixelPrecisionBiasNV = loadFunction<GlSubpixelPrecisionBiasNVNative>(lib, 'glSubpixelPrecisionBiasNV').asFunction<GlSubpixelPrecisionBiasNV>();
  glConservativeRasterParameterfNV = loadFunction<GlConservativeRasterParameterfNVNative>(lib, 'glConservativeRasterParameterfNV').asFunction<GlConservativeRasterParameterfNV>();
  glConservativeRasterParameteriNV = loadFunction<GlConservativeRasterParameteriNVNative>(lib, 'glConservativeRasterParameteriNV').asFunction<GlConservativeRasterParameteriNV>();
  glDepthRangedNV = loadFunction<GlDepthRangedNVNative>(lib, 'glDepthRangedNV').asFunction<GlDepthRangedNV>();
  glClearDepthdNV = loadFunction<GlClearDepthdNVNative>(lib, 'glClearDepthdNV').asFunction<GlClearDepthdNV>();
  glDepthBoundsdNV = loadFunction<GlDepthBoundsdNVNative>(lib, 'glDepthBoundsdNV').asFunction<GlDepthBoundsdNV>();
  glDrawVkImageNV = loadFunction<GlDrawVkImageNVNative>(lib, 'glDrawVkImageNV').asFunction<GlDrawVkImageNV>();
  glGetVkProcAddrNV = loadFunction<GlGetVkProcAddrNVNative>(lib, 'glGetVkProcAddrNV').asFunction<GlGetVkProcAddrNV>();
  glWaitVkSemaphoreNV = loadFunction<GlWaitVkSemaphoreNVNative>(lib, 'glWaitVkSemaphoreNV').asFunction<GlWaitVkSemaphoreNV>();
  glSignalVkSemaphoreNV = loadFunction<GlSignalVkSemaphoreNVNative>(lib, 'glSignalVkSemaphoreNV').asFunction<GlSignalVkSemaphoreNV>();
  glSignalVkFenceNV = loadFunction<GlSignalVkFenceNVNative>(lib, 'glSignalVkFenceNV').asFunction<GlSignalVkFenceNV>();
  glFragmentCoverageColorNV = loadFunction<GlFragmentCoverageColorNVNative>(lib, 'glFragmentCoverageColorNV').asFunction<GlFragmentCoverageColorNV>();
  glCoverageModulationTableNV = loadFunction<GlCoverageModulationTableNVNative>(lib, 'glCoverageModulationTableNV').asFunction<GlCoverageModulationTableNV>();
  glGetCoverageModulationTableNV = loadFunction<GlGetCoverageModulationTableNVNative>(lib, 'glGetCoverageModulationTableNV').asFunction<GlGetCoverageModulationTableNV>();
  glCoverageModulationNV = loadFunction<GlCoverageModulationNVNative>(lib, 'glCoverageModulationNV').asFunction<GlCoverageModulationNV>();
  glRenderbufferStorageMultisampleCoverageNV = loadFunction<GlRenderbufferStorageMultisampleCoverageNVNative>(lib, 'glRenderbufferStorageMultisampleCoverageNV').asFunction<GlRenderbufferStorageMultisampleCoverageNV>();
  glUniform1i64NV = loadFunction<GlUniform1i64NVNative>(lib, 'glUniform1i64NV').asFunction<GlUniform1i64NV>();
  glUniform2i64NV = loadFunction<GlUniform2i64NVNative>(lib, 'glUniform2i64NV').asFunction<GlUniform2i64NV>();
  glUniform3i64NV = loadFunction<GlUniform3i64NVNative>(lib, 'glUniform3i64NV').asFunction<GlUniform3i64NV>();
  glUniform4i64NV = loadFunction<GlUniform4i64NVNative>(lib, 'glUniform4i64NV').asFunction<GlUniform4i64NV>();
  glUniform1i64vNV = loadFunction<GlUniform1i64vNVNative>(lib, 'glUniform1i64vNV').asFunction<GlUniform1i64vNV>();
  glUniform2i64vNV = loadFunction<GlUniform2i64vNVNative>(lib, 'glUniform2i64vNV').asFunction<GlUniform2i64vNV>();
  glUniform3i64vNV = loadFunction<GlUniform3i64vNVNative>(lib, 'glUniform3i64vNV').asFunction<GlUniform3i64vNV>();
  glUniform4i64vNV = loadFunction<GlUniform4i64vNVNative>(lib, 'glUniform4i64vNV').asFunction<GlUniform4i64vNV>();
  glUniform1ui64NV = loadFunction<GlUniform1ui64NVNative>(lib, 'glUniform1ui64NV').asFunction<GlUniform1ui64NV>();
  glUniform2ui64NV = loadFunction<GlUniform2ui64NVNative>(lib, 'glUniform2ui64NV').asFunction<GlUniform2ui64NV>();
  glUniform3ui64NV = loadFunction<GlUniform3ui64NVNative>(lib, 'glUniform3ui64NV').asFunction<GlUniform3ui64NV>();
  glUniform4ui64NV = loadFunction<GlUniform4ui64NVNative>(lib, 'glUniform4ui64NV').asFunction<GlUniform4ui64NV>();
  glUniform1ui64vNV = loadFunction<GlUniform1ui64vNVNative>(lib, 'glUniform1ui64vNV').asFunction<GlUniform1ui64vNV>();
  glUniform2ui64vNV = loadFunction<GlUniform2ui64vNVNative>(lib, 'glUniform2ui64vNV').asFunction<GlUniform2ui64vNV>();
  glUniform3ui64vNV = loadFunction<GlUniform3ui64vNVNative>(lib, 'glUniform3ui64vNV').asFunction<GlUniform3ui64vNV>();
  glUniform4ui64vNV = loadFunction<GlUniform4ui64vNVNative>(lib, 'glUniform4ui64vNV').asFunction<GlUniform4ui64vNV>();
  glGetUniformi64vNV = loadFunction<GlGetUniformi64vNVNative>(lib, 'glGetUniformi64vNV').asFunction<GlGetUniformi64vNV>();
  glProgramUniform1i64NV = loadFunction<GlProgramUniform1i64NVNative>(lib, 'glProgramUniform1i64NV').asFunction<GlProgramUniform1i64NV>();
  glProgramUniform2i64NV = loadFunction<GlProgramUniform2i64NVNative>(lib, 'glProgramUniform2i64NV').asFunction<GlProgramUniform2i64NV>();
  glProgramUniform3i64NV = loadFunction<GlProgramUniform3i64NVNative>(lib, 'glProgramUniform3i64NV').asFunction<GlProgramUniform3i64NV>();
  glProgramUniform4i64NV = loadFunction<GlProgramUniform4i64NVNative>(lib, 'glProgramUniform4i64NV').asFunction<GlProgramUniform4i64NV>();
  glProgramUniform1i64vNV = loadFunction<GlProgramUniform1i64vNVNative>(lib, 'glProgramUniform1i64vNV').asFunction<GlProgramUniform1i64vNV>();
  glProgramUniform2i64vNV = loadFunction<GlProgramUniform2i64vNVNative>(lib, 'glProgramUniform2i64vNV').asFunction<GlProgramUniform2i64vNV>();
  glProgramUniform3i64vNV = loadFunction<GlProgramUniform3i64vNVNative>(lib, 'glProgramUniform3i64vNV').asFunction<GlProgramUniform3i64vNV>();
  glProgramUniform4i64vNV = loadFunction<GlProgramUniform4i64vNVNative>(lib, 'glProgramUniform4i64vNV').asFunction<GlProgramUniform4i64vNV>();
  glProgramUniform1ui64NV = loadFunction<GlProgramUniform1ui64NVNative>(lib, 'glProgramUniform1ui64NV').asFunction<GlProgramUniform1ui64NV>();
  glProgramUniform2ui64NV = loadFunction<GlProgramUniform2ui64NVNative>(lib, 'glProgramUniform2ui64NV').asFunction<GlProgramUniform2ui64NV>();
  glProgramUniform3ui64NV = loadFunction<GlProgramUniform3ui64NVNative>(lib, 'glProgramUniform3ui64NV').asFunction<GlProgramUniform3ui64NV>();
  glProgramUniform4ui64NV = loadFunction<GlProgramUniform4ui64NVNative>(lib, 'glProgramUniform4ui64NV').asFunction<GlProgramUniform4ui64NV>();
  glProgramUniform1ui64vNV = loadFunction<GlProgramUniform1ui64vNVNative>(lib, 'glProgramUniform1ui64vNV').asFunction<GlProgramUniform1ui64vNV>();
  glProgramUniform2ui64vNV = loadFunction<GlProgramUniform2ui64vNVNative>(lib, 'glProgramUniform2ui64vNV').asFunction<GlProgramUniform2ui64vNV>();
  glProgramUniform3ui64vNV = loadFunction<GlProgramUniform3ui64vNVNative>(lib, 'glProgramUniform3ui64vNV').asFunction<GlProgramUniform3ui64vNV>();
  glProgramUniform4ui64vNV = loadFunction<GlProgramUniform4ui64vNVNative>(lib, 'glProgramUniform4ui64vNV').asFunction<GlProgramUniform4ui64vNV>();
  glGetInternalformatSampleivNV = loadFunction<GlGetInternalformatSampleivNVNative>(lib, 'glGetInternalformatSampleivNV').asFunction<GlGetInternalformatSampleivNV>();
  glGetMemoryObjectDetachedResourcesuivNV = loadFunction<GlGetMemoryObjectDetachedResourcesuivNVNative>(lib, 'glGetMemoryObjectDetachedResourcesuivNV').asFunction<GlGetMemoryObjectDetachedResourcesuivNV>();
  glResetMemoryObjectParameterNV = loadFunction<GlResetMemoryObjectParameterNVNative>(lib, 'glResetMemoryObjectParameterNV').asFunction<GlResetMemoryObjectParameterNV>();
  glTexAttachMemoryNV = loadFunction<GlTexAttachMemoryNVNative>(lib, 'glTexAttachMemoryNV').asFunction<GlTexAttachMemoryNV>();
  glBufferAttachMemoryNV = loadFunction<GlBufferAttachMemoryNVNative>(lib, 'glBufferAttachMemoryNV').asFunction<GlBufferAttachMemoryNV>();
  glTextureAttachMemoryNV = loadFunction<GlTextureAttachMemoryNVNative>(lib, 'glTextureAttachMemoryNV').asFunction<GlTextureAttachMemoryNV>();
  glNamedBufferAttachMemoryNV = loadFunction<GlNamedBufferAttachMemoryNVNative>(lib, 'glNamedBufferAttachMemoryNV').asFunction<GlNamedBufferAttachMemoryNV>();
  glBufferPageCommitmentMemNV = loadFunction<GlBufferPageCommitmentMemNVNative>(lib, 'glBufferPageCommitmentMemNV').asFunction<GlBufferPageCommitmentMemNV>();
  glTexPageCommitmentMemNV = loadFunction<GlTexPageCommitmentMemNVNative>(lib, 'glTexPageCommitmentMemNV').asFunction<GlTexPageCommitmentMemNV>();
  glNamedBufferPageCommitmentMemNV = loadFunction<GlNamedBufferPageCommitmentMemNVNative>(lib, 'glNamedBufferPageCommitmentMemNV').asFunction<GlNamedBufferPageCommitmentMemNV>();
  glTexturePageCommitmentMemNV = loadFunction<GlTexturePageCommitmentMemNVNative>(lib, 'glTexturePageCommitmentMemNV').asFunction<GlTexturePageCommitmentMemNV>();
  glDrawMeshTasksNV = loadFunction<GlDrawMeshTasksNVNative>(lib, 'glDrawMeshTasksNV').asFunction<GlDrawMeshTasksNV>();
  glDrawMeshTasksIndirectNV = loadFunction<GlDrawMeshTasksIndirectNVNative>(lib, 'glDrawMeshTasksIndirectNV').asFunction<GlDrawMeshTasksIndirectNV>();
  glMultiDrawMeshTasksIndirectNV = loadFunction<GlMultiDrawMeshTasksIndirectNVNative>(lib, 'glMultiDrawMeshTasksIndirectNV').asFunction<GlMultiDrawMeshTasksIndirectNV>();
  glMultiDrawMeshTasksIndirectCountNV = loadFunction<GlMultiDrawMeshTasksIndirectCountNVNative>(lib, 'glMultiDrawMeshTasksIndirectCountNV').asFunction<GlMultiDrawMeshTasksIndirectCountNV>();
  glGenPathsNV = loadFunction<GlGenPathsNVNative>(lib, 'glGenPathsNV').asFunction<GlGenPathsNV>();
  glDeletePathsNV = loadFunction<GlDeletePathsNVNative>(lib, 'glDeletePathsNV').asFunction<GlDeletePathsNV>();
  glIsPathNV = loadFunction<GlIsPathNVNative>(lib, 'glIsPathNV').asFunction<GlIsPathNV>();
  glPathCommandsNV = loadFunction<GlPathCommandsNVNative>(lib, 'glPathCommandsNV').asFunction<GlPathCommandsNV>();
  glPathCoordsNV = loadFunction<GlPathCoordsNVNative>(lib, 'glPathCoordsNV').asFunction<GlPathCoordsNV>();
  glPathSubCommandsNV = loadFunction<GlPathSubCommandsNVNative>(lib, 'glPathSubCommandsNV').asFunction<GlPathSubCommandsNV>();
  glPathSubCoordsNV = loadFunction<GlPathSubCoordsNVNative>(lib, 'glPathSubCoordsNV').asFunction<GlPathSubCoordsNV>();
  glPathStringNV = loadFunction<GlPathStringNVNative>(lib, 'glPathStringNV').asFunction<GlPathStringNV>();
  glPathGlyphsNV = loadFunction<GlPathGlyphsNVNative>(lib, 'glPathGlyphsNV').asFunction<GlPathGlyphsNV>();
  glPathGlyphRangeNV = loadFunction<GlPathGlyphRangeNVNative>(lib, 'glPathGlyphRangeNV').asFunction<GlPathGlyphRangeNV>();
  glWeightPathsNV = loadFunction<GlWeightPathsNVNative>(lib, 'glWeightPathsNV').asFunction<GlWeightPathsNV>();
  glCopyPathNV = loadFunction<GlCopyPathNVNative>(lib, 'glCopyPathNV').asFunction<GlCopyPathNV>();
  glInterpolatePathsNV = loadFunction<GlInterpolatePathsNVNative>(lib, 'glInterpolatePathsNV').asFunction<GlInterpolatePathsNV>();
  glTransformPathNV = loadFunction<GlTransformPathNVNative>(lib, 'glTransformPathNV').asFunction<GlTransformPathNV>();
  glPathParameterivNV = loadFunction<GlPathParameterivNVNative>(lib, 'glPathParameterivNV').asFunction<GlPathParameterivNV>();
  glPathParameteriNV = loadFunction<GlPathParameteriNVNative>(lib, 'glPathParameteriNV').asFunction<GlPathParameteriNV>();
  glPathParameterfvNV = loadFunction<GlPathParameterfvNVNative>(lib, 'glPathParameterfvNV').asFunction<GlPathParameterfvNV>();
  glPathParameterfNV = loadFunction<GlPathParameterfNVNative>(lib, 'glPathParameterfNV').asFunction<GlPathParameterfNV>();
  glPathDashArrayNV = loadFunction<GlPathDashArrayNVNative>(lib, 'glPathDashArrayNV').asFunction<GlPathDashArrayNV>();
  glPathStencilFuncNV = loadFunction<GlPathStencilFuncNVNative>(lib, 'glPathStencilFuncNV').asFunction<GlPathStencilFuncNV>();
  glPathStencilDepthOffsetNV = loadFunction<GlPathStencilDepthOffsetNVNative>(lib, 'glPathStencilDepthOffsetNV').asFunction<GlPathStencilDepthOffsetNV>();
  glStencilFillPathNV = loadFunction<GlStencilFillPathNVNative>(lib, 'glStencilFillPathNV').asFunction<GlStencilFillPathNV>();
  glStencilStrokePathNV = loadFunction<GlStencilStrokePathNVNative>(lib, 'glStencilStrokePathNV').asFunction<GlStencilStrokePathNV>();
  glStencilFillPathInstancedNV = loadFunction<GlStencilFillPathInstancedNVNative>(lib, 'glStencilFillPathInstancedNV').asFunction<GlStencilFillPathInstancedNV>();
  glStencilStrokePathInstancedNV = loadFunction<GlStencilStrokePathInstancedNVNative>(lib, 'glStencilStrokePathInstancedNV').asFunction<GlStencilStrokePathInstancedNV>();
  glPathCoverDepthFuncNV = loadFunction<GlPathCoverDepthFuncNVNative>(lib, 'glPathCoverDepthFuncNV').asFunction<GlPathCoverDepthFuncNV>();
  glCoverFillPathNV = loadFunction<GlCoverFillPathNVNative>(lib, 'glCoverFillPathNV').asFunction<GlCoverFillPathNV>();
  glCoverStrokePathNV = loadFunction<GlCoverStrokePathNVNative>(lib, 'glCoverStrokePathNV').asFunction<GlCoverStrokePathNV>();
  glCoverFillPathInstancedNV = loadFunction<GlCoverFillPathInstancedNVNative>(lib, 'glCoverFillPathInstancedNV').asFunction<GlCoverFillPathInstancedNV>();
  glCoverStrokePathInstancedNV = loadFunction<GlCoverStrokePathInstancedNVNative>(lib, 'glCoverStrokePathInstancedNV').asFunction<GlCoverStrokePathInstancedNV>();
  glGetPathParameterivNV = loadFunction<GlGetPathParameterivNVNative>(lib, 'glGetPathParameterivNV').asFunction<GlGetPathParameterivNV>();
  glGetPathParameterfvNV = loadFunction<GlGetPathParameterfvNVNative>(lib, 'glGetPathParameterfvNV').asFunction<GlGetPathParameterfvNV>();
  glGetPathCommandsNV = loadFunction<GlGetPathCommandsNVNative>(lib, 'glGetPathCommandsNV').asFunction<GlGetPathCommandsNV>();
  glGetPathCoordsNV = loadFunction<GlGetPathCoordsNVNative>(lib, 'glGetPathCoordsNV').asFunction<GlGetPathCoordsNV>();
  glGetPathDashArrayNV = loadFunction<GlGetPathDashArrayNVNative>(lib, 'glGetPathDashArrayNV').asFunction<GlGetPathDashArrayNV>();
  glGetPathMetricsNV = loadFunction<GlGetPathMetricsNVNative>(lib, 'glGetPathMetricsNV').asFunction<GlGetPathMetricsNV>();
  glGetPathMetricRangeNV = loadFunction<GlGetPathMetricRangeNVNative>(lib, 'glGetPathMetricRangeNV').asFunction<GlGetPathMetricRangeNV>();
  glGetPathSpacingNV = loadFunction<GlGetPathSpacingNVNative>(lib, 'glGetPathSpacingNV').asFunction<GlGetPathSpacingNV>();
  glIsPointInFillPathNV = loadFunction<GlIsPointInFillPathNVNative>(lib, 'glIsPointInFillPathNV').asFunction<GlIsPointInFillPathNV>();
  glIsPointInStrokePathNV = loadFunction<GlIsPointInStrokePathNVNative>(lib, 'glIsPointInStrokePathNV').asFunction<GlIsPointInStrokePathNV>();
  glGetPathLengthNV = loadFunction<GlGetPathLengthNVNative>(lib, 'glGetPathLengthNV').asFunction<GlGetPathLengthNV>();
  glPointAlongPathNV = loadFunction<GlPointAlongPathNVNative>(lib, 'glPointAlongPathNV').asFunction<GlPointAlongPathNV>();
  glMatrixLoad3x2fNV = loadFunction<GlMatrixLoad3x2fNVNative>(lib, 'glMatrixLoad3x2fNV').asFunction<GlMatrixLoad3x2fNV>();
  glMatrixLoad3x3fNV = loadFunction<GlMatrixLoad3x3fNVNative>(lib, 'glMatrixLoad3x3fNV').asFunction<GlMatrixLoad3x3fNV>();
  glMatrixLoadTranspose3x3fNV = loadFunction<GlMatrixLoadTranspose3x3fNVNative>(lib, 'glMatrixLoadTranspose3x3fNV').asFunction<GlMatrixLoadTranspose3x3fNV>();
  glMatrixMult3x2fNV = loadFunction<GlMatrixMult3x2fNVNative>(lib, 'glMatrixMult3x2fNV').asFunction<GlMatrixMult3x2fNV>();
  glMatrixMult3x3fNV = loadFunction<GlMatrixMult3x3fNVNative>(lib, 'glMatrixMult3x3fNV').asFunction<GlMatrixMult3x3fNV>();
  glMatrixMultTranspose3x3fNV = loadFunction<GlMatrixMultTranspose3x3fNVNative>(lib, 'glMatrixMultTranspose3x3fNV').asFunction<GlMatrixMultTranspose3x3fNV>();
  glStencilThenCoverFillPathNV = loadFunction<GlStencilThenCoverFillPathNVNative>(lib, 'glStencilThenCoverFillPathNV').asFunction<GlStencilThenCoverFillPathNV>();
  glStencilThenCoverStrokePathNV = loadFunction<GlStencilThenCoverStrokePathNVNative>(lib, 'glStencilThenCoverStrokePathNV').asFunction<GlStencilThenCoverStrokePathNV>();
  glStencilThenCoverFillPathInstancedNV = loadFunction<GlStencilThenCoverFillPathInstancedNVNative>(lib, 'glStencilThenCoverFillPathInstancedNV').asFunction<GlStencilThenCoverFillPathInstancedNV>();
  glStencilThenCoverStrokePathInstancedNV = loadFunction<GlStencilThenCoverStrokePathInstancedNVNative>(lib, 'glStencilThenCoverStrokePathInstancedNV').asFunction<GlStencilThenCoverStrokePathInstancedNV>();
  glPathGlyphIndexRangeNV = loadFunction<GlPathGlyphIndexRangeNVNative>(lib, 'glPathGlyphIndexRangeNV').asFunction<GlPathGlyphIndexRangeNV>();
  glPathGlyphIndexArrayNV = loadFunction<GlPathGlyphIndexArrayNVNative>(lib, 'glPathGlyphIndexArrayNV').asFunction<GlPathGlyphIndexArrayNV>();
  glPathMemoryGlyphIndexArrayNV = loadFunction<GlPathMemoryGlyphIndexArrayNVNative>(lib, 'glPathMemoryGlyphIndexArrayNV').asFunction<GlPathMemoryGlyphIndexArrayNV>();
  glProgramPathFragmentInputGenNV = loadFunction<GlProgramPathFragmentInputGenNVNative>(lib, 'glProgramPathFragmentInputGenNV').asFunction<GlProgramPathFragmentInputGenNV>();
  glGetProgramResourcefvNV = loadFunction<GlGetProgramResourcefvNVNative>(lib, 'glGetProgramResourcefvNV').asFunction<GlGetProgramResourcefvNV>();
  glFramebufferSampleLocationsfvNV = loadFunction<GlFramebufferSampleLocationsfvNVNative>(lib, 'glFramebufferSampleLocationsfvNV').asFunction<GlFramebufferSampleLocationsfvNV>();
  glNamedFramebufferSampleLocationsfvNV = loadFunction<GlNamedFramebufferSampleLocationsfvNVNative>(lib, 'glNamedFramebufferSampleLocationsfvNV').asFunction<GlNamedFramebufferSampleLocationsfvNV>();
  glResolveDepthValuesNV = loadFunction<GlResolveDepthValuesNVNative>(lib, 'glResolveDepthValuesNV').asFunction<GlResolveDepthValuesNV>();
  glScissorExclusiveNV = loadFunction<GlScissorExclusiveNVNative>(lib, 'glScissorExclusiveNV').asFunction<GlScissorExclusiveNV>();
  glScissorExclusiveArrayvNV = loadFunction<GlScissorExclusiveArrayvNVNative>(lib, 'glScissorExclusiveArrayvNV').asFunction<GlScissorExclusiveArrayvNV>();
  glMakeBufferResidentNV = loadFunction<GlMakeBufferResidentNVNative>(lib, 'glMakeBufferResidentNV').asFunction<GlMakeBufferResidentNV>();
  glMakeBufferNonResidentNV = loadFunction<GlMakeBufferNonResidentNVNative>(lib, 'glMakeBufferNonResidentNV').asFunction<GlMakeBufferNonResidentNV>();
  glIsBufferResidentNV = loadFunction<GlIsBufferResidentNVNative>(lib, 'glIsBufferResidentNV').asFunction<GlIsBufferResidentNV>();
  glMakeNamedBufferResidentNV = loadFunction<GlMakeNamedBufferResidentNVNative>(lib, 'glMakeNamedBufferResidentNV').asFunction<GlMakeNamedBufferResidentNV>();
  glMakeNamedBufferNonResidentNV = loadFunction<GlMakeNamedBufferNonResidentNVNative>(lib, 'glMakeNamedBufferNonResidentNV').asFunction<GlMakeNamedBufferNonResidentNV>();
  glIsNamedBufferResidentNV = loadFunction<GlIsNamedBufferResidentNVNative>(lib, 'glIsNamedBufferResidentNV').asFunction<GlIsNamedBufferResidentNV>();
  glGetBufferParameterui64vNV = loadFunction<GlGetBufferParameterui64vNVNative>(lib, 'glGetBufferParameterui64vNV').asFunction<GlGetBufferParameterui64vNV>();
  glGetNamedBufferParameterui64vNV = loadFunction<GlGetNamedBufferParameterui64vNVNative>(lib, 'glGetNamedBufferParameterui64vNV').asFunction<GlGetNamedBufferParameterui64vNV>();
  glGetIntegerui64vNV = loadFunction<GlGetIntegerui64vNVNative>(lib, 'glGetIntegerui64vNV').asFunction<GlGetIntegerui64vNV>();
  glUniformui64NV = loadFunction<GlUniformui64NVNative>(lib, 'glUniformui64NV').asFunction<GlUniformui64NV>();
  glUniformui64vNV = loadFunction<GlUniformui64vNVNative>(lib, 'glUniformui64vNV').asFunction<GlUniformui64vNV>();
  glGetUniformui64vNV = loadFunction<GlGetUniformui64vNVNative>(lib, 'glGetUniformui64vNV').asFunction<GlGetUniformui64vNV>();
  glProgramUniformui64NV = loadFunction<GlProgramUniformui64NVNative>(lib, 'glProgramUniformui64NV').asFunction<GlProgramUniformui64NV>();
  glProgramUniformui64vNV = loadFunction<GlProgramUniformui64vNVNative>(lib, 'glProgramUniformui64vNV').asFunction<GlProgramUniformui64vNV>();
  glBindShadingRateImageNV = loadFunction<GlBindShadingRateImageNVNative>(lib, 'glBindShadingRateImageNV').asFunction<GlBindShadingRateImageNV>();
  glGetShadingRateImagePaletteNV = loadFunction<GlGetShadingRateImagePaletteNVNative>(lib, 'glGetShadingRateImagePaletteNV').asFunction<GlGetShadingRateImagePaletteNV>();
  glGetShadingRateSampleLocationivNV = loadFunction<GlGetShadingRateSampleLocationivNVNative>(lib, 'glGetShadingRateSampleLocationivNV').asFunction<GlGetShadingRateSampleLocationivNV>();
  glShadingRateImageBarrierNV = loadFunction<GlShadingRateImageBarrierNVNative>(lib, 'glShadingRateImageBarrierNV').asFunction<GlShadingRateImageBarrierNV>();
  glShadingRateImagePaletteNV = loadFunction<GlShadingRateImagePaletteNVNative>(lib, 'glShadingRateImagePaletteNV').asFunction<GlShadingRateImagePaletteNV>();
  glShadingRateSampleOrderNV = loadFunction<GlShadingRateSampleOrderNVNative>(lib, 'glShadingRateSampleOrderNV').asFunction<GlShadingRateSampleOrderNV>();
  glShadingRateSampleOrderCustomNV = loadFunction<GlShadingRateSampleOrderCustomNVNative>(lib, 'glShadingRateSampleOrderCustomNV').asFunction<GlShadingRateSampleOrderCustomNV>();
  glTextureBarrierNV = loadFunction<GlTextureBarrierNVNative>(lib, 'glTextureBarrierNV').asFunction<GlTextureBarrierNV>();
  glVertexAttribL1i64NV = loadFunction<GlVertexAttribL1i64NVNative>(lib, 'glVertexAttribL1i64NV').asFunction<GlVertexAttribL1i64NV>();
  glVertexAttribL2i64NV = loadFunction<GlVertexAttribL2i64NVNative>(lib, 'glVertexAttribL2i64NV').asFunction<GlVertexAttribL2i64NV>();
  glVertexAttribL3i64NV = loadFunction<GlVertexAttribL3i64NVNative>(lib, 'glVertexAttribL3i64NV').asFunction<GlVertexAttribL3i64NV>();
  glVertexAttribL4i64NV = loadFunction<GlVertexAttribL4i64NVNative>(lib, 'glVertexAttribL4i64NV').asFunction<GlVertexAttribL4i64NV>();
  glVertexAttribL1i64vNV = loadFunction<GlVertexAttribL1i64vNVNative>(lib, 'glVertexAttribL1i64vNV').asFunction<GlVertexAttribL1i64vNV>();
  glVertexAttribL2i64vNV = loadFunction<GlVertexAttribL2i64vNVNative>(lib, 'glVertexAttribL2i64vNV').asFunction<GlVertexAttribL2i64vNV>();
  glVertexAttribL3i64vNV = loadFunction<GlVertexAttribL3i64vNVNative>(lib, 'glVertexAttribL3i64vNV').asFunction<GlVertexAttribL3i64vNV>();
  glVertexAttribL4i64vNV = loadFunction<GlVertexAttribL4i64vNVNative>(lib, 'glVertexAttribL4i64vNV').asFunction<GlVertexAttribL4i64vNV>();
  glVertexAttribL1ui64NV = loadFunction<GlVertexAttribL1ui64NVNative>(lib, 'glVertexAttribL1ui64NV').asFunction<GlVertexAttribL1ui64NV>();
  glVertexAttribL2ui64NV = loadFunction<GlVertexAttribL2ui64NVNative>(lib, 'glVertexAttribL2ui64NV').asFunction<GlVertexAttribL2ui64NV>();
  glVertexAttribL3ui64NV = loadFunction<GlVertexAttribL3ui64NVNative>(lib, 'glVertexAttribL3ui64NV').asFunction<GlVertexAttribL3ui64NV>();
  glVertexAttribL4ui64NV = loadFunction<GlVertexAttribL4ui64NVNative>(lib, 'glVertexAttribL4ui64NV').asFunction<GlVertexAttribL4ui64NV>();
  glVertexAttribL1ui64vNV = loadFunction<GlVertexAttribL1ui64vNVNative>(lib, 'glVertexAttribL1ui64vNV').asFunction<GlVertexAttribL1ui64vNV>();
  glVertexAttribL2ui64vNV = loadFunction<GlVertexAttribL2ui64vNVNative>(lib, 'glVertexAttribL2ui64vNV').asFunction<GlVertexAttribL2ui64vNV>();
  glVertexAttribL3ui64vNV = loadFunction<GlVertexAttribL3ui64vNVNative>(lib, 'glVertexAttribL3ui64vNV').asFunction<GlVertexAttribL3ui64vNV>();
  glVertexAttribL4ui64vNV = loadFunction<GlVertexAttribL4ui64vNVNative>(lib, 'glVertexAttribL4ui64vNV').asFunction<GlVertexAttribL4ui64vNV>();
  glGetVertexAttribLi64vNV = loadFunction<GlGetVertexAttribLi64vNVNative>(lib, 'glGetVertexAttribLi64vNV').asFunction<GlGetVertexAttribLi64vNV>();
  glGetVertexAttribLui64vNV = loadFunction<GlGetVertexAttribLui64vNVNative>(lib, 'glGetVertexAttribLui64vNV').asFunction<GlGetVertexAttribLui64vNV>();
  glVertexAttribLFormatNV = loadFunction<GlVertexAttribLFormatNVNative>(lib, 'glVertexAttribLFormatNV').asFunction<GlVertexAttribLFormatNV>();
  glBufferAddressRangeNV = loadFunction<GlBufferAddressRangeNVNative>(lib, 'glBufferAddressRangeNV').asFunction<GlBufferAddressRangeNV>();
  glVertexFormatNV = loadFunction<GlVertexFormatNVNative>(lib, 'glVertexFormatNV').asFunction<GlVertexFormatNV>();
  glNormalFormatNV = loadFunction<GlNormalFormatNVNative>(lib, 'glNormalFormatNV').asFunction<GlNormalFormatNV>();
  glColorFormatNV = loadFunction<GlColorFormatNVNative>(lib, 'glColorFormatNV').asFunction<GlColorFormatNV>();
  glIndexFormatNV = loadFunction<GlIndexFormatNVNative>(lib, 'glIndexFormatNV').asFunction<GlIndexFormatNV>();
  glTexCoordFormatNV = loadFunction<GlTexCoordFormatNVNative>(lib, 'glTexCoordFormatNV').asFunction<GlTexCoordFormatNV>();
  glEdgeFlagFormatNV = loadFunction<GlEdgeFlagFormatNVNative>(lib, 'glEdgeFlagFormatNV').asFunction<GlEdgeFlagFormatNV>();
  glSecondaryColorFormatNV = loadFunction<GlSecondaryColorFormatNVNative>(lib, 'glSecondaryColorFormatNV').asFunction<GlSecondaryColorFormatNV>();
  glFogCoordFormatNV = loadFunction<GlFogCoordFormatNVNative>(lib, 'glFogCoordFormatNV').asFunction<GlFogCoordFormatNV>();
  glVertexAttribFormatNV = loadFunction<GlVertexAttribFormatNVNative>(lib, 'glVertexAttribFormatNV').asFunction<GlVertexAttribFormatNV>();
  glVertexAttribIFormatNV = loadFunction<GlVertexAttribIFormatNVNative>(lib, 'glVertexAttribIFormatNV').asFunction<GlVertexAttribIFormatNV>();
  glGetIntegerui64i_vNV = loadFunction<GlGetIntegerui64i_vNVNative>(lib, 'glGetIntegerui64i_vNV').asFunction<GlGetIntegerui64i_vNV>();
  glViewportSwizzleNV = loadFunction<GlViewportSwizzleNVNative>(lib, 'glViewportSwizzleNV').asFunction<GlViewportSwizzleNV>();
  glFramebufferTextureMultiviewOVR = loadFunction<GlFramebufferTextureMultiviewOVRNative>(lib, 'glFramebufferTextureMultiviewOVR').asFunction<GlFramebufferTextureMultiviewOVR>();
}

